// python wrapper for vtkAnnotationLink
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAnnotationLink.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAnnotationLink(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAnnotationLink_ClassNew(); }

#ifndef DECLARED_PyvtkAnnotationLayersAlgorithm_ClassNew
extern "C" { PyObject *PyvtkAnnotationLayersAlgorithm_ClassNew(); }
#define DECLARED_PyvtkAnnotationLayersAlgorithm_ClassNew
#endif

static const char **PyvtkAnnotationLink_Doc();


static PyObject *
PyvtkAnnotationLink_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAnnotationLink::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAnnotationLink::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAnnotationLink *tempr = vtkAnnotationLink::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAnnotationLink *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAnnotationLink::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_GetAnnotationLayers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAnnotationLayers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAnnotationLayers *tempr = (ap.IsBound() ?
      op->GetAnnotationLayers() :
      op->vtkAnnotationLink::GetAnnotationLayers());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_SetAnnotationLayers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationLayers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  vtkAnnotationLayers *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAnnotationLayers"))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationLayers(temp0);
    }
    else
    {
      op->vtkAnnotationLink::SetAnnotationLayers(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_SetCurrentSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurrentSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  vtkSelection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSelection"))
  {
    if (ap.IsBound())
    {
      op->SetCurrentSelection(temp0);
    }
    else
    {
      op->vtkAnnotationLink::SetCurrentSelection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_GetCurrentSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSelection *tempr = (ap.IsBound() ?
      op->GetCurrentSelection() :
      op->vtkAnnotationLink::GetCurrentSelection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_AddDomainMap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddDomainMap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  vtkTable *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTable"))
  {
    if (ap.IsBound())
    {
      op->AddDomainMap(temp0);
    }
    else
    {
      op->vtkAnnotationLink::AddDomainMap(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_RemoveDomainMap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveDomainMap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  vtkTable *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTable"))
  {
    if (ap.IsBound())
    {
      op->RemoveDomainMap(temp0);
    }
    else
    {
      op->vtkAnnotationLink::RemoveDomainMap(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_RemoveAllDomainMaps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllDomainMaps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllDomainMaps();
    }
    else
    {
      op->vtkAnnotationLink::RemoveAllDomainMaps();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_GetNumberOfDomainMaps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfDomainMaps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfDomainMaps() :
      op->vtkAnnotationLink::GetNumberOfDomainMaps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_GetDomainMap(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDomainMap");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetDomainMap(temp0) :
      op->vtkAnnotationLink::GetDomainMap(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAnnotationLink_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAnnotationLink *op = static_cast<vtkAnnotationLink *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkAnnotationLink::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkAnnotationLink_Methods[] = {
  {"IsTypeOf", PyvtkAnnotationLink_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkAnnotationLink_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkAnnotationLink_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkAnnotationLink\nC++: static vtkAnnotationLink *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkAnnotationLink_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAnnotationLink\nC++: vtkAnnotationLink *NewInstance()\n\n"},
  {"GetAnnotationLayers", PyvtkAnnotationLink_GetAnnotationLayers, METH_VARARGS,
   "V.GetAnnotationLayers() -> vtkAnnotationLayers\nC++: virtual vtkAnnotationLayers *GetAnnotationLayers()\n\nThe annotations to be shared.\n"},
  {"SetAnnotationLayers", PyvtkAnnotationLink_SetAnnotationLayers, METH_VARARGS,
   "V.SetAnnotationLayers(vtkAnnotationLayers)\nC++: virtual void SetAnnotationLayers(vtkAnnotationLayers *layers)\n\nThe annotations to be shared.\n"},
  {"SetCurrentSelection", PyvtkAnnotationLink_SetCurrentSelection, METH_VARARGS,
   "V.SetCurrentSelection(vtkSelection)\nC++: virtual void SetCurrentSelection(vtkSelection *sel)\n\nSet or get the current selection in the annotation layers.\n"},
  {"GetCurrentSelection", PyvtkAnnotationLink_GetCurrentSelection, METH_VARARGS,
   "V.GetCurrentSelection() -> vtkSelection\nC++: virtual vtkSelection *GetCurrentSelection()\n\nSet or get the current selection in the annotation layers.\n"},
  {"AddDomainMap", PyvtkAnnotationLink_AddDomainMap, METH_VARARGS,
   "V.AddDomainMap(vtkTable)\nC++: void AddDomainMap(vtkTable *map)\n\nThe domain mappings.\n"},
  {"RemoveDomainMap", PyvtkAnnotationLink_RemoveDomainMap, METH_VARARGS,
   "V.RemoveDomainMap(vtkTable)\nC++: void RemoveDomainMap(vtkTable *map)\n\nThe domain mappings.\n"},
  {"RemoveAllDomainMaps", PyvtkAnnotationLink_RemoveAllDomainMaps, METH_VARARGS,
   "V.RemoveAllDomainMaps()\nC++: void RemoveAllDomainMaps()\n\nThe domain mappings.\n"},
  {"GetNumberOfDomainMaps", PyvtkAnnotationLink_GetNumberOfDomainMaps, METH_VARARGS,
   "V.GetNumberOfDomainMaps() -> int\nC++: int GetNumberOfDomainMaps()\n\nThe domain mappings.\n"},
  {"GetDomainMap", PyvtkAnnotationLink_GetDomainMap, METH_VARARGS,
   "V.GetDomainMap(int) -> vtkTable\nC++: vtkTable *GetDomainMap(int i)\n\nThe domain mappings.\n"},
  {"GetMTime", PyvtkAnnotationLink_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime()\n\nGet the mtime of this object.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAnnotationLink_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkAnnotationLink", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAnnotationLink_StaticNew()
{
  return vtkAnnotationLink::New();
}

PyObject *PyvtkAnnotationLink_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAnnotationLink_Type, PyvtkAnnotationLink_Methods,
    "vtkAnnotationLink",
    PyvtkAnnotationLink_Doc(), &PyvtkAnnotationLink_StaticNew);

  PyTypeObject *pytype = &PyvtkAnnotationLink_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAnnotationLayersAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAnnotationLink_Doc()
{
  static const char *docstring[] = {
    "vtkAnnotationLink - An algorithm for linking annotations among objects\n\n",
    "Superclass: vtkAnnotationLayersAlgorithm\n\n",
    "vtkAnnotationLink is a simple source filter which outputs the\nvtkAnnotationLayers object stored internally.  Multiple objects may\nshare the same annotation link filter and connect it to an internal\npipeline so that if one object changes the annotation set, it will be\npulled into all the other objects when their pipelines update.\n\nThe shared vtkAnnotationLayers object (a collection of annotations)\n",
    "is shallow copied to output port 0.\n\nvtkAnnotationLink can also store a set of domain maps. A domain map\nis simply a table associating values between domains. The domain of\neach column is defined by the array name of the column. The domain\nmaps are sent to a multi-block dataset in output port 1.\n\nOutput ports 0 and 1 can be set as input ports 0 and 1 to\nvtkConvertSelectionDomain, which can use the",
    " domain maps to convert\nthe domains of selections in the vtkAnnotationLayers to match a\nparticular data object (set as port 2 on vtkConvertSelectionDomain).\n\nThe shared vtkAnnotationLayers object also stores a \"current\nselection\" normally interpreted as the interactive selection of an\napplication. As a convenience, this selection is sent to output port\n2 so that it can be connected to pipelines re",
    "quiring a vtkSelection.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAnnotationLink(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAnnotationLink_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAnnotationLink", o) != 0)
  {
    Py_DECREF(o);
  }

}

