// python wrapper for vtkCellTypeSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCellTypeSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCellTypeSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCellTypeSource_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkCellTypeSource_Doc();


static PyObject *
PyvtkCellTypeSource_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCellTypeSource::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCellTypeSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCellTypeSource *tempr = vtkCellTypeSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCellTypeSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCellTypeSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_SetCellType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCellType(temp0);
    }
    else
    {
      op->vtkCellTypeSource::SetCellType(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetCellType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCellType() :
      op->vtkCellTypeSource::GetCellType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_SetPolynomialFieldOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPolynomialFieldOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPolynomialFieldOrder(temp0);
    }
    else
    {
      op->vtkCellTypeSource::SetPolynomialFieldOrder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetPolynomialFieldOrderMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolynomialFieldOrderMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPolynomialFieldOrderMinValue() :
      op->vtkCellTypeSource::GetPolynomialFieldOrderMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetPolynomialFieldOrderMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolynomialFieldOrderMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPolynomialFieldOrderMaxValue() :
      op->vtkCellTypeSource::GetPolynomialFieldOrderMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetPolynomialFieldOrder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPolynomialFieldOrder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPolynomialFieldOrder() :
      op->vtkCellTypeSource::GetPolynomialFieldOrder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetCellDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCellDimension() :
      op->vtkCellTypeSource::GetCellDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_SetOutputPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutputPrecision(temp0);
    }
    else
    {
      op->vtkCellTypeSource::SetOutputPrecision(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetOutputPrecisionMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPrecisionMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPrecisionMinValue() :
      op->vtkCellTypeSource::GetOutputPrecisionMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetOutputPrecisionMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPrecisionMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPrecisionMaxValue() :
      op->vtkCellTypeSource::GetOutputPrecisionMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_GetOutputPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPrecision() :
      op->vtkCellTypeSource::GetOutputPrecision());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCellTypeSource_SetBlocksDimensions_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBlocksDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(2*size0);
  int *temp0 = store0.Data();
  int *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->SetBlocksDimensions(temp0);
    }
    else
    {
      op->vtkCellTypeSource::SetBlocksDimensions(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkCellTypeSource_SetBlocksDimensions_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBlocksDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetBlocksDimensions(temp0, temp1, temp2);
    }
    else
    {
      op->vtkCellTypeSource::SetBlocksDimensions(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkCellTypeSource_SetBlocksDimensions(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkCellTypeSource_SetBlocksDimensions_s1(self, args);
    case 3:
      return PyvtkCellTypeSource_SetBlocksDimensions_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetBlocksDimensions");
  return NULL;
}



static PyObject *
PyvtkCellTypeSource_GetBlocksDimensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBlocksDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCellTypeSource *op = static_cast<vtkCellTypeSource *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetBlocksDimensions() :
      op->vtkCellTypeSource::GetBlocksDimensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}

static PyMethodDef PyvtkCellTypeSource_Methods[] = {
  {"IsTypeOf", PyvtkCellTypeSource_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nStandard methods for instantiation, obtaining type and printing\ninstance values.\n"},
  {"IsA", PyvtkCellTypeSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nStandard methods for instantiation, obtaining type and printing\ninstance values.\n"},
  {"SafeDownCast", PyvtkCellTypeSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkCellTypeSource\nC++: static vtkCellTypeSource *SafeDownCast(vtkObjectBase *o)\n\nStandard methods for instantiation, obtaining type and printing\ninstance values.\n"},
  {"NewInstance", PyvtkCellTypeSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCellTypeSource\nC++: vtkCellTypeSource *NewInstance()\n\nStandard methods for instantiation, obtaining type and printing\ninstance values.\n"},
  {"SetCellType", PyvtkCellTypeSource_SetCellType, METH_VARARGS,
   "V.SetCellType(int)\nC++: void SetCellType(int cellType)\n\nSet/Get the type of cells to be generated.\n"},
  {"GetCellType", PyvtkCellTypeSource_GetCellType, METH_VARARGS,
   "V.GetCellType() -> int\nC++: virtual int GetCellType()\n\nSet/Get the type of cells to be generated.\n"},
  {"SetPolynomialFieldOrder", PyvtkCellTypeSource_SetPolynomialFieldOrder, METH_VARARGS,
   "V.SetPolynomialFieldOrder(int)\nC++: virtual void SetPolynomialFieldOrder(int _arg)\n\nSet/Get the polynomial order of the \"Polynomial\" point field. The\ndefault is 1.\n"},
  {"GetPolynomialFieldOrderMinValue", PyvtkCellTypeSource_GetPolynomialFieldOrderMinValue, METH_VARARGS,
   "V.GetPolynomialFieldOrderMinValue() -> int\nC++: virtual int GetPolynomialFieldOrderMinValue()\n\nSet/Get the polynomial order of the \"Polynomial\" point field. The\ndefault is 1.\n"},
  {"GetPolynomialFieldOrderMaxValue", PyvtkCellTypeSource_GetPolynomialFieldOrderMaxValue, METH_VARARGS,
   "V.GetPolynomialFieldOrderMaxValue() -> int\nC++: virtual int GetPolynomialFieldOrderMaxValue()\n\nSet/Get the polynomial order of the \"Polynomial\" point field. The\ndefault is 1.\n"},
  {"GetPolynomialFieldOrder", PyvtkCellTypeSource_GetPolynomialFieldOrder, METH_VARARGS,
   "V.GetPolynomialFieldOrder() -> int\nC++: virtual int GetPolynomialFieldOrder()\n\nSet/Get the polynomial order of the \"Polynomial\" point field. The\ndefault is 1.\n"},
  {"GetCellDimension", PyvtkCellTypeSource_GetCellDimension, METH_VARARGS,
   "V.GetCellDimension() -> int\nC++: int GetCellDimension()\n\nGet the dimension of the cell blocks to be generated\n"},
  {"SetOutputPrecision", PyvtkCellTypeSource_SetOutputPrecision, METH_VARARGS,
   "V.SetOutputPrecision(int)\nC++: virtual void SetOutputPrecision(int _arg)\n\nSet/get the desired precision for the output points.\nvtkAlgorithm::SINGLE_PRECISION (0) - Output single-precision\nfloating point. vtkAlgorithm::DOUBLE_PRECISION (1) - Output\ndouble-precision floating point.\n"},
  {"GetOutputPrecisionMinValue", PyvtkCellTypeSource_GetOutputPrecisionMinValue, METH_VARARGS,
   "V.GetOutputPrecisionMinValue() -> int\nC++: virtual int GetOutputPrecisionMinValue()\n\nSet/get the desired precision for the output points.\nvtkAlgorithm::SINGLE_PRECISION (0) - Output single-precision\nfloating point. vtkAlgorithm::DOUBLE_PRECISION (1) - Output\ndouble-precision floating point.\n"},
  {"GetOutputPrecisionMaxValue", PyvtkCellTypeSource_GetOutputPrecisionMaxValue, METH_VARARGS,
   "V.GetOutputPrecisionMaxValue() -> int\nC++: virtual int GetOutputPrecisionMaxValue()\n\nSet/get the desired precision for the output points.\nvtkAlgorithm::SINGLE_PRECISION (0) - Output single-precision\nfloating point. vtkAlgorithm::DOUBLE_PRECISION (1) - Output\ndouble-precision floating point.\n"},
  {"GetOutputPrecision", PyvtkCellTypeSource_GetOutputPrecision, METH_VARARGS,
   "V.GetOutputPrecision() -> int\nC++: virtual int GetOutputPrecision()\n\nSet/get the desired precision for the output points.\nvtkAlgorithm::SINGLE_PRECISION (0) - Output single-precision\nfloating point. vtkAlgorithm::DOUBLE_PRECISION (1) - Output\ndouble-precision floating point.\n"},
  {"SetBlocksDimensions", PyvtkCellTypeSource_SetBlocksDimensions, METH_VARARGS,
   "V.SetBlocksDimensions([int, ...])\nC++: void SetBlocksDimensions(int *)\nV.SetBlocksDimensions(int, int, int)\nC++: void SetBlocksDimensions(int, int, int)\n\nSet the number of cells in each direction. If a 1D cell type is\nselected then only the first dimension is used and if a 2D cell\ntype is selected then the first and second dimensions are used.\nDefault is (1, 1, 1), which results in a single block of cells.\n"},
  {"GetBlocksDimensions", PyvtkCellTypeSource_GetBlocksDimensions, METH_VARARGS,
   "V.GetBlocksDimensions() -> (int, int, int)\nC++: int *GetBlocksDimensions()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCellTypeSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSourcesPython.vtkCellTypeSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCellTypeSource_StaticNew()
{
  return vtkCellTypeSource::New();
}

PyObject *PyvtkCellTypeSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCellTypeSource_Type, PyvtkCellTypeSource_Methods,
    "vtkCellTypeSource",
    PyvtkCellTypeSource_Doc(), &PyvtkCellTypeSource_StaticNew);

  PyTypeObject *pytype = &PyvtkCellTypeSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCellTypeSource_Doc()
{
  static const char *docstring[] = {
    "vtkCellTypeSource - Create cells of a given type\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "vtkCellTypeSource is a source object that creates cells of the given\ninput type. BlocksDimensions specifies the number of cell \"blocks\" in\neach direction. A cell block may be divided into multiple cells based\non the chosen cell type (e.g. 6 pyramid cells make up a single cell\nblock). If a 1D cell is selected then only the first dimension is\nused to specify how many cells are generated. If a 2D cel",
    "l is\nselected then only the first and second dimensions are used to\ndetermine how many cells are created. The source respects pieces.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCellTypeSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCellTypeSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCellTypeSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

