// python wrapper for vtkCinemaDatabase
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkCinemaDatabase.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCinemaDatabase(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCinemaDatabase_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkCinemaDatabase_Doc();


static PyObject *
PyvtkCinemaDatabase_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCinemaDatabase::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCinemaDatabase::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCinemaDatabase *tempr = vtkCinemaDatabase::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCinemaDatabase *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCinemaDatabase::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_Load(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Load");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->Load(temp0) :
      op->vtkCinemaDatabase::Load(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_GetPipelineObjectVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPipelineObjectVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetPipelineObjectVisibility(temp0) :
      op->vtkCinemaDatabase::GetPipelineObjectVisibility(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_GetFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetFieldName(temp0) :
      op->vtkCinemaDatabase::GetFieldName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaDatabase_GetFieldValueRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFieldValueRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaDatabase *op = static_cast<vtkCinemaDatabase *>(vp);

  std::string temp0;
  std::string temp1;
  const int size2 = 2;
  double temp2[2];
  double save2[2];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.SaveArray(temp2, save2, size2);

    bool tempr = (ap.IsBound() ?
      op->GetFieldValueRange(temp0, temp1, temp2) :
      op->vtkCinemaDatabase::GetFieldValueRange(temp0, temp1, temp2));

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCinemaDatabase_Methods[] = {
  {"IsTypeOf", PyvtkCinemaDatabase_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkCinemaDatabase_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkCinemaDatabase_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkCinemaDatabase\nC++: static vtkCinemaDatabase *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkCinemaDatabase_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCinemaDatabase\nC++: vtkCinemaDatabase *NewInstance()\n\n"},
  {"Load", PyvtkCinemaDatabase_Load, METH_VARARGS,
   "V.Load(string) -> bool\nC++: bool Load(const char *fname)\n\nLoads the cinema database.\n@param[in] fname path to the `info.json` file corresponding to a\n    Cinema store.\n@returns true on success\n"},
  {"GetPipelineObjectVisibility", PyvtkCinemaDatabase_GetPipelineObjectVisibility, METH_VARARGS,
   "V.GetPipelineObjectVisibility(string) -> bool\nC++: bool GetPipelineObjectVisibility(\n    const std::string &objectname)\n\nReturns a pipeline objects default visibility, as recorded in the\ndatabase.\n"},
  {"GetFieldName", PyvtkCinemaDatabase_GetFieldName, METH_VARARGS,
   "V.GetFieldName(string) -> string\nC++: std::string GetFieldName(const std::string &objectname)\n\nGet the name for the field associated with the object.\n`GetFieldValues` will returns values for this field.\n"},
  {"GetFieldValueRange", PyvtkCinemaDatabase_GetFieldValueRange, METH_VARARGS,
   "V.GetFieldValueRange(string, string, [float, float]) -> bool\nC++: bool GetFieldValueRange(const std::string &objectname,\n    const std::string &fieldvalue, double range[2])\n\nGets the range for a field value.\n@param[in] objectname name of the pipeline object\n@param[in] fieldvalue name of the field value\n@param[out] range range for the field value\n@returns true if range was available.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCinemaDatabase_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCinemaReaderPython.vtkCinemaDatabase", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCinemaDatabase_StaticNew()
{
  return vtkCinemaDatabase::New();
}

PyObject *PyvtkCinemaDatabase_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCinemaDatabase_Type, PyvtkCinemaDatabase_Methods,
    "vtkCinemaDatabase",
    PyvtkCinemaDatabase_Doc(), &PyvtkCinemaDatabase_StaticNew);

  PyTypeObject *pytype = &PyvtkCinemaDatabase_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCinemaDatabase_Doc()
{
  static const char *docstring[] = {
    "vtkCinemaDatabase - class that provides access to\n`cinema_python.database.file_store`\n\n",
    "Superclass: vtkObject\n\n",
    "API.\n\nvtkCinemaDatabase is an abstraction that provides access to a\n`cinema_python.database.file_store.FileStore` instance. The API is\nlimited to the functionality needed for the rendering Cinema layers\nin\n ParaView.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCinemaDatabase(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCinemaDatabase_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCinemaDatabase", o) != 0)
  {
    Py_DECREF(o);
  }

}

