// python wrapper for vtkDashedStreamLine
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDashedStreamLine.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDashedStreamLine(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDashedStreamLine_ClassNew(); }

#ifndef DECLARED_PyvtkStreamLine_ClassNew
extern "C" { PyObject *PyvtkStreamLine_ClassNew(); }
#define DECLARED_PyvtkStreamLine_ClassNew
#endif

static const char **PyvtkDashedStreamLine_Doc();


static PyObject *
PyvtkDashedStreamLine_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDashedStreamLine::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDashedStreamLine::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDashedStreamLine *tempr = vtkDashedStreamLine::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDashedStreamLine *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDashedStreamLine::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_SetDashFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDashFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDashFactor(temp0);
    }
    else
    {
      op->vtkDashedStreamLine::SetDashFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_GetDashFactorMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDashFactorMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDashFactorMinValue() :
      op->vtkDashedStreamLine::GetDashFactorMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_GetDashFactorMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDashFactorMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDashFactorMaxValue() :
      op->vtkDashedStreamLine::GetDashFactorMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDashedStreamLine_GetDashFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDashFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDashedStreamLine *op = static_cast<vtkDashedStreamLine *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDashFactor() :
      op->vtkDashedStreamLine::GetDashFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDashedStreamLine_Methods[] = {
  {"IsTypeOf", PyvtkDashedStreamLine_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkDashedStreamLine_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkDashedStreamLine_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkDashedStreamLine\nC++: static vtkDashedStreamLine *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDashedStreamLine_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDashedStreamLine\nC++: vtkDashedStreamLine *NewInstance()\n\n"},
  {"SetDashFactor", PyvtkDashedStreamLine_SetDashFactor, METH_VARARGS,
   "V.SetDashFactor(float)\nC++: virtual void SetDashFactor(double _arg)\n\nFor each dash, specify the fraction of the dash that is \"on\". A\nfactor of 1.0 will result in a continuous line, a factor of 0.5\nwill result in dashed that are half on and half off.\n"},
  {"GetDashFactorMinValue", PyvtkDashedStreamLine_GetDashFactorMinValue, METH_VARARGS,
   "V.GetDashFactorMinValue() -> float\nC++: virtual double GetDashFactorMinValue()\n\nFor each dash, specify the fraction of the dash that is \"on\". A\nfactor of 1.0 will result in a continuous line, a factor of 0.5\nwill result in dashed that are half on and half off.\n"},
  {"GetDashFactorMaxValue", PyvtkDashedStreamLine_GetDashFactorMaxValue, METH_VARARGS,
   "V.GetDashFactorMaxValue() -> float\nC++: virtual double GetDashFactorMaxValue()\n\nFor each dash, specify the fraction of the dash that is \"on\". A\nfactor of 1.0 will result in a continuous line, a factor of 0.5\nwill result in dashed that are half on and half off.\n"},
  {"GetDashFactor", PyvtkDashedStreamLine_GetDashFactor, METH_VARARGS,
   "V.GetDashFactor() -> float\nC++: virtual double GetDashFactor()\n\nFor each dash, specify the fraction of the dash that is \"on\". A\nfactor of 1.0 will result in a continuous line, a factor of 0.5\nwill result in dashed that are half on and half off.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDashedStreamLine_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersFlowPathsPython.vtkDashedStreamLine", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDashedStreamLine_StaticNew()
{
  return vtkDashedStreamLine::New();
}

PyObject *PyvtkDashedStreamLine_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDashedStreamLine_Type, PyvtkDashedStreamLine_Methods,
    "vtkDashedStreamLine",
    PyvtkDashedStreamLine_Doc(), &PyvtkDashedStreamLine_StaticNew);

  PyTypeObject *pytype = &PyvtkDashedStreamLine_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStreamLine_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDashedStreamLine_Doc()
{
  static const char *docstring[] = {
    "vtkDashedStreamLine - generate constant-time dashed streamline in\narbitrary dataset\n\n",
    "Superclass: vtkStreamLine\n\n",
    "vtkDashedStreamLine is a filter that generates a \"dashed\" streamline\nfor an arbitrary dataset. The streamline consists of a series of\ndashes, each of which represents (approximately) a constant time\nincrement. Thus, in the resulting visual representation, relatively\nlong dashes represent areas of high velocity, and small dashes\nrepresent areas of low velocity.\n\nvtkDashedStreamLine introduces the i",
    "nstance variable DashFactor.\nDashFactor interacts with its superclass' instance variable\nStepLength to create the dashes. DashFactor is the percentage of the\nStepLength line segment that is visible. Thus, if the\nDashFactor=0.75, the dashes will be \"three-quarters on\" and \"one-quarter\noff\".\n\n@sa\nvtkStreamer vtkStreamLine vtkStreamPoints\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDashedStreamLine(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDashedStreamLine_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDashedStreamLine", o) != 0)
  {
    Py_DECREF(o);
  }

}

