// python wrapper for vtkExtractTimeSteps
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkExtractTimeSteps.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkExtractTimeSteps(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkExtractTimeSteps_ClassNew(); }

#ifndef DECLARED_PyvtkPassInputTypeAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPassInputTypeAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPassInputTypeAlgorithm_ClassNew
#endif

static const char **PyvtkExtractTimeSteps_Doc();


static PyObject *
PyvtkExtractTimeSteps_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkExtractTimeSteps::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkExtractTimeSteps::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkExtractTimeSteps *tempr = vtkExtractTimeSteps::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkExtractTimeSteps *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkExtractTimeSteps::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetNumberOfTimeSteps(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTimeSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfTimeSteps() :
      op->vtkExtractTimeSteps::GetNumberOfTimeSteps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_AddTimeStepIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddTimeStepIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->AddTimeStepIndex(temp0);
    }
    else
    {
      op->vtkExtractTimeSteps::AddTimeStepIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_SetTimeStepIndices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeStepIndices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int temp0;
  int size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<int> store1(size1);
  int *temp1 = store1.Data();
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->SetTimeStepIndices(temp0, temp1);
    }
    else
    {
      op->vtkExtractTimeSteps::SetTimeStepIndices(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetTimeStepIndices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepIndices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(2*size0);
  int *temp0 = store0.Data();
  int *save0 = (size0 == 0 ? NULL : temp0 + size0);
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    if (ap.IsBound())
    {
      op->GetTimeStepIndices(temp0);
    }
    else
    {
      op->vtkExtractTimeSteps::GetTimeStepIndices(temp0);
    }

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GenerateTimeStepIndices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GenerateTimeStepIndices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->GenerateTimeStepIndices(temp0, temp1, temp2);
    }
    else
    {
      op->vtkExtractTimeSteps::GenerateTimeStepIndices(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_ClearTimeStepIndices(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearTimeStepIndices");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearTimeStepIndices();
    }
    else
    {
      op->vtkExtractTimeSteps::ClearTimeStepIndices();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetUseRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseRange() :
      op->vtkExtractTimeSteps::GetUseRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_SetUseRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseRange(temp0);
    }
    else
    {
      op->vtkExtractTimeSteps::SetUseRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_UseRangeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseRangeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseRangeOn();
    }
    else
    {
      op->vtkExtractTimeSteps::UseRangeOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_UseRangeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseRangeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseRangeOff();
    }
    else
    {
      op->vtkExtractTimeSteps::UseRangeOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetRange() :
      op->vtkExtractTimeSteps::GetRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_SetRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetRange(temp0, temp1);
    }
    else
    {
      op->vtkExtractTimeSteps::SetRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkExtractTimeSteps_SetRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  const int size0 = 2;
  int temp0[2];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetRange(temp0);
    }
    else
    {
      op->vtkExtractTimeSteps::SetRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkExtractTimeSteps_SetRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkExtractTimeSteps_SetRange_s1(self, args);
    case 1:
      return PyvtkExtractTimeSteps_SetRange_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetRange");
  return NULL;
}



static PyObject *
PyvtkExtractTimeSteps_GetTimeStepInterval(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepInterval");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeStepInterval() :
      op->vtkExtractTimeSteps::GetTimeStepInterval());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_SetTimeStepInterval(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTimeStepInterval");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTimeStepInterval(temp0);
    }
    else
    {
      op->vtkExtractTimeSteps::SetTimeStepInterval(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetTimeStepIntervalMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepIntervalMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeStepIntervalMinValue() :
      op->vtkExtractTimeSteps::GetTimeStepIntervalMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractTimeSteps_GetTimeStepIntervalMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepIntervalMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractTimeSteps *op = static_cast<vtkExtractTimeSteps *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTimeStepIntervalMaxValue() :
      op->vtkExtractTimeSteps::GetTimeStepIntervalMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkExtractTimeSteps_Methods[] = {
  {"IsTypeOf", PyvtkExtractTimeSteps_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkExtractTimeSteps_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkExtractTimeSteps_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkExtractTimeSteps\nC++: static vtkExtractTimeSteps *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkExtractTimeSteps_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkExtractTimeSteps\nC++: vtkExtractTimeSteps *NewInstance()\n\n"},
  {"GetNumberOfTimeSteps", PyvtkExtractTimeSteps_GetNumberOfTimeSteps, METH_VARARGS,
   "V.GetNumberOfTimeSteps() -> int\nC++: int GetNumberOfTimeSteps()\n\nGet the number of time steps that will be extracted\n"},
  {"AddTimeStepIndex", PyvtkExtractTimeSteps_AddTimeStepIndex, METH_VARARGS,
   "V.AddTimeStepIndex(int)\nC++: void AddTimeStepIndex(int timeStepIndex)\n\nAdd a time step index. Not added if the index already exists.\n"},
  {"SetTimeStepIndices", PyvtkExtractTimeSteps_SetTimeStepIndices, METH_VARARGS,
   "V.SetTimeStepIndices(int, (int, ...))\nC++: void SetTimeStepIndices(int count,\n    const int *timeStepIndices)\n\nGet/Set an array of time step indices. For the Get function,\ntimeStepIndices should be big enough for GetNumberOfTimeSteps()\nvalues.\n"},
  {"GetTimeStepIndices", PyvtkExtractTimeSteps_GetTimeStepIndices, METH_VARARGS,
   "V.GetTimeStepIndices([int, ...])\nC++: void GetTimeStepIndices(int *timeStepIndices)\n\nGet/Set an array of time step indices. For the Get function,\ntimeStepIndices should be big enough for GetNumberOfTimeSteps()\nvalues.\n"},
  {"GenerateTimeStepIndices", PyvtkExtractTimeSteps_GenerateTimeStepIndices, METH_VARARGS,
   "V.GenerateTimeStepIndices(int, int, int)\nC++: void GenerateTimeStepIndices(int begin, int end, int step)\n\nGenerate a range of indices in [begin, end) with a step size of\n'step'\n"},
  {"ClearTimeStepIndices", PyvtkExtractTimeSteps_ClearTimeStepIndices, METH_VARARGS,
   "V.ClearTimeStepIndices()\nC++: void ClearTimeStepIndices()\n\nClear the time step indices\n"},
  {"GetUseRange", PyvtkExtractTimeSteps_GetUseRange, METH_VARARGS,
   "V.GetUseRange() -> bool\nC++: virtual bool GetUseRange()\n\nGet/Set whether to extract a range of timesteps.  When false,\nextracts the time steps explicitly set with SetTimeStepIndices. \nDefaults to false.\n"},
  {"SetUseRange", PyvtkExtractTimeSteps_SetUseRange, METH_VARARGS,
   "V.SetUseRange(bool)\nC++: virtual void SetUseRange(bool _arg)\n\nGet/Set whether to extract a range of timesteps.  When false,\nextracts the time steps explicitly set with SetTimeStepIndices. \nDefaults to false.\n"},
  {"UseRangeOn", PyvtkExtractTimeSteps_UseRangeOn, METH_VARARGS,
   "V.UseRangeOn()\nC++: virtual void UseRangeOn()\n\nGet/Set whether to extract a range of timesteps.  When false,\nextracts the time steps explicitly set with SetTimeStepIndices. \nDefaults to false.\n"},
  {"UseRangeOff", PyvtkExtractTimeSteps_UseRangeOff, METH_VARARGS,
   "V.UseRangeOff()\nC++: virtual void UseRangeOff()\n\nGet/Set whether to extract a range of timesteps.  When false,\nextracts the time steps explicitly set with SetTimeStepIndices. \nDefaults to false.\n"},
  {"GetRange", PyvtkExtractTimeSteps_GetRange, METH_VARARGS,
   "V.GetRange() -> (int, int)\nC++: int *GetRange()\n\n"},
  {"SetRange", PyvtkExtractTimeSteps_SetRange, METH_VARARGS,
   "V.SetRange(int, int)\nC++: void SetRange(int, int)\nV.SetRange((int, int))\nC++: void SetRange(int a[2])\n\n"},
  {"GetTimeStepInterval", PyvtkExtractTimeSteps_GetTimeStepInterval, METH_VARARGS,
   "V.GetTimeStepInterval() -> int\nC++: virtual int GetTimeStepInterval()\n\nGet/Set the time step interval to extract.  This is the N in\n'extract every Nth timestep in this range'.  Default to 1 or\n'extract all timesteps in this range.\n"},
  {"SetTimeStepInterval", PyvtkExtractTimeSteps_SetTimeStepInterval, METH_VARARGS,
   "V.SetTimeStepInterval(int)\nC++: virtual void SetTimeStepInterval(int _arg)\n\nGet/Set the time step interval to extract.  This is the N in\n'extract every Nth timestep in this range'.  Default to 1 or\n'extract all timesteps in this range.\n"},
  {"GetTimeStepIntervalMinValue", PyvtkExtractTimeSteps_GetTimeStepIntervalMinValue, METH_VARARGS,
   "V.GetTimeStepIntervalMinValue() -> int\nC++: virtual int GetTimeStepIntervalMinValue()\n\nGet/Set the time step interval to extract.  This is the N in\n'extract every Nth timestep in this range'.  Default to 1 or\n'extract all timesteps in this range.\n"},
  {"GetTimeStepIntervalMaxValue", PyvtkExtractTimeSteps_GetTimeStepIntervalMaxValue, METH_VARARGS,
   "V.GetTimeStepIntervalMaxValue() -> int\nC++: virtual int GetTimeStepIntervalMaxValue()\n\nGet/Set the time step interval to extract.  This is the N in\n'extract every Nth timestep in this range'.  Default to 1 or\n'extract all timesteps in this range.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkExtractTimeSteps_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersExtractionPython.vtkExtractTimeSteps", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkExtractTimeSteps_StaticNew()
{
  return vtkExtractTimeSteps::New();
}

PyObject *PyvtkExtractTimeSteps_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkExtractTimeSteps_Type, PyvtkExtractTimeSteps_Methods,
    "vtkExtractTimeSteps",
    PyvtkExtractTimeSteps_Doc(), &PyvtkExtractTimeSteps_StaticNew);

  PyTypeObject *pytype = &PyvtkExtractTimeSteps_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPassInputTypeAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkExtractTimeSteps_Doc()
{
  static const char *docstring[] = {
    "vtkExtractTimeSteps - extract specific time-steps from dataset\n\n",
    "Superclass: vtkPassInputTypeAlgorithm\n\n",
    "vtkExtractTimeSteps extracts the specified time steps from the input\ndataset. It has two modes, one to specify timesteps explicitly by\ntheir indices and one to specify a range of timesteps to extract.\n\nWhen specifying timesteps explicitly the timesteps to be extracted\nare specified by their indices. If no time step is specified, all of\nthe input time steps are extracted.\n\nWhen specifying a range, ",
    "the beginning and end times are specified\nand the timesteps in between are extracted.  This can be modified by\nthe TimeStepInterval property that sets the filter to extract every\nNth timestep.\n\nThis filter is useful when one wants to work with only a sub-set of\nthe input time steps.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkExtractTimeSteps(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkExtractTimeSteps_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkExtractTimeSteps", o) != 0)
  {
    Py_DECREF(o);
  }

}

