// python wrapper for vtkFileSequenceParser
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkFileSequenceParser.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkFileSequenceParser(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkFileSequenceParser_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkFileSequenceParser_Doc();


static PyObject *
PyvtkFileSequenceParser_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkFileSequenceParser::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFileSequenceParser *op = static_cast<vtkFileSequenceParser *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkFileSequenceParser::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkFileSequenceParser *tempr = vtkFileSequenceParser::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFileSequenceParser *op = static_cast<vtkFileSequenceParser *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkFileSequenceParser *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkFileSequenceParser::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_ParseFileSequence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ParseFileSequence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFileSequenceParser *op = static_cast<vtkFileSequenceParser *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->ParseFileSequence(temp0) :
      op->vtkFileSequenceParser::ParseFileSequence(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_GetSequenceName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSequenceName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFileSequenceParser *op = static_cast<vtkFileSequenceParser *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetSequenceName() :
      op->vtkFileSequenceParser::GetSequenceName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFileSequenceParser_GetSequenceIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSequenceIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFileSequenceParser *op = static_cast<vtkFileSequenceParser *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSequenceIndex() :
      op->vtkFileSequenceParser::GetSequenceIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkFileSequenceParser_Methods[] = {
  {"IsTypeOf", PyvtkFileSequenceParser_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkFileSequenceParser_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkFileSequenceParser_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkFileSequenceParser\nC++: static vtkFileSequenceParser *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkFileSequenceParser_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkFileSequenceParser\nC++: vtkFileSequenceParser *NewInstance()\n\n"},
  {"ParseFileSequence", PyvtkFileSequenceParser_ParseFileSequence, METH_VARARGS,
   "V.ParseFileSequence(string) -> bool\nC++: bool ParseFileSequence(const char *file)\n\nExtract base file name sequence from the file. Returns true if a\nsequence is detected and sets SequenceName and SequenceIndex.\n"},
  {"GetSequenceName", PyvtkFileSequenceParser_GetSequenceName, METH_VARARGS,
   "V.GetSequenceName() -> string\nC++: virtual char *GetSequenceName()\n\n"},
  {"GetSequenceIndex", PyvtkFileSequenceParser_GetSequenceIndex, METH_VARARGS,
   "V.GetSequenceIndex() -> int\nC++: virtual int GetSequenceIndex()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkFileSequenceParser_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkFileSequenceParser", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkFileSequenceParser_StaticNew()
{
  return vtkFileSequenceParser::New();
}

PyObject *PyvtkFileSequenceParser_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkFileSequenceParser_Type, PyvtkFileSequenceParser_Methods,
    "vtkFileSequenceParser",
    PyvtkFileSequenceParser_Doc(), &PyvtkFileSequenceParser_StaticNew);

  PyTypeObject *pytype = &PyvtkFileSequenceParser_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkFileSequenceParser_Doc()
{
  static const char *docstring[] = {
    "vtkFileSequenceParser - Parses out the base file name of a file\nsequence and also the specific index of the given file.\n\n",
    "Superclass: vtkObject\n\n",
    "Given a file name (without path). I will extract the base portion of\nthe file name that is common to all the files in the sequence. It\nwill also provide the current sequence index of the provided file\nname. by several vtkPVUpdateSuppressor objects.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkFileSequenceParser(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkFileSequenceParser_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkFileSequenceParser", o) != 0)
  {
    Py_DECREF(o);
  }

}

