// python wrapper for vtkIceTContext
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkIceTContext.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIceTContext(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkIceTContext_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkIceTContext_Doc();


static PyObject *
PyvtkIceTContext_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkIceTContext::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkIceTContext::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkIceTContext *tempr = vtkIceTContext::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIceTContext *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkIceTContext::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkIceTContext::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkIceTContext::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_MakeCurrent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MakeCurrent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MakeCurrent();
    }
    else
    {
      op->vtkIceTContext::MakeCurrent();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_GetUseOpenGL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseOpenGL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseOpenGL() :
      op->vtkIceTContext::GetUseOpenGL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_SetUseOpenGL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOpenGL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOpenGL(temp0);
    }
    else
    {
      op->vtkIceTContext::SetUseOpenGL(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_UseOpenGLOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOpenGLOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOpenGLOn();
    }
    else
    {
      op->vtkIceTContext::UseOpenGLOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_UseOpenGLOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOpenGLOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOpenGLOff();
    }
    else
    {
      op->vtkIceTContext::UseOpenGLOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_CopyState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  vtkIceTContext *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkIceTContext"))
  {
    if (ap.IsBound())
    {
      op->CopyState(temp0);
    }
    else
    {
      op->vtkIceTContext::CopyState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTContext_IsValid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTContext *op = static_cast<vtkIceTContext *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->IsValid() :
      op->vtkIceTContext::IsValid());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkIceTContext_Methods[] = {
  {"IsTypeOf", PyvtkIceTContext_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkIceTContext_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkIceTContext_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkIceTContext\nC++: static vtkIceTContext *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkIceTContext_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkIceTContext\nC++: vtkIceTContext *NewInstance()\n\n"},
  {"SetController", PyvtkIceTContext_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(\n    vtkMultiProcessController *controller)\n\nAssociate the context with the given controller.  Currently, this\nmust be a vtkMPIController.  The context is not valid until a\ncontroller is set.\n"},
  {"GetController", PyvtkIceTContext_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\nAssociate the context with the given controller.  Currently, this\nmust be a vtkMPIController.  The context is not valid until a\ncontroller is set.\n"},
  {"MakeCurrent", PyvtkIceTContext_MakeCurrent, METH_VARARGS,
   "V.MakeCurrent()\nC++: virtual void MakeCurrent()\n\nMake this context the current one.\n"},
  {"GetUseOpenGL", PyvtkIceTContext_GetUseOpenGL, METH_VARARGS,
   "V.GetUseOpenGL() -> int\nC++: virtual int GetUseOpenGL()\n\nTurn this on to enable the OpenGL layer in IceT.  By default this\nis off. Unless you explicitly plan to use the OpenGL layer, it\nshould probably remain off to ensure that you don't accidentally\nuse a feature you did not intend to use.\n"},
  {"SetUseOpenGL", PyvtkIceTContext_SetUseOpenGL, METH_VARARGS,
   "V.SetUseOpenGL(int)\nC++: virtual void SetUseOpenGL(int flag)\n\nTurn this on to enable the OpenGL layer in IceT.  By default this\nis off. Unless you explicitly plan to use the OpenGL layer, it\nshould probably remain off to ensure that you don't accidentally\nuse a feature you did not intend to use.\n"},
  {"UseOpenGLOn", PyvtkIceTContext_UseOpenGLOn, METH_VARARGS,
   "V.UseOpenGLOn()\nC++: virtual void UseOpenGLOn()\n\nTurn this on to enable the OpenGL layer in IceT.  By default this\nis off. Unless you explicitly plan to use the OpenGL layer, it\nshould probably remain off to ensure that you don't accidentally\nuse a feature you did not intend to use.\n"},
  {"UseOpenGLOff", PyvtkIceTContext_UseOpenGLOff, METH_VARARGS,
   "V.UseOpenGLOff()\nC++: virtual void UseOpenGLOff()\n\nTurn this on to enable the OpenGL layer in IceT.  By default this\nis off. Unless you explicitly plan to use the OpenGL layer, it\nshould probably remain off to ensure that you don't accidentally\nuse a feature you did not intend to use.\n"},
  {"CopyState", PyvtkIceTContext_CopyState, METH_VARARGS,
   "V.CopyState(vtkIceTContext)\nC++: virtual void CopyState(vtkIceTContext *src)\n\nCopy the state from the given context to this context.\n"},
  {"IsValid", PyvtkIceTContext_IsValid, METH_VARARGS,
   "V.IsValid() -> int\nC++: virtual int IsValid()\n\nReturns true if the current state is valid.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkIceTContext_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsRenderingPython.vtkIceTContext", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkIceTContext_StaticNew()
{
  return vtkIceTContext::New();
}

PyObject *PyvtkIceTContext_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkIceTContext_Type, PyvtkIceTContext_Methods,
    "vtkIceTContext",
    PyvtkIceTContext_Doc(), &PyvtkIceTContext_StaticNew);

  PyTypeObject *pytype = &PyvtkIceTContext_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkIceTContext_Doc()
{
  static const char *docstring[] = {
    "vtkIceTContext - This is a helper class for vtkIceTRenderManager and\nvtkOpenGLIceTRenderer.\n\n",
    "Superclass: vtkObject\n\n",
    "Most users will never need this class.\n\nThis class was conceived to pass IceT contexts between\nvtkIceTRenderManager and vtkOpenGLIceTRenderer without having to\ninclude the IceT header file in either class.  Along the way, some\nfunctionality was added.\n\n@bug If you set the communicator to NULL and then to a valid value,\nthe IceT state will be lost.\n\n@sa\nvtkIceTRenderManager\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkIceTContext(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIceTContext_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkIceTContext", o) != 0)
  {
    Py_DECREF(o);
  }

}

