// python wrapper for vtkIceTSynchronizedRenderers
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkIceTSynchronizedRenderers.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIceTSynchronizedRenderers(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkIceTSynchronizedRenderers_ClassNew(); }

#ifndef DECLARED_PyvtkSynchronizedRenderers_ClassNew
extern "C" { PyObject *PyvtkSynchronizedRenderers_ClassNew(); }
#define DECLARED_PyvtkSynchronizedRenderers_ClassNew
#endif

static const char **PyvtkIceTSynchronizedRenderers_Doc();


static PyObject *
PyvtkIceTSynchronizedRenderers_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkIceTSynchronizedRenderers::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkIceTSynchronizedRenderers::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkIceTSynchronizedRenderers *tempr = vtkIceTSynchronizedRenderers::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIceTSynchronizedRenderers *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkIceTSynchronizedRenderers::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetIdentifier(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetIdentifier");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetIdentifier(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetIdentifier(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_GetIdentifier(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIdentifier");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetIdentifier() :
      op->vtkIceTSynchronizedRenderers::GetIdentifier());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetRenderer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  vtkRenderer *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    if (ap.IsBound())
    {
      op->SetRenderer(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetRenderer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetTileDimensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTileDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetTileDimensions(temp0, temp1);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetTileDimensions(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetTileMullions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTileMullions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetTileMullions(temp0, temp1);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetTileMullions(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetDataReplicatedOnAllProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDataReplicatedOnAllProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDataReplicatedOnAllProcesses(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetDataReplicatedOnAllProcesses(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetPartitionOrdering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPartitionOrdering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  vtkPartitionOrderingInterface *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPartitionOrderingInterface"))
  {
    if (ap.IsBound())
    {
      op->SetPartitionOrdering(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetPartitionOrdering(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetUseOrderedCompositing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOrderedCompositing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOrderedCompositing(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetUseOrderedCompositing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetImageReductionFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImageReductionFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetImageReductionFactor(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetImageReductionFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_GetImageReductionFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageReductionFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetImageReductionFactor() :
      op->vtkIceTSynchronizedRenderers::GetImageReductionFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetParallelController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParallelController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetParallelController(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetParallelController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetImageProcessingPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetImageProcessingPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  vtkImageProcessingPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkImageProcessingPass"))
  {
    if (ap.IsBound())
    {
      op->SetImageProcessingPass(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetImageProcessingPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_GetImageProcessingPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetImageProcessingPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageProcessingPass *tempr = (ap.IsBound() ?
      op->GetImageProcessingPass() :
      op->vtkIceTSynchronizedRenderers::GetImageProcessingPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetUseDepthBuffer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseDepthBuffer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseDepthBuffer(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetUseDepthBuffer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetRenderEmptyImages(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderEmptyImages");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRenderEmptyImages(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetRenderEmptyImages(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_SetRenderPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  vtkRenderPass *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderPass"))
  {
    if (ap.IsBound())
    {
      op->SetRenderPass(temp0);
    }
    else
    {
      op->vtkIceTSynchronizedRenderers::SetRenderPass(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_GetRenderPass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRenderPass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderPass *tempr = (ap.IsBound() ?
      op->GetRenderPass() :
      op->vtkIceTSynchronizedRenderers::GetRenderPass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIceTSynchronizedRenderers_GetIceTCompositePass(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIceTCompositePass");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIceTSynchronizedRenderers *op = static_cast<vtkIceTSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIceTCompositePass *tempr = (ap.IsBound() ?
      op->GetIceTCompositePass() :
      op->vtkIceTSynchronizedRenderers::GetIceTCompositePass());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkIceTSynchronizedRenderers_Methods[] = {
  {"IsTypeOf", PyvtkIceTSynchronizedRenderers_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkIceTSynchronizedRenderers_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkIceTSynchronizedRenderers_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkIceTSynchronizedRenderers\nC++: static vtkIceTSynchronizedRenderers *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkIceTSynchronizedRenderers_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkIceTSynchronizedRenderers\nC++: vtkIceTSynchronizedRenderers *NewInstance()\n\n"},
  {"SetIdentifier", PyvtkIceTSynchronizedRenderers_SetIdentifier, METH_VARARGS,
   "V.SetIdentifier(int)\nC++: virtual void SetIdentifier(unsigned int _arg)\n\nIdentifier used to indentify the view to the\nvtkTileDisplayHelper.\n"},
  {"GetIdentifier", PyvtkIceTSynchronizedRenderers_GetIdentifier, METH_VARARGS,
   "V.GetIdentifier() -> int\nC++: virtual unsigned int GetIdentifier()\n\nIdentifier used to indentify the view to the\nvtkTileDisplayHelper.\n"},
  {"SetRenderer", PyvtkIceTSynchronizedRenderers_SetRenderer, METH_VARARGS,
   "V.SetRenderer(vtkRenderer)\nC++: virtual void SetRenderer(vtkRenderer *)\n\nSet the renderer to be synchronized by this instance. A\nvtkSynchronizedRenderers instance can be used to synchronize\nexactly 1 renderer on each processes. You can create multiple\ninstances on vtkSynchronizedRenderers to synchronize multiple\nrenderers.\n"},
  {"SetTileDimensions", PyvtkIceTSynchronizedRenderers_SetTileDimensions, METH_VARARGS,
   "V.SetTileDimensions(int, int)\nC++: void SetTileDimensions(int x, int y)\n\nSet the tile dimensions. Default is (1, 1). If any of the\ndimensions is > 1 then tile display mode is assumed.\n"},
  {"SetTileMullions", PyvtkIceTSynchronizedRenderers_SetTileMullions, METH_VARARGS,
   "V.SetTileMullions(int, int)\nC++: void SetTileMullions(int x, int y)\n\nSet the tile mullions. The mullions are measured in pixels. Use\nnegative numbers for overlap.\n"},
  {"SetDataReplicatedOnAllProcesses", PyvtkIceTSynchronizedRenderers_SetDataReplicatedOnAllProcesses, METH_VARARGS,
   "V.SetDataReplicatedOnAllProcesses(bool)\nC++: void SetDataReplicatedOnAllProcesses(bool val)\n\nSet to true if data is replicated on all processes. This will\nenable IceT to minimize communications since data is available on\nall process. Off by default.\n"},
  {"SetPartitionOrdering", PyvtkIceTSynchronizedRenderers_SetPartitionOrdering, METH_VARARGS,
   "V.SetPartitionOrdering(vtkPartitionOrderingInterface)\nC++: void SetPartitionOrdering(\n    vtkPartitionOrderingInterface *partitionOrdering)\n\npartition ordering that gives processes ordering. Initial value\nis a NULL pointer. This is used only when UseOrderedCompositing\nis true.\n"},
  {"SetUseOrderedCompositing", PyvtkIceTSynchronizedRenderers_SetUseOrderedCompositing, METH_VARARGS,
   "V.SetUseOrderedCompositing(bool)\nC++: void SetUseOrderedCompositing(bool uoc)\n\nSet this to true, if compositing must be done in a specific\norder. This is necessary when rendering volumes or translucent\ngeometries. When UseOrderedCompositing is set to true, it is\nexpected that the PartitionOrdering is set as well. The\nPartitionOrdering is used to decide the process-order for\ncompositing.\n"},
  {"SetImageReductionFactor", PyvtkIceTSynchronizedRenderers_SetImageReductionFactor, METH_VARARGS,
   "V.SetImageReductionFactor(int)\nC++: virtual void SetImageReductionFactor(int val)\n\nSet the image reduction factor. Overrides superclass\nimplementation.\n"},
  {"GetImageReductionFactor", PyvtkIceTSynchronizedRenderers_GetImageReductionFactor, METH_VARARGS,
   "V.GetImageReductionFactor() -> int\nC++: virtual int GetImageReductionFactor()\n\n"},
  {"SetParallelController", PyvtkIceTSynchronizedRenderers_SetParallelController, METH_VARARGS,
   "V.SetParallelController(vtkMultiProcessController)\nC++: virtual void SetParallelController(\n    vtkMultiProcessController *cont)\n\nSet the parallel message communicator. This is used to\ncommunicate among processes.\n"},
  {"SetImageProcessingPass", PyvtkIceTSynchronizedRenderers_SetImageProcessingPass, METH_VARARGS,
   "V.SetImageProcessingPass(vtkImageProcessingPass)\nC++: void SetImageProcessingPass(vtkImageProcessingPass *)\n\nGet/Set an image processing pass to process the rendered images.\n"},
  {"GetImageProcessingPass", PyvtkIceTSynchronizedRenderers_GetImageProcessingPass, METH_VARARGS,
   "V.GetImageProcessingPass() -> vtkImageProcessingPass\nC++: virtual vtkImageProcessingPass *GetImageProcessingPass()\n\nGet/Set an image processing pass to process the rendered images.\n"},
  {"SetUseDepthBuffer", PyvtkIceTSynchronizedRenderers_SetUseDepthBuffer, METH_VARARGS,
   "V.SetUseDepthBuffer(bool)\nC++: void SetUseDepthBuffer(bool)\n\nActivates or de-activated the use of Depth Buffer\n"},
  {"SetRenderEmptyImages", PyvtkIceTSynchronizedRenderers_SetRenderEmptyImages, METH_VARARGS,
   "V.SetRenderEmptyImages(bool)\nC++: void SetRenderEmptyImages(bool)\n\nEnable/Disable empty images optimization. Render empty images is\ndisabled by default. It may be needed if a painter needs to make\nMPI global collective communication.\n"},
  {"SetRenderPass", PyvtkIceTSynchronizedRenderers_SetRenderPass, METH_VARARGS,
   "V.SetRenderPass(vtkRenderPass)\nC++: void SetRenderPass(vtkRenderPass *)\n\nGet/Set geometry rendering pass. This pass is used to render the\ngeometry. If none specified then default rendering pipeline is\nused. This is typically the render-pass pipeline after the\nCameraPass. The CameraPass is setup by ParaView specially since\nParaView needs some customizations for multiviews/icet etc.\n"},
  {"GetRenderPass", PyvtkIceTSynchronizedRenderers_GetRenderPass, METH_VARARGS,
   "V.GetRenderPass() -> vtkRenderPass\nC++: virtual vtkRenderPass *GetRenderPass()\n\nGet/Set geometry rendering pass. This pass is used to render the\ngeometry. If none specified then default rendering pipeline is\nused. This is typically the render-pass pipeline after the\nCameraPass. The CameraPass is setup by ParaView specially since\nParaView needs some customizations for multiviews/icet etc.\n"},
  {"GetIceTCompositePass", PyvtkIceTSynchronizedRenderers_GetIceTCompositePass, METH_VARARGS,
   "V.GetIceTCompositePass() -> vtkIceTCompositePass\nC++: virtual vtkIceTCompositePass *GetIceTCompositePass()\n\nProvides access to the internal vtkIceTCompositePass. Only use\nthis if you know what you're doing.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkIceTSynchronizedRenderers_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkIceTSynchronizedRenderers", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkIceTSynchronizedRenderers_StaticNew()
{
  return vtkIceTSynchronizedRenderers::New();
}

PyObject *PyvtkIceTSynchronizedRenderers_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkIceTSynchronizedRenderers_Type, PyvtkIceTSynchronizedRenderers_Methods,
    "vtkIceTSynchronizedRenderers",
    PyvtkIceTSynchronizedRenderers_Doc(), &PyvtkIceTSynchronizedRenderers_StaticNew);

  PyTypeObject *pytype = &PyvtkIceTSynchronizedRenderers_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSynchronizedRenderers_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkIceTSynchronizedRenderers_Doc()
{
  static const char *docstring[] = {
    "vtkIceTSynchronizedRenderers - vtkSynchronizedRenderers subclass that\nuses IceT for parallel rendering and compositing.\n\n",
    "Superclass: vtkSynchronizedRenderers\n\n",
    "vtkIceTSynchronizedRenderers uses IceT (the Image Compositing Engine\nfor Tiles) for parallel rendering and compositing. This class simply\nuses vtkIceTCompositePass internally, even though this class is\ndesigned to be used with traditional renderers and not those using\nrender-passes. Note that this class internally does indeed leverage\nthe RenderPass mechanism to intercept render calls from a\nvtkRe",
    "nderer. In other words, if you are using render passes, you\nshould not use this class. Your render passes will  be overridden.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkIceTSynchronizedRenderers(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIceTSynchronizedRenderers_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkIceTSynchronizedRenderers", o) != 0)
  {
    Py_DECREF(o);
  }

}

