// python wrapper for vtkImagePointDataIterator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkImagePointDataIterator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImagePointDataIterator(PyObject *); }

static const char **PyvtkImagePointDataIterator_Doc();


static PyObject *
PyvtkImagePointDataIterator_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  vtkImageData *temp0 = NULL;
  int size1 = 0;
  int store1[6];
  int *temp1 = NULL;
  if (ap.GetArgSize(1) > 0)
  {
    size1 = 6;
    temp1 = store1;
  }
  vtkImageStencilData *temp2 = 0;
  vtkAlgorithm *temp3 = 0;
  int temp4 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 5) &&
      ap.GetVTKObject(temp0, "vtkImageData") &&
      (ap.NoArgsLeft() || ap.GetArray(temp1, size1)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp2, "vtkImageStencilData")) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp3, "vtkAlgorithm")) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    op->Initialize(temp0, temp1, temp2, temp3, temp4);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_NextSpan(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NextSpan");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->NextSpan();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_IsAtEnd(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsAtEnd");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsAtEnd();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_IsInStencil(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsInStencil");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->IsInStencil();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_GetIndex_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  const int size0 = 3;
  int temp0[3];
  int save0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    op->GetIndex(temp0);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkImagePointDataIterator_GetIndex_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const int *tempr = op->GetIndex();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}

static PyObject *
PyvtkImagePointDataIterator_GetIndex(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkImagePointDataIterator_GetIndex_s1(self, args);
    case 0:
      return PyvtkImagePointDataIterator_GetIndex_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetIndex");
  return NULL;
}



static PyObject *
PyvtkImagePointDataIterator_GetId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetId");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = op->GetId();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_SpanEndId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SpanEndId");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkImagePointDataIterator *op = static_cast<vtkImagePointDataIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = op->SpanEndId();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImagePointDataIterator_GetVoidPointer_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVoidPointer");

  vtkImageData *temp0 = NULL;
  vtkIdType temp1 = 0;
  int size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<int> store2(2*size2);
  int *temp2 = store2.Data();
  int *save2 = (size2 == 0 ? NULL : temp2 + size2);
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 3) &&
      ap.GetVTKObject(temp0, "vtkImageData") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetArray(temp2, size2)))
  {
    ap.SaveArray(temp2, save2, size2);

    void  *tempr = vtkImagePointDataIterator::GetVoidPointer(temp0, temp1, temp2);

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkImagePointDataIterator_GetVoidPointer_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetVoidPointer");

  vtkDataArray *temp0 = NULL;
  vtkIdType temp1 = 0;
  int size2 = ap.GetArgSize(2);
  vtkPythonArgs::Array<int> store2(2*size2);
  int *temp2 = store2.Data();
  int *save2 = (size2 == 0 ? NULL : temp2 + size2);
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 3) &&
      ap.GetVTKObject(temp0, "vtkDataArray") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetArray(temp2, size2)))
  {
    ap.SaveArray(temp2, save2, size2);

    void  *tempr = vtkImagePointDataIterator::GetVoidPointer(temp0, temp1, temp2);

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkImagePointDataIterator_GetVoidPointer_Methods[] = {
  {NULL, PyvtkImagePointDataIterator_GetVoidPointer_s1, METH_VARARGS | METH_STATIC,
   "V|kP *vtkImageData *i"},
  {NULL, PyvtkImagePointDataIterator_GetVoidPointer_s2, METH_VARARGS | METH_STATIC,
   "V|kP *vtkDataArray *i"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkImagePointDataIterator_GetVoidPointer(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkImagePointDataIterator_GetVoidPointer_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetVoidPointer");
  return NULL;
}


static PyMethodDef PyvtkImagePointDataIterator_Methods[] = {
  {"Initialize", PyvtkImagePointDataIterator_Initialize, METH_VARARGS,
   "V.Initialize(vtkImageData, (int, int, int, int, int, int),\n    vtkImageStencilData, vtkAlgorithm, int)\nC++: void Initialize(vtkImageData *image, const int extent[6]=0,\n    vtkImageStencilData *stencil=0, vtkAlgorithm *algorithm=0,\n    int threadId=0)\n\nInitialize an iterator.  See constructor for more details.\n"},
  {"NextSpan", PyvtkImagePointDataIterator_NextSpan, METH_VARARGS,
   "V.NextSpan()\nC++: void NextSpan()\n\nMove the iterator to the beginning of the next span. A span is a\ncontiguous region of the image over which nothing but the point\nId and the X index changes.\n"},
  {"IsAtEnd", PyvtkImagePointDataIterator_IsAtEnd, METH_VARARGS,
   "V.IsAtEnd() -> bool\nC++: bool IsAtEnd()\n\nTest if the iterator has completed iterating over the entire\nextent.\n"},
  {"IsInStencil", PyvtkImagePointDataIterator_IsInStencil, METH_VARARGS,
   "V.IsInStencil() -> bool\nC++: bool IsInStencil()\n\nCheck if the iterator is within the region specified by the\nstencil. This is updated when NextSpan() is called.\n"},
  {"GetIndex", PyvtkImagePointDataIterator_GetIndex, METH_VARARGS,
   "V.GetIndex([int, int, int])\nC++: void GetIndex(int result[3])\nV.GetIndex() -> (int, int, int)\nC++: const int *GetIndex()\n\nGet the index at the beginning of the current span.\n"},
  {"GetId", PyvtkImagePointDataIterator_GetId, METH_VARARGS,
   "V.GetId() -> int\nC++: vtkIdType GetId()\n\nGet the point Id at the beginning of the current span.\n"},
  {"SpanEndId", PyvtkImagePointDataIterator_SpanEndId, METH_VARARGS,
   "V.SpanEndId() -> int\nC++: vtkIdType SpanEndId()\n\nGet the end of the span.\n"},
  {"GetVoidPointer", PyvtkImagePointDataIterator_GetVoidPointer, METH_VARARGS,
   "V.GetVoidPointer(vtkImageData, int, [int, ...]) -> void\nC++: static void *GetVoidPointer(vtkImageData *image,\n    vtkIdType i=0, int *pixelIncrement=0)\nV.GetVoidPointer(vtkDataArray, int, [int, ...]) -> void\nC++: static void *GetVoidPointer(vtkDataArray *array,\n    vtkIdType i=0, int *pixelIncrement=0)\n\nGet a void pointer and pixel increment for the given point Id.\nThe pixel increment is the number of scalar components.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkImagePointDataIterator_vtkImagePointDataIterator_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkImagePointDataIterator");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkImagePointDataIterator *op = new vtkImagePointDataIterator();

    result = PyVTKSpecialObject_New("vtkImagePointDataIterator", op);
  }

  return result;
}

static PyObject *
PyvtkImagePointDataIterator_vtkImagePointDataIterator_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkImagePointDataIterator");

  vtkImageData *temp0 = NULL;
  int size1 = 0;
  int store1[6];
  int *temp1 = NULL;
  if (ap.GetArgSize(1) > 0)
  {
    size1 = 6;
    temp1 = store1;
  }
  vtkImageStencilData *temp2 = 0;
  vtkAlgorithm *temp3 = 0;
  int temp4 = 0;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 5) &&
      ap.GetVTKObject(temp0, "vtkImageData") &&
      (ap.NoArgsLeft() || ap.GetArray(temp1, size1)) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp2, "vtkImageStencilData")) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp3, "vtkAlgorithm")) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    vtkImagePointDataIterator *op = new vtkImagePointDataIterator(temp0, temp1, temp2, temp3, temp4);

    result = PyVTKSpecialObject_New("vtkImagePointDataIterator", op);
  }

  return result;
}

static PyObject *
PyvtkImagePointDataIterator_vtkImagePointDataIterator_s3(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkImagePointDataIterator");

  vtkImagePointDataIterator *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkImagePointDataIterator"))
  {
    vtkImagePointDataIterator *op = new vtkImagePointDataIterator(*temp0);

    result = PyVTKSpecialObject_New("vtkImagePointDataIterator", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkImagePointDataIterator_vtkImagePointDataIterator_Methods[] = {
  {NULL, PyvtkImagePointDataIterator_vtkImagePointDataIterator_s2, METH_VARARGS,
   "@V|PVVi *vtkImageData *i *vtkImageStencilData *vtkAlgorithm"},
  {NULL, PyvtkImagePointDataIterator_vtkImagePointDataIterator_s3, METH_VARARGS,
   "@W vtkImagePointDataIterator"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkImagePointDataIterator_vtkImagePointDataIterator(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkImagePointDataIterator_vtkImagePointDataIterator_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkImagePointDataIterator_vtkImagePointDataIterator_s1(self, args);
    case 2:
    case 3:
    case 4:
    case 5:
      return PyvtkImagePointDataIterator_vtkImagePointDataIterator_s2(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkImagePointDataIterator");
  return NULL;
}


static PyObject *
PyvtkImagePointDataIterator_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkImagePointDataIterator_vtkImagePointDataIterator(NULL, args);
}

static void PyvtkImagePointDataIterator_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkImagePointDataIterator *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkImagePointDataIterator_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkImagePointDataIterator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImagePointDataIterator", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkImagePointDataIterator_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkImagePointDataIterator_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkImagePointDataIterator_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkImagePointDataIterator_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkImagePointDataIterator(*static_cast<const vtkImagePointDataIterator*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImagePointDataIterator_TypeNew(); }

PyObject *PyvtkImagePointDataIterator_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkImagePointDataIterator_Type,
    PyvtkImagePointDataIterator_Methods,
    PyvtkImagePointDataIterator_vtkImagePointDataIterator_Methods,
    PyvtkImagePointDataIterator_Doc(), &PyvtkImagePointDataIterator_CCopy);

  PyTypeObject *pytype = &PyvtkImagePointDataIterator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImagePointDataIterator_Doc()
{
  static const char *docstring[] = {
    "vtkImagePointDataIterator - iterate over point data in an image.\n\n",
    "This class will iterate over an image.  For each position, it will\nprovide the (I,J,K) index, the point Id, and if a stencil is\nsupplied, it will report whether the point is inside or outside of\nthe stencil.\n\nFor efficiency, this class iterates over spans rather than points.\nEach span is one image row or partial row, defined by a start\nposition and a size.  Within a span, only the X index and the ",
    "point\nId will change. The vtkImagePointDataIterator and related iterators\nare the preferred method of iterating over image data within the VTK\nimage filters.\n@sa\nvtkImageData vtkImageStencilData vtkImageProgressIterator\n\n",
    "V.vtkImagePointDataIterator()\nC++: vtkImagePointDataIterator()\nV.vtkImagePointDataIterator(vtkImageData, (int, int, int, int, int,\n    int), vtkImageStencilData, vtkAlgorithm, int)\nC++: vtkImagePointDataIterator(vtkImageData *image,\n    const int extent[6]=0, vtkImageStencilData *stencil=0,\n    vtkAlgorithm *algorithm=0, int threadId=0)\nV.vtkImagePointDataIterator(vtkImagePointDataIterator)\nC++: vtkImagePointDataIterator(const &vtkImagePointDataIterator)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImagePointDataIterator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImagePointDataIterator_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkImagePointDataIterator", o) != 0)
  {
    Py_DECREF(o);
  }

}

