// python wrapper for vtkIndent
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIndent(PyObject *); }

static const char **PyvtkIndent_Doc();


static PyObject *
PyvtkIndent_GetNextIndent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextIndent");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkIndent *op = static_cast<vtkIndent *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIndent tempr = op->GetNextIndent();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkIndent");
    }
  }

  return result;
}

static PyMethodDef PyvtkIndent_Methods[] = {
  {"GetNextIndent", PyvtkIndent_GetNextIndent, METH_VARARGS,
   "V.GetNextIndent() -> vtkIndent\nC++: vtkIndent GetNextIndent()\n\nDetermine the next indentation level. Keep indenting by two until\nthe max of forty.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkIndent_vtkIndent_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkIndent");

  int temp0 = 0;
  PyObject *result = NULL;

  if (ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    vtkIndent *op = new vtkIndent(temp0);

    result = PyVTKSpecialObject_New("vtkIndent", op);
  }

  return result;
}

static PyObject *
PyvtkIndent_vtkIndent_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkIndent");

  vtkIndent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkIndent"))
  {
    vtkIndent *op = new vtkIndent(*temp0);

    result = PyVTKSpecialObject_New("vtkIndent", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkIndent_vtkIndent_Methods[] = {
  {NULL, PyvtkIndent_vtkIndent_s1, METH_VARARGS,
   "-@|i"},
  {NULL, PyvtkIndent_vtkIndent_s2, METH_VARARGS,
   "@W vtkIndent"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkIndent_vtkIndent(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkIndent_vtkIndent_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkIndent_vtkIndent_s1(self, args);
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkIndent");
  return NULL;
}


static PyObject *
PyvtkIndent_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkIndent_vtkIndent(NULL, args);
}

static void PyvtkIndent_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkIndent *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static PyObject *PyvtkIndent_String(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  std::ostringstream os;
  if (obj->vtk_ptr)
  {
    os << *static_cast<const vtkIndent *>(obj->vtk_ptr);
  }
  const std::string &s = os.str();
  return PyString_FromStringAndSize(s.data(), s.size());
}

static Py_hash_t PyvtkIndent_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkIndent_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkIndent", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkIndent_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkIndent_Hash, // tp_hash
  0, // tp_call
  PyvtkIndent_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkIndent_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkIndent_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkIndent(*static_cast<const vtkIndent*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkIndent_TypeNew(); }

PyObject *PyvtkIndent_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkIndent_Type,
    PyvtkIndent_Methods,
    PyvtkIndent_vtkIndent_Methods,
    PyvtkIndent_Doc(), &PyvtkIndent_CCopy);

  PyTypeObject *pytype = &PyvtkIndent_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkIndent_Doc()
{
  static const char *docstring[] = {
    "vtkIndent - a simple class to control print indentation\n\n",
    "vtkIndent is used to control indentation during the chaining print\nprocess. This way nested objects can correctly indent themselves.\n\n",
    "V.vtkIndent(int)\nC++: explicit vtkIndent(int ind=0)\nV.vtkIndent(vtkIndent)\nC++: vtkIndent(const &vtkIndent)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkIndent(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIndent_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkIndent", o) != 0)
  {
    Py_DECREF(o);
  }

}

