// python wrapper for vtkInstantiator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInstantiator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkInstantiator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInstantiator_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkInstantiator_Doc();


static PyObject *
PyvtkInstantiator_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkInstantiator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInstantiator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInstantiator *op = static_cast<vtkInstantiator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkInstantiator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInstantiator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkInstantiator *tempr = vtkInstantiator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInstantiator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInstantiator *op = static_cast<vtkInstantiator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkInstantiator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkInstantiator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkInstantiator_CreateInstance(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CreateInstance");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkObject *tempr = vtkInstantiator::CreateInstance(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkInstantiator_Methods[] = {
  {"IsTypeOf", PyvtkInstantiator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkInstantiator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkInstantiator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkInstantiator\nC++: static vtkInstantiator *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkInstantiator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkInstantiator\nC++: vtkInstantiator *NewInstance()\n\n"},
  {"CreateInstance", PyvtkInstantiator_CreateInstance, METH_VARARGS,
   "V.CreateInstance(string) -> vtkObject\nC++: static vtkObject *CreateInstance(const char *className)\n\nCreate an instance of the class whose name is given.  If creation\nfails, a NULL pointer is returned.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkInstantiator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkInstantiator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkInstantiator_StaticNew()
{
  return vtkInstantiator::New();
}

PyObject *PyvtkInstantiator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkInstantiator_Type, PyvtkInstantiator_Methods,
    "vtkInstantiator",
    PyvtkInstantiator_Doc(), &PyvtkInstantiator_StaticNew);

  PyTypeObject *pytype = &PyvtkInstantiator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkInstantiator_Doc()
{
  static const char *docstring[] = {
    "vtkInstantiator - create an instance of any VTK class from its name.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkInstantiator provides an interface to create an instance of any\nVTK class from its name.  Instances are created through registered\npointers to functions returning the objects.  New classes can also be\nregistered with the creator.  VTK libraries automatically register\ntheir classes with the creator when they are loaded.  Instances are\ncreated using the static New() method, so the normal vtkObjec",
    "tFactory\nmechanism is still invoked.\n\nWhen using this class from language wrappers (Tcl, Python, or Java),\nthe vtkInstantiator should be able to create any class from any kit\nthat has been loaded.\n\nIn C++ code, one should include the header for each kit from which\none wishes to create instances through vtkInstantiator.  This is\nnecessary to ensure proper linking when building static libraries. Be\n",
    "careful, though, because including each kit's header means every\nclass from that kit will be linked into your executable whether or\nnot the class is used.  The headers are:\n\n\n  vtkCommon          - vtkCommonInstantiator.h\n  vtkFiltering       - vtkFilteringInstantiator.h\n  vtkIO              - vtkIOInstantiator.h\n  vtkImaging         - vtkImagingInstantiator.h\n  vtkGraphics        - vtkGraphicsIns",
    "tantiator.h\n  vtkRendering       - vtkRenderingInstantiator.h\n  vtkVolumeRendering - vtkVolumeRenderingInstantiator.h\n  vtkHybrid          - vtkHybridInstantiator.h\n  vtkParallel        - vtkParallelInstantiator.h\n\nThe VTK_MAKE_INSTANTIATOR() command in CMake is used to automatically\ngenerate the creator registration for each VTK library.  It can also\nbe used to create registration code for VTK-st",
    "yle user libraries that\nare linked to vtkCommon.  After using this command to register\nclasses from a new library, the generated header must be included.\n\n",
    NULL
  };

  return docstring;
}


static const char **PyvtkInstantiatorInitialize_Doc();

static PyMethodDef PyvtkInstantiatorInitialize_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkInstantiatorInitialize_vtkInstantiatorInitialize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkInstantiatorInitialize");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkInstantiatorInitialize *op = new vtkInstantiatorInitialize();

    result = PyVTKSpecialObject_New("vtkInstantiatorInitialize", op);
  }

  return result;
}

static PyMethodDef PyvtkInstantiatorInitialize_vtkInstantiatorInitialize_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkInstantiatorInitialize_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkInstantiatorInitialize_vtkInstantiatorInitialize(NULL, args);
}

static void PyvtkInstantiatorInitialize_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkInstantiatorInitialize *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkInstantiatorInitialize_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkInstantiatorInitialize_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkInstantiatorInitialize", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkInstantiatorInitialize_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkInstantiatorInitialize_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkInstantiatorInitialize_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInstantiatorInitialize_TypeNew(); }

PyObject *PyvtkInstantiatorInitialize_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkInstantiatorInitialize_Type,
    PyvtkInstantiatorInitialize_Methods,
    PyvtkInstantiatorInitialize_vtkInstantiatorInitialize_Methods,
    PyvtkInstantiatorInitialize_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkInstantiatorInitialize_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkInstantiatorInitialize_Doc()
{
  static const char *docstring[] = {
    "vtkInstantiatorInitialize - no description provided.\n\n",
    "V.vtkInstantiatorInitialize()\nC++: vtkInstantiatorInitialize()\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkInstantiator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkInstantiator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkInstantiator", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkInstantiatorInitialize_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkInstantiatorInitialize", o) != 0)
  {
    Py_DECREF(o);
  }

}

