// python wrapper for vtkLZ4DataCompressor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkLZ4DataCompressor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkLZ4DataCompressor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkLZ4DataCompressor_ClassNew(); }

#ifndef DECLARED_PyvtkDataCompressor_ClassNew
extern "C" { PyObject *PyvtkDataCompressor_ClassNew(); }
#define DECLARED_PyvtkDataCompressor_ClassNew
#endif

static const char **PyvtkLZ4DataCompressor_Doc();


static PyObject *
PyvtkLZ4DataCompressor_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkLZ4DataCompressor::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkLZ4DataCompressor::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkLZ4DataCompressor *tempr = vtkLZ4DataCompressor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkLZ4DataCompressor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkLZ4DataCompressor::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_GetMaximumCompressionSpace(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumCompressionSpace");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  size_t temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    size_t tempr = (ap.IsBound() ?
      op->GetMaximumCompressionSpace(temp0) :
      op->vtkLZ4DataCompressor::GetMaximumCompressionSpace(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_SetAccelerationLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAccelerationLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAccelerationLevel(temp0);
    }
    else
    {
      op->vtkLZ4DataCompressor::SetAccelerationLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_GetAccelerationLevelMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAccelerationLevelMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAccelerationLevelMinValue() :
      op->vtkLZ4DataCompressor::GetAccelerationLevelMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_GetAccelerationLevelMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAccelerationLevelMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAccelerationLevelMaxValue() :
      op->vtkLZ4DataCompressor::GetAccelerationLevelMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLZ4DataCompressor_GetAccelerationLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAccelerationLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLZ4DataCompressor *op = static_cast<vtkLZ4DataCompressor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetAccelerationLevel() :
      op->vtkLZ4DataCompressor::GetAccelerationLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkLZ4DataCompressor_Methods[] = {
  {"IsTypeOf", PyvtkLZ4DataCompressor_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkLZ4DataCompressor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkLZ4DataCompressor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkLZ4DataCompressor\nC++: static vtkLZ4DataCompressor *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkLZ4DataCompressor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkLZ4DataCompressor\nC++: vtkLZ4DataCompressor *NewInstance()\n\n"},
  {"GetMaximumCompressionSpace", PyvtkLZ4DataCompressor_GetMaximumCompressionSpace, METH_VARARGS,
   "V.GetMaximumCompressionSpace(int) -> int\nC++: size_t GetMaximumCompressionSpace(size_t size)\n\nGet the maximum space that may be needed to store data of the\ngiven uncompressed size after compression.  This is the minimum\nsize of the output buffer that can be passed to the four-argument\nCompress method.\n"},
  {"SetAccelerationLevel", PyvtkLZ4DataCompressor_SetAccelerationLevel, METH_VARARGS,
   "V.SetAccelerationLevel(int)\nC++: virtual void SetAccelerationLevel(int _arg)\n\nGet/Set the compression level.\n"},
  {"GetAccelerationLevelMinValue", PyvtkLZ4DataCompressor_GetAccelerationLevelMinValue, METH_VARARGS,
   "V.GetAccelerationLevelMinValue() -> int\nC++: virtual int GetAccelerationLevelMinValue()\n\nGet/Set the compression level.\n"},
  {"GetAccelerationLevelMaxValue", PyvtkLZ4DataCompressor_GetAccelerationLevelMaxValue, METH_VARARGS,
   "V.GetAccelerationLevelMaxValue() -> int\nC++: virtual int GetAccelerationLevelMaxValue()\n\nGet/Set the compression level.\n"},
  {"GetAccelerationLevel", PyvtkLZ4DataCompressor_GetAccelerationLevel, METH_VARARGS,
   "V.GetAccelerationLevel() -> int\nC++: virtual int GetAccelerationLevel()\n\nGet/Set the compression level.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkLZ4DataCompressor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOCorePython.vtkLZ4DataCompressor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkLZ4DataCompressor_StaticNew()
{
  return vtkLZ4DataCompressor::New();
}

PyObject *PyvtkLZ4DataCompressor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkLZ4DataCompressor_Type, PyvtkLZ4DataCompressor_Methods,
    "vtkLZ4DataCompressor",
    PyvtkLZ4DataCompressor_Doc(), &PyvtkLZ4DataCompressor_StaticNew);

  PyTypeObject *pytype = &PyvtkLZ4DataCompressor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataCompressor_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkLZ4DataCompressor_Doc()
{
  static const char *docstring[] = {
    "vtkLZ4DataCompressor - Data compression using zlib.\n\n",
    "Superclass: vtkDataCompressor\n\n",
    "vtkLZ4DataCompressor provides a concrete vtkDataCompressor class\nusing LZ4 for compressing and uncompressing data.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkLZ4DataCompressor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkLZ4DataCompressor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkLZ4DataCompressor", o) != 0)
  {
    Py_DECREF(o);
  }

}

