// python wrapper for vtkMaterialInterfaceIdList
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkMaterialInterfaceIdList.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMaterialInterfaceIdList(PyObject *); }

static const char **PyvtkMaterialInterfaceIdList_Doc();


static PyObject *
PyvtkMaterialInterfaceIdList_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceIdList *op = static_cast<vtkMaterialInterfaceIdList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->Clear();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceIdList_GetLocalId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocalId");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceIdList *op = static_cast<vtkMaterialInterfaceIdList *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = op->GetLocalId(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMaterialInterfaceIdList_Methods[] = {
  {"Clear", PyvtkMaterialInterfaceIdList_Clear, METH_VARARGS,
   "V.Clear()\nC++: void Clear()\n\nReturn the container to an empty state.\n"},
  {"GetLocalId", PyvtkMaterialInterfaceIdList_GetLocalId, METH_VARARGS,
   "V.GetLocalId(int) -> int\nC++: int GetLocalId(int globalId)\n\nGiven a global id, get the local id, or -1 if the global id is\nnot in the list.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMaterialInterfaceIdList");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkMaterialInterfaceIdList *op = new vtkMaterialInterfaceIdList();

    result = PyVTKSpecialObject_New("vtkMaterialInterfaceIdList", op);
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMaterialInterfaceIdList");

  vtkMaterialInterfaceIdList *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkMaterialInterfaceIdList"))
  {
    vtkMaterialInterfaceIdList *op = new vtkMaterialInterfaceIdList(*temp0);

    result = PyVTKSpecialObject_New("vtkMaterialInterfaceIdList", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_Methods[] = {
  {NULL, PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_s2, METH_VARARGS,
   "@W vtkMaterialInterfaceIdList"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_s1(self, args);
    case 1:
      return PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkMaterialInterfaceIdList");
  return NULL;
}


static PyObject *
PyvtkMaterialInterfaceIdList_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList(NULL, args);
}

static void PyvtkMaterialInterfaceIdList_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkMaterialInterfaceIdList *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkMaterialInterfaceIdList_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkMaterialInterfaceIdList_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkMaterialInterfaceIdList", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkMaterialInterfaceIdList_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkMaterialInterfaceIdList_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkMaterialInterfaceIdList_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkMaterialInterfaceIdList_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkMaterialInterfaceIdList(*static_cast<const vtkMaterialInterfaceIdList*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMaterialInterfaceIdList_TypeNew(); }

PyObject *PyvtkMaterialInterfaceIdList_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkMaterialInterfaceIdList_Type,
    PyvtkMaterialInterfaceIdList_Methods,
    PyvtkMaterialInterfaceIdList_vtkMaterialInterfaceIdList_Methods,
    PyvtkMaterialInterfaceIdList_Doc(), &PyvtkMaterialInterfaceIdList_CCopy);

  PyTypeObject *pytype = &PyvtkMaterialInterfaceIdList_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMaterialInterfaceIdList_Doc()
{
  static const char *docstring[] = {
    "vtkMaterialInterfaceIdList - Class that facilitates efficient\noperation on lists fragment ids.\n\n",
    "This class is introduced to deal with the fact that local to global\nid search is a constant time operation, while its inverse glooabl to\nlocal id search is not.\n\n",
    "V.vtkMaterialInterfaceIdList()\nC++: vtkMaterialInterfaceIdList()\nV.vtkMaterialInterfaceIdList(vtkMaterialInterfaceIdList)\nC++: vtkMaterialInterfaceIdList(const &vtkMaterialInterfaceIdList)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMaterialInterfaceIdList(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMaterialInterfaceIdList_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkMaterialInterfaceIdList", o) != 0)
  {
    Py_DECREF(o);
  }

}

