// python wrapper for vtkMultiProcessStream
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkStdString.h"
#include "vtkMultiProcessStream.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMultiProcessStream(PyObject *); }

static const char **PyvtkMultiProcessStream_Doc();


static PyObject *
PyvtkMultiProcessStream_Push_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Push");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(2*size0);
  double *temp0 = store0.Data();
  double *save0 = (size0 == 0 ? NULL : temp0 + size0);
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    ap.SaveArray(temp0, save0, size0);

    op->Push(temp0, temp1);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMultiProcessStream_Push_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Push");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(2*size0);
  int *temp0 = store0.Data();
  int *save0 = (size0 == 0 ? NULL : temp0 + size0);
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    ap.SaveArray(temp0, save0, size0);

    op->Push(temp0, temp1);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMultiProcessStream_Push_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Push");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  char *temp0 = NULL;
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->Push(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMultiProcessStream_Push_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Push");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<long long> store0(2*size0);
  long long *temp0 = store0.Data();
  long long *save0 = (size0 == 0 ? NULL : temp0 + size0);
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    ap.SaveArray(temp0, save0, size0);

    op->Push(temp0, temp1);

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMultiProcessStream_Push_Methods[] = {
  {NULL, PyvtkMultiProcessStream_Push_s1, METH_VARARGS,
   "@PI *d"},
  {NULL, PyvtkMultiProcessStream_Push_s2, METH_VARARGS,
   "@PI *i"},
  {NULL, PyvtkMultiProcessStream_Push_s3, METH_VARARGS,
   "@zI"},
  {NULL, PyvtkMultiProcessStream_Push_s4, METH_VARARGS,
   "@PI *k"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMultiProcessStream_Push(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkMultiProcessStream_Push_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Push");
  return NULL;
}



static PyObject *
PyvtkMultiProcessStream_Reset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Reset");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->Reset();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMultiProcessStream_Size(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Size");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->Size();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiProcessStream_RawSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RawSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->RawSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiProcessStream_Empty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Empty");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->Empty();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiProcessStream_SetRawData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRawData");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMultiProcessStream *op = static_cast<vtkMultiProcessStream *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<unsigned char> store0(size0);
  unsigned char *temp0 = store0.Data();
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    op->SetRawData(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMultiProcessStream_Methods[] = {
  {"Push", PyvtkMultiProcessStream_Push, METH_VARARGS,
   "V.Push([float, ...], int)\nC++: void Push(double array[], unsigned int size)\nV.Push([int, ...], int)\nC++: void Push(int array[], unsigned int size)\nV.Push(string, int)\nC++: void Push(char array[], unsigned int size)\nV.Push([int, ...], int)\nC++: void Push(vtkTypeInt64 array[], unsigned int size)\n\nAdd-array-to-stream methods. Adds to the end of the stream\n"},
  {"Reset", PyvtkMultiProcessStream_Reset, METH_VARARGS,
   "V.Reset()\nC++: void Reset()\n\nClears everything in the stream.\n"},
  {"Size", PyvtkMultiProcessStream_Size, METH_VARARGS,
   "V.Size() -> int\nC++: int Size()\n\nReturns the size of the stream.\n"},
  {"RawSize", PyvtkMultiProcessStream_RawSize, METH_VARARGS,
   "V.RawSize() -> int\nC++: int RawSize()\n\nReturns the size of the raw data returned by GetRawData. This\nincludes 1 byte to store the endian type.\n"},
  {"Empty", PyvtkMultiProcessStream_Empty, METH_VARARGS,
   "V.Empty() -> bool\nC++: bool Empty()\n\nReturns true iff the stream is empty.\n"},
  {"SetRawData", PyvtkMultiProcessStream_SetRawData, METH_VARARGS,
   "V.SetRawData((int, ...), int)\nC++: void SetRawData(const unsigned char *, unsigned int size)\n\nSerialization methods used to save/restore the stream to/from raw\ndata. Note: The 1st byte of the raw data buffer consists of the\nendian type.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkMultiProcessStream_vtkMultiProcessStream_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMultiProcessStream");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkMultiProcessStream *op = new vtkMultiProcessStream();

    result = PyVTKSpecialObject_New("vtkMultiProcessStream", op);
  }

  return result;
}

static PyObject *
PyvtkMultiProcessStream_vtkMultiProcessStream_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMultiProcessStream");

  vtkMultiProcessStream *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkMultiProcessStream"))
  {
    vtkMultiProcessStream *op = new vtkMultiProcessStream(*temp0);

    result = PyVTKSpecialObject_New("vtkMultiProcessStream", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkMultiProcessStream_vtkMultiProcessStream_Methods[] = {
  {NULL, PyvtkMultiProcessStream_vtkMultiProcessStream_s2, METH_VARARGS,
   "@W vtkMultiProcessStream"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMultiProcessStream_vtkMultiProcessStream(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkMultiProcessStream_vtkMultiProcessStream_s1(self, args);
    case 1:
      return PyvtkMultiProcessStream_vtkMultiProcessStream_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkMultiProcessStream");
  return NULL;
}


static PyObject *
PyvtkMultiProcessStream_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkMultiProcessStream_vtkMultiProcessStream(NULL, args);
}

static void PyvtkMultiProcessStream_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkMultiProcessStream *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkMultiProcessStream_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkMultiProcessStream_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkParallelCorePython.vtkMultiProcessStream", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkMultiProcessStream_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkMultiProcessStream_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkMultiProcessStream_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkMultiProcessStream_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkMultiProcessStream(*static_cast<const vtkMultiProcessStream*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMultiProcessStream_TypeNew(); }

PyObject *PyvtkMultiProcessStream_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkMultiProcessStream_Type,
    PyvtkMultiProcessStream_Methods,
    PyvtkMultiProcessStream_vtkMultiProcessStream_Methods,
    PyvtkMultiProcessStream_Doc(), &PyvtkMultiProcessStream_CCopy);

  PyTypeObject *pytype = &PyvtkMultiProcessStream_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMultiProcessStream_Doc()
{
  static const char *docstring[] = {
    "vtkMultiProcessStream - stream used to pass data across processes\nusing vtkMultiProcessController.\n\n",
    "vtkMultiProcessStream is used to pass data across processes. Using\nvtkMultiProcessStream it is possible to send data whose length is not\nknown at the receiving end.\n\n@warning\nNote, stream operators cannot be combined with the Push/Pop array\noperators. For example, if you push an array to the stream,\n\n",
    "V.vtkMultiProcessStream()\nC++: vtkMultiProcessStream()\nV.vtkMultiProcessStream(vtkMultiProcessStream)\nC++: vtkMultiProcessStream(const vtkMultiProcessStream &)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMultiProcessStream(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMultiProcessStream_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkMultiProcessStream", o) != 0)
  {
    Py_DECREF(o);
  }

}

