// python wrapper for vtkMutexLock
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMutexLock.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMutexLock(PyObject *); }

static const char **PyvtkSimpleMutexLock_Doc();


static PyObject *
PyvtkSimpleMutexLock_Lock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Lock");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkSimpleMutexLock *op = static_cast<vtkSimpleMutexLock *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->Lock();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSimpleMutexLock_Unlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Unlock");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkSimpleMutexLock *op = static_cast<vtkSimpleMutexLock *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->Unlock();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSimpleMutexLock_Methods[] = {
  {"Lock", PyvtkSimpleMutexLock_Lock, METH_VARARGS,
   "V.Lock()\nC++: void Lock(void)\n\nLock the vtkMutexLock\n"},
  {"Unlock", PyvtkSimpleMutexLock_Unlock, METH_VARARGS,
   "V.Unlock()\nC++: void Unlock(void)\n\nUnlock the vtkMutexLock\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkSimpleMutexLock_vtkSimpleMutexLock(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkSimpleMutexLock");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkSimpleMutexLock *op = new vtkSimpleMutexLock();

    result = PyVTKSpecialObject_New("vtkSimpleMutexLock", op);
  }

  return result;
}

static PyMethodDef PyvtkSimpleMutexLock_vtkSimpleMutexLock_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSimpleMutexLock_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkSimpleMutexLock_vtkSimpleMutexLock(NULL, args);
}

static void PyvtkSimpleMutexLock_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkSimpleMutexLock *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkSimpleMutexLock_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkSimpleMutexLock_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkSimpleMutexLock", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkSimpleMutexLock_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkSimpleMutexLock_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkSimpleMutexLock_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSimpleMutexLock_TypeNew(); }

PyObject *PyvtkSimpleMutexLock_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkSimpleMutexLock_Type,
    PyvtkSimpleMutexLock_Methods,
    PyvtkSimpleMutexLock_vtkSimpleMutexLock_Methods,
    PyvtkSimpleMutexLock_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkSimpleMutexLock_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSimpleMutexLock_Doc()
{
  static const char *docstring[] = {
    "vtkSimpleMutexLock - no description provided.\n\n",
    "V.vtkSimpleMutexLock()\nC++: vtkSimpleMutexLock()\n",
    NULL
  };

  return docstring;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMutexLock_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkMutexLock_Doc();


static PyObject *
PyvtkMutexLock_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMutexLock::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMutexLock_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMutexLock *op = static_cast<vtkMutexLock *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMutexLock::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMutexLock_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMutexLock *tempr = vtkMutexLock::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMutexLock_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMutexLock *op = static_cast<vtkMutexLock *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMutexLock *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMutexLock::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMutexLock_Lock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Lock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMutexLock *op = static_cast<vtkMutexLock *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Lock();
    }
    else
    {
      op->vtkMutexLock::Lock();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMutexLock_Unlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Unlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMutexLock *op = static_cast<vtkMutexLock *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Unlock();
    }
    else
    {
      op->vtkMutexLock::Unlock();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMutexLock_Methods[] = {
  {"IsTypeOf", PyvtkMutexLock_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkMutexLock_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkMutexLock_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMutexLock\nC++: static vtkMutexLock *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMutexLock_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMutexLock\nC++: vtkMutexLock *NewInstance()\n\n"},
  {"Lock", PyvtkMutexLock_Lock, METH_VARARGS,
   "V.Lock()\nC++: void Lock(void)\n\nLock the vtkMutexLock\n"},
  {"Unlock", PyvtkMutexLock_Unlock, METH_VARARGS,
   "V.Unlock()\nC++: void Unlock(void)\n\nUnlock the vtkMutexLock\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMutexLock_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkMutexLock", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMutexLock_StaticNew()
{
  return vtkMutexLock::New();
}

PyObject *PyvtkMutexLock_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMutexLock_Type, PyvtkMutexLock_Methods,
    "vtkMutexLock",
    PyvtkMutexLock_Doc(), &PyvtkMutexLock_StaticNew);

  PyTypeObject *pytype = &PyvtkMutexLock_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMutexLock_Doc()
{
  static const char *docstring[] = {
    "vtkMutexLock - mutual exclusion locking class\n\n",
    "Superclass: vtkObject\n\n",
    "vtkMutexLock allows the locking of variables which are accessed\nthrough different threads.  This header file also defines\nvtkSimpleMutexLock which is not a subclass of vtkObject.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMutexLock(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSimpleMutexLock_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkSimpleMutexLock", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkMutexLock_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMutexLock", o) != 0)
  {
    Py_DECREF(o);
  }

}

