// python wrapper for vtkPDataSetWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPDataSetWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPDataSetWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPDataSetWriter_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetWriter_ClassNew
extern "C" { PyObject *PyvtkDataSetWriter_ClassNew(); }
#define DECLARED_PyvtkDataSetWriter_ClassNew
#endif

static const char **PyvtkPDataSetWriter_Doc();


static PyObject *
PyvtkPDataSetWriter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPDataSetWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPDataSetWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPDataSetWriter *tempr = vtkPDataSetWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPDataSetWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPDataSetWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->Write() :
      op->vtkPDataSetWriter::Write());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetNumberOfPieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfPieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfPieces(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetNumberOfPieces(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetNumberOfPieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPieces() :
      op->vtkPDataSetWriter::GetNumberOfPieces());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetGhostLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGhostLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGhostLevel(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetGhostLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetGhostLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGhostLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGhostLevel() :
      op->vtkPDataSetWriter::GetGhostLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetStartPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStartPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetStartPiece(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetStartPiece(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetStartPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStartPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetStartPiece() :
      op->vtkPDataSetWriter::GetStartPiece());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetEndPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEndPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEndPiece(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetEndPiece(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetEndPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEndPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetEndPiece() :
      op->vtkPDataSetWriter::GetEndPiece());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetFilePattern(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFilePattern");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFilePattern(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetFilePattern(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetFilePattern(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFilePattern");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFilePattern() :
      op->vtkPDataSetWriter::GetFilePattern());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetUseRelativeFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseRelativeFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseRelativeFileNames(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetUseRelativeFileNames(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetUseRelativeFileNames(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseRelativeFileNames");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseRelativeFileNames() :
      op->vtkPDataSetWriter::GetUseRelativeFileNames());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_UseRelativeFileNamesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseRelativeFileNamesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseRelativeFileNamesOn();
    }
    else
    {
      op->vtkPDataSetWriter::UseRelativeFileNamesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_UseRelativeFileNamesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseRelativeFileNamesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseRelativeFileNamesOff();
    }
    else
    {
      op->vtkPDataSetWriter::UseRelativeFileNamesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPDataSetWriter::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetWriter_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetWriter *op = static_cast<vtkPDataSetWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPDataSetWriter::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPDataSetWriter_Methods[] = {
  {"IsTypeOf", PyvtkPDataSetWriter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPDataSetWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPDataSetWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPDataSetWriter\nC++: static vtkPDataSetWriter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPDataSetWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPDataSetWriter\nC++: vtkPDataSetWriter *NewInstance()\n\n"},
  {"Write", PyvtkPDataSetWriter_Write, METH_VARARGS,
   "V.Write() -> int\nC++: int Write()\n\nWrite the pvtk file and cooresponding vtk files.\n"},
  {"SetNumberOfPieces", PyvtkPDataSetWriter_SetNumberOfPieces, METH_VARARGS,
   "V.SetNumberOfPieces(int)\nC++: void SetNumberOfPieces(int num)\n\nThis is how many pieces the whole data set will be divided into.\n"},
  {"GetNumberOfPieces", PyvtkPDataSetWriter_GetNumberOfPieces, METH_VARARGS,
   "V.GetNumberOfPieces() -> int\nC++: virtual int GetNumberOfPieces()\n\nThis is how many pieces the whole data set will be divided into.\n"},
  {"SetGhostLevel", PyvtkPDataSetWriter_SetGhostLevel, METH_VARARGS,
   "V.SetGhostLevel(int)\nC++: virtual void SetGhostLevel(int _arg)\n\nExtra ghost cells will be written out to each piece file if this\nvalue is larger than 0.\n"},
  {"GetGhostLevel", PyvtkPDataSetWriter_GetGhostLevel, METH_VARARGS,
   "V.GetGhostLevel() -> int\nC++: virtual int GetGhostLevel()\n\nExtra ghost cells will be written out to each piece file if this\nvalue is larger than 0.\n"},
  {"SetStartPiece", PyvtkPDataSetWriter_SetStartPiece, METH_VARARGS,
   "V.SetStartPiece(int)\nC++: virtual void SetStartPiece(int _arg)\n\nThis is the range of pieces that that this writer is responsible\nfor writing.  All pieces must be written by some process.  The\nprocess that writes piece 0 also writes the pvtk file that lists\nall the piece file names.\n"},
  {"GetStartPiece", PyvtkPDataSetWriter_GetStartPiece, METH_VARARGS,
   "V.GetStartPiece() -> int\nC++: virtual int GetStartPiece()\n\nThis is the range of pieces that that this writer is responsible\nfor writing.  All pieces must be written by some process.  The\nprocess that writes piece 0 also writes the pvtk file that lists\nall the piece file names.\n"},
  {"SetEndPiece", PyvtkPDataSetWriter_SetEndPiece, METH_VARARGS,
   "V.SetEndPiece(int)\nC++: virtual void SetEndPiece(int _arg)\n\nThis is the range of pieces that that this writer is responsible\nfor writing.  All pieces must be written by some process.  The\nprocess that writes piece 0 also writes the pvtk file that lists\nall the piece file names.\n"},
  {"GetEndPiece", PyvtkPDataSetWriter_GetEndPiece, METH_VARARGS,
   "V.GetEndPiece() -> int\nC++: virtual int GetEndPiece()\n\nThis is the range of pieces that that this writer is responsible\nfor writing.  All pieces must be written by some process.  The\nprocess that writes piece 0 also writes the pvtk file that lists\nall the piece file names.\n"},
  {"SetFilePattern", PyvtkPDataSetWriter_SetFilePattern, METH_VARARGS,
   "V.SetFilePattern(string)\nC++: virtual void SetFilePattern(const char *_arg)\n\nThis file pattern uses the file name and piece number to contruct\na file name for the piece file.\n"},
  {"GetFilePattern", PyvtkPDataSetWriter_GetFilePattern, METH_VARARGS,
   "V.GetFilePattern() -> string\nC++: virtual char *GetFilePattern()\n\nThis file pattern uses the file name and piece number to contruct\na file name for the piece file.\n"},
  {"SetUseRelativeFileNames", PyvtkPDataSetWriter_SetUseRelativeFileNames, METH_VARARGS,
   "V.SetUseRelativeFileNames(int)\nC++: virtual void SetUseRelativeFileNames(int _arg)\n\nThis flag determines whether to use absolute paths for the piece\nfiles. By default the pieces are put in the main directory, and\nthe piece file names in the meta data pvtk file are relative to\nthis directory. This should make moving the whole lot to another\ndirectory, an easier task.\n"},
  {"GetUseRelativeFileNames", PyvtkPDataSetWriter_GetUseRelativeFileNames, METH_VARARGS,
   "V.GetUseRelativeFileNames() -> int\nC++: virtual int GetUseRelativeFileNames()\n\nThis flag determines whether to use absolute paths for the piece\nfiles. By default the pieces are put in the main directory, and\nthe piece file names in the meta data pvtk file are relative to\nthis directory. This should make moving the whole lot to another\ndirectory, an easier task.\n"},
  {"UseRelativeFileNamesOn", PyvtkPDataSetWriter_UseRelativeFileNamesOn, METH_VARARGS,
   "V.UseRelativeFileNamesOn()\nC++: virtual void UseRelativeFileNamesOn()\n\nThis flag determines whether to use absolute paths for the piece\nfiles. By default the pieces are put in the main directory, and\nthe piece file names in the meta data pvtk file are relative to\nthis directory. This should make moving the whole lot to another\ndirectory, an easier task.\n"},
  {"UseRelativeFileNamesOff", PyvtkPDataSetWriter_UseRelativeFileNamesOff, METH_VARARGS,
   "V.UseRelativeFileNamesOff()\nC++: virtual void UseRelativeFileNamesOff()\n\nThis flag determines whether to use absolute paths for the piece\nfiles. By default the pieces are put in the main directory, and\nthe piece file names in the meta data pvtk file are relative to\nthis directory. This should make moving the whole lot to another\ndirectory, an easier task.\n"},
  {"SetController", PyvtkPDataSetWriter_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(vtkMultiProcessController *)\n\nController used to communicate data type of blocks. By default,\nthe global controller is used. If you want another controller to\nbe used, set it with this.\n"},
  {"GetController", PyvtkPDataSetWriter_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\nController used to communicate data type of blocks. By default,\nthe global controller is used. If you want another controller to\nbe used, set it with this.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPDataSetWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOParallelPython.vtkPDataSetWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPDataSetWriter_StaticNew()
{
  return vtkPDataSetWriter::New();
}

PyObject *PyvtkPDataSetWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPDataSetWriter_Type, PyvtkPDataSetWriter_Methods,
    "vtkPDataSetWriter",
    PyvtkPDataSetWriter_Doc(), &PyvtkPDataSetWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkPDataSetWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPDataSetWriter_Doc()
{
  static const char *docstring[] = {
    "vtkPDataSetWriter - Manages writing pieces of a data set.\n\n",
    "Superclass: vtkDataSetWriter\n\n",
    "vtkPDataSetWriter will write a piece of a file, and will also create\na metadata file that lists all of the files in a data set.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPDataSetWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPDataSetWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPDataSetWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

