// python wrapper for vtkPResampleFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPResampleFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPResampleFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPResampleFilter_ClassNew(); }

#ifndef DECLARED_PyvtkImageAlgorithm_ClassNew
extern "C" { PyObject *PyvtkImageAlgorithm_ClassNew(); }
#define DECLARED_PyvtkImageAlgorithm_ClassNew
#endif

static const char **PyvtkPResampleFilter_Doc();


static PyObject *
PyvtkPResampleFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPResampleFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPResampleFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPResampleFilter *tempr = vtkPResampleFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPResampleFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPResampleFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPResampleFilter::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPResampleFilter::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_SetUseInputBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseInputBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseInputBounds(temp0);
    }
    else
    {
      op->vtkPResampleFilter::SetUseInputBounds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_GetUseInputBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseInputBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetUseInputBounds() :
      op->vtkPResampleFilter::GetUseInputBounds());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_UseInputBoundsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseInputBoundsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseInputBoundsOn();
    }
    else
    {
      op->vtkPResampleFilter::UseInputBoundsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_UseInputBoundsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseInputBoundsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseInputBoundsOff();
    }
    else
    {
      op->vtkPResampleFilter::UseInputBoundsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_SetCustomSamplingBounds_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCustomSamplingBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  double temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    if (ap.IsBound())
    {
      op->SetCustomSamplingBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkPResampleFilter::SetCustomSamplingBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPResampleFilter_SetCustomSamplingBounds_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCustomSamplingBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  const int size0 = 6;
  double temp0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetCustomSamplingBounds(temp0);
    }
    else
    {
      op->vtkPResampleFilter::SetCustomSamplingBounds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPResampleFilter_SetCustomSamplingBounds(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 6:
      return PyvtkPResampleFilter_SetCustomSamplingBounds_s1(self, args);
    case 1:
      return PyvtkPResampleFilter_SetCustomSamplingBounds_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetCustomSamplingBounds");
  return NULL;
}



static PyObject *
PyvtkPResampleFilter_GetCustomSamplingBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCustomSamplingBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  int sizer = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetCustomSamplingBounds() :
      op->vtkPResampleFilter::GetCustomSamplingBounds());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkPResampleFilter_SetSamplingDimension_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSamplingDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetSamplingDimension(temp0, temp1, temp2);
    }
    else
    {
      op->vtkPResampleFilter::SetSamplingDimension(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPResampleFilter_SetSamplingDimension_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSamplingDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  const int size0 = 3;
  int temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetSamplingDimension(temp0);
    }
    else
    {
      op->vtkPResampleFilter::SetSamplingDimension(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPResampleFilter_SetSamplingDimension(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkPResampleFilter_SetSamplingDimension_s1(self, args);
    case 1:
      return PyvtkPResampleFilter_SetSamplingDimension_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetSamplingDimension");
  return NULL;
}



static PyObject *
PyvtkPResampleFilter_GetSamplingDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSamplingDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPResampleFilter *op = static_cast<vtkPResampleFilter *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetSamplingDimension() :
      op->vtkPResampleFilter::GetSamplingDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}

static PyMethodDef PyvtkPResampleFilter_Methods[] = {
  {"IsTypeOf", PyvtkPResampleFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPResampleFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPResampleFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPResampleFilter\nC++: static vtkPResampleFilter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPResampleFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPResampleFilter\nC++: vtkPResampleFilter *NewInstance()\n\n"},
  {"SetController", PyvtkPResampleFilter_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(vtkMultiProcessController *)\n\nSet and get the controller.\n"},
  {"GetController", PyvtkPResampleFilter_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\nSet and get the controller.\n"},
  {"SetUseInputBounds", PyvtkPResampleFilter_SetUseInputBounds, METH_VARARGS,
   "V.SetUseInputBounds(int)\nC++: virtual void SetUseInputBounds(int _arg)\n\nSet/Get if the filter should use Input bounds to sub-sample the\ndata. By default it is set to 1.\n"},
  {"GetUseInputBounds", PyvtkPResampleFilter_GetUseInputBounds, METH_VARARGS,
   "V.GetUseInputBounds() -> int\nC++: virtual int GetUseInputBounds()\n\nSet/Get if the filter should use Input bounds to sub-sample the\ndata. By default it is set to 1.\n"},
  {"UseInputBoundsOn", PyvtkPResampleFilter_UseInputBoundsOn, METH_VARARGS,
   "V.UseInputBoundsOn()\nC++: virtual void UseInputBoundsOn()\n\nSet/Get if the filter should use Input bounds to sub-sample the\ndata. By default it is set to 1.\n"},
  {"UseInputBoundsOff", PyvtkPResampleFilter_UseInputBoundsOff, METH_VARARGS,
   "V.UseInputBoundsOff()\nC++: virtual void UseInputBoundsOff()\n\nSet/Get if the filter should use Input bounds to sub-sample the\ndata. By default it is set to 1.\n"},
  {"SetCustomSamplingBounds", PyvtkPResampleFilter_SetCustomSamplingBounds, METH_VARARGS,
   "V.SetCustomSamplingBounds(float, float, float, float, float,\n    float)\nC++: void SetCustomSamplingBounds(double, double, double, double,\n    double, double)\nV.SetCustomSamplingBounds((float, float, float, float, float,\n    float))\nC++: void SetCustomSamplingBounds(double a[6])\n\n"},
  {"GetCustomSamplingBounds", PyvtkPResampleFilter_GetCustomSamplingBounds, METH_VARARGS,
   "V.GetCustomSamplingBounds() -> (float, float, float, float, float,\n     float)\nC++: double *GetCustomSamplingBounds()\n\n"},
  {"SetSamplingDimension", PyvtkPResampleFilter_SetSamplingDimension, METH_VARARGS,
   "V.SetSamplingDimension(int, int, int)\nC++: void SetSamplingDimension(int, int, int)\nV.SetSamplingDimension((int, int, int))\nC++: void SetSamplingDimension(int a[3])\n\n"},
  {"GetSamplingDimension", PyvtkPResampleFilter_GetSamplingDimension, METH_VARARGS,
   "V.GetSamplingDimension() -> (int, int, int)\nC++: int *GetSamplingDimension()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPResampleFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelPython.vtkPResampleFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPResampleFilter_StaticNew()
{
  return vtkPResampleFilter::New();
}

PyObject *PyvtkPResampleFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPResampleFilter_Type, PyvtkPResampleFilter_Methods,
    "vtkPResampleFilter",
    PyvtkPResampleFilter_Doc(), &PyvtkPResampleFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkPResampleFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPResampleFilter_Doc()
{
  static const char *docstring[] = {
    "vtkPResampleFilter - probe dataset in parallel using a vtkImageData\n\n",
    "Superclass: vtkImageAlgorithm\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPResampleFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPResampleFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPResampleFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

