// python wrapper for vtkPVPlugin
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkPVPlugin.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVPlugin(PyObject *); }

static const char **PyvtkPVPlugin_Doc();


static PyObject *
PyvtkPVPlugin_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetFileName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPlugin_GetPluginName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPluginName");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetPluginName();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPlugin_GetPluginVersionString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPluginVersionString");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetPluginVersionString();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPlugin_GetRequiredOnServer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequiredOnServer");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->GetRequiredOnServer();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPlugin_GetRequiredOnClient(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequiredOnClient");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->GetRequiredOnClient();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPlugin_GetRequiredPlugins(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRequiredPlugins");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPVPlugin *op = static_cast<vtkPVPlugin *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetRequiredPlugins();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVPlugin_Methods[] = {
  {"GetFileName", PyvtkPVPlugin_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: const char *GetFileName()\n\n"},
  {"GetPluginName", PyvtkPVPlugin_GetPluginName, METH_VARARGS,
   "V.GetPluginName() -> string\nC++: virtual const char *GetPluginName()\n\nReturns the name for this plugin.\n"},
  {"GetPluginVersionString", PyvtkPVPlugin_GetPluginVersionString, METH_VARARGS,
   "V.GetPluginVersionString() -> string\nC++: virtual const char *GetPluginVersionString()\n\nReturns the version for this plugin.\n"},
  {"GetRequiredOnServer", PyvtkPVPlugin_GetRequiredOnServer, METH_VARARGS,
   "V.GetRequiredOnServer() -> bool\nC++: virtual bool GetRequiredOnServer()\n\nReturns true if this plugin is required on the server.\n"},
  {"GetRequiredOnClient", PyvtkPVPlugin_GetRequiredOnClient, METH_VARARGS,
   "V.GetRequiredOnClient() -> bool\nC++: virtual bool GetRequiredOnClient()\n\nReturns true if this plugin is required on the client.\n"},
  {"GetRequiredPlugins", PyvtkPVPlugin_GetRequiredPlugins, METH_VARARGS,
   "V.GetRequiredPlugins() -> string\nC++: virtual const char *GetRequiredPlugins()\n\nReturns a ';' separated list of plugin names required by this\nplugin.\n"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkPVPlugin_New(PyTypeObject *, PyObject *, PyObject *)
{
  PyErr_SetString(PyExc_TypeError,
                  "this class cannot be instantiated");

  return NULL;
}

static void PyvtkPVPlugin_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkPVPlugin *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkPVPlugin_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkPVPlugin_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreCorePython.vtkPVPlugin", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkPVPlugin_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkPVPlugin_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkPVPlugin_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVPlugin_TypeNew(); }

PyObject *PyvtkPVPlugin_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkPVPlugin_Type,
    PyvtkPVPlugin_Methods,
    NULL,
    PyvtkPVPlugin_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPVPlugin_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVPlugin_Doc()
{
  static const char *docstring[] = {
    "vtkPVPlugin - defines the core interface for any ParaView plugin.\n\n",
    "vtkPVPlugin defines the core interface for any ParaView plugin. A\nplugin implementing merely this interface is pretty much useless. The\nheader file also defines few import macros that are required for\nexporting/importing plugins.\n\nWhen debugging issues with plugins try setting the PV_PLUGIN_DEBUG\nenvironment variable on all the processes where you are trying to\nload the plugin. That will print ext",
    "ra information as the plugin is\nbeing loaded.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVPlugin(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVPlugin_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkPVPlugin", o) != 0)
  {
    Py_DECREF(o);
  }

}

