// python wrapper for vtkPVProgressHandler
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVProgressHandler.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVProgressHandler(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVProgressHandler_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPVProgressHandler_Doc();


static PyObject *
PyvtkPVProgressHandler_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVProgressHandler::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVProgressHandler::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVProgressHandler *tempr = vtkPVProgressHandler::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVProgressHandler *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVProgressHandler::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_SetSession(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSession");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  vtkPVSession *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVSession"))
  {
    if (ap.IsBound())
    {
      op->SetSession(temp0);
    }
    else
    {
      op->vtkPVProgressHandler::SetSession(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetSession(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSession");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVSession *tempr = (ap.IsBound() ?
      op->GetSession() :
      op->vtkPVProgressHandler::GetSession());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_RegisterProgressEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterProgressEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  vtkObject *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkObject") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->RegisterProgressEvent(temp0, temp1);
    }
    else
    {
      op->vtkPVProgressHandler::RegisterProgressEvent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_PrepareProgress(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PrepareProgress");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PrepareProgress();
    }
    else
    {
      op->vtkPVProgressHandler::PrepareProgress();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_CleanupPendingProgress(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CleanupPendingProgress");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CleanupPendingProgress();
    }
    else
    {
      op->vtkPVProgressHandler::CleanupPendingProgress();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_SetProgressFrequency(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProgressFrequency");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetProgressFrequency(temp0);
    }
    else
    {
      op->vtkPVProgressHandler::SetProgressFrequency(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetProgressFrequencyMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgressFrequencyMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetProgressFrequencyMinValue() :
      op->vtkPVProgressHandler::GetProgressFrequencyMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetProgressFrequencyMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgressFrequencyMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetProgressFrequencyMaxValue() :
      op->vtkPVProgressHandler::GetProgressFrequencyMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetProgressFrequency(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgressFrequency");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetProgressFrequency() :
      op->vtkPVProgressHandler::GetProgressFrequency());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetLastProgressText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastProgressText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetLastProgressText() :
      op->vtkPVProgressHandler::GetLastProgressText());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetLastProgress(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastProgress");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLastProgress() :
      op->vtkPVProgressHandler::GetLastProgress());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVProgressHandler_GetLastMessage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastMessage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVProgressHandler *op = static_cast<vtkPVProgressHandler *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetLastMessage() :
      op->vtkPVProgressHandler::GetLastMessage());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVProgressHandler_Methods[] = {
  {"IsTypeOf", PyvtkPVProgressHandler_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVProgressHandler_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVProgressHandler_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVProgressHandler\nC++: static vtkPVProgressHandler *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVProgressHandler_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVProgressHandler\nC++: vtkPVProgressHandler *NewInstance()\n\n"},
  {"SetSession", PyvtkPVProgressHandler_SetSession, METH_VARARGS,
   "V.SetSession(vtkPVSession)\nC++: void SetSession(vtkPVSession *conn)\n\nGet/Set the session. This is not reference-counted to avoid\ncycles.\n"},
  {"GetSession", PyvtkPVProgressHandler_GetSession, METH_VARARGS,
   "V.GetSession() -> vtkPVSession\nC++: virtual vtkPVSession *GetSession()\n\nGet/Set the session. This is not reference-counted to avoid\ncycles.\n"},
  {"RegisterProgressEvent", PyvtkPVProgressHandler_RegisterProgressEvent, METH_VARARGS,
   "V.RegisterProgressEvent(vtkObject, int)\nC++: void RegisterProgressEvent(vtkObject *object, int id)\n\nListen to progress events from the object.\n"},
  {"PrepareProgress", PyvtkPVProgressHandler_PrepareProgress, METH_VARARGS,
   "V.PrepareProgress()\nC++: void PrepareProgress()\n\nThis method resets all the progress counters and prepares\nprogress reporting. All progress events before this call are\nignored.\n"},
  {"CleanupPendingProgress", PyvtkPVProgressHandler_CleanupPendingProgress, METH_VARARGS,
   "V.CleanupPendingProgress()\nC++: void CleanupPendingProgress()\n\nThis method collects all outstanding progress messages. All\nprogress events after this call are ignored.\n"},
  {"SetProgressFrequency", PyvtkPVProgressHandler_SetProgressFrequency, METH_VARARGS,
   "V.SetProgressFrequency(float)\nC++: virtual void SetProgressFrequency(double _arg)\n\nGet/Set the progress frequency in seconds. Default is 0.5\nseconds.\n"},
  {"GetProgressFrequencyMinValue", PyvtkPVProgressHandler_GetProgressFrequencyMinValue, METH_VARARGS,
   "V.GetProgressFrequencyMinValue() -> float\nC++: virtual double GetProgressFrequencyMinValue()\n\nGet/Set the progress frequency in seconds. Default is 0.5\nseconds.\n"},
  {"GetProgressFrequencyMaxValue", PyvtkPVProgressHandler_GetProgressFrequencyMaxValue, METH_VARARGS,
   "V.GetProgressFrequencyMaxValue() -> float\nC++: virtual double GetProgressFrequencyMaxValue()\n\nGet/Set the progress frequency in seconds. Default is 0.5\nseconds.\n"},
  {"GetProgressFrequency", PyvtkPVProgressHandler_GetProgressFrequency, METH_VARARGS,
   "V.GetProgressFrequency() -> float\nC++: virtual double GetProgressFrequency()\n\nGet/Set the progress frequency in seconds. Default is 0.5\nseconds.\n"},
  {"GetLastProgressText", PyvtkPVProgressHandler_GetLastProgressText, METH_VARARGS,
   "V.GetLastProgressText() -> string\nC++: virtual char *GetLastProgressText()\n\nThese are only valid in handler for the\nvtkCommand::ProgressEvent.\n"},
  {"GetLastProgress", PyvtkPVProgressHandler_GetLastProgress, METH_VARARGS,
   "V.GetLastProgress() -> int\nC++: virtual int GetLastProgress()\n\nThese are only valid in handler for the\nvtkCommand::ProgressEvent.\n"},
  {"GetLastMessage", PyvtkPVProgressHandler_GetLastMessage, METH_VARARGS,
   "V.GetLastMessage() -> string\nC++: virtual char *GetLastMessage()\n\nTemporary storage for most recent message text.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVProgressHandler_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreCorePython.vtkPVProgressHandler", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVProgressHandler_StaticNew()
{
  return vtkPVProgressHandler::New();
}

PyObject *PyvtkPVProgressHandler_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVProgressHandler_Type, PyvtkPVProgressHandler_Methods,
    "vtkPVProgressHandler",
    PyvtkPVProgressHandler_Doc(), &PyvtkPVProgressHandler_StaticNew);

  PyTypeObject *pytype = &PyvtkPVProgressHandler_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVProgressHandler_Doc()
{
  static const char *docstring[] = {
    "vtkPVProgressHandler - progress handler.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkPVProgressHandler handles the progress messages. It handles\nprogress in all configurations single process, client-server. It must\nbe noted that when running in parallel, progress updates are fetched\nfrom the root node. Due to performance reasons, we no longer collect\nprogress events (or messages) from satellites, only root-node events\nare reported back to the client. While this may not faithful",
    "ly report\nthe progress, this avoid nasty MPI issues that can be painful to\ndebug and diagnose.\n\nProgress events are currently not supported in multi-clients mode.\n\n@par Events: vtkCommand::StartEvent\n\\li fired to indicate beginning of progress handling\n\\li calldata: vtkPVProgressHandler*\nvtkCommand::ProgressEvent\n\\li fired to indicate a progress event.\n\\li calldata: vtkPVProgressHandler*\nvtkComman",
    "d::EndEvent\n\\li fired to indicate end of progress handling\n\\li calldata: vtkPVProgressHandler*\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVProgressHandler(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVProgressHandler_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVProgressHandler", o) != 0)
  {
    Py_DECREF(o);
  }

}

