// python wrapper for vtkParallelTimer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkParallelTimer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkParallelTimer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkParallelTimer_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkParallelTimer_Doc();


static PyObject *
PyvtkParallelTimer_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkParallelTimer::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkParallelTimer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkParallelTimer *tempr = vtkParallelTimer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkParallelTimer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkParallelTimer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_SetWriterRank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWriterRank");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetWriterRank(temp0);
    }
    else
    {
      op->vtkParallelTimer::SetWriterRank(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_GetWriterRank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWriterRank");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetWriterRank() :
      op->vtkParallelTimer::GetWriterRank());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkParallelTimer::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  std::string temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkParallelTimer::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_StartEvent_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->StartEvent(temp0);
    }
    else
    {
      op->vtkParallelTimer::StartEvent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_StartEvent_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->StartEvent(temp0, temp1);
    }
    else
    {
      op->vtkParallelTimer::StartEvent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_StartEvent(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkParallelTimer_StartEvent_s1(self, args);
    case 2:
      return PyvtkParallelTimer_StartEvent_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "StartEvent");
  return NULL;
}



static PyObject *
PyvtkParallelTimer_EndEvent_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->EndEvent(temp0);
    }
    else
    {
      op->vtkParallelTimer::EndEvent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_EndEvent_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->EndEvent(temp0, temp1);
    }
    else
    {
      op->vtkParallelTimer::EndEvent(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_EndEvent(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkParallelTimer_EndEvent_s1(self, args);
    case 2:
      return PyvtkParallelTimer_EndEvent_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "EndEvent");
  return NULL;
}



static PyObject *
PyvtkParallelTimer_EndEventSynch_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndEventSynch");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->EndEventSynch(temp0);
    }
    else
    {
      op->vtkParallelTimer::EndEventSynch(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_EndEventSynch_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndEventSynch");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->EndEventSynch(temp0, temp1);
    }
    else
    {
      op->vtkParallelTimer::EndEventSynch(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkParallelTimer_EndEventSynch(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkParallelTimer_EndEventSynch_s1(self, args);
    case 2:
      return PyvtkParallelTimer_EndEventSynch_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "EndEventSynch");
  return NULL;
}



static PyObject *
PyvtkParallelTimer_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Clear();
    }
    else
    {
      op->vtkParallelTimer::Clear();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkParallelTimer::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->Write() :
      op->vtkParallelTimer::Write());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_GetGlobalInstance(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetGlobalInstance");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkParallelTimer *tempr = vtkParallelTimer::GetGlobalInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_DeleteGlobalInstance(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DeleteGlobalInstance");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkParallelTimer::DeleteGlobalInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_SetWriteOnClose(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWriteOnClose");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetWriteOnClose(temp0);
    }
    else
    {
      op->vtkParallelTimer::SetWriteOnClose(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_GetWriteOnClose(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWriteOnClose");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetWriteOnClose() :
      op->vtkParallelTimer::GetWriteOnClose());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_SetGlobalLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlobalLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlobalLevel(temp0);
    }
    else
    {
      op->vtkParallelTimer::SetGlobalLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkParallelTimer_GetGlobalLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlobalLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkParallelTimer *op = static_cast<vtkParallelTimer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGlobalLevel() :
      op->vtkParallelTimer::GetGlobalLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkParallelTimer_Methods[] = {
  {"IsTypeOf", PyvtkParallelTimer_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkParallelTimer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkParallelTimer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkParallelTimer\nC++: static vtkParallelTimer *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkParallelTimer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkParallelTimer\nC++: vtkParallelTimer *NewInstance()\n\n"},
  {"SetWriterRank", PyvtkParallelTimer_SetWriterRank, METH_VARARGS,
   "V.SetWriterRank(int)\nC++: virtual void SetWriterRank(int _arg)\n\nSet the rank who writes.\n"},
  {"GetWriterRank", PyvtkParallelTimer_GetWriterRank, METH_VARARGS,
   "V.GetWriterRank() -> int\nC++: virtual int GetWriterRank()\n\nSet the rank who writes.\n"},
  {"GetFileName", PyvtkParallelTimer_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: virtual char *GetFileName()\n\nSet the filename that is used during write when the object is\nused as a singleton. If nothing is set the default is\nROOT_RANKS_PID.log\n"},
  {"SetFileName", PyvtkParallelTimer_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(const std::string &fileName)\n\n"},
  {"StartEvent", PyvtkParallelTimer_StartEvent, METH_VARARGS,
   "V.StartEvent(string)\nC++: void StartEvent(const char *event)\nV.StartEvent(int, string)\nC++: void StartEvent(int rank, const char *event)\n\nThe log works as an event stack. EventStart pushes the event\nidentifier and its start time onto the stack. EventEnd pops the\nmost recent event time and identifier computes the ellapsed time\nand adds an entry to the log recording the event, it's start and\nend times, and its ellapsed time. EndEventSynch includes a\nbarrier before the measurement.\n"},
  {"EndEvent", PyvtkParallelTimer_EndEvent, METH_VARARGS,
   "V.EndEvent(string)\nC++: void EndEvent(const char *event)\nV.EndEvent(int, string)\nC++: void EndEvent(int rank, const char *event)\n\nThe log works as an event stack. EventStart pushes the event\nidentifier and its start time onto the stack. EventEnd pops the\nmost recent event time and identifier computes the ellapsed time\nand adds an entry to the log recording the event, it's start and\nend times, and its ellapsed time. EndEventSynch includes a\nbarrier before the measurement.\n"},
  {"EndEventSynch", PyvtkParallelTimer_EndEventSynch, METH_VARARGS,
   "V.EndEventSynch(string)\nC++: void EndEventSynch(const char *event)\nV.EndEventSynch(int, string)\nC++: void EndEventSynch(int rank, const char *event)\n\nThe log works as an event stack. EventStart pushes the event\nidentifier and its start time onto the stack. EventEnd pops the\nmost recent event time and identifier computes the ellapsed time\nand adds an entry to the log recording the event, it's start and\nend times, and its ellapsed time. EndEventSynch includes a\nbarrier before the measurement.\n"},
  {"Clear", PyvtkParallelTimer_Clear, METH_VARARGS,
   "V.Clear()\nC++: void Clear()\n\nClear the log.\n"},
  {"Update", PyvtkParallelTimer_Update, METH_VARARGS,
   "V.Update()\nC++: void Update()\n\nWhen an object is finished writing data to the log object it must\ncall Update to send the data to the writer rank. This ensures\nthat all data is transferred to the root before MPI_Finalize is\ncalled while allowing the write to occur after Mpi_finalize.\nNote: This is a collective call.\n"},
  {"Write", PyvtkParallelTimer_Write, METH_VARARGS,
   "V.Write() -> int\nC++: int Write()\n\nWrite the log contents to a file.\n"},
  {"GetGlobalInstance", PyvtkParallelTimer_GetGlobalInstance, METH_VARARGS,
   "V.GetGlobalInstance() -> vtkParallelTimer\nC++: static vtkParallelTimer *GetGlobalInstance()\n\nThe log class implements the singleton patern so that it may be\nshared across class boundaries. If the log instance doesn't exist\nthen one is created. It will be automatically destroyed at exit\nby the signleton destructor. It can be destroyed explicitly by\ncalling DeleteGlobalInstance.\n"},
  {"DeleteGlobalInstance", PyvtkParallelTimer_DeleteGlobalInstance, METH_VARARGS,
   "V.DeleteGlobalInstance()\nC++: static void DeleteGlobalInstance()\n\nExplicitly delete the singleton.\n"},
  {"SetWriteOnClose", PyvtkParallelTimer_SetWriteOnClose, METH_VARARGS,
   "V.SetWriteOnClose(int)\nC++: virtual void SetWriteOnClose(int _arg)\n\nIf enabled and used as a singleton the log will write it's\ncontents to disk during program termination.\n"},
  {"GetWriteOnClose", PyvtkParallelTimer_GetWriteOnClose, METH_VARARGS,
   "V.GetWriteOnClose() -> int\nC++: virtual int GetWriteOnClose()\n\nIf enabled and used as a singleton the log will write it's\ncontents to disk during program termination.\n"},
  {"SetGlobalLevel", PyvtkParallelTimer_SetGlobalLevel, METH_VARARGS,
   "V.SetGlobalLevel(int)\nC++: virtual void SetGlobalLevel(int _arg)\n\nSet/Get the global log level. Applications can set this to the\ndesired level so that all pipeline objects will log data.\n"},
  {"GetGlobalLevel", PyvtkParallelTimer_GetGlobalLevel, METH_VARARGS,
   "V.GetGlobalLevel() -> int\nC++: virtual int GetGlobalLevel()\n\nSet/Get the global log level. Applications can set this to the\ndesired level so that all pipeline objects will log data.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkParallelTimer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingParallelLICPython.vtkParallelTimer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkParallelTimer_StaticNew()
{
  return vtkParallelTimer::New();
}

PyObject *PyvtkParallelTimer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkParallelTimer_Type, PyvtkParallelTimer_Methods,
    "vtkParallelTimer",
    PyvtkParallelTimer_Doc(), &PyvtkParallelTimer_StaticNew);

  PyTypeObject *pytype = &PyvtkParallelTimer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkParallelTimer_Doc()
{
  static const char *docstring[] = {
    "vtkParallelTimer -  Provides distributed log functionality.\n\n",
    "Superclass: vtkObject\n\n",
    "When the file is\n written each process data is collected by rank 0 who\n writes the data to a single file in rank order.\n\n\n The log works as an event stack. EventStart pushes the\n event identifier and its start time onto the stack. EventEnd\n pops the most recent event time and identifier computes the\n ellapsed time and adds an entry to the log recording the\n event, it's start and end times, and its",
    " ellapsed time.\n EndEventSynch includes a barrier before the measurement.\n\n\n The log class implements the singleton patern so that it\n may be shared across class boundaries. If the log instance\n doesn't exist then one is created. It will be automatically\n destroyed at exit by the signleton destructor. It can be\n destroyed explicitly by calling DeleteGlobalInstance.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkParallelTimer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkParallelTimer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkParallelTimer", o) != 0)
  {
    Py_DECREF(o);
  }

}

