// python wrapper for vtkPlot3DMetaReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPlot3DMetaReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPlot3DMetaReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPlot3DMetaReader_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkMultiBlockDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkPlot3DMetaReader_Doc();


static PyObject *
PyvtkPlot3DMetaReader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPlot3DMetaReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPlot3DMetaReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPlot3DMetaReader *op = static_cast<vtkPlot3DMetaReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPlot3DMetaReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPlot3DMetaReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPlot3DMetaReader *tempr = vtkPlot3DMetaReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPlot3DMetaReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPlot3DMetaReader *op = static_cast<vtkPlot3DMetaReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPlot3DMetaReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPlot3DMetaReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPlot3DMetaReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPlot3DMetaReader *op = static_cast<vtkPlot3DMetaReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkPlot3DMetaReader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPlot3DMetaReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPlot3DMetaReader *op = static_cast<vtkPlot3DMetaReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkPlot3DMetaReader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPlot3DMetaReader_Methods[] = {
  {"IsTypeOf", PyvtkPlot3DMetaReader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPlot3DMetaReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPlot3DMetaReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPlot3DMetaReader\nC++: static vtkPlot3DMetaReader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPlot3DMetaReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPlot3DMetaReader\nC++: vtkPlot3DMetaReader *NewInstance()\n\n"},
  {"SetFileName", PyvtkPlot3DMetaReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: virtual void SetFileName(const char *_arg)\n\nSet/Get the meta PLOT3D filename. See the class documentation for\nformat details.\n"},
  {"GetFileName", PyvtkPlot3DMetaReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: virtual char *GetFileName()\n\nSet/Get the meta PLOT3D filename. See the class documentation for\nformat details.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPlot3DMetaReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOParallelPython.vtkPlot3DMetaReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPlot3DMetaReader_StaticNew()
{
  return vtkPlot3DMetaReader::New();
}

PyObject *PyvtkPlot3DMetaReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPlot3DMetaReader_Type, PyvtkPlot3DMetaReader_Methods,
    "vtkPlot3DMetaReader",
    PyvtkPlot3DMetaReader_Doc(), &PyvtkPlot3DMetaReader_StaticNew);

  PyTypeObject *pytype = &PyvtkPlot3DMetaReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPlot3DMetaReader_Doc()
{
  static const char *docstring[] = {
    "vtkPlot3DMetaReader - reads meta-files points to PLOT3D files\n\n",
    "Superclass: vtkMultiBlockDataSetAlgorithm\n\n",
    "The main goal of this reader is to make it easy to read PLOT3D files,\nspecifically time series of PLOT3D files. PLOT3D files can take many\ndifferent forms based on their content. Unfortunately, it is not a\nself-describing format therefore the user needs to pass information\nabout the contents of the file to the reader. Normally, this is done\nby setting a number of member variables. The goal of this",
    " reader is\nto provide a simple format that enable the writer of the PLOT3D file\nto describe its settings as well as group a number of files as a time\nseries. Note that for binary files, the auto-detect-format option,\nwhich is on by default negates the need to specify most other option.\nHowever, this reader is still very useful when trying to read file\nseries even for binary files. The format for t",
    "his meta-file is very\nsimple and is based on JSON (there is no need to know anything about\nJSON to understand this format). Below is an example with comments\n(followed by //) that describe the format. Note that the PLOT3D file\nnames are relative to the location of the meta-file unless they start\nwith a leading /.\n\n\n {\n \"auto-detect-format\" : true // Tells the reader to try to figure out the format",
    " automatically. Only works\n                             // with binary file. This is on by default, negating the need for most other\n                             // options for binary files (format, byte-order, precision, multi-grid,\n                             // blanking, 2D).\n \"format\" : \"binary\",  // Is this a binary or ascii file, values : binary, ascii\n \"byte-order\" : \"big\", // Byte order f",
    "or binary files, values : little, big (denoting little or big endian)\n \"precision\" : 32,     // Precision of floating point values, can be 32 or 64 (bits)\n \"multi-grid\" : false, // Is this a multi-grid file, values: true, false\n \"language\" : \"C\",     // Which language was this file written in, values : C, fortran. This is\n                       // used to determine if an binary PLOT3D file contain",
    "s byte counts, used by\n                       // Fortran IO routines.\n \"blanking\" : false,   // Does this file have blanking information (iblanks), values : true, false\n \"2D\" : false,         // Is this a 2D dataset, values : true, false\n \"R\" : 8.314,          // The value of the gas constant, default is 1.0. Set this according to the dimensions you use\n \"gamma\" : 1.4,        // Ratio of specific ",
    "heats. Default is 1.4.\n \"functions\": [ 110, 200, 201 ],  // Additional derived values to calculate. This is an array of integers formatted\n                                  // as [ value, value, value, ...]\n \"filenames\" : [     // List of xyz (geometry) and q (value) file names along with the time values.\n                     // This is an array which contains items in the format:\n                ",
    "     // {\"time\" : values, \"xyz\" : \"xyz file name\", \"q\" : \"q file name\", \"function\" : \"function file name\"}\n                     // Note that q and function are optional. Also, you can repeat the same file name for xyz or q\n                     // if they don't change over time. The reader will not read files unnecessarily.\n  { \"time\" : 3.5, \"xyz\" : \"combxyz.bin\", \"q\" : \"combq.1.bin\", \"function\" : ",
    "\"combf.1.bin\" },\n  { \"time\" : 4.5, \"xyz\" : \"combxyz.bin\", \"q\" : \"combq.2.bin\", \"function\" : \"combf.2.bin\" }\n ],\n \"function-names\" : [\"density\", \"velocity_x\", \"temperature\"]\n                   // list of names of functions in function files\n }\n \n\nThis reader leverages vtkMultiBlockPLOT3DReader to do the actual\nreading so you may want to refer to the documenation of\nvtkMultiBlockPLOT3DReader about t",
    "he details of some of these\nparameters including the function numbers for derived value\ncalculation.\n\n@sa\nvtkMultiBlockPLOT3DReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPlot3DMetaReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPlot3DMetaReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPlot3DMetaReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

