// python wrapper for vtkPythonInteractiveInterpreter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPythonInteractiveInterpreter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPythonInteractiveInterpreter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPythonInteractiveInterpreter_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPythonInteractiveInterpreter_Doc();


static PyObject *
PyvtkPythonInteractiveInterpreter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPythonInteractiveInterpreter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPythonInteractiveInterpreter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPythonInteractiveInterpreter *tempr = vtkPythonInteractiveInterpreter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPythonInteractiveInterpreter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPythonInteractiveInterpreter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_Reset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Reset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Reset();
    }
    else
    {
      op->vtkPythonInteractiveInterpreter::Reset();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_RunStringWithConsoleLocals(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RunStringWithConsoleLocals");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->RunStringWithConsoleLocals(temp0) :
      op->vtkPythonInteractiveInterpreter::RunStringWithConsoleLocals(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_GetInteractiveConsolePyObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractiveConsolePyObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    void  *tempr = (ap.IsBound() ?
      op->GetInteractiveConsolePyObject() :
      op->vtkPythonInteractiveInterpreter::GetInteractiveConsolePyObject());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInteractiveInterpreter_GetInteractiveConsoleLocalsPyObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractiveConsoleLocalsPyObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInteractiveInterpreter *op = static_cast<vtkPythonInteractiveInterpreter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    void  *tempr = (ap.IsBound() ?
      op->GetInteractiveConsoleLocalsPyObject() :
      op->vtkPythonInteractiveInterpreter::GetInteractiveConsoleLocalsPyObject());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPythonInteractiveInterpreter_Methods[] = {
  {"IsTypeOf", PyvtkPythonInteractiveInterpreter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPythonInteractiveInterpreter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPythonInteractiveInterpreter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPythonInteractiveInterpreter\nC++: static vtkPythonInteractiveInterpreter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPythonInteractiveInterpreter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPythonInteractiveInterpreter\nC++: vtkPythonInteractiveInterpreter *NewInstance()\n\n"},
  {"Reset", PyvtkPythonInteractiveInterpreter_Reset, METH_VARARGS,
   "V.Reset()\nC++: void Reset()\n\nThis destroys the internal code.InteractiveConsole instance.\nHence, next time Push() will be called, it will use a brand new\ninstance of code.InteractiveConsole().\n"},
  {"RunStringWithConsoleLocals", PyvtkPythonInteractiveInterpreter_RunStringWithConsoleLocals, METH_VARARGS,
   "V.RunStringWithConsoleLocals(string) -> int\nC++: int RunStringWithConsoleLocals(const char *script)\n\nExecutes the given python source code using the context given by\nthe locals() object used by this interactive console.  This is\nsimilar to using vtkPythonInterpreter::RunSimpleString(), except\nthat method will execute code in the context of the __main__\nmodule. Returns 0 on success or -1 if an exception was raised.\n"},
  {"GetInteractiveConsolePyObject", PyvtkPythonInteractiveInterpreter_GetInteractiveConsolePyObject, METH_VARARGS,
   "V.GetInteractiveConsolePyObject() -> void\nC++: void *GetInteractiveConsolePyObject()\n\nProvides access to the internal PyObject instances used for the\ncode.InteractiveConsole() as well as the dictionary for the\nlocals of the code.InteractiveConsole() instance. Do not use if\nyou are not sure what these are for.\n"},
  {"GetInteractiveConsoleLocalsPyObject", PyvtkPythonInteractiveInterpreter_GetInteractiveConsoleLocalsPyObject, METH_VARARGS,
   "V.GetInteractiveConsoleLocalsPyObject() -> void\nC++: void *GetInteractiveConsoleLocalsPyObject()\n\nProvides access to the internal PyObject instances used for the\ncode.InteractiveConsole() as well as the dictionary for the\nlocals of the code.InteractiveConsole() instance. Do not use if\nyou are not sure what these are for.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPythonInteractiveInterpreter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPythonInterpreterPython.vtkPythonInteractiveInterpreter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPythonInteractiveInterpreter_StaticNew()
{
  return vtkPythonInteractiveInterpreter::New();
}

PyObject *PyvtkPythonInteractiveInterpreter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPythonInteractiveInterpreter_Type, PyvtkPythonInteractiveInterpreter_Methods,
    "vtkPythonInteractiveInterpreter",
    PyvtkPythonInteractiveInterpreter_Doc(), &PyvtkPythonInteractiveInterpreter_StaticNew);

  PyTypeObject *pytype = &PyvtkPythonInteractiveInterpreter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPythonInteractiveInterpreter_Doc()
{
  static const char *docstring[] = {
    "vtkPythonInteractiveInterpreter - interpreter for interactive shells.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkPythonInteractiveInterpreter provides an interpreter that can be\nused in interactive shells. It mimicks the behaviour of the\ninteractive console (much like the default Python shell) providing\nthe \"read-eval-print\" loops. It also handles incomplete statements\ncorrectly. It uses \"code\" module provided by Python standard library\nto achieve this. It uses vtkPythonInterpreter to ensure that the\nglob",
    "al Python environment is setup correctly. Note that any time the\nvtkPythonInterpreter::Finalize() is called, the interactive\ninterpreter will be destroyed as well. Subsequent calls to\nvtkPythonInterpreter::Push() will reinitialize Python as start a new\ninteractive interpreter shell.\n\nThis class also observers and forwards all events invoked by a\nvtkPythonInterpreter instance include vtkCommand::En",
    "terEvent,\nvtkCommand::ExitEvent, vtkCommand::UpdateEvent,\nvtkCommand::ErrorEvent and vtkCommand::SetOutputEvent.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPythonInteractiveInterpreter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPythonInteractiveInterpreter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPythonInteractiveInterpreter", o) != 0)
  {
    Py_DECREF(o);
  }

}

