// python wrapper for vtkSMAnimationSceneProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMAnimationSceneProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMAnimationSceneProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMAnimationSceneProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMProxy_ClassNew
extern "C" { PyObject *PyvtkSMProxy_ClassNew(); }
#define DECLARED_PyvtkSMProxy_ClassNew
#endif

static const char **PyvtkSMAnimationSceneProxy_Doc();


static PyObject *
PyvtkSMAnimationSceneProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMAnimationSceneProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMAnimationSceneProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMAnimationSceneProxy *op = static_cast<vtkSMAnimationSceneProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMAnimationSceneProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMAnimationSceneProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMAnimationSceneProxy *tempr = vtkSMAnimationSceneProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMAnimationSceneProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMAnimationSceneProxy *op = static_cast<vtkSMAnimationSceneProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMAnimationSceneProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMAnimationSceneProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateAnimationUsingDataTimeSteps");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMAnimationSceneProxy *op = static_cast<vtkSMAnimationSceneProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->UpdateAnimationUsingDataTimeSteps() :
      op->vtkSMAnimationSceneProxy::UpdateAnimationUsingDataTimeSteps());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "UpdateAnimationUsingDataTimeSteps");

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    bool tempr = vtkSMAnimationSceneProxy::UpdateAnimationUsingDataTimeSteps(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps_s1(self, args);
    case 1:
      return PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "UpdateAnimationUsingDataTimeSteps");
  return NULL;
}



static PyObject *
PyvtkSMAnimationSceneProxy_FindAnimationCue_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FindAnimationCue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMAnimationSceneProxy *op = static_cast<vtkSMAnimationSceneProxy *>(vp);

  vtkSMProxy *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkSMProxy") &&
      ap.GetValue(temp1))
  {
    vtkSMProxy *tempr = (ap.IsBound() ?
      op->FindAnimationCue(temp0, temp1) :
      op->vtkSMAnimationSceneProxy::FindAnimationCue(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMAnimationSceneProxy_FindAnimationCue_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "FindAnimationCue");

  vtkSMProxy *temp0 = NULL;
  vtkSMProxy *temp1 = NULL;
  char *temp2 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkSMProxy") &&
      ap.GetVTKObject(temp1, "vtkSMProxy") &&
      ap.GetValue(temp2))
  {
    vtkSMProxy *tempr = vtkSMAnimationSceneProxy::FindAnimationCue(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMAnimationSceneProxy_FindAnimationCue(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 2:
      return PyvtkSMAnimationSceneProxy_FindAnimationCue_s1(self, args);
    case 3:
      return PyvtkSMAnimationSceneProxy_FindAnimationCue_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "FindAnimationCue");
  return NULL;
}


static PyMethodDef PyvtkSMAnimationSceneProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMAnimationSceneProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMAnimationSceneProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMAnimationSceneProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMAnimationSceneProxy\nC++: static vtkSMAnimationSceneProxy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMAnimationSceneProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMAnimationSceneProxy\nC++: vtkSMAnimationSceneProxy *NewInstance()\n\n"},
  {"UpdateAnimationUsingDataTimeSteps", PyvtkSMAnimationSceneProxy_UpdateAnimationUsingDataTimeSteps, METH_VARARGS,
   "V.UpdateAnimationUsingDataTimeSteps() -> bool\nC++: virtual bool UpdateAnimationUsingDataTimeSteps()\nV.UpdateAnimationUsingDataTimeSteps(vtkSMProxy) -> bool\nC++: static bool UpdateAnimationUsingDataTimeSteps(\n    vtkSMProxy *scene)\n\nSetups the animation scene's playback mode and time-ranges based\non the timesteps available on the time-keeper proxy set on the\nanimation scene.\n"},
  {"FindAnimationCue", PyvtkSMAnimationSceneProxy_FindAnimationCue, METH_VARARGS,
   "V.FindAnimationCue(vtkSMProxy, string) -> vtkSMProxy\nC++: virtual vtkSMProxy *FindAnimationCue(\n    vtkSMProxy *animatedProxy, const char *animatedPropertyName)\nV.FindAnimationCue(vtkSMProxy, vtkSMProxy, string) -> vtkSMProxy\nC++: static vtkSMProxy *FindAnimationCue(vtkSMProxy *scene,\n    vtkSMProxy *animatedProxy, const char *animatedPropertyName)\n\nReturns the first animation cue (enabled or otherwise) that\nanimates the given property on the proxy. This will return NULL\nif none such cue exists.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMAnimationSceneProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVAnimationPython.vtkSMAnimationSceneProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMAnimationSceneProxy_StaticNew()
{
  return vtkSMAnimationSceneProxy::New();
}

PyObject *PyvtkSMAnimationSceneProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMAnimationSceneProxy_Type, PyvtkSMAnimationSceneProxy_Methods,
    "vtkSMAnimationSceneProxy",
    PyvtkSMAnimationSceneProxy_Doc(), &PyvtkSMAnimationSceneProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMAnimationSceneProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMAnimationSceneProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMAnimationSceneProxy - vtkSMAnimationSceneProxy observe\nvtkCommand::ModifiedEvent on the client-side VTK-object to call\nUpdatePropertyInformation() every time that happens.\n\n",
    "Superclass: vtkSMProxy\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMAnimationSceneProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMAnimationSceneProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMAnimationSceneProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

