// python wrapper for vtkSMCameraConfigurationWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMCameraConfigurationWriter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMCameraConfigurationWriter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMCameraConfigurationWriter_ClassNew(); }

#ifndef DECLARED_PyvtkSMProxyConfigurationWriter_ClassNew
extern "C" { PyObject *PyvtkSMProxyConfigurationWriter_ClassNew(); }
#define DECLARED_PyvtkSMProxyConfigurationWriter_ClassNew
#endif

static const char **PyvtkSMCameraConfigurationWriter_Doc();


static PyObject *
PyvtkSMCameraConfigurationWriter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMCameraConfigurationWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCameraConfigurationWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCameraConfigurationWriter *op = static_cast<vtkSMCameraConfigurationWriter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMCameraConfigurationWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCameraConfigurationWriter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMCameraConfigurationWriter *tempr = vtkSMCameraConfigurationWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCameraConfigurationWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCameraConfigurationWriter *op = static_cast<vtkSMCameraConfigurationWriter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMCameraConfigurationWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMCameraConfigurationWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMCameraConfigurationWriter_SetRenderViewProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderViewProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCameraConfigurationWriter *op = static_cast<vtkSMCameraConfigurationWriter *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->SetRenderViewProxy(temp0);
    }
    else
    {
      op->vtkSMCameraConfigurationWriter::SetRenderViewProxy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMCameraConfigurationWriter_Methods[] = {
  {"IsTypeOf", PyvtkSMCameraConfigurationWriter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMCameraConfigurationWriter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMCameraConfigurationWriter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMCameraConfigurationWriter\nC++: static vtkSMCameraConfigurationWriter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMCameraConfigurationWriter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMCameraConfigurationWriter\nC++: vtkSMCameraConfigurationWriter *NewInstance()\n\n"},
  {"SetRenderViewProxy", PyvtkSMCameraConfigurationWriter_SetRenderViewProxy, METH_VARARGS,
   "V.SetRenderViewProxy(vtkSMProxy)\nC++: void SetRenderViewProxy(vtkSMProxy *rvProxy)\n\nSet the render view proxy to extract camera properties from.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMCameraConfigurationWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkSMCameraConfigurationWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMCameraConfigurationWriter_StaticNew()
{
  return vtkSMCameraConfigurationWriter::New();
}

PyObject *PyvtkSMCameraConfigurationWriter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMCameraConfigurationWriter_Type, PyvtkSMCameraConfigurationWriter_Methods,
    "vtkSMCameraConfigurationWriter",
    PyvtkSMCameraConfigurationWriter_Doc(), &PyvtkSMCameraConfigurationWriter_StaticNew);

  PyTypeObject *pytype = &PyvtkSMCameraConfigurationWriter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMProxyConfigurationWriter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMCameraConfigurationWriter_Doc()
{
  static const char *docstring[] = {
    "vtkSMCameraConfigurationWriter - A writer for XML camera\nconfiguration.\n\n",
    "Superclass: vtkSMProxyConfigurationWriter\n\n",
    "A writer for XML camera configuration. Writes camera configuration\nfiles using ParaView state file machinery.\n\n@sa\nvtkSMCameraConfigurationReader, vtkSMProxyConfigurationWriter\n\n@par Thanks: This class was contributed by SciberQuest Inc.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMCameraConfigurationWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMCameraConfigurationWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMCameraConfigurationWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

