// python wrapper for vtkSMCinemaDatabaseImporter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSMCinemaDatabaseImporter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMCinemaDatabaseImporter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMCinemaDatabaseImporter_ClassNew(); }

#ifndef DECLARED_PyvtkSMObject_ClassNew
extern "C" { PyObject *PyvtkSMObject_ClassNew(); }
#define DECLARED_PyvtkSMObject_ClassNew
#endif

static const char **PyvtkSMCinemaDatabaseImporter_Doc();


static PyObject *
PyvtkSMCinemaDatabaseImporter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMCinemaDatabaseImporter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCinemaDatabaseImporter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCinemaDatabaseImporter *op = static_cast<vtkSMCinemaDatabaseImporter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMCinemaDatabaseImporter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCinemaDatabaseImporter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMCinemaDatabaseImporter *tempr = vtkSMCinemaDatabaseImporter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCinemaDatabaseImporter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCinemaDatabaseImporter *op = static_cast<vtkSMCinemaDatabaseImporter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMCinemaDatabaseImporter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMCinemaDatabaseImporter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMCinemaDatabaseImporter_SupportsCinema(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SupportsCinema");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCinemaDatabaseImporter *op = static_cast<vtkSMCinemaDatabaseImporter *>(vp);

  vtkSMSession *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMSession"))
  {
    bool tempr = (ap.IsBound() ?
      op->SupportsCinema(temp0) :
      op->vtkSMCinemaDatabaseImporter::SupportsCinema(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCinemaDatabaseImporter_ImportCinema(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ImportCinema");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCinemaDatabaseImporter *op = static_cast<vtkSMCinemaDatabaseImporter *>(vp);

  std::string temp0;
  vtkSMSession *temp1 = NULL;
  vtkSMViewProxy *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMSession") &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp2, "vtkSMViewProxy")))
  {
    bool tempr = (ap.IsBound() ?
      op->ImportCinema(temp0, temp1, temp2) :
      op->vtkSMCinemaDatabaseImporter::ImportCinema(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMCinemaDatabaseImporter_Methods[] = {
  {"IsTypeOf", PyvtkSMCinemaDatabaseImporter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMCinemaDatabaseImporter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMCinemaDatabaseImporter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMCinemaDatabaseImporter\nC++: static vtkSMCinemaDatabaseImporter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMCinemaDatabaseImporter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMCinemaDatabaseImporter\nC++: vtkSMCinemaDatabaseImporter *NewInstance()\n\n"},
  {"SupportsCinema", PyvtkSMCinemaDatabaseImporter_SupportsCinema, METH_VARARGS,
   "V.SupportsCinema(vtkSMSession) -> bool\nC++: virtual bool SupportsCinema(vtkSMSession *session)\n\nReturns true if the session supports Cinema databases. Currently,\nonly\n**builtin** sessions and single rank client-server sessions are\n    supported.\n@param[in] session session to check for Cinema importing support.\n@returns `true` if supported, else `false`.\n"},
  {"ImportCinema", PyvtkSMCinemaDatabaseImporter_ImportCinema, METH_VARARGS,
   "V.ImportCinema(string, vtkSMSession, vtkSMViewProxy) -> bool\nC++: virtual bool ImportCinema(const std::string &dbase,\n    vtkSMSession *session, vtkSMViewProxy *view=NULL)\n\nImports a Cinema database and creates sources as needed for\nobjects in the database.\n@param[in] dbase path to the Cinema database, typically an\n    `info.json` file.\n@param[in] session session to load the Cinema database on.\n@param[in] view if provided, view to show cinema sources by\n    default in.\n@returns `true` on success, else `false`.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMCinemaDatabaseImporter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCinemaReaderPython.vtkSMCinemaDatabaseImporter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMCinemaDatabaseImporter_StaticNew()
{
  return vtkSMCinemaDatabaseImporter::New();
}

PyObject *PyvtkSMCinemaDatabaseImporter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMCinemaDatabaseImporter_Type, PyvtkSMCinemaDatabaseImporter_Methods,
    "vtkSMCinemaDatabaseImporter",
    PyvtkSMCinemaDatabaseImporter_Doc(), &PyvtkSMCinemaDatabaseImporter_StaticNew);

  PyTypeObject *pytype = &PyvtkSMCinemaDatabaseImporter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMCinemaDatabaseImporter_Doc()
{
  static const char *docstring[] = {
    "vtkSMCinemaDatabaseImporter - helper to import a Cinema database in\nParaView\n\n",
    "Superclass: vtkSMObject\n\n",
    "vtkSMCinemaDatabaseImporter can be used by client code to import a\nCinema database in ParaView. The importer creates multiple proxies\nfor data-producers in the Cinema database.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMCinemaDatabaseImporter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMCinemaDatabaseImporter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMCinemaDatabaseImporter", o) != 0)
  {
    Py_DECREF(o);
  }

}

