// python wrapper for vtkSMProxyProperty
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMProxy.h"
#include "vtkSMProxyProperty.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMProxyProperty(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMProxyProperty_ClassNew(); }

#ifndef DECLARED_PyvtkSMProperty_ClassNew
extern "C" { PyObject *PyvtkSMProperty_ClassNew(); }
#define DECLARED_PyvtkSMProperty_ClassNew
#endif

static const char **PyvtkSMProxyProperty_Doc();


static PyObject *
PyvtkSMProxyProperty_EnableProxyCreation(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "EnableProxyCreation");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkSMProxyProperty::EnableProxyCreation();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_DisableProxyCreation(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DisableProxyCreation");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkSMProxyProperty::DisableProxyCreation();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_CanCreateProxy(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CanCreateProxy");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkSMProxyProperty::CanCreateProxy();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMProxyProperty::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMProxyProperty::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMProxyProperty *tempr = vtkSMProxyProperty::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMProxyProperty *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMProxyProperty::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_AddProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->AddProxy(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::AddProxy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_SetProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  vtkSMProxy *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->SetProxy(temp0, temp1);
    }
    else
    {
      op->vtkSMProxyProperty::SetProxy(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_RemoveProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->RemoveProxy(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::RemoveProxy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_RemoveAllProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllProxies();
    }
    else
    {
      op->vtkSMProxyProperty::RemoveAllProxies();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_IsProxyAdded(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsProxyAdded");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    bool tempr = (ap.IsBound() ?
      op->IsProxyAdded(temp0) :
      op->vtkSMProxyProperty::IsProxyAdded(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_AddUncheckedProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUncheckedProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->AddUncheckedProxy(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::AddUncheckedProxy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_SetUncheckedProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUncheckedProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  vtkSMProxy *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->SetUncheckedProxy(temp0, temp1);
    }
    else
    {
      op->vtkSMProxyProperty::SetUncheckedProxy(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_RemoveAllUncheckedProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllUncheckedProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllUncheckedProxies();
    }
    else
    {
      op->vtkSMProxyProperty::RemoveAllUncheckedProxies();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_ClearUncheckedElements(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearUncheckedElements");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearUncheckedElements();
    }
    else
    {
      op->vtkSMProxyProperty::ClearUncheckedElements();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_GetNumberOfProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfProxies() :
      op->vtkSMProxyProperty::GetNumberOfProxies());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_GetNumberOfUncheckedProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfUncheckedProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfUncheckedProxies() :
      op->vtkSMProxyProperty::GetNumberOfUncheckedProxies());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_SetNumberOfProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfProxies(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::SetNumberOfProxies(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_SetNumberOfUncheckedProxies(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfUncheckedProxies");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfUncheckedProxies(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::SetNumberOfUncheckedProxies(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_GetProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkSMProxy *tempr = (ap.IsBound() ?
      op->GetProxy(temp0) :
      op->vtkSMProxyProperty::GetProxy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_GetUncheckedProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUncheckedProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkSMProxy *tempr = (ap.IsBound() ?
      op->GetUncheckedProxy(temp0) :
      op->vtkSMProxyProperty::GetUncheckedProxy(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_Copy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Copy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  vtkSMProperty *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProperty"))
  {
    if (ap.IsBound())
    {
      op->Copy(temp0);
    }
    else
    {
      op->vtkSMProxyProperty::Copy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_GetSkipDependency(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSkipDependency");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetSkipDependency() :
      op->vtkSMProxyProperty::GetSkipDependency());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_UpdateAllInputs(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateAllInputs");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateAllInputs();
    }
    else
    {
      op->vtkSMProxyProperty::UpdateAllInputs();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_IsValueDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsValueDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsValueDefault() :
      op->vtkSMProxyProperty::IsValueDefault());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMProxyProperty_ResetToXMLDefaults(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ResetToXMLDefaults");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMProxyProperty *op = static_cast<vtkSMProxyProperty *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ResetToXMLDefaults();
    }
    else
    {
      op->vtkSMProxyProperty::ResetToXMLDefaults();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMProxyProperty_Methods[] = {
  {"EnableProxyCreation", PyvtkSMProxyProperty_EnableProxyCreation, METH_VARARGS,
   "V.EnableProxyCreation()\nC++: static void EnableProxyCreation()\n\nWhen we load ProxyManager state we want Proxy/InputProperty to be\nable to create the corresponding missing proxy. Although when the\ngoal is to load a state on any standard proxy, we do not want\nthat proxy property be able to create new proxy based on some\nprevious state.\n"},
  {"DisableProxyCreation", PyvtkSMProxyProperty_DisableProxyCreation, METH_VARARGS,
   "V.DisableProxyCreation()\nC++: static void DisableProxyCreation()\n\nWhen we load ProxyManager state we want Proxy/InputProperty to be\nable to create the corresponding missing proxy. Although when the\ngoal is to load a state on any standard proxy, we do not want\nthat proxy property be able to create new proxy based on some\nprevious state.\n"},
  {"CanCreateProxy", PyvtkSMProxyProperty_CanCreateProxy, METH_VARARGS,
   "V.CanCreateProxy() -> bool\nC++: static bool CanCreateProxy()\n\nWhen we load ProxyManager state we want Proxy/InputProperty to be\nable to create the corresponding missing proxy. Although when the\ngoal is to load a state on any standard proxy, we do not want\nthat proxy property be able to create new proxy based on some\nprevious state.\n"},
  {"IsTypeOf", PyvtkSMProxyProperty_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMProxyProperty_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMProxyProperty_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMProxyProperty\nC++: static vtkSMProxyProperty *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMProxyProperty_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMProxyProperty\nC++: vtkSMProxyProperty *NewInstance()\n\n"},
  {"AddProxy", PyvtkSMProxyProperty_AddProxy, METH_VARARGS,
   "V.AddProxy(vtkSMProxy)\nC++: virtual void AddProxy(vtkSMProxy *proxy)\n\nAdd/remove/set a proxy to the list of proxies. For SetProxy, the\nproperty automatically resizes to accommodate the index\nspecified.\n"},
  {"SetProxy", PyvtkSMProxyProperty_SetProxy, METH_VARARGS,
   "V.SetProxy(int, vtkSMProxy)\nC++: virtual void SetProxy(unsigned int idx, vtkSMProxy *proxy)\n\nAdd/remove/set a proxy to the list of proxies. For SetProxy, the\nproperty automatically resizes to accommodate the index\nspecified.\n"},
  {"RemoveProxy", PyvtkSMProxyProperty_RemoveProxy, METH_VARARGS,
   "V.RemoveProxy(vtkSMProxy)\nC++: virtual void RemoveProxy(vtkSMProxy *proxy)\n\nAdd/remove/set a proxy to the list of proxies. For SetProxy, the\nproperty automatically resizes to accommodate the index\nspecified.\n"},
  {"RemoveAllProxies", PyvtkSMProxyProperty_RemoveAllProxies, METH_VARARGS,
   "V.RemoveAllProxies()\nC++: virtual void RemoveAllProxies()\n\nAdd/remove/set a proxy to the list of proxies. For SetProxy, the\nproperty automatically resizes to accommodate the index\nspecified.\n"},
  {"IsProxyAdded", PyvtkSMProxyProperty_IsProxyAdded, METH_VARARGS,
   "V.IsProxyAdded(vtkSMProxy) -> bool\nC++: bool IsProxyAdded(vtkSMProxy *proxy)\n\nReturns if the given proxy is already added to the property.\n"},
  {"AddUncheckedProxy", PyvtkSMProxyProperty_AddUncheckedProxy, METH_VARARGS,
   "V.AddUncheckedProxy(vtkSMProxy)\nC++: virtual void AddUncheckedProxy(vtkSMProxy *proxy)\n\nAdd an unchecked proxy. Does not modify the property. Unchecked\nproxies are used by domains when verifying whether a value is\nacceptable. To check if a value is in the domains, you can do the\nfollowing:\n - RemoveAllUncheckedProxies()\n - AddUncheckedProxy(proxy)\n - IsInDomains()\n \n"},
  {"SetUncheckedProxy", PyvtkSMProxyProperty_SetUncheckedProxy, METH_VARARGS,
   "V.SetUncheckedProxy(int, vtkSMProxy)\nC++: virtual void SetUncheckedProxy(unsigned int idx,\n    vtkSMProxy *proxy)\n\nAdd an unchecked proxy. Does not modify the property. Unchecked\nproxies are used by domains when verifying whether a value is\nacceptable. To check if a value is in the domains, you can do the\nfollowing:\n - RemoveAllUncheckedProxies()\n - AddUncheckedProxy(proxy)\n - IsInDomains()\n \n"},
  {"RemoveAllUncheckedProxies", PyvtkSMProxyProperty_RemoveAllUncheckedProxies, METH_VARARGS,
   "V.RemoveAllUncheckedProxies()\nC++: virtual void RemoveAllUncheckedProxies()\n\nRemoves all unchecked proxies.\n"},
  {"ClearUncheckedElements", PyvtkSMProxyProperty_ClearUncheckedElements, METH_VARARGS,
   "V.ClearUncheckedElements()\nC++: virtual void ClearUncheckedElements()\n\n"},
  {"GetNumberOfProxies", PyvtkSMProxyProperty_GetNumberOfProxies, METH_VARARGS,
   "V.GetNumberOfProxies() -> int\nC++: unsigned int GetNumberOfProxies()\n\nReturns the number of proxies.\n"},
  {"GetNumberOfUncheckedProxies", PyvtkSMProxyProperty_GetNumberOfUncheckedProxies, METH_VARARGS,
   "V.GetNumberOfUncheckedProxies() -> int\nC++: unsigned int GetNumberOfUncheckedProxies()\n\nReturns the number of unchecked proxies.\n"},
  {"SetNumberOfProxies", PyvtkSMProxyProperty_SetNumberOfProxies, METH_VARARGS,
   "V.SetNumberOfProxies(int)\nC++: void SetNumberOfProxies(unsigned int count)\n\nSet the number of proxies.\n"},
  {"SetNumberOfUncheckedProxies", PyvtkSMProxyProperty_SetNumberOfUncheckedProxies, METH_VARARGS,
   "V.SetNumberOfUncheckedProxies(int)\nC++: void SetNumberOfUncheckedProxies(unsigned int count)\n\nSet the number of proxies.\n"},
  {"GetProxy", PyvtkSMProxyProperty_GetProxy, METH_VARARGS,
   "V.GetProxy(int) -> vtkSMProxy\nC++: vtkSMProxy *GetProxy(unsigned int idx)\n\nReturn a proxy. No bounds check is performed.\n"},
  {"GetUncheckedProxy", PyvtkSMProxyProperty_GetUncheckedProxy, METH_VARARGS,
   "V.GetUncheckedProxy(int) -> vtkSMProxy\nC++: vtkSMProxy *GetUncheckedProxy(unsigned int idx)\n\nReturn a proxy. No bounds check is performed.\n"},
  {"Copy", PyvtkSMProxyProperty_Copy, METH_VARARGS,
   "V.Copy(vtkSMProperty)\nC++: virtual void Copy(vtkSMProperty *src)\n\nCopy all property values. This method behaves differently for\nproperties with vtkSMProxyListDomain and those without it. If the\nproperty has a vtkSMProxyListDomain, then the property is acting\nas an enumeration, giving user ability to pick one of the\navailable proxies in the domain, hence a `Copy` request, will\nfind an equivalent proxy on the target's domain and set that as\nthe value of the target property.\n"},
  {"GetSkipDependency", PyvtkSMProxyProperty_GetSkipDependency, METH_VARARGS,
   "V.GetSkipDependency() -> bool\nC++: virtual bool GetSkipDependency()\n\nReturns whether the \"skip_dependency\" attribute is set.\n"},
  {"UpdateAllInputs", PyvtkSMProxyProperty_UpdateAllInputs, METH_VARARGS,
   "V.UpdateAllInputs()\nC++: virtual void UpdateAllInputs()\n\nUpdate all proxies referred by this property (if any).\n"},
  {"IsValueDefault", PyvtkSMProxyProperty_IsValueDefault, METH_VARARGS,
   "V.IsValueDefault() -> bool\nC++: virtual bool IsValueDefault()\n\n"},
  {"ResetToXMLDefaults", PyvtkSMProxyProperty_ResetToXMLDefaults, METH_VARARGS,
   "V.ResetToXMLDefaults()\nC++: virtual void ResetToXMLDefaults()\n\nFor properties that support specifying defaults in XML\nconfiguration, this method will reset the property value to the\ndefault values specified in the XML. Simply clears the property.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMProxyProperty_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMProxyProperty", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMProxyProperty_StaticNew()
{
  return vtkSMProxyProperty::New();
}

PyObject *PyvtkSMProxyProperty_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMProxyProperty_Type, PyvtkSMProxyProperty_Methods,
    "vtkSMProxyProperty",
    PyvtkSMProxyProperty_Doc(), &PyvtkSMProxyProperty_StaticNew);

  PyTypeObject *pytype = &PyvtkSMProxyProperty_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMProperty_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMProxyProperty_Doc()
{
  static const char *docstring[] = {
    "vtkSMProxyProperty - property representing pointer(s) to vtkObject(s)\n\n",
    "Superclass: vtkSMProperty\n\n",
    "vtkSMProxyProperty is a concrete sub-class of vtkSMProperty\nrepresenting pointer(s) to vtkObject(s) (through vtkSMProxy).\n\nvtkSMProperty::UpdateDomains() is called by vtkSMProperty itself\nwhenever its unchecked values are modified. In case of\nproxy-properties, the dependent domains typically tend to depend on\nthe data information provided by the source-proxies added to the\nproperty. Thus, to ensur",
    "e that the domains get updated if the data\ninformation changes, vtkSMProxyProperty ensures that\nvtkSMProperty::UpdateDomains() is called whenever any of the added\nproxies fires the vtkCommand::UpdateDataEvent (which is fired\nwhenever the pipeline us updated through the ServerManager indicating\nthat the data-information last used may have been invalidated).\n\nBesides the standard set of attributes, ",
    "the following XML attributes\nare supported:\n\\li command : identifies the method to call on the VTK object e.g.\nAddRepresentation.\n\\li clean_command : if present, called once before invoking the\n    method\nspecified by command every time the property value is pushed e.g.\nRemoveAllRepresentations. If property can take multiple values then\nthe command is called for for each of the values after the cl",
    "ean\ncommand for every push.\n\\li remove_command : an alternative to clean_command where instead of\nresetting and adding all the values for every push, this simply calls\nthe specified method to remove the vtk-objects no longer referred to\ne.g. RemoveRepresentation.\n\\li argument_type : identifies the type for value passed to the\n    method on the\nVTK object. Accepted values are \"VTK\", \"SMProxy\" or \"S",
    "IProxy\".\nDefault is VTK.\n\\li null_on_empty : if set to 1, whenever the property's value\n    changes to\nempty i.e. it contains no proxies, the command is called on the VTK\nobject with NULL argument useful when there's no clean_command that\ncan be called on the VTK object to unset the property e.g.\nSetLookupTable(NULL). li skip_dependency : if set to 1, this property\ndoes not result in adding a depe",
    "ndency between the proxies set as\nvalues of this property and the proxy to which the property belongs\n(which is the default behaviour). Use this with care as it would mean\nthat ParaView would no realize any updates are needed to the pipeline\nif any proxy set on the property changes. This is necessary in some\ncases, e.g. if LUT proxy on a representation changes, we don't want\nto representation to t",
    "reat it same as if the input pipeline changed!\n@sa\nvtkSMProperty\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMProxyProperty(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMProxyProperty_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMProxyProperty", o) != 0)
  {
    Py_DECREF(o);
  }

}

