// python wrapper for vtkSMSelectionHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMSelectionHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMSelectionHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMSelectionHelper_ClassNew(); }

#ifndef DECLARED_PyvtkSMObject_ClassNew
extern "C" { PyObject *PyvtkSMObject_ClassNew(); }
#define DECLARED_PyvtkSMObject_ClassNew
#endif

static const char **PyvtkSMSelectionHelper_Doc();


static PyObject *
PyvtkSMSelectionHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMSelectionHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSelectionHelper *op = static_cast<vtkSMSelectionHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMSelectionHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMSelectionHelper *tempr = vtkSMSelectionHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSelectionHelper *op = static_cast<vtkSMSelectionHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMSelectionHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMSelectionHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_NewSelectionSourceFromSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "NewSelectionSourceFromSelection");

  vtkSMSession *temp0 = NULL;
  vtkSelection *temp1 = NULL;
  bool temp2 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkSMSession") &&
      ap.GetVTKObject(temp1, "vtkSelection") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkSMProxy *tempr = vtkSMSelectionHelper::NewSelectionSourceFromSelection(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_NewSelectionSourcesFromSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "NewSelectionSourcesFromSelection");

  vtkSelection *temp0 = NULL;
  vtkSMProxy *temp1 = NULL;
  vtkCollection *temp2 = NULL;
  vtkCollection *temp3 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkSelection") &&
      ap.GetVTKObject(temp1, "vtkSMProxy") &&
      ap.GetVTKObject(temp2, "vtkCollection") &&
      ap.GetVTKObject(temp3, "vtkCollection"))
  {
    vtkSMSelectionHelper::NewSelectionSourcesFromSelection(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_ConvertSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ConvertSelection");

  int temp0;
  vtkSMProxy *temp1 = NULL;
  vtkSMSourceProxy *temp2 = NULL;
  int temp3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMProxy") &&
      ap.GetVTKObject(temp2, "vtkSMSourceProxy") &&
      ap.GetValue(temp3))
  {
    vtkSMProxy *tempr = vtkSMSelectionHelper::ConvertSelection(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_MergeSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "MergeSelection");

  vtkSMSourceProxy *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  vtkSMSourceProxy *temp2 = NULL;
  int temp3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp2, "vtkSMSourceProxy") &&
      ap.GetValue(temp3))
  {
    bool tempr = vtkSMSelectionHelper::MergeSelection(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_SubtractSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SubtractSelection");

  vtkSMSourceProxy *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  vtkSMSourceProxy *temp2 = NULL;
  int temp3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp2, "vtkSMSourceProxy") &&
      ap.GetValue(temp3))
  {
    bool tempr = vtkSMSelectionHelper::SubtractSelection(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSelectionHelper_ToggleSelection(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "ToggleSelection");

  vtkSMSourceProxy *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  vtkSMSourceProxy *temp2 = NULL;
  int temp3;
  PyObject *result = NULL;

  if (ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp2, "vtkSMSourceProxy") &&
      ap.GetValue(temp3))
  {
    bool tempr = vtkSMSelectionHelper::ToggleSelection(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMSelectionHelper_Methods[] = {
  {"IsTypeOf", PyvtkSMSelectionHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMSelectionHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMSelectionHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMSelectionHelper\nC++: static vtkSMSelectionHelper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMSelectionHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMSelectionHelper\nC++: vtkSMSelectionHelper *NewInstance()\n\n"},
  {"NewSelectionSourceFromSelection", PyvtkSMSelectionHelper_NewSelectionSourceFromSelection, METH_VARARGS,
   "V.NewSelectionSourceFromSelection(vtkSMSession, vtkSelection,\n    bool) -> vtkSMProxy\nC++: static vtkSMProxy *NewSelectionSourceFromSelection(\n    vtkSMSession *session, vtkSelection *selection,\n    bool ignore_composite_keys=false)\n\nGiven a selection, returns a proxy for a selection source that\nhas the ids specified by it. This source can then be used as\ninput to a vtkExtractSelection filter. CAVEAT: Make sure to\nspecify the connection id for the server on which the selection\nwas performed. This method can only handle 3 types of selection\nFRUSTUM, INDICES and GLOBALIDS. We can easily change this to\nhandle all other types of selection but that's not required\ncurrently and hence we not adding that code.\n"},
  {"NewSelectionSourcesFromSelection", PyvtkSMSelectionHelper_NewSelectionSourcesFromSelection, METH_VARARGS,
   "V.NewSelectionSourcesFromSelection(vtkSelection, vtkSMProxy,\n    vtkCollection, vtkCollection)\nC++: static void NewSelectionSourcesFromSelection(\n    vtkSelection *selection, vtkSMProxy *view,\n    vtkCollection *selSources, vtkCollection *selRepresentations)\n\n"},
  {"ConvertSelection", PyvtkSMSelectionHelper_ConvertSelection, METH_VARARGS,
   "V.ConvertSelection(int, vtkSMProxy, vtkSMSourceProxy, int)\n    -> vtkSMProxy\nC++: static vtkSMProxy *ConvertSelection(int outputType,\n    vtkSMProxy *selectionSourceProxy,\n    vtkSMSourceProxy *dataSource, int outputport)\n\nGiven the ContentType for an output vtkSelection, this create a\nnew source proxy generating the selection, the input\nselectionSourceProxy is used to fill the default values for\ncreated selection source.\n"},
  {"MergeSelection", PyvtkSMSelectionHelper_MergeSelection, METH_VARARGS,
   "V.MergeSelection(vtkSMSourceProxy, vtkSMSourceProxy,\n    vtkSMSourceProxy, int) -> bool\nC++: static bool MergeSelection(vtkSMSourceProxy *output,\n    vtkSMSourceProxy *input, vtkSMSourceProxy *dataSource,\n    int outputport)\n\nUpdates output to be a combination of (input | output) if the two\nselection sources are mergeable. Returns true if merge\nsuccessful. dataSource and outputport are needed if a conversion\nis needed to make the input expandable to the type of the output.\n"},
  {"SubtractSelection", PyvtkSMSelectionHelper_SubtractSelection, METH_VARARGS,
   "V.SubtractSelection(vtkSMSourceProxy, vtkSMSourceProxy,\n    vtkSMSourceProxy, int) -> bool\nC++: static bool SubtractSelection(vtkSMSourceProxy *output,\n    vtkSMSourceProxy *input, vtkSMSourceProxy *dataSource,\n    int outputport)\n\nUpdates output to be a subtraction of input and output (input -\noutput) if the two selection sources are mergeable. Returns true\nif the subtraction is successful. dataSource and outputport are\nneeded if a conversion is needed to make the input expandable to\nthe type of the output.\n"},
  {"ToggleSelection", PyvtkSMSelectionHelper_ToggleSelection, METH_VARARGS,
   "V.ToggleSelection(vtkSMSourceProxy, vtkSMSourceProxy,\n    vtkSMSourceProxy, int) -> bool\nC++: static bool ToggleSelection(vtkSMSourceProxy *output,\n    vtkSMSourceProxy *input, vtkSMSourceProxy *dataSource,\n    int outputport)\n\nUpdates output to be a toggle of input and output (input + (input\n| output ) - (input & output ) ) if the two selection sources are\nmergeable. Returns true if the toggling is successful. dataSource\nand outputport are needed if a conversion is needed to make the\ninput expandable to the type of the output.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMSelectionHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerRenderingPython.vtkSMSelectionHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMSelectionHelper_StaticNew()
{
  return vtkSMSelectionHelper::New();
}

PyObject *PyvtkSMSelectionHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMSelectionHelper_Type, PyvtkSMSelectionHelper_Methods,
    "vtkSMSelectionHelper",
    PyvtkSMSelectionHelper_Doc(), &PyvtkSMSelectionHelper_StaticNew);

  PyTypeObject *pytype = &PyvtkSMSelectionHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMSelectionHelper_Doc()
{
  static const char *docstring[] = {
    "vtkSMSelectionHelper - Utility class to help with selection tasks\n\n",
    "Superclass: vtkSMObject\n\n",
    "This class contains several static methods that help with the\ncomplicated selection task.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMSelectionHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMSelectionHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMSelectionHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

