// python wrapper for vtkSMTooltipSelectionPipeline
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSMTooltipSelectionPipeline.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMTooltipSelectionPipeline(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMTooltipSelectionPipeline_ClassNew(); }

#ifndef DECLARED_PyvtkSMPreselectionPipeline_ClassNew
extern "C" { PyObject *PyvtkSMPreselectionPipeline_ClassNew(); }
#define DECLARED_PyvtkSMPreselectionPipeline_ClassNew
#endif

static const char **PyvtkSMTooltipSelectionPipeline_Doc();


static PyObject *
PyvtkSMTooltipSelectionPipeline_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMTooltipSelectionPipeline::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMTooltipSelectionPipeline::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMTooltipSelectionPipeline *tempr = vtkSMTooltipSelectionPipeline::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMTooltipSelectionPipeline *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMTooltipSelectionPipeline::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_GetInstance(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetInstance");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkSMTooltipSelectionPipeline *tempr = vtkSMTooltipSelectionPipeline::GetInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_Hide(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Hide");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  vtkSMRenderViewProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMRenderViewProxy"))
  {
    if (ap.IsBound())
    {
      op->Hide(temp0);
    }
    else
    {
      op->vtkSMTooltipSelectionPipeline::Hide(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_Show(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Show");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  vtkSMSourceProxy *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  vtkSMRenderViewProxy *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy") &&
      ap.GetVTKObject(temp2, "vtkSMRenderViewProxy"))
  {
    if (ap.IsBound())
    {
      op->Show(temp0, temp1, temp2);
    }
    else
    {
      op->vtkSMTooltipSelectionPipeline::Show(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_CanDisplayTooltip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanDisplayTooltip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  bool temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->CanDisplayTooltip(temp0) :
      op->vtkSMTooltipSelectionPipeline::CanDisplayTooltip(temp0));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(0, temp0);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMTooltipSelectionPipeline_GetTooltipInfo(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTooltipInfo");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMTooltipSelectionPipeline *op = static_cast<vtkSMTooltipSelectionPipeline *>(vp);

  int temp0;
  const int size1 = 2;
  double temp1[2];
  double save1[2];
  std::string temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetValue(temp2))
  {
    ap.SaveArray(temp1, save1, size1);

    bool tempr = (ap.IsBound() ?
      op->GetTooltipInfo(temp0, temp1, temp2) :
      op->vtkSMTooltipSelectionPipeline::GetTooltipInfo(temp0, temp1, temp2));

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMTooltipSelectionPipeline_Methods[] = {
  {"IsTypeOf", PyvtkSMTooltipSelectionPipeline_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMTooltipSelectionPipeline_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMTooltipSelectionPipeline_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMTooltipSelectionPipeline\nC++: static vtkSMTooltipSelectionPipeline *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMTooltipSelectionPipeline_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMTooltipSelectionPipeline\nC++: vtkSMTooltipSelectionPipeline *NewInstance()\n\n"},
  {"GetInstance", PyvtkSMTooltipSelectionPipeline_GetInstance, METH_VARARGS,
   "V.GetInstance() -> vtkSMTooltipSelectionPipeline\nC++: static vtkSMTooltipSelectionPipeline *GetInstance()\n\n"},
  {"Hide", PyvtkSMTooltipSelectionPipeline_Hide, METH_VARARGS,
   "V.Hide(vtkSMRenderViewProxy)\nC++: virtual void Hide(vtkSMRenderViewProxy *view)\n\nRe-implemented from vtkSMPreselectionPipeline\n"},
  {"Show", PyvtkSMTooltipSelectionPipeline_Show, METH_VARARGS,
   "V.Show(vtkSMSourceProxy, vtkSMSourceProxy, vtkSMRenderViewProxy)\nC++: virtual void Show(vtkSMSourceProxy *sourceRepresentation,\n    vtkSMSourceProxy *selection, vtkSMRenderViewProxy *view)\n\nRe-implemented from vtkSMPreselectionPipeline\n"},
  {"CanDisplayTooltip", PyvtkSMTooltipSelectionPipeline_CanDisplayTooltip, METH_VARARGS,
   "V.CanDisplayTooltip(bool) -> bool\nC++: bool CanDisplayTooltip(bool &showTooltip)\n\nReturn true if a tooltip can be displayed according to the\ncontext, otherwise return false. The argument showTooltip is true\nif the tooltip must be shown, false if the tooltip must be\nhidden.\n"},
  {"GetTooltipInfo", PyvtkSMTooltipSelectionPipeline_GetTooltipInfo, METH_VARARGS,
   "V.GetTooltipInfo(int, [float, float], string) -> bool\nC++: bool GetTooltipInfo(int association, double tooltipPos[2],\n    std::string &tooltipText)\n\nGet information about the tooltip to be displayed. Return false\nif the method failed computing information.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMTooltipSelectionPipeline_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkSMTooltipSelectionPipeline", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMTooltipSelectionPipeline_StaticNew()
{
  return vtkSMTooltipSelectionPipeline::New();
}

PyObject *PyvtkSMTooltipSelectionPipeline_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMTooltipSelectionPipeline_Type, PyvtkSMTooltipSelectionPipeline_Methods,
    "vtkSMTooltipSelectionPipeline",
    PyvtkSMTooltipSelectionPipeline_Doc(), &PyvtkSMTooltipSelectionPipeline_StaticNew);

  PyTypeObject *pytype = &PyvtkSMTooltipSelectionPipeline_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMPreselectionPipeline_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMTooltipSelectionPipeline_Doc()
{
  static const char *docstring[] = {
    "vtkSMTooltipSelectionPipeline - Point tooltip mode enables the user\nto inspect points (coordinates, data array values) by hovering the\nmouse cursor over a point.\n\n",
    "Superclass: vtkSMPreselectionPipeline\n\n",
    "This is a global object that holds the pipeline for showing the point\ntooltip mode.\n\n@sa\nvtkSMPreselectionPipeline vtkSMInteractiveSelectionPipeline\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMTooltipSelectionPipeline(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMTooltipSelectionPipeline_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMTooltipSelectionPipeline", o) != 0)
  {
    Py_DECREF(o);
  }

}

