// python wrapper for vtkSMViewExportHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSMViewExportHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMViewExportHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMViewExportHelper_ClassNew(); }

#ifndef DECLARED_PyvtkSMObject_ClassNew
extern "C" { PyObject *PyvtkSMObject_ClassNew(); }
#define DECLARED_PyvtkSMObject_ClassNew
#endif

static const char **PyvtkSMViewExportHelper_Doc();


static PyObject *
PyvtkSMViewExportHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMViewExportHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewExportHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewExportHelper *op = static_cast<vtkSMViewExportHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMViewExportHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewExportHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMViewExportHelper *tempr = vtkSMViewExportHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewExportHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewExportHelper *op = static_cast<vtkSMViewExportHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMViewExportHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMViewExportHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewExportHelper_GetSupportedFileTypes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSupportedFileTypes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewExportHelper *op = static_cast<vtkSMViewExportHelper *>(vp);

  vtkSMViewProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMViewProxy"))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetSupportedFileTypes(temp0) :
      op->vtkSMViewExportHelper::GetSupportedFileTypes(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewExportHelper_CreateExporter(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateExporter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewExportHelper *op = static_cast<vtkSMViewExportHelper *>(vp);

  char *temp0 = NULL;
  vtkSMViewProxy *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMViewProxy"))
  {
    vtkSMExporterProxy *tempr = (ap.IsBound() ?
      op->CreateExporter(temp0, temp1) :
      op->vtkSMViewExportHelper::CreateExporter(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMViewExportHelper_Methods[] = {
  {"IsTypeOf", PyvtkSMViewExportHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMViewExportHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMViewExportHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMViewExportHelper\nC++: static vtkSMViewExportHelper *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMViewExportHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMViewExportHelper\nC++: vtkSMViewExportHelper *NewInstance()\n\n"},
  {"GetSupportedFileTypes", PyvtkSMViewExportHelper_GetSupportedFileTypes, METH_VARARGS,
   "V.GetSupportedFileTypes(vtkSMViewProxy) -> string\nC++: virtual vtkStdString GetSupportedFileTypes(\n    vtkSMViewProxy *view)\n\nReturns a formatted string with all supported file types for the\ngiven view. An example returned string would look like:\n \"PVD Files (*.pvd);;VTK Files (*.vtk)\"\n \n"},
  {"CreateExporter", PyvtkSMViewExportHelper_CreateExporter, METH_VARARGS,
   "V.CreateExporter(string, vtkSMViewProxy) -> vtkSMExporterProxy\nC++: virtual vtkSMExporterProxy *CreateExporter(\n    const char *filename, vtkSMViewProxy *)\n\nExports the view to the given output file. Returns a new exporter\ninstance (or NULL). Caller must release the returned object\nexplicitly.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMViewExportHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkSMViewExportHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMViewExportHelper_StaticNew()
{
  return vtkSMViewExportHelper::New();
}

PyObject *PyvtkSMViewExportHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMViewExportHelper_Type, PyvtkSMViewExportHelper_Methods,
    "vtkSMViewExportHelper",
    PyvtkSMViewExportHelper_Doc(), &PyvtkSMViewExportHelper_StaticNew);

  PyTypeObject *pytype = &PyvtkSMViewExportHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMViewExportHelper_Doc()
{
  static const char *docstring[] = {
    "vtkSMViewExportHelper - helper class to export views.\n\n",
    "Superclass: vtkSMObject\n\n",
    "vtkSMViewExportHelper is a helper class to aid in exporting views.\nYou can create instances of this helper on-demand to query available\nexporters and create and exporter proxy (in same spirit as\nvtkSMWriterFactory, except that there's no globally existing\ninstance).\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMViewExportHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMViewExportHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMViewExportHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

