// python wrapper for vtkSMViewProxyInteractorHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMViewProxyInteractorHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMViewProxyInteractorHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMViewProxyInteractorHelper_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkSMViewProxyInteractorHelper_Doc();


static PyObject *
PyvtkSMViewProxyInteractorHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMViewProxyInteractorHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMViewProxyInteractorHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMViewProxyInteractorHelper *tempr = vtkSMViewProxyInteractorHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMViewProxyInteractorHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMViewProxyInteractorHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_SetViewProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetViewProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  vtkSMViewProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMViewProxy"))
  {
    if (ap.IsBound())
    {
      op->SetViewProxy(temp0);
    }
    else
    {
      op->vtkSMViewProxyInteractorHelper::SetViewProxy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_GetViewProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetViewProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMViewProxy *tempr = (ap.IsBound() ?
      op->GetViewProxy() :
      op->vtkSMViewProxyInteractorHelper::GetViewProxy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_SetupInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetupInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  vtkRenderWindowInteractor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindowInteractor"))
  {
    if (ap.IsBound())
    {
      op->SetupInteractor(temp0);
    }
    else
    {
      op->vtkSMViewProxyInteractorHelper::SetupInteractor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_GetInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderWindowInteractor *tempr = (ap.IsBound() ?
      op->GetInteractor() :
      op->vtkSMViewProxyInteractorHelper::GetInteractor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMViewProxyInteractorHelper_CleanupInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CleanupInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMViewProxyInteractorHelper *op = static_cast<vtkSMViewProxyInteractorHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CleanupInteractor();
    }
    else
    {
      op->vtkSMViewProxyInteractorHelper::CleanupInteractor();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMViewProxyInteractorHelper_Methods[] = {
  {"IsTypeOf", PyvtkSMViewProxyInteractorHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMViewProxyInteractorHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMViewProxyInteractorHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMViewProxyInteractorHelper\nC++: static vtkSMViewProxyInteractorHelper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMViewProxyInteractorHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMViewProxyInteractorHelper\nC++: vtkSMViewProxyInteractorHelper *NewInstance()\n\n"},
  {"SetViewProxy", PyvtkSMViewProxyInteractorHelper_SetViewProxy, METH_VARARGS,
   "V.SetViewProxy(vtkSMViewProxy)\nC++: void SetViewProxy(vtkSMViewProxy *proxy)\n\nSet the view proxy. This is a weak reference i.e. the view\nproxy's reference count will be unchanged by this call.\n"},
  {"GetViewProxy", PyvtkSMViewProxyInteractorHelper_GetViewProxy, METH_VARARGS,
   "V.GetViewProxy() -> vtkSMViewProxy\nC++: vtkSMViewProxy *GetViewProxy()\n\nSet the view proxy. This is a weak reference i.e. the view\nproxy's reference count will be unchanged by this call.\n"},
  {"SetupInteractor", PyvtkSMViewProxyInteractorHelper_SetupInteractor, METH_VARARGS,
   "V.SetupInteractor(vtkRenderWindowInteractor)\nC++: void SetupInteractor(vtkRenderWindowInteractor *iren)\n\nSet the interactor to \"help\" the view with. This is a weak\nreference i.e. the interactor's reference count will be unchanged\nby this call.\n"},
  {"GetInteractor", PyvtkSMViewProxyInteractorHelper_GetInteractor, METH_VARARGS,
   "V.GetInteractor() -> vtkRenderWindowInteractor\nC++: vtkRenderWindowInteractor *GetInteractor()\n\nSet the interactor to \"help\" the view with. This is a weak\nreference i.e. the interactor's reference count will be unchanged\nby this call.\n"},
  {"CleanupInteractor", PyvtkSMViewProxyInteractorHelper_CleanupInteractor, METH_VARARGS,
   "V.CleanupInteractor()\nC++: void CleanupInteractor()\n\nSet the interactor to \"help\" the view with. This is a weak\nreference i.e. the interactor's reference count will be unchanged\nby this call.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMViewProxyInteractorHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerRenderingPython.vtkSMViewProxyInteractorHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMViewProxyInteractorHelper_StaticNew()
{
  return vtkSMViewProxyInteractorHelper::New();
}

PyObject *PyvtkSMViewProxyInteractorHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMViewProxyInteractorHelper_Type, PyvtkSMViewProxyInteractorHelper_Methods,
    "vtkSMViewProxyInteractorHelper",
    PyvtkSMViewProxyInteractorHelper_Doc(), &PyvtkSMViewProxyInteractorHelper_StaticNew);

  PyTypeObject *pytype = &PyvtkSMViewProxyInteractorHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMViewProxyInteractorHelper_Doc()
{
  static const char *docstring[] = {
    "vtkSMViewProxyInteractorHelper - helper class that make it easier to\nhook vtkRenderWindowInteractor and vtkSMViewProxy.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkSMViewProxyInteractorHelper is a helper class designed to make it\neasier to hook up vtkRenderWindowInteractor to call methods on a\nvtkSMViewProxy (or subclass). It's primarily designed to work with\nvtkSMRenderViewProxy (and subclasses), but it should work with other\ntypes of views too.\n\nTo use this helper, the view typically creates a instance for itself\nas register itself (using\nvtkSMViewProxy",
    "InteractorHelper::SetViewProxy) and then calls\nvtkSMViewProxyInteractorHelper::SetupInteractor(). This method will\ninitialize the interactor (potentially changing some ivars on the\ninteractor to avoid automatic rendering, using\nvtkRenderWindowInteractor::EnableRenderOff(), etc.) and setup event\nobserver to monitor interaction.\n\nvtkSMViewProxyInteractorHelper only using\nvtkSMViewProxy::StillRender(",
    ") and vtkSMViewProxy::InteractiveRender()\nAPIs directly. However several properties can be optionally present\non the view proxy to dictate this class' behaviour. These are as\nfollows:\n\n\\li NonInteractiveRenderDelay :- when present provides time in\n    seconds to\ndelay the StillRender() call after user interaction has ended i.e.\nvtkRenderWindowInteractor fires the vtkCommand::EndInteractionEvent.\nI",
    "f missing, or less than 0.01, the view will immediately render.\n\n\\li EnableRenderOnInteraction :- when present provides a flag whether\nthe interactor\nshould trigger the render calls (either StillRender or\nInteractiveRender) as a consequence of interaction. If missing, we\ntreat EnableRender as ON.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMViewProxyInteractorHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMViewProxyInteractorHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMViewProxyInteractorHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

