// python wrapper for vtkSMWidgetRepresentationProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMWidgetRepresentationProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMWidgetRepresentationProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMWidgetRepresentationProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMProxy_ClassNew
extern "C" { PyObject *PyvtkSMProxy_ClassNew(); }
#define DECLARED_PyvtkSMProxy_ClassNew
#endif

static const char **PyvtkSMWidgetRepresentationProxy_Doc();


static PyObject *
PyvtkSMWidgetRepresentationProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMWidgetRepresentationProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWidgetRepresentationProxy *op = static_cast<vtkSMWidgetRepresentationProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMWidgetRepresentationProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMWidgetRepresentationProxy *tempr = vtkSMWidgetRepresentationProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWidgetRepresentationProxy *op = static_cast<vtkSMWidgetRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMWidgetRepresentationProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMWidgetRepresentationProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_OnStartInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnStartInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWidgetRepresentationProxy *op = static_cast<vtkSMWidgetRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnStartInteraction();
    }
    else
    {
      op->vtkSMWidgetRepresentationProxy::OnStartInteraction();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_OnEndInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnEndInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWidgetRepresentationProxy *op = static_cast<vtkSMWidgetRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnEndInteraction();
    }
    else
    {
      op->vtkSMWidgetRepresentationProxy::OnEndInteraction();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWidgetRepresentationProxy_OnInteraction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnInteraction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWidgetRepresentationProxy *op = static_cast<vtkSMWidgetRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnInteraction();
    }
    else
    {
      op->vtkSMWidgetRepresentationProxy::OnInteraction();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMWidgetRepresentationProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMWidgetRepresentationProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMWidgetRepresentationProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMWidgetRepresentationProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMWidgetRepresentationProxy\nC++: static vtkSMWidgetRepresentationProxy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMWidgetRepresentationProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMWidgetRepresentationProxy\nC++: vtkSMWidgetRepresentationProxy *NewInstance()\n\n"},
  {"OnStartInteraction", PyvtkSMWidgetRepresentationProxy_OnStartInteraction, METH_VARARGS,
   "V.OnStartInteraction()\nC++: virtual void OnStartInteraction()\n\nThese method forward the representation state of the client side\nwidget representation to the server.\n"},
  {"OnEndInteraction", PyvtkSMWidgetRepresentationProxy_OnEndInteraction, METH_VARARGS,
   "V.OnEndInteraction()\nC++: virtual void OnEndInteraction()\n\nThese method forward the representation state of the client side\nwidget representation to the server.\n"},
  {"OnInteraction", PyvtkSMWidgetRepresentationProxy_OnInteraction, METH_VARARGS,
   "V.OnInteraction()\nC++: virtual void OnInteraction()\n\nThese method forward the representation state of the client side\nwidget representation to the server.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMWidgetRepresentationProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerRenderingPython.vtkSMWidgetRepresentationProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMWidgetRepresentationProxy_StaticNew()
{
  return vtkSMWidgetRepresentationProxy::New();
}

PyObject *PyvtkSMWidgetRepresentationProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMWidgetRepresentationProxy_Type, PyvtkSMWidgetRepresentationProxy_Methods,
    "vtkSMWidgetRepresentationProxy",
    PyvtkSMWidgetRepresentationProxy_Doc(), &PyvtkSMWidgetRepresentationProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMWidgetRepresentationProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMWidgetRepresentationProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMWidgetRepresentationProxy - proxy for a widget representation\n\n",
    "Superclass: vtkSMProxy\n\n",
    "vtkSMWidgetRepresentationProxy is a specialized proxy that represents\nVTK widget representation. It adds the capability of syncing the\nappearance of server-side representation to the client-side\nrepresentation\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMWidgetRepresentationProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMWidgetRepresentationProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMWidgetRepresentationProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

