// python wrapper for vtkSMWriterProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMWriterProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMWriterProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMWriterProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMSourceProxy_ClassNew
extern "C" { PyObject *PyvtkSMSourceProxy_ClassNew(); }
#define DECLARED_PyvtkSMSourceProxy_ClassNew
#endif

static const char **PyvtkSMWriterProxy_Doc();


static PyObject *
PyvtkSMWriterProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMWriterProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMWriterProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMWriterProxy *tempr = vtkSMWriterProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMWriterProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMWriterProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_UpdatePipeline_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdatePipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdatePipeline();
    }
    else
    {
      op->vtkSMWriterProxy::UpdatePipeline();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterProxy_UpdatePipeline_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdatePipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->UpdatePipeline(temp0);
    }
    else
    {
      op->vtkSMWriterProxy::UpdatePipeline(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterProxy_UpdatePipeline(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkSMWriterProxy_UpdatePipeline_s1(self, args);
    case 1:
      return PyvtkSMWriterProxy_UpdatePipeline_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "UpdatePipeline");
  return NULL;
}



static PyObject *
PyvtkSMWriterProxy_SetSupportsParallel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSupportsParallel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSupportsParallel(temp0);
    }
    else
    {
      op->vtkSMWriterProxy::SetSupportsParallel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_GetSupportsParallel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSupportsParallel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSupportsParallel() :
      op->vtkSMWriterProxy::GetSupportsParallel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_GetParallelOnly(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParallelOnly");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetParallelOnly() :
      op->vtkSMWriterProxy::GetParallelOnly());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterProxy_SetParallelOnly(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParallelOnly");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterProxy *op = static_cast<vtkSMWriterProxy *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetParallelOnly(temp0);
    }
    else
    {
      op->vtkSMWriterProxy::SetParallelOnly(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMWriterProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMWriterProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMWriterProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMWriterProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMWriterProxy\nC++: static vtkSMWriterProxy *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMWriterProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMWriterProxy\nC++: vtkSMWriterProxy *NewInstance()\n\n"},
  {"UpdatePipeline", PyvtkSMWriterProxy_UpdatePipeline, METH_VARARGS,
   "V.UpdatePipeline()\nC++: virtual void UpdatePipeline()\nV.UpdatePipeline(float)\nC++: virtual void UpdatePipeline(double time)\n\nUpdates the pipeline and writes the file(s). Must call\nUpdateVTKObjects() before calling UpdatePipeline() to ensure that\nthe filename etc. are set correctly.\n"},
  {"SetSupportsParallel", PyvtkSMWriterProxy_SetSupportsParallel, METH_VARARGS,
   "V.SetSupportsParallel(int)\nC++: virtual void SetSupportsParallel(int _arg)\n\nFlag indicating if the writer supports writing in parallel. Not\nset by default.\n"},
  {"GetSupportsParallel", PyvtkSMWriterProxy_GetSupportsParallel, METH_VARARGS,
   "V.GetSupportsParallel() -> int\nC++: int GetSupportsParallel()\n\nFlag indicating if the writer supports writing in parallel. Not\nset by default.\n"},
  {"GetParallelOnly", PyvtkSMWriterProxy_GetParallelOnly, METH_VARARGS,
   "V.GetParallelOnly() -> int\nC++: virtual int GetParallelOnly()\n\nFlag indicating if the writer works only in parallel. If this is\nset, SupportsParallel is always true.\n"},
  {"SetParallelOnly", PyvtkSMWriterProxy_SetParallelOnly, METH_VARARGS,
   "V.SetParallelOnly(int)\nC++: virtual void SetParallelOnly(int _arg)\n\nFlag indicating if the writer works only in parallel. If this is\nset, SupportsParallel is always true.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMWriterProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMWriterProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMWriterProxy_StaticNew()
{
  return vtkSMWriterProxy::New();
}

PyObject *PyvtkSMWriterProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMWriterProxy_Type, PyvtkSMWriterProxy_Methods,
    "vtkSMWriterProxy",
    PyvtkSMWriterProxy_Doc(), &PyvtkSMWriterProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMWriterProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMSourceProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMWriterProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMWriterProxy - proxy for a VTK writer on a server\n\n",
    "Superclass: vtkSMSourceProxy\n\n",
    "vtkSMWriterProxy manages VTK writers that are created on a server\nusing the proxy pattern. vtkSMWriterProxy also provides support for\nmeta-writers. i.e. if the proxy has a subproxy name \"Writer\" that\nthis proxy represents a meta-writer which uses the given writer as\nthe writer to write each component.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMWriterProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMWriterProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMWriterProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

