// python wrapper for vtkSliceAlongPolyPlane
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSliceAlongPolyPlane.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSliceAlongPolyPlane(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSliceAlongPolyPlane_ClassNew(); }

#ifndef DECLARED_PyvtkDataObjectAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataObjectAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataObjectAlgorithm_ClassNew
#endif

static const char **PyvtkSliceAlongPolyPlane_Doc();


static PyObject *
PyvtkSliceAlongPolyPlane_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSliceAlongPolyPlane::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceAlongPolyPlane_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAlongPolyPlane *op = static_cast<vtkSliceAlongPolyPlane *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSliceAlongPolyPlane::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceAlongPolyPlane_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSliceAlongPolyPlane *tempr = vtkSliceAlongPolyPlane::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSliceAlongPolyPlane_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAlongPolyPlane *op = static_cast<vtkSliceAlongPolyPlane *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSliceAlongPolyPlane *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSliceAlongPolyPlane::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSliceAlongPolyPlane_SetTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAlongPolyPlane *op = static_cast<vtkSliceAlongPolyPlane *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTolerance(temp0);
    }
    else
    {
      op->vtkSliceAlongPolyPlane::SetTolerance(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSliceAlongPolyPlane_GetTolerance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTolerance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSliceAlongPolyPlane *op = static_cast<vtkSliceAlongPolyPlane *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTolerance() :
      op->vtkSliceAlongPolyPlane::GetTolerance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSliceAlongPolyPlane_Methods[] = {
  {"IsTypeOf", PyvtkSliceAlongPolyPlane_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSliceAlongPolyPlane_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSliceAlongPolyPlane_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSliceAlongPolyPlane\nC++: static vtkSliceAlongPolyPlane *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSliceAlongPolyPlane_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSliceAlongPolyPlane\nC++: vtkSliceAlongPolyPlane *NewInstance()\n\n"},
  {"SetTolerance", PyvtkSliceAlongPolyPlane_SetTolerance, METH_VARARGS,
   "V.SetTolerance(float)\nC++: virtual void SetTolerance(double _arg)\n\n"},
  {"GetTolerance", PyvtkSliceAlongPolyPlane_GetTolerance, METH_VARARGS,
   "V.GetTolerance() -> float\nC++: virtual double GetTolerance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSliceAlongPolyPlane_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreDefaultPython.vtkSliceAlongPolyPlane", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSliceAlongPolyPlane_StaticNew()
{
  return vtkSliceAlongPolyPlane::New();
}

PyObject *PyvtkSliceAlongPolyPlane_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSliceAlongPolyPlane_Type, PyvtkSliceAlongPolyPlane_Methods,
    "vtkSliceAlongPolyPlane",
    PyvtkSliceAlongPolyPlane_Doc(), &PyvtkSliceAlongPolyPlane_StaticNew);

  PyTypeObject *pytype = &PyvtkSliceAlongPolyPlane_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataObjectAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSliceAlongPolyPlane_Doc()
{
  static const char *docstring[] = {
    "vtkSliceAlongPolyPlane - slice a dataset along a polyplane\n\n",
    "Superclass: vtkDataObjectAlgorithm\n\n",
    "vtkSliceAlongPolyPlane is a filter that slices its first input\ndataset along the surface defined by sliding the poly line in the\nsecond input dataset along a line parallel to the Z-axis.\n\n@sa\nvtkCutter vtkPolyPlane\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSliceAlongPolyPlane(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSliceAlongPolyPlane_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSliceAlongPolyPlane", o) != 0)
  {
    Py_DECREF(o);
  }

}

