// python wrapper for vtkStringList
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStringList.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkStringList(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkStringList_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkStringList_Doc();


static PyObject *
PyvtkStringList_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkStringList::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkStringList::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkStringList *tempr = vtkStringList::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkStringList *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkStringList::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_AddString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->AddString(temp0);
    }
    else
    {
      op->vtkStringList::AddString(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_AddUniqueString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddUniqueString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->AddUniqueString(temp0);
    }
    else
    {
      op->vtkStringList::AddUniqueString(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_AddFormattedString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddFormattedString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->AddFormattedString(temp0);
    }
    else
    {
      op->vtkStringList::AddFormattedString(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_RemoveAllItems(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllItems");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllItems();
    }
    else
    {
      op->vtkStringList::RemoveAllItems();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_SetString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  int temp0;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetString(temp0, temp1);
    }
    else
    {
      op->vtkStringList::SetString(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_GetLength(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLength");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLength() :
      op->vtkStringList::GetLength());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_GetIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetIndex(temp0) :
      op->vtkStringList::GetIndex(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_GetString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetString(temp0) :
      op->vtkStringList::GetString(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkStringList_GetNumberOfStrings(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfStrings");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkStringList *op = static_cast<vtkStringList *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfStrings() :
      op->vtkStringList::GetNumberOfStrings());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkStringList_Methods[] = {
  {"IsTypeOf", PyvtkStringList_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkStringList_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkStringList_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkStringList\nC++: static vtkStringList *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkStringList_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkStringList\nC++: vtkStringList *NewInstance()\n\n"},
  {"AddString", PyvtkStringList_AddString, METH_VARARGS,
   "V.AddString(string)\nC++: void AddString(const char *str)\n\nAdd a simple string.\n"},
  {"AddUniqueString", PyvtkStringList_AddUniqueString, METH_VARARGS,
   "V.AddUniqueString(string)\nC++: void AddUniqueString(const char *str)\n\nAdd a simple string.\n"},
  {"AddFormattedString", PyvtkStringList_AddFormattedString, METH_VARARGS,
   "V.AddFormattedString(string)\nC++: void AddFormattedString(const char *EventString, ...)\n\nAdd a command and format it any way you like.\n"},
  {"RemoveAllItems", PyvtkStringList_RemoveAllItems, METH_VARARGS,
   "V.RemoveAllItems()\nC++: void RemoveAllItems()\n\nInitialize to empty.\n"},
  {"SetString", PyvtkStringList_SetString, METH_VARARGS,
   "V.SetString(int, string)\nC++: void SetString(int idx, const char *str)\n\nRandom access.\n"},
  {"GetLength", PyvtkStringList_GetLength, METH_VARARGS,
   "V.GetLength() -> int\nC++: int GetLength()\n\nGet the length of the list.\n"},
  {"GetIndex", PyvtkStringList_GetIndex, METH_VARARGS,
   "V.GetIndex(string) -> int\nC++: int GetIndex(const char *str)\n\nGet the index of a string.\n"},
  {"GetString", PyvtkStringList_GetString, METH_VARARGS,
   "V.GetString(int) -> string\nC++: const char *GetString(int idx)\n\nGet a command from its index.\n"},
  {"GetNumberOfStrings", PyvtkStringList_GetNumberOfStrings, METH_VARARGS,
   "V.GetNumberOfStrings() -> int\nC++: virtual int GetNumberOfStrings()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkStringList_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCommonPython.vtkStringList", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkStringList_StaticNew()
{
  return vtkStringList::New();
}

PyObject *PyvtkStringList_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkStringList_Type, PyvtkStringList_Methods,
    "vtkStringList",
    PyvtkStringList_Doc(), &PyvtkStringList_StaticNew);

  PyTypeObject *pytype = &PyvtkStringList_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkStringList_Doc()
{
  static const char *docstring[] = {
    "vtkStringList - no description provided.\n\n",
    "Superclass: vtkObject\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkStringList(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkStringList_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkStringList", o) != 0)
  {
    Py_DECREF(o);
  }

}

