// python wrapper for vtkWeightedRedistributePolyData
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkWeightedRedistributePolyData.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkWeightedRedistributePolyData(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkWeightedRedistributePolyData_ClassNew(); }

#ifndef DECLARED_PyvtkRedistributePolyData_ClassNew
extern "C" { PyObject *PyvtkRedistributePolyData_ClassNew(); }
#define DECLARED_PyvtkRedistributePolyData_ClassNew
#endif

static const char **PyvtkWeightedRedistributePolyData_Doc();


static PyObject *
PyvtkWeightedRedistributePolyData_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkWeightedRedistributePolyData::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkWeightedRedistributePolyData_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWeightedRedistributePolyData *op = static_cast<vtkWeightedRedistributePolyData *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkWeightedRedistributePolyData::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkWeightedRedistributePolyData_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkWeightedRedistributePolyData *tempr = vtkWeightedRedistributePolyData::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkWeightedRedistributePolyData_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWeightedRedistributePolyData *op = static_cast<vtkWeightedRedistributePolyData *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkWeightedRedistributePolyData *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkWeightedRedistributePolyData::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkWeightedRedistributePolyData_SetWeights(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetWeights");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkWeightedRedistributePolyData *op = static_cast<vtkWeightedRedistributePolyData *>(vp);

  int temp0;
  int temp1;
  float temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetWeights(temp0, temp1, temp2);
    }
    else
    {
      op->vtkWeightedRedistributePolyData::SetWeights(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkWeightedRedistributePolyData_Methods[] = {
  {"IsTypeOf", PyvtkWeightedRedistributePolyData_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkWeightedRedistributePolyData_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkWeightedRedistributePolyData_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkWeightedRedistributePolyData\nC++: static vtkWeightedRedistributePolyData *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkWeightedRedistributePolyData_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkWeightedRedistributePolyData\nC++: vtkWeightedRedistributePolyData *NewInstance()\n\n"},
  {"SetWeights", PyvtkWeightedRedistributePolyData_SetWeights, METH_VARARGS,
   "V.SetWeights(int, int, float)\nC++: void SetWeights(int, int, float)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkWeightedRedistributePolyData_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsRenderingPython.vtkWeightedRedistributePolyData", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkWeightedRedistributePolyData_StaticNew()
{
  return vtkWeightedRedistributePolyData::New();
}

PyObject *PyvtkWeightedRedistributePolyData_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkWeightedRedistributePolyData_Type, PyvtkWeightedRedistributePolyData_Methods,
    "vtkWeightedRedistributePolyData",
    PyvtkWeightedRedistributePolyData_Doc(), &PyvtkWeightedRedistributePolyData_StaticNew);

  PyTypeObject *pytype = &PyvtkWeightedRedistributePolyData_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkRedistributePolyData_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkWeightedRedistributePolyData_Doc()
{
  static const char *docstring[] = {
    "vtkWeightedRedistributePolyData - do weighted balance of cells on\nprocessors\n\n",
    "Superclass: vtkRedistributePolyData\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkWeightedRedistributePolyData(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkWeightedRedistributePolyData_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkWeightedRedistributePolyData", o) != 0)
  {
    Py_DECREF(o);
  }

}

