/* #undef PARAVIEW_USE_UNIFIED_BINDINGS */
/* #undef NO_PYTHON_BINDINGS_AVAILABLE */
#ifdef NO_PYTHON_BINDINGS_AVAILABLE
#undef PARAVIEW_USE_UNIFIED_BINDINGS
#endif
#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
#include "vtkPython.h"
#include "vtkPythonInterpreter.h"
#endif

#include "vtkClientServerInterpreter.h"

#ifndef PARAVIEW_BUILD_SHARED_LIBS
#define PARAVIEW_BUILD_SHARED_LIBS
#endif
#if defined(PARAVIEW_BUILD_SHARED_LIBS) && defined(_WIN32)
# define VTK_WRAP_CS_EXPORT __declspec(dllexport)
#else
# define VTK_WRAP_CS_EXPORT
#endif

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
extern "C" void real_initvtkIOImportPython(const char *modulename);

void initvtkIOImportPython()
{
  static const char modulename[] = "vtkIOImportPython";
  real_initvtkIOImportPython(modulename);
}
#endif

extern void vtk3DSImporter_Init(vtkClientServerInterpreter* csi);
extern void vtkImporter_Init(vtkClientServerInterpreter* csi);
extern void vtkVRMLImporter_Init(vtkClientServerInterpreter* csi);
extern void vtkOBJImporter_Init(vtkClientServerInterpreter* csi);


extern "C" void VTK_WRAP_CS_EXPORT vtkIOImportCS_Initialize(
  vtkClientServerInterpreter *csi)
{
  // silence unreferenced var warning.
  (void) csi;

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
  if (!vtkPythonInterpreter::IsInitialized())
    {
    vtkPythonInterpreter::Initialize();
    }

  static bool initialized = false;

  if (!initialized)
    {
    initialized = true;
    PyImport_AppendInittab("vtkIOImportPython", initvtkIOImportPython);
    }

  csi->Load("vtkIOImport");
#endif

  vtk3DSImporter_Init(csi);
  vtkImporter_Init(csi);
  vtkVRMLImporter_Init(csi);
  vtkOBJImporter_Init(csi);

}
