// python wrapper for vtkAvtFileFormatAlgorithm
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAvtFileFormatAlgorithm.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAvtFileFormatAlgorithm(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAvtFileFormatAlgorithm_ClassNew(); }

#ifndef DECLARED_PyvtkCompositeDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkCompositeDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkCompositeDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkAvtFileFormatAlgorithm_Doc();


static PyObject *
PyvtkAvtFileFormatAlgorithm_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAvtFileFormatAlgorithm::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAvtFileFormatAlgorithm::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAvtFileFormatAlgorithm *tempr = vtkAvtFileFormatAlgorithm::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAvtFileFormatAlgorithm *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAvtFileFormatAlgorithm::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetNumberOfPointArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPointArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPointArrays() :
      op->vtkAvtFileFormatAlgorithm::GetNumberOfPointArrays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetNumberOfCellArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfCellArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfCellArrays() :
      op->vtkAvtFileFormatAlgorithm::GetNumberOfCellArrays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetNumberOfMeshArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfMeshArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfMeshArrays() :
      op->vtkAvtFileFormatAlgorithm::GetNumberOfMeshArrays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetNumberOfMaterialArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfMaterialArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfMaterialArrays() :
      op->vtkAvtFileFormatAlgorithm::GetNumberOfMaterialArrays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetPointArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPointArrayName(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetPointArrayName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetCellArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCellArrayName(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetCellArrayName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetMeshArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMeshArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetMeshArrayName(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetMeshArrayName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetMaterialArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaterialArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetMaterialArrayName(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetMaterialArrayName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetPointArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPointArrayStatus(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetPointArrayStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetCellArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCellArrayStatus(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetCellArrayStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetMeshArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMeshArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMeshArrayStatus(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetMeshArrayStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_GetMaterialArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaterialArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaterialArrayStatus(temp0) :
      op->vtkAvtFileFormatAlgorithm::GetMaterialArrayStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_SetPointArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPointArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetPointArrayStatus(temp0, temp1);
    }
    else
    {
      op->vtkAvtFileFormatAlgorithm::SetPointArrayStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_SetCellArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetCellArrayStatus(temp0, temp1);
    }
    else
    {
      op->vtkAvtFileFormatAlgorithm::SetCellArrayStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_SetMeshArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMeshArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetMeshArrayStatus(temp0, temp1);
    }
    else
    {
      op->vtkAvtFileFormatAlgorithm::SetMeshArrayStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAvtFileFormatAlgorithm_SetMaterialArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaterialArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAvtFileFormatAlgorithm *op = static_cast<vtkAvtFileFormatAlgorithm *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetMaterialArrayStatus(temp0, temp1);
    }
    else
    {
      op->vtkAvtFileFormatAlgorithm::SetMaterialArrayStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkAvtFileFormatAlgorithm_Methods[] = {
  {"IsTypeOf", PyvtkAvtFileFormatAlgorithm_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkAvtFileFormatAlgorithm_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkAvtFileFormatAlgorithm_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkAvtFileFormatAlgorithm\nC++: static vtkAvtFileFormatAlgorithm *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkAvtFileFormatAlgorithm_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAvtFileFormatAlgorithm\nC++: vtkAvtFileFormatAlgorithm *NewInstance()\n\n"},
  {"GetNumberOfPointArrays", PyvtkAvtFileFormatAlgorithm_GetNumberOfPointArrays, METH_VARARGS,
   "V.GetNumberOfPointArrays() -> int\nC++: int GetNumberOfPointArrays()\n\nGet the number of point or cell arrays available in the input.\n"},
  {"GetNumberOfCellArrays", PyvtkAvtFileFormatAlgorithm_GetNumberOfCellArrays, METH_VARARGS,
   "V.GetNumberOfCellArrays() -> int\nC++: int GetNumberOfCellArrays()\n\nGet the number of point or cell arrays available in the input.\n"},
  {"GetNumberOfMeshArrays", PyvtkAvtFileFormatAlgorithm_GetNumberOfMeshArrays, METH_VARARGS,
   "V.GetNumberOfMeshArrays() -> int\nC++: int GetNumberOfMeshArrays()\n\nGet the number of point or cell arrays available in the input.\n"},
  {"GetNumberOfMaterialArrays", PyvtkAvtFileFormatAlgorithm_GetNumberOfMaterialArrays, METH_VARARGS,
   "V.GetNumberOfMaterialArrays() -> int\nC++: int GetNumberOfMaterialArrays()\n\nGet the number of point or cell arrays available in the input.\n"},
  {"GetPointArrayName", PyvtkAvtFileFormatAlgorithm_GetPointArrayName, METH_VARARGS,
   "V.GetPointArrayName(int) -> string\nC++: const char *GetPointArrayName(int index)\n\nGet the name of the point or cell array with the given index in\nthe input.\n"},
  {"GetCellArrayName", PyvtkAvtFileFormatAlgorithm_GetCellArrayName, METH_VARARGS,
   "V.GetCellArrayName(int) -> string\nC++: const char *GetCellArrayName(int index)\n\nGet the name of the point or cell array with the given index in\nthe input.\n"},
  {"GetMeshArrayName", PyvtkAvtFileFormatAlgorithm_GetMeshArrayName, METH_VARARGS,
   "V.GetMeshArrayName(int) -> string\nC++: const char *GetMeshArrayName(int index)\n\nGet the name of the point or cell array with the given index in\nthe input.\n"},
  {"GetMaterialArrayName", PyvtkAvtFileFormatAlgorithm_GetMaterialArrayName, METH_VARARGS,
   "V.GetMaterialArrayName(int) -> string\nC++: const char *GetMaterialArrayName(int index)\n\nGet the name of the point or cell array with the given index in\nthe input.\n"},
  {"GetPointArrayStatus", PyvtkAvtFileFormatAlgorithm_GetPointArrayStatus, METH_VARARGS,
   "V.GetPointArrayStatus(string) -> int\nC++: int GetPointArrayStatus(const char *name)\n\nGet/Set whether the point or cell array with the given name is to\nbe read.\n"},
  {"GetCellArrayStatus", PyvtkAvtFileFormatAlgorithm_GetCellArrayStatus, METH_VARARGS,
   "V.GetCellArrayStatus(string) -> int\nC++: int GetCellArrayStatus(const char *name)\n\nGet/Set whether the point or cell array with the given name is to\nbe read.\n"},
  {"GetMeshArrayStatus", PyvtkAvtFileFormatAlgorithm_GetMeshArrayStatus, METH_VARARGS,
   "V.GetMeshArrayStatus(string) -> int\nC++: int GetMeshArrayStatus(const char *name)\n\nGet/Set whether the point or cell array with the given name is to\nbe read.\n"},
  {"GetMaterialArrayStatus", PyvtkAvtFileFormatAlgorithm_GetMaterialArrayStatus, METH_VARARGS,
   "V.GetMaterialArrayStatus(string) -> int\nC++: int GetMaterialArrayStatus(const char *name)\n\nGet/Set whether the point or cell array with the given name is to\nbe read.\n"},
  {"SetPointArrayStatus", PyvtkAvtFileFormatAlgorithm_SetPointArrayStatus, METH_VARARGS,
   "V.SetPointArrayStatus(string, int)\nC++: void SetPointArrayStatus(const char *name, int status)\n\n"},
  {"SetCellArrayStatus", PyvtkAvtFileFormatAlgorithm_SetCellArrayStatus, METH_VARARGS,
   "V.SetCellArrayStatus(string, int)\nC++: void SetCellArrayStatus(const char *name, int status)\n\n"},
  {"SetMeshArrayStatus", PyvtkAvtFileFormatAlgorithm_SetMeshArrayStatus, METH_VARARGS,
   "V.SetMeshArrayStatus(string, int)\nC++: void SetMeshArrayStatus(const char *name, int status)\n\n"},
  {"SetMaterialArrayStatus", PyvtkAvtFileFormatAlgorithm_SetMaterialArrayStatus, METH_VARARGS,
   "V.SetMaterialArrayStatus(string, int)\nC++: void SetMaterialArrayStatus(const char *name, int status)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAvtFileFormatAlgorithm_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOVisItBridgePython.vtkAvtFileFormatAlgorithm", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAvtFileFormatAlgorithm_StaticNew()
{
  return vtkAvtFileFormatAlgorithm::New();
}

PyObject *PyvtkAvtFileFormatAlgorithm_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAvtFileFormatAlgorithm_Type, PyvtkAvtFileFormatAlgorithm_Methods,
    "vtkAvtFileFormatAlgorithm",
    PyvtkAvtFileFormatAlgorithm_Doc(), &PyvtkAvtFileFormatAlgorithm_StaticNew);

  PyTypeObject *pytype = &PyvtkAvtFileFormatAlgorithm_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCompositeDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAvtFileFormatAlgorithm_Doc()
{
  static const char *docstring[] = {
    "vtkAvtFileFormatAlgorithm - no description provided.\n\n",
    "Superclass: vtkCompositeDataSetAlgorithm\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAvtFileFormatAlgorithm(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAvtFileFormatAlgorithm_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAvtFileFormatAlgorithm", o) != 0)
  {
    Py_DECREF(o);
  }

}

