// python wrapper for vtkButterflySubdivisionFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkButterflySubdivisionFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkButterflySubdivisionFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkButterflySubdivisionFilter_ClassNew(); }

#ifndef DECLARED_PyvtkInterpolatingSubdivisionFilter_ClassNew
extern "C" { PyObject *PyvtkInterpolatingSubdivisionFilter_ClassNew(); }
#define DECLARED_PyvtkInterpolatingSubdivisionFilter_ClassNew
#endif

static const char **PyvtkButterflySubdivisionFilter_Doc();


static PyObject *
PyvtkButterflySubdivisionFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkButterflySubdivisionFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkButterflySubdivisionFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkButterflySubdivisionFilter *op = static_cast<vtkButterflySubdivisionFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkButterflySubdivisionFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkButterflySubdivisionFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkButterflySubdivisionFilter *tempr = vtkButterflySubdivisionFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkButterflySubdivisionFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkButterflySubdivisionFilter *op = static_cast<vtkButterflySubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkButterflySubdivisionFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkButterflySubdivisionFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkButterflySubdivisionFilter_Methods[] = {
  {"IsTypeOf", PyvtkButterflySubdivisionFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"IsA", PyvtkButterflySubdivisionFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"SafeDownCast", PyvtkButterflySubdivisionFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkButterflySubdivisionFilter\nC++: static vtkButterflySubdivisionFilter *SafeDownCast(\n    vtkObjectBase *o)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"NewInstance", PyvtkButterflySubdivisionFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkButterflySubdivisionFilter\nC++: vtkButterflySubdivisionFilter *NewInstance()\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkButterflySubdivisionFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersModelingPython.vtkButterflySubdivisionFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkButterflySubdivisionFilter_StaticNew()
{
  return vtkButterflySubdivisionFilter::New();
}

PyObject *PyvtkButterflySubdivisionFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkButterflySubdivisionFilter_Type, PyvtkButterflySubdivisionFilter_Methods,
    "vtkButterflySubdivisionFilter",
    PyvtkButterflySubdivisionFilter_Doc(), &PyvtkButterflySubdivisionFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkButterflySubdivisionFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkInterpolatingSubdivisionFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkButterflySubdivisionFilter_Doc()
{
  static const char *docstring[] = {
    "vtkButterflySubdivisionFilter - generate a subdivision surface using\nthe Butterfly Scheme\n\n",
    "Superclass: vtkInterpolatingSubdivisionFilter\n\n",
    "vtkButterflySubdivisionFilter is an interpolating subdivision scheme\nthat creates four new triangles for each triangle in the mesh. The\nuser can specify the NumberOfSubdivisions. This filter implements the\n8-point butterfly scheme described in: Zorin, D., Schroder, P., and\nSweldens, W., \"Interpolating Subdivisions for Meshes with Arbitrary\nTopology,\" Computer Graphics Proceedings, Annual Conferenc",
    "e Series,\n1996, ACM SIGGRAPH, pp.189-192. This scheme improves previous\nbutterfly subdivisions with special treatment of vertices with\nvalence other than 6.\n\nCurrently, the filter only operates on triangles. Users should use\nthe vtkTriangleFilter to triangulate meshes that contain polygons or\ntriangle strips.\n\nThe filter interpolates point data using the same scheme. New\ntriangles created at a sub",
    "division step will have the cell data of\ntheir parent cell.\n\n@par Thanks: This work was supported by PHS Research Grant No. 1 P41\nRR13218-01 from the National Center for Research Resources.\n\n@sa\nvtkInterpolatingSubdivisionFilter vtkLinearSubdivisionFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkButterflySubdivisionFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkButterflySubdivisionFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkButterflySubdivisionFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

