// python wrapper for vtkCinemaLayerRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCinemaLayerRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCinemaLayerRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCinemaLayerRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkPVDataRepresentation_ClassNew
extern "C" { PyObject *PyvtkPVDataRepresentation_ClassNew(); }
#define DECLARED_PyvtkPVDataRepresentation_ClassNew
#endif

static const char **PyvtkCinemaLayerRepresentation_Doc();


static PyObject *
PyvtkCinemaLayerRepresentation_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCinemaLayerRepresentation::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCinemaLayerRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCinemaLayerRepresentation *tempr = vtkCinemaLayerRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCinemaLayerRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCinemaLayerRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_SetVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVisibility(temp0);
    }
    else
    {
      op->vtkCinemaLayerRepresentation::SetVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_MarkModified(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkModified");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MarkModified();
    }
    else
    {
      op->vtkCinemaLayerRepresentation::MarkModified();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_ProcessViewRequest(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessViewRequest");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  vtkInformationRequestKey *temp0 = NULL;
  vtkInformation *temp1 = NULL;
  vtkInformation *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkInformationRequestKey") &&
      ap.GetVTKObject(temp1, "vtkInformation") &&
      ap.GetVTKObject(temp2, "vtkInformation"))
  {
    int tempr = (ap.IsBound() ?
      op->ProcessViewRequest(temp0, temp1, temp2) :
      op->vtkCinemaLayerRepresentation::ProcessViewRequest(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_SetLookupTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLookupTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  vtkScalarsToColors *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkScalarsToColors"))
  {
    if (ap.IsBound())
    {
      op->SetLookupTable(temp0);
    }
    else
    {
      op->vtkCinemaLayerRepresentation::SetLookupTable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCinemaLayerRepresentation_SetRenderLayersAsImage(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderLayersAsImage");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCinemaLayerRepresentation *op = static_cast<vtkCinemaLayerRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRenderLayersAsImage(temp0);
    }
    else
    {
      op->vtkCinemaLayerRepresentation::SetRenderLayersAsImage(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkCinemaLayerRepresentation_Methods[] = {
  {"IsTypeOf", PyvtkCinemaLayerRepresentation_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkCinemaLayerRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkCinemaLayerRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkCinemaLayerRepresentation\nC++: static vtkCinemaLayerRepresentation *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkCinemaLayerRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCinemaLayerRepresentation\nC++: vtkCinemaLayerRepresentation *NewInstance()\n\n"},
  {"SetVisibility", PyvtkCinemaLayerRepresentation_SetVisibility, METH_VARARGS,
   "V.SetVisibility(bool)\nC++: void SetVisibility(bool)\n\n"},
  {"MarkModified", PyvtkCinemaLayerRepresentation_MarkModified, METH_VARARGS,
   "V.MarkModified()\nC++: void MarkModified()\n\n"},
  {"ProcessViewRequest", PyvtkCinemaLayerRepresentation_ProcessViewRequest, METH_VARARGS,
   "V.ProcessViewRequest(vtkInformationRequestKey, vtkInformation,\n    vtkInformation) -> int\nC++: int ProcessViewRequest(\n    vtkInformationRequestKey *request_type,\n    vtkInformation *inInfo, vtkInformation *outInfo)\n\n"},
  {"SetLookupTable", PyvtkCinemaLayerRepresentation_SetLookupTable, METH_VARARGS,
   "V.SetLookupTable(vtkScalarsToColors)\nC++: void SetLookupTable(vtkScalarsToColors *lut)\n\nForwarded to the mapper\n"},
  {"SetRenderLayersAsImage", PyvtkCinemaLayerRepresentation_SetRenderLayersAsImage, METH_VARARGS,
   "V.SetRenderLayersAsImage(bool)\nC++: void SetRenderLayersAsImage(bool)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCinemaLayerRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCinemaReaderPython.vtkCinemaLayerRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCinemaLayerRepresentation_StaticNew()
{
  return vtkCinemaLayerRepresentation::New();
}

PyObject *PyvtkCinemaLayerRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCinemaLayerRepresentation_Type, PyvtkCinemaLayerRepresentation_Methods,
    "vtkCinemaLayerRepresentation",
    PyvtkCinemaLayerRepresentation_Doc(), &PyvtkCinemaLayerRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkCinemaLayerRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVDataRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCinemaLayerRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkCinemaLayerRepresentation - Representation for\nvtkCinemaDatabaseReader.\n\n",
    "Superclass: vtkPVDataRepresentation\n\n",
    "vtkCinemaLayerRepresentation is designed for vtkCinemaDatabaseReader.\nIt can process data produced by vtkCinemaDatabaseReader (which in\nreality is simply meta-data about the CinemaDatabase database and\nquery) and render layers obtained from the database in a\nvtkPVRenderView.\n\nDuring each render, vtkCinemaLayerRepresentation generates\nappropriate query using control parameters obtained from the rea",
    "der\nand camera parameters determined using the current camera. Using\nvtkCinemaDatabase, vtkCinemaLayerRepresentation then obtains the\nlayers (or images) from the database corresponding to the query. The\nlayers along with information about the camera used when layer was\ngenerated is passed on to the vtkCinemaLayerMapper which handles\nrendering the layers into the view.\n\n@warning Currently vtkCinema",
    "LayerRepresentation is designed for\n    builtin mode\nalone. It will need some additional work to support remote rendering.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCinemaLayerRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCinemaLayerRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCinemaLayerRepresentation", o) != 0)
  {
    Py_DECREF(o);
  }

}

