// python wrapper for vtkContourHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkContourHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkContourHelper(PyObject *); }

static const char **PyvtkContourHelper_Doc();


static PyObject *
PyvtkContourHelper_Contour(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Contour");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkContourHelper *op = static_cast<vtkContourHelper *>(vp);

  vtkCell *temp0 = NULL;
  double temp1;
  vtkDataArray *temp2 = NULL;
  vtkIdType temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkCell") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkDataArray") &&
      ap.GetValue(temp3))
  {
    op->Contour(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkContourHelper_Methods[] = {
  {"Contour", PyvtkContourHelper_Contour, METH_VARARGS,
   "V.Contour(vtkCell, float, vtkDataArray, int)\nC++: void Contour(vtkCell *cell, double value,\n    vtkDataArray *cellScalars, vtkIdType cellId)\n\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkContourHelper_vtkContourHelper(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkContourHelper");

  vtkIncrementalPointLocator *temp0 = NULL;
  vtkCellArray *temp1 = NULL;
  vtkCellArray *temp2 = NULL;
  vtkCellArray *temp3 = NULL;
  vtkPointData *temp4 = NULL;
  vtkCellData *temp5 = NULL;
  vtkPointData *temp6 = NULL;
  vtkCellData *temp7 = NULL;
  int temp8;
  bool temp9 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(10) &&
      ap.GetVTKObject(temp0, "vtkIncrementalPointLocator") &&
      ap.GetVTKObject(temp1, "vtkCellArray") &&
      ap.GetVTKObject(temp2, "vtkCellArray") &&
      ap.GetVTKObject(temp3, "vtkCellArray") &&
      ap.GetVTKObject(temp4, "vtkPointData") &&
      ap.GetVTKObject(temp5, "vtkCellData") &&
      ap.GetVTKObject(temp6, "vtkPointData") &&
      ap.GetVTKObject(temp7, "vtkCellData") &&
      ap.GetValue(temp8) &&
      ap.GetValue(temp9))
  {
    vtkContourHelper *op = new vtkContourHelper(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9);

    result = PyVTKSpecialObject_New("vtkContourHelper", op);
  }

  return result;
}

static PyMethodDef PyvtkContourHelper_vtkContourHelper_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkContourHelper_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkContourHelper_vtkContourHelper(NULL, args);
}

static void PyvtkContourHelper_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkContourHelper *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkContourHelper_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkContourHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersCorePython.vtkContourHelper", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkContourHelper_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkContourHelper_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkContourHelper_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkContourHelper_TypeNew(); }

PyObject *PyvtkContourHelper_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkContourHelper_Type,
    PyvtkContourHelper_Methods,
    PyvtkContourHelper_vtkContourHelper_Methods,
    PyvtkContourHelper_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkContourHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkContourHelper_Doc()
{
  static const char *docstring[] = {
    "vtkContourHelper - A utility class used by various contour filters\n\n",
    "This is a simple utility class that can be used by various contour\nfilters to\n produce either triangles or polygons based on the outputTriangles\nparameter\n@sa\nvtkContourGrid vtkCutter vtkContourFilter\n\n",
    "V.vtkContourHelper(vtkIncrementalPointLocator, vtkCellArray,\n    vtkCellArray, vtkCellArray, vtkPointData, vtkCellData,\n    vtkPointData, vtkCellData, int, bool)\nC++: vtkContourHelper(vtkIncrementalPointLocator *locator,\n    vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys,\n    vtkPointData *inPd, vtkCellData *inCd, vtkPointData *outPd,\n    vtkCellData *outCd, int estimatedSize, bool outputTriangles)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkContourHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkContourHelper_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkContourHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

