// python wrapper for vtkContourLoopExtraction
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkContourLoopExtraction.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkContourLoopExtraction(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkContourLoopExtraction_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkContourLoopExtraction_Doc();


static PyObject *
PyvtkContourLoopExtraction_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkContourLoopExtraction::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkContourLoopExtraction::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkContourLoopExtraction *tempr = vtkContourLoopExtraction::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkContourLoopExtraction *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkContourLoopExtraction::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetLoopClosure(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoopClosure");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLoopClosure(temp0);
    }
    else
    {
      op->vtkContourLoopExtraction::SetLoopClosure(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_GetLoopClosureMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoopClosureMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLoopClosureMinValue() :
      op->vtkContourLoopExtraction::GetLoopClosureMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_GetLoopClosureMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoopClosureMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLoopClosureMaxValue() :
      op->vtkContourLoopExtraction::GetLoopClosureMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_GetLoopClosure(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoopClosure");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLoopClosure() :
      op->vtkContourLoopExtraction::GetLoopClosure());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetLoopClosureToOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoopClosureToOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLoopClosureToOff();
    }
    else
    {
      op->vtkContourLoopExtraction::SetLoopClosureToOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetLoopClosureToBoundary(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoopClosureToBoundary");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLoopClosureToBoundary();
    }
    else
    {
      op->vtkContourLoopExtraction::SetLoopClosureToBoundary();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetLoopClosureToAll(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLoopClosureToAll");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetLoopClosureToAll();
    }
    else
    {
      op->vtkContourLoopExtraction::SetLoopClosureToAll();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_GetLoopClosureAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLoopClosureAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetLoopClosureAsString() :
      op->vtkContourLoopExtraction::GetLoopClosureAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetScalarThresholding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarThresholding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetScalarThresholding(temp0);
    }
    else
    {
      op->vtkContourLoopExtraction::SetScalarThresholding(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_GetScalarThresholding(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarThresholding");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetScalarThresholding() :
      op->vtkContourLoopExtraction::GetScalarThresholding());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_ScalarThresholdingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ScalarThresholdingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ScalarThresholdingOn();
    }
    else
    {
      op->vtkContourLoopExtraction::ScalarThresholdingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_ScalarThresholdingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ScalarThresholdingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ScalarThresholdingOff();
    }
    else
    {
      op->vtkContourLoopExtraction::ScalarThresholdingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetScalarRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  double temp0;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetScalarRange(temp0, temp1);
    }
    else
    {
      op->vtkContourLoopExtraction::SetScalarRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkContourLoopExtraction_SetScalarRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetScalarRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  const int size0 = 2;
  double temp0[2];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetScalarRange(temp0);
    }
    else
    {
      op->vtkContourLoopExtraction::SetScalarRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkContourLoopExtraction_SetScalarRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkContourLoopExtraction_SetScalarRange_s1(self, args);
    case 1:
      return PyvtkContourLoopExtraction_SetScalarRange_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetScalarRange");
  return NULL;
}



static PyObject *
PyvtkContourLoopExtraction_GetScalarRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetScalarRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetScalarRange() :
      op->vtkContourLoopExtraction::GetScalarRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkContourLoopExtraction_SetNormal_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetNormal(temp0, temp1, temp2);
    }
    else
    {
      op->vtkContourLoopExtraction::SetNormal(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkContourLoopExtraction_SetNormal_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  const int size0 = 3;
  double temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetNormal(temp0);
    }
    else
    {
      op->vtkContourLoopExtraction::SetNormal(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkContourLoopExtraction_SetNormal(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkContourLoopExtraction_SetNormal_s1(self, args);
    case 1:
      return PyvtkContourLoopExtraction_SetNormal_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetNormal");
  return NULL;
}



static PyObject *
PyvtkContourLoopExtraction_GetNormal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNormal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkContourLoopExtraction *op = static_cast<vtkContourLoopExtraction *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetNormal() :
      op->vtkContourLoopExtraction::GetNormal());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}

static PyMethodDef PyvtkContourLoopExtraction_Methods[] = {
  {"IsTypeOf", PyvtkContourLoopExtraction_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nStandard methods to instantiate, print and provide type\ninformation.\n"},
  {"IsA", PyvtkContourLoopExtraction_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nStandard methods to instantiate, print and provide type\ninformation.\n"},
  {"SafeDownCast", PyvtkContourLoopExtraction_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkContourLoopExtraction\nC++: static vtkContourLoopExtraction *SafeDownCast(\n    vtkObjectBase *o)\n\nStandard methods to instantiate, print and provide type\ninformation.\n"},
  {"NewInstance", PyvtkContourLoopExtraction_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkContourLoopExtraction\nC++: vtkContourLoopExtraction *NewInstance()\n\nStandard methods to instantiate, print and provide type\ninformation.\n"},
  {"SetLoopClosure", PyvtkContourLoopExtraction_SetLoopClosure, METH_VARARGS,
   "V.SetLoopClosure(int)\nC++: virtual void SetLoopClosure(int _arg)\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"GetLoopClosureMinValue", PyvtkContourLoopExtraction_GetLoopClosureMinValue, METH_VARARGS,
   "V.GetLoopClosureMinValue() -> int\nC++: virtual int GetLoopClosureMinValue()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"GetLoopClosureMaxValue", PyvtkContourLoopExtraction_GetLoopClosureMaxValue, METH_VARARGS,
   "V.GetLoopClosureMaxValue() -> int\nC++: virtual int GetLoopClosureMaxValue()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"GetLoopClosure", PyvtkContourLoopExtraction_GetLoopClosure, METH_VARARGS,
   "V.GetLoopClosure() -> int\nC++: virtual int GetLoopClosure()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"SetLoopClosureToOff", PyvtkContourLoopExtraction_SetLoopClosureToOff, METH_VARARGS,
   "V.SetLoopClosureToOff()\nC++: void SetLoopClosureToOff()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"SetLoopClosureToBoundary", PyvtkContourLoopExtraction_SetLoopClosureToBoundary, METH_VARARGS,
   "V.SetLoopClosureToBoundary()\nC++: void SetLoopClosureToBoundary()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"SetLoopClosureToAll", PyvtkContourLoopExtraction_SetLoopClosureToAll, METH_VARARGS,
   "V.SetLoopClosureToAll()\nC++: void SetLoopClosureToAll()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"GetLoopClosureAsString", PyvtkContourLoopExtraction_GetLoopClosureAsString, METH_VARARGS,
   "V.GetLoopClosureAsString() -> string\nC++: const char *GetLoopClosureAsString()\n\nSpecify whether to close loops or not. All loops can be closed;\nboundary loops (x or y vertical or horizontal lines) can be\nclosed (default); or all loops can be closed.\n"},
  {"SetScalarThresholding", PyvtkContourLoopExtraction_SetScalarThresholding, METH_VARARGS,
   "V.SetScalarThresholding(bool)\nC++: virtual void SetScalarThresholding(bool _arg)\n\nTurn on/off the extraction of loops based on scalar thresholding.\n Loops with scalar values in a specified range can be extracted.\nIf no scalars are available from the input than this data member\nis ignored.\n"},
  {"GetScalarThresholding", PyvtkContourLoopExtraction_GetScalarThresholding, METH_VARARGS,
   "V.GetScalarThresholding() -> bool\nC++: virtual bool GetScalarThresholding()\n\nTurn on/off the extraction of loops based on scalar thresholding.\n Loops with scalar values in a specified range can be extracted.\nIf no scalars are available from the input than this data member\nis ignored.\n"},
  {"ScalarThresholdingOn", PyvtkContourLoopExtraction_ScalarThresholdingOn, METH_VARARGS,
   "V.ScalarThresholdingOn()\nC++: virtual void ScalarThresholdingOn()\n\nTurn on/off the extraction of loops based on scalar thresholding.\n Loops with scalar values in a specified range can be extracted.\nIf no scalars are available from the input than this data member\nis ignored.\n"},
  {"ScalarThresholdingOff", PyvtkContourLoopExtraction_ScalarThresholdingOff, METH_VARARGS,
   "V.ScalarThresholdingOff()\nC++: virtual void ScalarThresholdingOff()\n\nTurn on/off the extraction of loops based on scalar thresholding.\n Loops with scalar values in a specified range can be extracted.\nIf no scalars are available from the input than this data member\nis ignored.\n"},
  {"SetScalarRange", PyvtkContourLoopExtraction_SetScalarRange, METH_VARARGS,
   "V.SetScalarRange(float, float)\nC++: void SetScalarRange(double, double)\nV.SetScalarRange((float, float))\nC++: void SetScalarRange(double a[2])\n\n"},
  {"GetScalarRange", PyvtkContourLoopExtraction_GetScalarRange, METH_VARARGS,
   "V.GetScalarRange() -> (float, float)\nC++: double *GetScalarRange()\n\n"},
  {"SetNormal", PyvtkContourLoopExtraction_SetNormal, METH_VARARGS,
   "V.SetNormal(float, float, float)\nC++: void SetNormal(double, double, double)\nV.SetNormal((float, float, float))\nC++: void SetNormal(double a[3])\n\n"},
  {"GetNormal", PyvtkContourLoopExtraction_GetNormal, METH_VARARGS,
   "V.GetNormal() -> (float, float, float)\nC++: double *GetNormal()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkContourLoopExtraction_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersModelingPython.vtkContourLoopExtraction", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkContourLoopExtraction_StaticNew()
{
  return vtkContourLoopExtraction::New();
}

PyObject *PyvtkContourLoopExtraction_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkContourLoopExtraction_Type, PyvtkContourLoopExtraction_Methods,
    "vtkContourLoopExtraction",
    PyvtkContourLoopExtraction_Doc(), &PyvtkContourLoopExtraction_StaticNew);

  PyTypeObject *pytype = &PyvtkContourLoopExtraction_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkContourLoopExtraction_Doc()
{
  static const char *docstring[] = {
    "vtkContourLoopExtraction - extract closed loops (polygons) from lines\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "This filter takes an input consisting of lines and polylines and\nconstructs polygons (i.e., closed loops) from them. It combines some\nof the capability of connectivity filters and the line stripper to\nproduce manifold loops that are suitable for geometric operations.\nFor example, the vtkCookieCutter works well with this filter.\n\nNote that the input to this filter consists of points and line or\npol",
    "yline cells. All other topological types (verts, polygons,\ntriangle strips) are ignored. The output of this filter is manifold\npolygons.\n\n@warning\nAlthough the loops are constructed in 3-space, a normal vector must\nbe supplied to help select turns when multiple choices are possible.\nBy default the normal vector is n={0,0,1} but may be user specified.\nNote also that some filters require that the lo",
    "ops are located in the\nz=constant or z=0 plane. Hence a transform filter of some sort may be\nnecesssary to project the loops to a plane.\n\n@warning\nNote that lines that do not close in on themselves can be optionally\nforced closed. This occurs when for example, 2D contours end and\nbegin at the boundaries of data. By forcing closure, the last point\nis joined to the first point. Note that there are d",
    "ifferent closure\nmodes: 1) do not close (and hence reject the polygon); 2) close along\ngrid boundaries (vertical or horizontal x and y lines); and 3) close\nall open loops.\n\n@warning\nScalar thresholding can be enabled. If enabled, then only those loops\nwith\n*any\" scalar point data within the thresholded range are extracted.\n\n@warning\nAny detached lines forming degenerate loops of two points or less",
    " are\ndiscarded. Non-manifold junctions are broken into separate,\nindependent loops.\n\n@sa\nvtkCookieCutter vtkFlyingEdges2D vtkMarchingSquares vtkFeatureEdges\nvtkConnectivityFilter vtkPolyDataConnectivityFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkContourLoopExtraction(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkContourLoopExtraction_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkContourLoopExtraction", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 3; c++)
  {
    static const struct { const char *name; int value; }
      constants[3] = {
        { "VTK_LOOP_CLOSURE_OFF", 0 },
        { "VTK_LOOP_CLOSURE_BOUNDARY", 1 },
        { "VTK_LOOP_CLOSURE_ALL", 2 },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

