// python wrapper for vtkDataArrayCollectionIterator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDataArrayCollectionIterator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDataArrayCollectionIterator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDataArrayCollectionIterator_ClassNew(); }

#ifndef DECLARED_PyvtkCollectionIterator_ClassNew
extern "C" { PyObject *PyvtkCollectionIterator_ClassNew(); }
#define DECLARED_PyvtkCollectionIterator_ClassNew
#endif

static const char **PyvtkDataArrayCollectionIterator_Doc();


static PyObject *
PyvtkDataArrayCollectionIterator_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDataArrayCollectionIterator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataArrayCollectionIterator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataArrayCollectionIterator *op = static_cast<vtkDataArrayCollectionIterator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDataArrayCollectionIterator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataArrayCollectionIterator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDataArrayCollectionIterator *tempr = vtkDataArrayCollectionIterator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataArrayCollectionIterator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataArrayCollectionIterator *op = static_cast<vtkDataArrayCollectionIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataArrayCollectionIterator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDataArrayCollectionIterator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDataArrayCollectionIterator_SetCollection_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCollection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataArrayCollectionIterator *op = static_cast<vtkDataArrayCollectionIterator *>(vp);

  vtkCollection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCollection"))
  {
    if (ap.IsBound())
    {
      op->SetCollection(temp0);
    }
    else
    {
      op->vtkDataArrayCollectionIterator::SetCollection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkDataArrayCollectionIterator_SetCollection_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCollection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataArrayCollectionIterator *op = static_cast<vtkDataArrayCollectionIterator *>(vp);

  vtkDataArrayCollection *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataArrayCollection"))
  {
    if (ap.IsBound())
    {
      op->SetCollection(temp0);
    }
    else
    {
      op->vtkDataArrayCollectionIterator::SetCollection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkDataArrayCollectionIterator_SetCollection_Methods[] = {
  {NULL, PyvtkDataArrayCollectionIterator_SetCollection_s1, METH_VARARGS,
   "@V *vtkCollection"},
  {NULL, PyvtkDataArrayCollectionIterator_SetCollection_s2, METH_VARARGS,
   "@V *vtkDataArrayCollection"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkDataArrayCollectionIterator_SetCollection(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkDataArrayCollectionIterator_SetCollection_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetCollection");
  return NULL;
}



static PyObject *
PyvtkDataArrayCollectionIterator_GetDataArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataArrayCollectionIterator *op = static_cast<vtkDataArrayCollectionIterator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetDataArray() :
      op->vtkDataArrayCollectionIterator::GetDataArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDataArrayCollectionIterator_Methods[] = {
  {"IsTypeOf", PyvtkDataArrayCollectionIterator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkDataArrayCollectionIterator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkDataArrayCollectionIterator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkDataArrayCollectionIterator\nC++: static vtkDataArrayCollectionIterator *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDataArrayCollectionIterator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDataArrayCollectionIterator\nC++: vtkDataArrayCollectionIterator *NewInstance()\n\n"},
  {"SetCollection", PyvtkDataArrayCollectionIterator_SetCollection, METH_VARARGS,
   "V.SetCollection(vtkCollection)\nC++: void SetCollection(vtkCollection *)\nV.SetCollection(vtkDataArrayCollection)\nC++: void SetCollection(vtkDataArrayCollection *)\n\nSet the collection over which to iterate.\n"},
  {"GetDataArray", PyvtkDataArrayCollectionIterator_GetDataArray, METH_VARARGS,
   "V.GetDataArray() -> vtkDataArray\nC++: vtkDataArray *GetDataArray()\n\nGet the item at the current iterator position.  Valid only when\nIsDoneWithTraversal() returns 1.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDataArrayCollectionIterator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkDataArrayCollectionIterator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDataArrayCollectionIterator_StaticNew()
{
  return vtkDataArrayCollectionIterator::New();
}

PyObject *PyvtkDataArrayCollectionIterator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDataArrayCollectionIterator_Type, PyvtkDataArrayCollectionIterator_Methods,
    "vtkDataArrayCollectionIterator",
    PyvtkDataArrayCollectionIterator_Doc(), &PyvtkDataArrayCollectionIterator_StaticNew);

  PyTypeObject *pytype = &PyvtkDataArrayCollectionIterator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkCollectionIterator_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDataArrayCollectionIterator_Doc()
{
  static const char *docstring[] = {
    "vtkDataArrayCollectionIterator - iterator through a\nvtkDataArrayCollection.\n\n",
    "Superclass: vtkCollectionIterator\n\n",
    "vtkDataArrayCollectionIterator provides an implementation of\nvtkCollectionIterator which allows the items to be retrieved with the\nproper subclass pointer type for vtkDataArrayCollection.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDataArrayCollectionIterator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDataArrayCollectionIterator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDataArrayCollectionIterator", o) != 0)
  {
    Py_DECREF(o);
  }

}

