// python wrapper for vtkDataSetGradientPrecompute
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkDataSetGradientPrecompute.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDataSetGradientPrecompute(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDataSetGradientPrecompute_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkDataSetGradientPrecompute_Doc();


static PyObject *
PyvtkDataSetGradientPrecompute_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkDataSetGradientPrecompute::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataSetGradientPrecompute_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataSetGradientPrecompute *op = static_cast<vtkDataSetGradientPrecompute *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkDataSetGradientPrecompute::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataSetGradientPrecompute_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkDataSetGradientPrecompute *tempr = vtkDataSetGradientPrecompute::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkDataSetGradientPrecompute_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkDataSetGradientPrecompute *op = static_cast<vtkDataSetGradientPrecompute *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataSetGradientPrecompute *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkDataSetGradientPrecompute::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkDataSetGradientPrecompute_GradientPrecompute(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GradientPrecompute");

  vtkDataSet *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataSet"))
  {
    int tempr = vtkDataSetGradientPrecompute::GradientPrecompute(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkDataSetGradientPrecompute_Methods[] = {
  {"IsTypeOf", PyvtkDataSetGradientPrecompute_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkDataSetGradientPrecompute_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkDataSetGradientPrecompute_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkDataSetGradientPrecompute\nC++: static vtkDataSetGradientPrecompute *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkDataSetGradientPrecompute_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkDataSetGradientPrecompute\nC++: vtkDataSetGradientPrecompute *NewInstance()\n\n"},
  {"GradientPrecompute", PyvtkDataSetGradientPrecompute_GradientPrecompute, METH_VARARGS,
   "V.GradientPrecompute(vtkDataSet) -> int\nC++: static int GradientPrecompute(vtkDataSet *ds)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkDataSetGradientPrecompute_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkDataSetGradientPrecompute", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkDataSetGradientPrecompute_StaticNew()
{
  return vtkDataSetGradientPrecompute::New();
}

PyObject *PyvtkDataSetGradientPrecompute_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkDataSetGradientPrecompute_Type, PyvtkDataSetGradientPrecompute_Methods,
    "vtkDataSetGradientPrecompute",
    PyvtkDataSetGradientPrecompute_Doc(), &PyvtkDataSetGradientPrecompute_StaticNew);

  PyTypeObject *pytype = &PyvtkDataSetGradientPrecompute_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDataSetGradientPrecompute_Doc()
{
  static const char *docstring[] = {
    "vtkDataSetGradientPrecompute - Computes a geometry based vector field\nthat the DataSetGradient filter uses to accelerate gradient\ncomputation.\n\n",
    "Superclass: vtkDataSetAlgorithm\n\n",
    "This vector field is added to FieldData since it has a different\nvalue for each vertex of each cell (a vertex shared by two cell has\ntwo differents values).\n\n@par Thanks: This file is part of the generalized Youngs material\ninterface reconstruction algorithm contributed by CEA/DIF -\nCommissariat a l'Energie Atomique, Centre DAM Ile-De-France\n\nBP12, F-91297 Arpajon, France.\n\nImplementation by Thier",
    "ry Carrard (CEA)\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDataSetGradientPrecompute(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDataSetGradientPrecompute_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkDataSetGradientPrecompute", o) != 0)
  {
    Py_DECREF(o);
  }

}

