// python wrapper for vtkDebugLeaksManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkDebugLeaksManager.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkDebugLeaksManager(PyObject *); }

static const char **PyvtkDebugLeaksManager_Doc();

static PyMethodDef PyvtkDebugLeaksManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkDebugLeaksManager_vtkDebugLeaksManager(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkDebugLeaksManager");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkDebugLeaksManager *op = new vtkDebugLeaksManager();

    result = PyVTKSpecialObject_New("vtkDebugLeaksManager", op);
  }

  return result;
}

static PyMethodDef PyvtkDebugLeaksManager_vtkDebugLeaksManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkDebugLeaksManager_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkDebugLeaksManager_vtkDebugLeaksManager(NULL, args);
}

static void PyvtkDebugLeaksManager_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkDebugLeaksManager *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkDebugLeaksManager_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkDebugLeaksManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkDebugLeaksManager", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkDebugLeaksManager_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkDebugLeaksManager_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkDebugLeaksManager_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkDebugLeaksManager_TypeNew(); }

PyObject *PyvtkDebugLeaksManager_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkDebugLeaksManager_Type,
    PyvtkDebugLeaksManager_Methods,
    PyvtkDebugLeaksManager_vtkDebugLeaksManager_Methods,
    PyvtkDebugLeaksManager_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkDebugLeaksManager_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkDebugLeaksManager_Doc()
{
  static const char *docstring[] = {
    "vtkDebugLeaksManager - Manages the vtkDebugLeaks singleton.\n\n",
    "vtkDebugLeaksManager should be included in any translation unit that\nwill use vtkDebugLeaks or that implements the singleton pattern.  It\nmakes sure that the vtkDebugLeaks singleton is created before and\ndestroyed after all other singletons in VTK.\n\n",
    "V.vtkDebugLeaksManager()\nC++: vtkDebugLeaksManager()\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkDebugLeaksManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkDebugLeaksManager_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkDebugLeaksManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

