// python wrapper for vtkGarbageCollectorManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkGarbageCollectorManager.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGarbageCollectorManager(PyObject *); }

static const char **PyvtkGarbageCollectorManager_Doc();

static PyMethodDef PyvtkGarbageCollectorManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkGarbageCollectorManager_vtkGarbageCollectorManager(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkGarbageCollectorManager");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkGarbageCollectorManager *op = new vtkGarbageCollectorManager();

    result = PyVTKSpecialObject_New("vtkGarbageCollectorManager", op);
  }

  return result;
}

static PyMethodDef PyvtkGarbageCollectorManager_vtkGarbageCollectorManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkGarbageCollectorManager_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkGarbageCollectorManager_vtkGarbageCollectorManager(NULL, args);
}

static void PyvtkGarbageCollectorManager_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkGarbageCollectorManager *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkGarbageCollectorManager_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkGarbageCollectorManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkGarbageCollectorManager", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkGarbageCollectorManager_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkGarbageCollectorManager_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkGarbageCollectorManager_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGarbageCollectorManager_TypeNew(); }

PyObject *PyvtkGarbageCollectorManager_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkGarbageCollectorManager_Type,
    PyvtkGarbageCollectorManager_Methods,
    PyvtkGarbageCollectorManager_vtkGarbageCollectorManager_Methods,
    PyvtkGarbageCollectorManager_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkGarbageCollectorManager_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGarbageCollectorManager_Doc()
{
  static const char *docstring[] = {
    "vtkGarbageCollectorManager - Manages the vtkGarbageCollector\nsingleton.\n\n",
    "vtkGarbageCollectorManager should be included in any translation unit\nthat will use vtkGarbageCollector or that implements the singleton\npattern.  It makes sure that the vtkGarbageCollector singleton is\ncreated before and destroyed after it is used.\n\n",
    "V.vtkGarbageCollectorManager()\nC++: vtkGarbageCollectorManager()\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGarbageCollectorManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGarbageCollectorManager_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkGarbageCollectorManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

