// python wrapper for vtkGridConnectivity
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGridConnectivity.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGridConnectivity(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGridConnectivity_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkMultiBlockDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkGridConnectivity_Doc();


static PyObject *
PyvtkGridConnectivity_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGridConnectivity::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGridConnectivity_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGridConnectivity *op = static_cast<vtkGridConnectivity *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGridConnectivity::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGridConnectivity_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGridConnectivity *tempr = vtkGridConnectivity::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGridConnectivity_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGridConnectivity *op = static_cast<vtkGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkGridConnectivity *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGridConnectivity::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGridConnectivity_IntegrateCellVolume(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IntegrateCellVolume");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGridConnectivity *op = static_cast<vtkGridConnectivity *>(vp);

  vtkCell *temp0 = NULL;
  int temp1;
  vtkUnstructuredGrid *temp2 = NULL;
  vtkIdType temp3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkCell") &&
      ap.GetValue(temp1) &&
      ap.GetVTKObject(temp2, "vtkUnstructuredGrid") &&
      ap.GetValue(temp3))
  {
    if (ap.IsBound())
    {
      op->IntegrateCellVolume(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkGridConnectivity::IntegrateCellVolume(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGridConnectivity_Methods[] = {
  {"IsTypeOf", PyvtkGridConnectivity_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkGridConnectivity_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkGridConnectivity_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGridConnectivity\nC++: static vtkGridConnectivity *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGridConnectivity_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGridConnectivity\nC++: vtkGridConnectivity *NewInstance()\n\n"},
  {"IntegrateCellVolume", PyvtkGridConnectivity_IntegrateCellVolume, METH_VARARGS,
   "V.IntegrateCellVolume(vtkCell, int, vtkUnstructuredGrid, int)\nC++: void IntegrateCellVolume(vtkCell *cell, int fragmentId,\n    vtkUnstructuredGrid *input, vtkIdType cellIndex)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkGridConnectivity_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkGridConnectivity", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGridConnectivity_StaticNew()
{
  return vtkGridConnectivity::New();
}

PyObject *PyvtkGridConnectivity_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGridConnectivity_Type, PyvtkGridConnectivity_Methods,
    "vtkGridConnectivity",
    PyvtkGridConnectivity_Doc(), &PyvtkGridConnectivity_StaticNew);

  PyTypeObject *pytype = &PyvtkGridConnectivity_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkGridConnectivity_Doc()
{
  static const char *docstring[] = {
    "vtkGridConnectivity - Integrates lines, surfaces and volume.\n\n",
    "Superclass: vtkMultiBlockDataSetAlgorithm\n\n",
    "Integrates all point and cell data attributes while computing length,\narea or volume.  Works for 1D, 2D or 3D.  Only one dimensionality at\na time.  For volume, this filter ignores all but 3D cells.  It will\nnot compute the volume contained in a closed surface. The output of\nthis filter is a single point and vertex.  The attributes for this\npoint and cell will contain the integration results for th",
    "e\ncorresponding input attributes.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkGridConnectivity(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGridConnectivity_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGridConnectivity", o) != 0)
  {
    Py_DECREF(o);
  }

}

