// python wrapper for vtkHierarchicalBinningFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkHierarchicalBinningFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHierarchicalBinningFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHierarchicalBinningFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkHierarchicalBinningFilter_Doc();


static PyObject *
PyvtkHierarchicalBinningFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkHierarchicalBinningFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHierarchicalBinningFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkHierarchicalBinningFilter *tempr = vtkHierarchicalBinningFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkHierarchicalBinningFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHierarchicalBinningFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_SetNumberOfLevels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfLevels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfLevels(temp0);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetNumberOfLevels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetNumberOfLevelsMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfLevelsMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfLevelsMinValue() :
      op->vtkHierarchicalBinningFilter::GetNumberOfLevelsMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetNumberOfLevelsMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfLevelsMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfLevelsMaxValue() :
      op->vtkHierarchicalBinningFilter::GetNumberOfLevelsMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetNumberOfLevels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfLevels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfLevels() :
      op->vtkHierarchicalBinningFilter::GetNumberOfLevels());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_SetAutomatic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutomatic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutomatic(temp0);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetAutomatic(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetAutomatic(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAutomatic");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetAutomatic() :
      op->vtkHierarchicalBinningFilter::GetAutomatic());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_AutomaticOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutomaticOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutomaticOn();
    }
    else
    {
      op->vtkHierarchicalBinningFilter::AutomaticOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_AutomaticOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AutomaticOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->AutomaticOff();
    }
    else
    {
      op->vtkHierarchicalBinningFilter::AutomaticOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_SetDivisions_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDivisions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetDivisions(temp0, temp1, temp2);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetDivisions(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkHierarchicalBinningFilter_SetDivisions_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDivisions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  const int size0 = 3;
  int temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetDivisions(temp0);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetDivisions(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkHierarchicalBinningFilter_SetDivisions(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkHierarchicalBinningFilter_SetDivisions_s1(self, args);
    case 1:
      return PyvtkHierarchicalBinningFilter_SetDivisions_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetDivisions");
  return NULL;
}



static PyObject *
PyvtkHierarchicalBinningFilter_GetDivisions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDivisions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetDivisions() :
      op->vtkHierarchicalBinningFilter::GetDivisions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_SetBounds_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  double temp0;
  double temp1;
  double temp2;
  double temp3;
  double temp4;
  double temp5;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(6) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4) &&
      ap.GetValue(temp5))
  {
    if (ap.IsBound())
    {
      op->SetBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetBounds(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkHierarchicalBinningFilter_SetBounds_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  const int size0 = 6;
  double temp0[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetBounds(temp0);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::SetBounds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkHierarchicalBinningFilter_SetBounds(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 6:
      return PyvtkHierarchicalBinningFilter_SetBounds_s1(self, args);
    case 1:
      return PyvtkHierarchicalBinningFilter_SetBounds_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetBounds");
  return NULL;
}



static PyObject *
PyvtkHierarchicalBinningFilter_GetBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int sizer = 6;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetBounds() :
      op->vtkHierarchicalBinningFilter::GetBounds());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetNumberOfGlobalBins(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGlobalBins");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfGlobalBins() :
      op->vtkHierarchicalBinningFilter::GetNumberOfGlobalBins());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetNumberOfBins(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfBins");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfBins(temp0) :
      op->vtkHierarchicalBinningFilter::GetNumberOfBins(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetLevelOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLevelOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  vtkIdType temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetLevelOffset(temp0, temp1) :
      op->vtkHierarchicalBinningFilter::GetLevelOffset(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(1, temp1);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetBinOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBinOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  vtkIdType temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetBinOffset(temp0, temp1) :
      op->vtkHierarchicalBinningFilter::GetBinOffset(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(1, temp1);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetLocalBinOffset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocalBinOffset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  int temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetLocalBinOffset(temp0, temp1, temp2) :
      op->vtkHierarchicalBinningFilter::GetLocalBinOffset(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      ap.SetArgValue(2, temp2);
    }
    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetBinBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBinBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  const int size1 = 6;
  double temp1[6];
  double save1[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->GetBinBounds(temp0, temp1);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::GetBinBounds(temp0, temp1);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalBinningFilter_GetLocalBinBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocalBinBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalBinningFilter *op = static_cast<vtkHierarchicalBinningFilter *>(vp);

  int temp0;
  int temp1;
  const int size2 = 6;
  double temp2[6];
  double save2[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetArray(temp2, size2))
  {
    ap.SaveArray(temp2, save2, size2);

    if (ap.IsBound())
    {
      op->GetLocalBinBounds(temp0, temp1, temp2);
    }
    else
    {
      op->vtkHierarchicalBinningFilter::GetLocalBinBounds(temp0, temp1, temp2);
    }

    if (ap.ArrayHasChanged(temp2, save2, size2) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(2, temp2, size2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkHierarchicalBinningFilter_Methods[] = {
  {"IsTypeOf", PyvtkHierarchicalBinningFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"IsA", PyvtkHierarchicalBinningFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SafeDownCast", PyvtkHierarchicalBinningFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkHierarchicalBinningFilter\nC++: static vtkHierarchicalBinningFilter *SafeDownCast(\n    vtkObjectBase *o)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"NewInstance", PyvtkHierarchicalBinningFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHierarchicalBinningFilter\nC++: vtkHierarchicalBinningFilter *NewInstance()\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SetNumberOfLevels", PyvtkHierarchicalBinningFilter_SetNumberOfLevels, METH_VARARGS,
   "V.SetNumberOfLevels(int)\nC++: virtual void SetNumberOfLevels(int _arg)\n\nSpecify the number of levels in the spatial hierarchy. By\ndefault, the number of levels is three.\n"},
  {"GetNumberOfLevelsMinValue", PyvtkHierarchicalBinningFilter_GetNumberOfLevelsMinValue, METH_VARARGS,
   "V.GetNumberOfLevelsMinValue() -> int\nC++: virtual int GetNumberOfLevelsMinValue()\n\nSpecify the number of levels in the spatial hierarchy. By\ndefault, the number of levels is three.\n"},
  {"GetNumberOfLevelsMaxValue", PyvtkHierarchicalBinningFilter_GetNumberOfLevelsMaxValue, METH_VARARGS,
   "V.GetNumberOfLevelsMaxValue() -> int\nC++: virtual int GetNumberOfLevelsMaxValue()\n\nSpecify the number of levels in the spatial hierarchy. By\ndefault, the number of levels is three.\n"},
  {"GetNumberOfLevels", PyvtkHierarchicalBinningFilter_GetNumberOfLevels, METH_VARARGS,
   "V.GetNumberOfLevels() -> int\nC++: virtual int GetNumberOfLevels()\n\nSpecify the number of levels in the spatial hierarchy. By\ndefault, the number of levels is three.\n"},
  {"SetAutomatic", PyvtkHierarchicalBinningFilter_SetAutomatic, METH_VARARGS,
   "V.SetAutomatic(bool)\nC++: virtual void SetAutomatic(bool _arg)\n\nSpecify whether to determine the determine the level divisions,\nand the bounding box automatically (by default this is on). If\noff, then the user must specify both the bounding box and bin\ndivisions. (Computing the bounding box can be slow for large\npoint clouds, manual specification can save time.)\n"},
  {"GetAutomatic", PyvtkHierarchicalBinningFilter_GetAutomatic, METH_VARARGS,
   "V.GetAutomatic() -> bool\nC++: virtual bool GetAutomatic()\n\nSpecify whether to determine the determine the level divisions,\nand the bounding box automatically (by default this is on). If\noff, then the user must specify both the bounding box and bin\ndivisions. (Computing the bounding box can be slow for large\npoint clouds, manual specification can save time.)\n"},
  {"AutomaticOn", PyvtkHierarchicalBinningFilter_AutomaticOn, METH_VARARGS,
   "V.AutomaticOn()\nC++: virtual void AutomaticOn()\n\nSpecify whether to determine the determine the level divisions,\nand the bounding box automatically (by default this is on). If\noff, then the user must specify both the bounding box and bin\ndivisions. (Computing the bounding box can be slow for large\npoint clouds, manual specification can save time.)\n"},
  {"AutomaticOff", PyvtkHierarchicalBinningFilter_AutomaticOff, METH_VARARGS,
   "V.AutomaticOff()\nC++: virtual void AutomaticOff()\n\nSpecify whether to determine the determine the level divisions,\nand the bounding box automatically (by default this is on). If\noff, then the user must specify both the bounding box and bin\ndivisions. (Computing the bounding box can be slow for large\npoint clouds, manual specification can save time.)\n"},
  {"SetDivisions", PyvtkHierarchicalBinningFilter_SetDivisions, METH_VARARGS,
   "V.SetDivisions(int, int, int)\nC++: void SetDivisions(int, int, int)\nV.SetDivisions((int, int, int))\nC++: void SetDivisions(int a[3])\n\n"},
  {"GetDivisions", PyvtkHierarchicalBinningFilter_GetDivisions, METH_VARARGS,
   "V.GetDivisions() -> (int, int, int)\nC++: int *GetDivisions()\n\nSet the number of branching divisions in each binning direction.\nEach level of the tree is subdivided by this factor. The\nDivisions[i] must be >= 1. Note: if Automatic subdivision is\nspecified, the the Divisions are set by the filter.\n"},
  {"SetBounds", PyvtkHierarchicalBinningFilter_SetBounds, METH_VARARGS,
   "V.SetBounds(float, float, float, float, float, float)\nC++: void SetBounds(double, double, double, double, double,\n    double)\nV.SetBounds((float, float, float, float, float, float))\nC++: void SetBounds(double a[6])\n\n"},
  {"GetBounds", PyvtkHierarchicalBinningFilter_GetBounds, METH_VARARGS,
   "V.GetBounds() -> (float, float, float, float, float, float)\nC++: double *GetBounds()\n\nSet the bounding box of the point cloud. If Automatic is enabled,\nthen this is computed during filter execution. If manually\nspecified (Automatic is off) then make sure the bounds is\nrepresented as (xmin,xmax, ymin,ymax, zmin,zmax). If the bounds\nspecified is does not enclose the points, then points are clamped\nto lie in the bounding box.\n"},
  {"GetNumberOfGlobalBins", PyvtkHierarchicalBinningFilter_GetNumberOfGlobalBins, METH_VARARGS,
   "V.GetNumberOfGlobalBins() -> int\nC++: int GetNumberOfGlobalBins()\n\nConvenience methods for extracting useful information about this\nbin tree.  Return the number of total bins across all levels\n(i.e., the total global bins). Invoke this method after the bin\ntree has been built.\n"},
  {"GetNumberOfBins", PyvtkHierarchicalBinningFilter_GetNumberOfBins, METH_VARARGS,
   "V.GetNumberOfBins(int) -> int\nC++: int GetNumberOfBins(int level)\n\nConvenience methods for extracting useful information about this\nbin tree.  Return the number of bins in a particular level of the\ntree. Invoke this method after the bin tree has been built.\n"},
  {"GetLevelOffset", PyvtkHierarchicalBinningFilter_GetLevelOffset, METH_VARARGS,
   "V.GetLevelOffset(int, int) -> int\nC++: vtkIdType GetLevelOffset(int level, vtkIdType &npts)\n\nConvenience methods for extracting useful information about this\nbin tree.  Given a level, return the beginning point id and\nnumber of points that level. Invoke this method after the bin\ntree has been built.\n"},
  {"GetBinOffset", PyvtkHierarchicalBinningFilter_GetBinOffset, METH_VARARGS,
   "V.GetBinOffset(int, int) -> int\nC++: vtkIdType GetBinOffset(int globalBin, vtkIdType &npts)\n\nConvenience methods for extracting useful information about this\nbin tree.  Given a global bin number, return the point id and\nnumber of points for that bin. Invoke this method after the bin\ntree has been built.\n"},
  {"GetLocalBinOffset", PyvtkHierarchicalBinningFilter_GetLocalBinOffset, METH_VARARGS,
   "V.GetLocalBinOffset(int, int, int) -> int\nC++: vtkIdType GetLocalBinOffset(int level, int localBin,\n    vtkIdType &npts)\n\nConvenience methods for extracting useful information about this\nbin tree.  Given a level, and the bin number in that level,\nreturn the offset point id and number of points for that bin.\nInvoke this method after the bin tree has been built.\n"},
  {"GetBinBounds", PyvtkHierarchicalBinningFilter_GetBinBounds, METH_VARARGS,
   "V.GetBinBounds(int, [float, float, float, float, float, float])\nC++: void GetBinBounds(int globalBin, double bounds[6])\n\nConvenience methods for extracting useful information about a bin\ntree. Given a global bin number, return the bounds\n(xmin,xmax,ymin,ymax,zmin,zmax) for that bin. Invoke this method\nafter the bin tree has been built.\n"},
  {"GetLocalBinBounds", PyvtkHierarchicalBinningFilter_GetLocalBinBounds, METH_VARARGS,
   "V.GetLocalBinBounds(int, int, [float, float, float, float, float,\n    float])\nC++: void GetLocalBinBounds(int level, int localBin,\n    double bounds[6])\n\nConvenience methods for extracting useful information about a bin\ntree. Given a level, and a local bin number, return the bounds\n(xmin,xmax,ymin,ymax,zmin,zmax) for that bin. Invoke this method\nafter the bin tree has been built.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHierarchicalBinningFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersPointsPython.vtkHierarchicalBinningFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHierarchicalBinningFilter_StaticNew()
{
  return vtkHierarchicalBinningFilter::New();
}

PyObject *PyvtkHierarchicalBinningFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHierarchicalBinningFilter_Type, PyvtkHierarchicalBinningFilter_Methods,
    "vtkHierarchicalBinningFilter",
    PyvtkHierarchicalBinningFilter_Doc(), &PyvtkHierarchicalBinningFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkHierarchicalBinningFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHierarchicalBinningFilter_Doc()
{
  static const char *docstring[] = {
    "vtkHierarchicalBinningFilter - uniform binning of points into a\nhierarchical structure\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkHierarchicalBinningFilter creates a spatial, hierarchical ordering\nof input points. This hierarchy is suitable for level-of-detail\nrendering, or multiresolution processing. Each level of the hierarchy\nis based on uniform binning of space, where deeper levels (and its\nbins) are repeatedly subdivided by a given branching factor. Points\nare associated with bins at different levels, with the number",
    " of\npoints in each level proportional to the number of bins in that\nlevel. The output points are sorted according to a bin number, where\nthe bin number is unique, monotonically increasing number\nrepresenting the breadth first ordering of all of the levels and\ntheir bins. Thus all points in a bin (or even a level) are segmented\ninto contiguous runs.\n\nNote that points are associated with different b",
    "ins using a pseudo\nrandom process. No points are repeated, and no new points are\ncreated, thus the effect of executing this filter is simply to\nreorder the input points.\n\nThe algorithm proceeds as follows: Given an initial bounding box, the\nspace is uniformally subdivided into bins of (M x N x O) dimensions;\nin turn each subsequent level in the tree is further divided into (M\nx N x O) bins (note t",
    "hat level 0 is a single, root bin). Thus the\nnumber of bins at level L of the hierarchical tree is: Nbins=(M^L x\nN^L x O^L). Once the binning is created to a specified depth, then\npoints are placed in the bins using a pseudo-random sampling\nproportional to the number of bins in each level. All input points\nare sorted in the order described above, with no points repeated.\n\nThe output of this filter",
    " are sorted points and associated point\nattributes represented by a vtkPolyData. In addition, an offest\nintegral array is associated with the field data of the output,\nproviding offsets into the points list via a breadth-first traversal\norder. Metadata describing the output is provided in the field data.\nConvenience functions are also provided here to access the data in a\nparticular bin or across ",
    "a level. (Using the offset array directly\nmay result in higher performance.)\n\nWhile any vtkPointSet type can be provided as input, the output is\nrepresented by an explicit representation of points via a\nvtkPolyData. This output polydata will populate its instance of\nvtkPoints, but no cells will be defined (i.e., no vtkVertex or\nvtkPolyVertex are contained in the output).\n\n@warning\nThis class has b",
    "een threaded with vtkSMPTools. Using TBB or other\nnon-sequential type (set in the CMake variable\nVTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.\n\n@sa\nvtkPointCloudFilter vtkQuadricClustering vtkStaticPointLocator\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHierarchicalBinningFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHierarchicalBinningFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHierarchicalBinningFilter", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyInt_FromLong(12);
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_MAX_LEVEL", o);
    Py_DECREF(o);
  }
}

