// python wrapper for vtkInteractorStyle3D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInteractorStyle3D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkInteractorStyle3D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInteractorStyle3D_ClassNew(); }

#ifndef DECLARED_PyvtkInteractorStyle_ClassNew
extern "C" { PyObject *PyvtkInteractorStyle_ClassNew(); }
#define DECLARED_PyvtkInteractorStyle_ClassNew
#endif

static const char **PyvtkInteractorStyle3D_Doc();


static PyObject *
PyvtkInteractorStyle3D_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkInteractorStyle3D::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkInteractorStyle3D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkInteractorStyle3D *tempr = vtkInteractorStyle3D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkInteractorStyle3D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkInteractorStyle3D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnMouseMove(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMouseMove");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMouseMove();
    }
    else
    {
      op->vtkInteractorStyle3D::OnMouseMove();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnLeftButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonDown();
    }
    else
    {
      op->vtkInteractorStyle3D::OnLeftButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnLeftButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonUp();
    }
    else
    {
      op->vtkInteractorStyle3D::OnLeftButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnRightButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnRightButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnRightButtonDown();
    }
    else
    {
      op->vtkInteractorStyle3D::OnRightButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnRightButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnRightButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnRightButtonUp();
    }
    else
    {
      op->vtkInteractorStyle3D::OnRightButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnMiddleButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMiddleButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMiddleButtonDown();
    }
    else
    {
      op->vtkInteractorStyle3D::OnMiddleButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnMiddleButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMiddleButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMiddleButtonUp();
    }
    else
    {
      op->vtkInteractorStyle3D::OnMiddleButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnFourthButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnFourthButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnFourthButtonUp();
    }
    else
    {
      op->vtkInteractorStyle3D::OnFourthButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnPinch(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnPinch");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnPinch();
    }
    else
    {
      op->vtkInteractorStyle3D::OnPinch();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_OnPan(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnPan");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnPan();
    }
    else
    {
      op->vtkInteractorStyle3D::OnPan();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_Rotate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Rotate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Rotate();
    }
    else
    {
      op->vtkInteractorStyle3D::Rotate();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_Dolly(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Dolly");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Dolly();
    }
    else
    {
      op->vtkInteractorStyle3D::Dolly();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_Clip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Clip();
    }
    else
    {
      op->vtkInteractorStyle3D::Clip();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_StartClip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartClip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StartClip();
    }
    else
    {
      op->vtkInteractorStyle3D::StartClip();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_EndClip(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndClip");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EndClip();
    }
    else
    {
      op->vtkInteractorStyle3D::EndClip();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_SetDollyMotionFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDollyMotionFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDollyMotionFactor(temp0);
    }
    else
    {
      op->vtkInteractorStyle3D::SetDollyMotionFactor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_GetDollyMotionFactor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDollyMotionFactor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDollyMotionFactor() :
      op->vtkInteractorStyle3D::GetDollyMotionFactor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyle3D_SetDistance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDistance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyle3D *op = static_cast<vtkInteractorStyle3D *>(vp);

  vtkCamera *temp0 = NULL;
  double temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkCamera") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetDistance(temp0, temp1);
    }
    else
    {
      op->vtkInteractorStyle3D::SetDistance(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkInteractorStyle3D_Methods[] = {
  {"IsTypeOf", PyvtkInteractorStyle3D_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkInteractorStyle3D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkInteractorStyle3D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkInteractorStyle3D\nC++: static vtkInteractorStyle3D *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkInteractorStyle3D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkInteractorStyle3D\nC++: vtkInteractorStyle3D *NewInstance()\n\n"},
  {"OnMouseMove", PyvtkInteractorStyle3D_OnMouseMove, METH_VARARGS,
   "V.OnMouseMove()\nC++: void OnMouseMove()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnLeftButtonDown", PyvtkInteractorStyle3D_OnLeftButtonDown, METH_VARARGS,
   "V.OnLeftButtonDown()\nC++: void OnLeftButtonDown()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnLeftButtonUp", PyvtkInteractorStyle3D_OnLeftButtonUp, METH_VARARGS,
   "V.OnLeftButtonUp()\nC++: void OnLeftButtonUp()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnRightButtonDown", PyvtkInteractorStyle3D_OnRightButtonDown, METH_VARARGS,
   "V.OnRightButtonDown()\nC++: void OnRightButtonDown()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnRightButtonUp", PyvtkInteractorStyle3D_OnRightButtonUp, METH_VARARGS,
   "V.OnRightButtonUp()\nC++: void OnRightButtonUp()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnMiddleButtonDown", PyvtkInteractorStyle3D_OnMiddleButtonDown, METH_VARARGS,
   "V.OnMiddleButtonDown()\nC++: void OnMiddleButtonDown()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnMiddleButtonUp", PyvtkInteractorStyle3D_OnMiddleButtonUp, METH_VARARGS,
   "V.OnMiddleButtonUp()\nC++: void OnMiddleButtonUp()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnFourthButtonUp", PyvtkInteractorStyle3D_OnFourthButtonUp, METH_VARARGS,
   "V.OnFourthButtonUp()\nC++: void OnFourthButtonUp()\n\nEvent bindings controlling the effects of pressing mouse buttons\nor moving the mouse.\n"},
  {"OnPinch", PyvtkInteractorStyle3D_OnPinch, METH_VARARGS,
   "V.OnPinch()\nC++: void OnPinch()\n\nEvent bindings for gestures\n"},
  {"OnPan", PyvtkInteractorStyle3D_OnPan, METH_VARARGS,
   "V.OnPan()\nC++: void OnPan()\n\nEvent bindings for gestures\n"},
  {"Rotate", PyvtkInteractorStyle3D_Rotate, METH_VARARGS,
   "V.Rotate()\nC++: void Rotate()\n\n"},
  {"Dolly", PyvtkInteractorStyle3D_Dolly, METH_VARARGS,
   "V.Dolly()\nC++: void Dolly()\n\n"},
  {"Clip", PyvtkInteractorStyle3D_Clip, METH_VARARGS,
   "V.Clip()\nC++: virtual void Clip()\n\n"},
  {"StartClip", PyvtkInteractorStyle3D_StartClip, METH_VARARGS,
   "V.StartClip()\nC++: virtual void StartClip()\n\nInteraction mode for adjusting a hardware clipping plane\n"},
  {"EndClip", PyvtkInteractorStyle3D_EndClip, METH_VARARGS,
   "V.EndClip()\nC++: virtual void EndClip()\n\nInteraction mode for adjusting a hardware clipping plane\n"},
  {"SetDollyMotionFactor", PyvtkInteractorStyle3D_SetDollyMotionFactor, METH_VARARGS,
   "V.SetDollyMotionFactor(float)\nC++: virtual void SetDollyMotionFactor(double _arg)\n\nSet/Get the dolly motion factor used when flying in 3D. Defaults\nto 2.0 to simulate 2 meters per second of movement in physical\nspace. The dolly speed is adjusted by the touchpad position as\nwell. The maximum rate is twice this setting.\n"},
  {"GetDollyMotionFactor", PyvtkInteractorStyle3D_GetDollyMotionFactor, METH_VARARGS,
   "V.GetDollyMotionFactor() -> float\nC++: virtual double GetDollyMotionFactor()\n\nSet/Get the dolly motion factor used when flying in 3D. Defaults\nto 2.0 to simulate 2 meters per second of movement in physical\nspace. The dolly speed is adjusted by the touchpad position as\nwell. The maximum rate is twice this setting.\n"},
  {"SetDistance", PyvtkInteractorStyle3D_SetDistance, METH_VARARGS,
   "V.SetDistance(vtkCamera, float)\nC++: void SetDistance(vtkCamera *cam, double distance)\n\nSet the distance for the camera. The distance in VR represents\nthe scaling from world to physical space. So when we set it to a\nnew value we also adjust the HMD position to maintain the same\nrelative position.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkInteractorStyle3D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingCorePython.vtkInteractorStyle3D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkInteractorStyle3D_StaticNew()
{
  return vtkInteractorStyle3D::New();
}

PyObject *PyvtkInteractorStyle3D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkInteractorStyle3D_Type, PyvtkInteractorStyle3D_Methods,
    "vtkInteractorStyle3D",
    PyvtkInteractorStyle3D_Doc(), &PyvtkInteractorStyle3D_StaticNew);

  PyTypeObject *pytype = &PyvtkInteractorStyle3D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkInteractorStyle_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkInteractorStyle3D_Doc()
{
  static const char *docstring[] = {
    "vtkInteractorStyle3D - extends interaction to support 3D input\n\n",
    "Superclass: vtkInteractorStyle\n\n",
    "vtkInteractorStyle3D allows the user to interact with (rotate, pan,\netc.) objects in the scene indendent of each other. It is designed to\nuse 3d positions and orientations instead of 2D.\n\nThe following interactions are specified by default.\n\nA click and hold in 3D within the bounding box of a prop will pick up\nthat prop allowing you to translate and orient that prop as desired\nwith the 3D controll",
    "er.\n\nClick/dragging two controllers and pulling them apart or pushing them\ntogether will initial a scale gesture that will scale the world\nlarger or smaller.\n\nClick/dragging two controllers and translating them in the same\ndirection will translate the camera/world pushing them together will\ninitial a scale gesture that will scale the world larger or smaller.\n\nIf a controller is right clicked (push",
    " touchpad on Vive) then it\nstarts a fly motion where the camer moves in the direction the\ncontroller is pointing. It moves at a speed scaled by the position of\nyour thumb on the trackpad. Higher moves faster forward. Lower moves\nfaster backwards.\n\nFor the Vive left click is mapped to the trigger and right click is\nmapped to pushing the trackpad down.\n\n@sa\nvtkRenderWindowInteractor3D\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkInteractorStyle3D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkInteractorStyle3D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkInteractorStyle3D", o) != 0)
  {
    Py_DECREF(o);
  }

}

