// python wrapper for vtkMaskPointsFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMaskPointsFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMaskPointsFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMaskPointsFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPointCloudFilter_ClassNew
extern "C" { PyObject *PyvtkPointCloudFilter_ClassNew(); }
#define DECLARED_PyvtkPointCloudFilter_ClassNew
#endif

static const char **PyvtkMaskPointsFilter_Doc();


static PyObject *
PyvtkMaskPointsFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMaskPointsFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMaskPointsFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMaskPointsFilter *tempr = vtkMaskPointsFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMaskPointsFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMaskPointsFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_SetMaskData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  vtkDataObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->SetMaskData(temp0);
    }
    else
    {
      op->vtkMaskPointsFilter::SetMaskData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_GetMask(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMask");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataObject *tempr = (ap.IsBound() ?
      op->GetMask() :
      op->vtkMaskPointsFilter::GetMask());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_SetMaskConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaskConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  vtkAlgorithmOutput *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->SetMaskConnection(temp0);
    }
    else
    {
      op->vtkMaskPointsFilter::SetMaskConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_SetEmptyValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEmptyValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  unsigned char temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEmptyValue(temp0);
    }
    else
    {
      op->vtkMaskPointsFilter::SetEmptyValue(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaskPointsFilter_GetEmptyValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEmptyValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMaskPointsFilter *op = static_cast<vtkMaskPointsFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned char tempr = (ap.IsBound() ?
      op->GetEmptyValue() :
      op->vtkMaskPointsFilter::GetEmptyValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMaskPointsFilter_Methods[] = {
  {"IsTypeOf", PyvtkMaskPointsFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"IsA", PyvtkMaskPointsFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SafeDownCast", PyvtkMaskPointsFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMaskPointsFilter\nC++: static vtkMaskPointsFilter *SafeDownCast(vtkObjectBase *o)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"NewInstance", PyvtkMaskPointsFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMaskPointsFilter\nC++: vtkMaskPointsFilter *NewInstance()\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SetMaskData", PyvtkMaskPointsFilter_SetMaskData, METH_VARARGS,
   "V.SetMaskData(vtkDataObject)\nC++: void SetMaskData(vtkDataObject *source)\n\nSpecify the masking image. It must be of type vtkImageData.\n"},
  {"GetMask", PyvtkMaskPointsFilter_GetMask, METH_VARARGS,
   "V.GetMask() -> vtkDataObject\nC++: vtkDataObject *GetMask()\n\nSpecify the masking image. It must be of type vtkImageData.\n"},
  {"SetMaskConnection", PyvtkMaskPointsFilter_SetMaskConnection, METH_VARARGS,
   "V.SetMaskConnection(vtkAlgorithmOutput)\nC++: void SetMaskConnection(vtkAlgorithmOutput *algOutput)\n\nSpecify the masking image. It is vtkImageData output from an\nalgorithm.\n"},
  {"SetEmptyValue", PyvtkMaskPointsFilter_SetEmptyValue, METH_VARARGS,
   "V.SetEmptyValue(int)\nC++: virtual void SetEmptyValue(unsigned char _arg)\n\nSet / get the values indicating whether a voxel is empty. By\ndefault, an empty voxel is marked with a zero value. Any point\ninside a voxel marked empty is not selected for output. All other\nvoxels with a value that is not equal to the empty value are\nselected for output.\n"},
  {"GetEmptyValue", PyvtkMaskPointsFilter_GetEmptyValue, METH_VARARGS,
   "V.GetEmptyValue() -> int\nC++: virtual unsigned char GetEmptyValue()\n\nSet / get the values indicating whether a voxel is empty. By\ndefault, an empty voxel is marked with a zero value. Any point\ninside a voxel marked empty is not selected for output. All other\nvoxels with a value that is not equal to the empty value are\nselected for output.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMaskPointsFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersPointsPython.vtkMaskPointsFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMaskPointsFilter_StaticNew()
{
  return vtkMaskPointsFilter::New();
}

PyObject *PyvtkMaskPointsFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMaskPointsFilter_Type, PyvtkMaskPointsFilter_Methods,
    "vtkMaskPointsFilter",
    PyvtkMaskPointsFilter_Doc(), &PyvtkMaskPointsFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkMaskPointsFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPointCloudFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMaskPointsFilter_Doc()
{
  static const char *docstring[] = {
    "vtkMaskPointsFilter - extract points within an image/volume mask\n\n",
    "Superclass: vtkPointCloudFilter\n\n",
    "vtkMaskPointsFilter extracts points that are inside an image mask.\nThe image mask is a second input to the filter. Points that are\ninside a voxel marked \"inside\" are copied to the output. The image\nmask can be generated by vtkPointOccupancyFilter, with optional image\nprocessing steps performed on the mask. Thus vtkPointOccupancyFilter\nand vtkMaskPointsFilter are generally used together, with a pip",
    "eline\nof image processing algorithms in between the two filters.\n\nNote also that this filter is a subclass of vtkPointCloudFilter which\nhas the ability to produce an output mask indicating which points\nwere selected for output. It also has an optional second output\ncontaining the points that were masked out (i.e., outliers) during\nprocessing.\n\nFinally, the mask value indicating non-selection of po",
    "ints (i.e., the\nempty value) may be specified. The second input, masking image, is\ntypically of type unsigned char so the empty value is of this type as\nwell.\n\n@warning\nDuring processing, points not within the masking image/volume are\nconsidered outside and never extracted.\n\n@warning\nThis class has been threaded with vtkSMPTools. Using TBB or other\nnon-sequential type (set in the CMake variable\nVT",
    "K_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.\n\n@sa\nvtkPointOccupancyFilter vtkPointCloudFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMaskPointsFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMaskPointsFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMaskPointsFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

