// python wrapper for vtkMultiBlockFromTimeSeriesFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMultiBlockFromTimeSeriesFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMultiBlockFromTimeSeriesFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMultiBlockFromTimeSeriesFilter_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkMultiBlockDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkMultiBlockFromTimeSeriesFilter_Doc();


static PyObject *
PyvtkMultiBlockFromTimeSeriesFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkMultiBlockFromTimeSeriesFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiBlockFromTimeSeriesFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMultiBlockFromTimeSeriesFilter *op = static_cast<vtkMultiBlockFromTimeSeriesFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMultiBlockFromTimeSeriesFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiBlockFromTimeSeriesFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkMultiBlockFromTimeSeriesFilter *tempr = vtkMultiBlockFromTimeSeriesFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMultiBlockFromTimeSeriesFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMultiBlockFromTimeSeriesFilter *op = static_cast<vtkMultiBlockFromTimeSeriesFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiBlockFromTimeSeriesFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMultiBlockFromTimeSeriesFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkMultiBlockFromTimeSeriesFilter_Methods[] = {
  {"IsTypeOf", PyvtkMultiBlockFromTimeSeriesFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkMultiBlockFromTimeSeriesFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkMultiBlockFromTimeSeriesFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkMultiBlockFromTimeSeriesFilter\nC++: static vtkMultiBlockFromTimeSeriesFilter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkMultiBlockFromTimeSeriesFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMultiBlockFromTimeSeriesFilter\nC++: vtkMultiBlockFromTimeSeriesFilter *NewInstance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMultiBlockFromTimeSeriesFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkMultiBlockFromTimeSeriesFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMultiBlockFromTimeSeriesFilter_StaticNew()
{
  return vtkMultiBlockFromTimeSeriesFilter::New();
}

PyObject *PyvtkMultiBlockFromTimeSeriesFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMultiBlockFromTimeSeriesFilter_Type, PyvtkMultiBlockFromTimeSeriesFilter_Methods,
    "vtkMultiBlockFromTimeSeriesFilter",
    PyvtkMultiBlockFromTimeSeriesFilter_Doc(), &PyvtkMultiBlockFromTimeSeriesFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkMultiBlockFromTimeSeriesFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMultiBlockFromTimeSeriesFilter_Doc()
{
  static const char *docstring[] = {
    "vtkMultiBlockFromTimeSeriesFilter - collects multiple inputs into one\nmulti-group dataset\n\n",
    "Superclass: vtkMultiBlockDataSetAlgorithm\n\n",
    "vtkMultiBlockFromTimeSeriesFilter is a 1 to 1 filter that merges\nmultiple time steps from the input into one multiblock dataset.  It\nwill assign each time step from the input to one group of the\nmulti-block dataset and will assign each timestep's data as a block\nin the multi-block datset.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMultiBlockFromTimeSeriesFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMultiBlockFromTimeSeriesFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMultiBlockFromTimeSeriesFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

