// python wrapper for vtkNetCDFCAMReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkNetCDFCAMReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkNetCDFCAMReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkNetCDFCAMReader_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkNetCDFCAMReader_Doc();

static PyTypeObject PyvtkNetCDFCAMReader_VerticalDimension_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIONetCDFPython.vtkNetCDFCAMReader.VerticalDimension", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkNetCDFCAMReader_VerticalDimension_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkNetCDFCAMReader_VerticalDimension_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkNetCDFCAMReader_VerticalDimension_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkNetCDFCAMReader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkNetCDFCAMReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkNetCDFCAMReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkNetCDFCAMReader *tempr = vtkNetCDFCAMReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkNetCDFCAMReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkNetCDFCAMReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_CanReadFile(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CanReadFile");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkNetCDFCAMReader::CanReadFile(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkNetCDFCAMReader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetConnectivityFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetConnectivityFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetConnectivityFileName(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetConnectivityFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetConnectivityFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetConnectivityFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetConnectivityFileName() :
      op->vtkNetCDFCAMReader::GetConnectivityFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_SingleLevelOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleLevelOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleLevelOn();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleLevelOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_SingleLevelOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleLevelOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleLevelOff();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleLevelOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_SetSingleLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSingleLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSingleLevel(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetSingleLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_GetSingleLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSingleLevel() :
      op->vtkNetCDFCAMReader::GetSingleLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}
#endif


static PyObject *
PyvtkNetCDFCAMReader_SetVerticalDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVerticalDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVerticalDimension(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetVerticalDimension(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetVerticalDimensionMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVerticalDimensionMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetVerticalDimensionMinValue() :
      op->vtkNetCDFCAMReader::GetVerticalDimensionMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetVerticalDimensionMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVerticalDimensionMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetVerticalDimensionMaxValue() :
      op->vtkNetCDFCAMReader::GetVerticalDimensionMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetVerticalDimension(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVerticalDimension");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetVerticalDimension() :
      op->vtkNetCDFCAMReader::GetVerticalDimension());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleMidpointLayerOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleMidpointLayerOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleMidpointLayerOn();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleMidpointLayerOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleMidpointLayerOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleMidpointLayerOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleMidpointLayerOff();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleMidpointLayerOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetSingleMidpointLayer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSingleMidpointLayer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSingleMidpointLayer(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetSingleMidpointLayer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetSingleMidpointLayer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleMidpointLayer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSingleMidpointLayer() :
      op->vtkNetCDFCAMReader::GetSingleMidpointLayer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetMidpointLayerIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMidpointLayerIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMidpointLayerIndex(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetMidpointLayerIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetMidpointLayerIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMidpointLayerIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMidpointLayerIndex() :
      op->vtkNetCDFCAMReader::GetMidpointLayerIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetMidpointLayersRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMidpointLayersRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetMidpointLayersRange() :
      op->vtkNetCDFCAMReader::GetMidpointLayersRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleInterfaceLayerOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleInterfaceLayerOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleInterfaceLayerOn();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleInterfaceLayerOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SingleInterfaceLayerOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SingleInterfaceLayerOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SingleInterfaceLayerOff();
    }
    else
    {
      op->vtkNetCDFCAMReader::SingleInterfaceLayerOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetSingleInterfaceLayer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSingleInterfaceLayer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSingleInterfaceLayer(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetSingleInterfaceLayer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetSingleInterfaceLayer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSingleInterfaceLayer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSingleInterfaceLayer() :
      op->vtkNetCDFCAMReader::GetSingleInterfaceLayer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetInterfaceLayerIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInterfaceLayerIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInterfaceLayerIndex(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetInterfaceLayerIndex(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetInterfaceLayerIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInterfaceLayerIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetInterfaceLayerIndex() :
      op->vtkNetCDFCAMReader::GetInterfaceLayerIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetInterfaceLayersRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInterfaceLayersRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetInterfaceLayersRange() :
      op->vtkNetCDFCAMReader::GetInterfaceLayersRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetNumberOfPointArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPointArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPointArrays() :
      op->vtkNetCDFCAMReader::GetNumberOfPointArrays());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetPointArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPointArrayName(temp0) :
      op->vtkNetCDFCAMReader::GetPointArrayName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_GetPointArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPointArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPointArrayStatus(temp0) :
      op->vtkNetCDFCAMReader::GetPointArrayStatus(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_SetPointArrayStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPointArrayStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  char *temp0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetPointArrayStatus(temp0, temp1);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetPointArrayStatus(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_DisableAllPointArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisableAllPointArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->DisableAllPointArrays();
    }
    else
    {
      op->vtkNetCDFCAMReader::DisableAllPointArrays();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkNetCDFCAMReader_EnableAllPointArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableAllPointArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EnableAllPointArrays();
    }
    else
    {
      op->vtkNetCDFCAMReader::EnableAllPointArrays();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_SetCellLayerRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCellLayerRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCellLayerRight(temp0);
    }
    else
    {
      op->vtkNetCDFCAMReader::SetCellLayerRight(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkNetCDFCAMReader_GetCellLayerRight(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCellLayerRight");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkNetCDFCAMReader *op = static_cast<vtkNetCDFCAMReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCellLayerRight() :
      op->vtkNetCDFCAMReader::GetCellLayerRight());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}
#endif

static PyMethodDef PyvtkNetCDFCAMReader_Methods[] = {
  {"IsTypeOf", PyvtkNetCDFCAMReader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkNetCDFCAMReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkNetCDFCAMReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkNetCDFCAMReader\nC++: static vtkNetCDFCAMReader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkNetCDFCAMReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkNetCDFCAMReader\nC++: vtkNetCDFCAMReader *NewInstance()\n\n"},
  {"CanReadFile", PyvtkNetCDFCAMReader_CanReadFile, METH_VARARGS,
   "V.CanReadFile(string) -> int\nC++: static int CanReadFile(const char *fileName)\n\nReturns 1 if this file can be read and 0 if the file cannot be\nread. Because NetCDF CAM files come in pairs and we only check\none of the files, the result is not definitive.  Invalid files\nmay still return 1 although a valid file will never return 0.\n"},
  {"SetFileName", PyvtkNetCDFCAMReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(const char *fileName)\n\n"},
  {"GetFileName", PyvtkNetCDFCAMReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: virtual char *GetFileName()\n\n"},
  {"SetConnectivityFileName", PyvtkNetCDFCAMReader_SetConnectivityFileName, METH_VARARGS,
   "V.SetConnectivityFileName(string)\nC++: void SetConnectivityFileName(const char *fileName)\n\n"},
  {"GetConnectivityFileName", PyvtkNetCDFCAMReader_GetConnectivityFileName, METH_VARARGS,
   "V.GetConnectivityFileName() -> string\nC++: virtual char *GetConnectivityFileName()\n\n"},
#if !defined(VTK_LEGACY_REMOVE)
  {"SingleLevelOn", PyvtkNetCDFCAMReader_SingleLevelOn, METH_VARARGS,
   "V.SingleLevelOn()\nC++: virtual void SingleLevelOn()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncol).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncol) will be read in. By default,\nSingleLevel = 0.@deprecated in VTK 7.1 use SetVerticalDimension\nor\n            GetVerticalDimension instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"SingleLevelOff", PyvtkNetCDFCAMReader_SingleLevelOff, METH_VARARGS,
   "V.SingleLevelOff()\nC++: virtual void SingleLevelOff()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncol).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncol) will be read in. By default,\nSingleLevel = 0.@deprecated in VTK 7.1 use SetVerticalDimension\nor\n            GetVerticalDimension instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"SetSingleLevel", PyvtkNetCDFCAMReader_SetSingleLevel, METH_VARARGS,
   "V.SetSingleLevel(int)\nC++: virtual void SetSingleLevel(int level)\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncol).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncol) will be read in. By default,\nSingleLevel = 0.@deprecated in VTK 7.1 use SetVerticalDimension\nor\n            GetVerticalDimension instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"GetSingleLevel", PyvtkNetCDFCAMReader_GetSingleLevel, METH_VARARGS,
   "V.GetSingleLevel() -> int\nC++: virtual int GetSingleLevel()\n\nSet whether or not to read a single level.  A value of one\nindicates that only a single level will be read in. The NetCDF\nvariables loaded will then be ones with dimensions of (time,\nncol).  This will result in a surface grid. Otherwise a\nvolumetric grid will be created (if lev > 1) and the variables\nwith dimensions of (time, lev, ncol) will be read in. By default,\nSingleLevel = 0.@deprecated in VTK 7.1 use SetVerticalDimension\nor\n            GetVerticalDimension instead.\n"},
#endif
  {"SetVerticalDimension", PyvtkNetCDFCAMReader_SetVerticalDimension, METH_VARARGS,
   "V.SetVerticalDimension(int)\nC++: virtual void SetVerticalDimension(int _arg)\n\nSet whether to read a single layer, midpoint layers or interface\nlayers. VERTICAL_DIMENSION_SINGLE_LAYER (0) indicates that only a\nsingle layer will be read in. The NetCDF variables loaded will be\nthe ones with dimensions (time, ncol).\nVERTICAL_DIMENSION_MIDPOINT_LAYERS (1) indicates that variables\ndefined on midpoint layers will be read in. These are variables\nwith dimensions (time, lev, ncol).\nVERTICAL_DIMENSION_INTERFACE_LAYERS (2) indicates that variables\ndefined on interface layers will be read in. These are variables\nwith dimensions (time, ilev, ncol).\n"},
  {"GetVerticalDimensionMinValue", PyvtkNetCDFCAMReader_GetVerticalDimensionMinValue, METH_VARARGS,
   "V.GetVerticalDimensionMinValue() -> int\nC++: virtual int GetVerticalDimensionMinValue()\n\nSet whether to read a single layer, midpoint layers or interface\nlayers. VERTICAL_DIMENSION_SINGLE_LAYER (0) indicates that only a\nsingle layer will be read in. The NetCDF variables loaded will be\nthe ones with dimensions (time, ncol).\nVERTICAL_DIMENSION_MIDPOINT_LAYERS (1) indicates that variables\ndefined on midpoint layers will be read in. These are variables\nwith dimensions (time, lev, ncol).\nVERTICAL_DIMENSION_INTERFACE_LAYERS (2) indicates that variables\ndefined on interface layers will be read in. These are variables\nwith dimensions (time, ilev, ncol).\n"},
  {"GetVerticalDimensionMaxValue", PyvtkNetCDFCAMReader_GetVerticalDimensionMaxValue, METH_VARARGS,
   "V.GetVerticalDimensionMaxValue() -> int\nC++: virtual int GetVerticalDimensionMaxValue()\n\nSet whether to read a single layer, midpoint layers or interface\nlayers. VERTICAL_DIMENSION_SINGLE_LAYER (0) indicates that only a\nsingle layer will be read in. The NetCDF variables loaded will be\nthe ones with dimensions (time, ncol).\nVERTICAL_DIMENSION_MIDPOINT_LAYERS (1) indicates that variables\ndefined on midpoint layers will be read in. These are variables\nwith dimensions (time, lev, ncol).\nVERTICAL_DIMENSION_INTERFACE_LAYERS (2) indicates that variables\ndefined on interface layers will be read in. These are variables\nwith dimensions (time, ilev, ncol).\n"},
  {"GetVerticalDimension", PyvtkNetCDFCAMReader_GetVerticalDimension, METH_VARARGS,
   "V.GetVerticalDimension() -> int\nC++: virtual int GetVerticalDimension()\n\nSet whether to read a single layer, midpoint layers or interface\nlayers. VERTICAL_DIMENSION_SINGLE_LAYER (0) indicates that only a\nsingle layer will be read in. The NetCDF variables loaded will be\nthe ones with dimensions (time, ncol).\nVERTICAL_DIMENSION_MIDPOINT_LAYERS (1) indicates that variables\ndefined on midpoint layers will be read in. These are variables\nwith dimensions (time, lev, ncol).\nVERTICAL_DIMENSION_INTERFACE_LAYERS (2) indicates that variables\ndefined on interface layers will be read in. These are variables\nwith dimensions (time, ilev, ncol).\n"},
  {"SingleMidpointLayerOn", PyvtkNetCDFCAMReader_SingleMidpointLayerOn, METH_VARARGS,
   "V.SingleMidpointLayerOn()\nC++: virtual void SingleMidpointLayerOn()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SingleMidpointLayerOff", PyvtkNetCDFCAMReader_SingleMidpointLayerOff, METH_VARARGS,
   "V.SingleMidpointLayerOff()\nC++: virtual void SingleMidpointLayerOff()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SetSingleMidpointLayer", PyvtkNetCDFCAMReader_SetSingleMidpointLayer, METH_VARARGS,
   "V.SetSingleMidpointLayer(int)\nC++: virtual void SetSingleMidpointLayer(int _arg)\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetSingleMidpointLayer", PyvtkNetCDFCAMReader_GetSingleMidpointLayer, METH_VARARGS,
   "V.GetSingleMidpointLayer() -> int\nC++: virtual int GetSingleMidpointLayer()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SetMidpointLayerIndex", PyvtkNetCDFCAMReader_SetMidpointLayerIndex, METH_VARARGS,
   "V.SetMidpointLayerIndex(int)\nC++: virtual void SetMidpointLayerIndex(int _arg)\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetMidpointLayerIndex", PyvtkNetCDFCAMReader_GetMidpointLayerIndex, METH_VARARGS,
   "V.GetMidpointLayerIndex() -> int\nC++: virtual int GetMidpointLayerIndex()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetMidpointLayersRange", PyvtkNetCDFCAMReader_GetMidpointLayersRange, METH_VARARGS,
   "V.GetMidpointLayersRange() -> (int, int)\nC++: int *GetMidpointLayersRange()\n\n"},
  {"SingleInterfaceLayerOn", PyvtkNetCDFCAMReader_SingleInterfaceLayerOn, METH_VARARGS,
   "V.SingleInterfaceLayerOn()\nC++: virtual void SingleInterfaceLayerOn()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SingleInterfaceLayerOff", PyvtkNetCDFCAMReader_SingleInterfaceLayerOff, METH_VARARGS,
   "V.SingleInterfaceLayerOff()\nC++: virtual void SingleInterfaceLayerOff()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SetSingleInterfaceLayer", PyvtkNetCDFCAMReader_SetSingleInterfaceLayer, METH_VARARGS,
   "V.SetSingleInterfaceLayer(int)\nC++: virtual void SetSingleInterfaceLayer(int _arg)\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetSingleInterfaceLayer", PyvtkNetCDFCAMReader_GetSingleInterfaceLayer, METH_VARARGS,
   "V.GetSingleInterfaceLayer() -> int\nC++: virtual int GetSingleInterfaceLayer()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"SetInterfaceLayerIndex", PyvtkNetCDFCAMReader_SetInterfaceLayerIndex, METH_VARARGS,
   "V.SetInterfaceLayerIndex(int)\nC++: virtual void SetInterfaceLayerIndex(int _arg)\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetInterfaceLayerIndex", PyvtkNetCDFCAMReader_GetInterfaceLayerIndex, METH_VARARGS,
   "V.GetInterfaceLayerIndex() -> int\nC++: virtual int GetInterfaceLayerIndex()\n\nIf SingleXXXLayer is 1, we'll load only the layer specified by\nXXXLayerIndex.  Otherwise, we load all layers. We do that for\nmidpoint layer variables ( which have dimension 'lev') or for\ninterface layer variables (which have dimension 'ilev').\n"},
  {"GetInterfaceLayersRange", PyvtkNetCDFCAMReader_GetInterfaceLayersRange, METH_VARARGS,
   "V.GetInterfaceLayersRange() -> (int, int)\nC++: int *GetInterfaceLayersRange()\n\n"},
  {"GetNumberOfPointArrays", PyvtkNetCDFCAMReader_GetNumberOfPointArrays, METH_VARARGS,
   "V.GetNumberOfPointArrays() -> int\nC++: int GetNumberOfPointArrays()\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
  {"GetPointArrayName", PyvtkNetCDFCAMReader_GetPointArrayName, METH_VARARGS,
   "V.GetPointArrayName(int) -> string\nC++: const char *GetPointArrayName(int index)\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
  {"GetPointArrayStatus", PyvtkNetCDFCAMReader_GetPointArrayStatus, METH_VARARGS,
   "V.GetPointArrayStatus(string) -> int\nC++: int GetPointArrayStatus(const char *name)\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
  {"SetPointArrayStatus", PyvtkNetCDFCAMReader_SetPointArrayStatus, METH_VARARGS,
   "V.SetPointArrayStatus(string, int)\nC++: void SetPointArrayStatus(const char *name, int status)\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
  {"DisableAllPointArrays", PyvtkNetCDFCAMReader_DisableAllPointArrays, METH_VARARGS,
   "V.DisableAllPointArrays()\nC++: void DisableAllPointArrays()\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
  {"EnableAllPointArrays", PyvtkNetCDFCAMReader_EnableAllPointArrays, METH_VARARGS,
   "V.EnableAllPointArrays()\nC++: void EnableAllPointArrays()\n\nThe following methods allow selective reading of variables. By\ndefault, ALL data variables on the nodes are read.\n"},
#if !defined(VTK_LEGACY_REMOVE)
  {"SetCellLayerRight", PyvtkNetCDFCAMReader_SetCellLayerRight, METH_VARARGS,
   "V.SetCellLayerRight(int)\nC++: void SetCellLayerRight(int)\n\nSpecify which \"side\" of the domain to add the connecting cells\nat.  0 indicates left side and 1 indicates right side. The\ndefault is the right side.@deprecated This method is no longer\nsupported. The reader automatically decides which side to pad\ncells on. Using this method has no effect.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"GetCellLayerRight", PyvtkNetCDFCAMReader_GetCellLayerRight, METH_VARARGS,
   "V.GetCellLayerRight() -> int\nC++: int GetCellLayerRight()\n\nSpecify which \"side\" of the domain to add the connecting cells\nat.  0 indicates left side and 1 indicates right side. The\ndefault is the right side.@deprecated This method is no longer\nsupported. The reader automatically decides which side to pad\ncells on. Using this method has no effect.\n"},
#endif
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkNetCDFCAMReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIONetCDFPython.vtkNetCDFCAMReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkNetCDFCAMReader_StaticNew()
{
  return vtkNetCDFCAMReader::New();
}

PyObject *PyvtkNetCDFCAMReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkNetCDFCAMReader_Type, PyvtkNetCDFCAMReader_Methods,
    "vtkNetCDFCAMReader",
    PyvtkNetCDFCAMReader_Doc(), &PyvtkNetCDFCAMReader_StaticNew);

  PyTypeObject *pytype = &PyvtkNetCDFCAMReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkNetCDFCAMReader_VerticalDimension_Type);
  PyvtkNetCDFCAMReader_VerticalDimension_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkNetCDFCAMReader_VerticalDimension_Type);

  o = (PyObject *)&PyvtkNetCDFCAMReader_VerticalDimension_Type;
  if (PyDict_SetItemString(d, "VerticalDimension", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    static const struct { const char *name; int value; }
      constants[4] = {
        { "VERTICAL_DIMENSION_SINGLE_LAYER", vtkNetCDFCAMReader::VERTICAL_DIMENSION_SINGLE_LAYER },
        { "VERTICAL_DIMENSION_MIDPOINT_LAYERS", vtkNetCDFCAMReader::VERTICAL_DIMENSION_MIDPOINT_LAYERS },
        { "VERTICAL_DIMENSION_INTERFACE_LAYERS", vtkNetCDFCAMReader::VERTICAL_DIMENSION_INTERFACE_LAYERS },
        { "VERTICAL_DIMENSION_COUNT", vtkNetCDFCAMReader::VERTICAL_DIMENSION_COUNT },
      };

    o = PyvtkNetCDFCAMReader_VerticalDimension_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkNetCDFCAMReader_Doc()
{
  static const char *docstring[] = {
    "vtkNetCDFCAMReader - Read unstructured NetCDF CAM files.\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "Reads in a NetCDF CAM (Community Atmospheric Model) file and produces\nand unstructured grid.  The grid is actually unstructured in the X\nand Y directions and rectilinear in the Z direction. If we read one\nlayer we produce quad cells otherwise we produce hex cells.  The\nreader requires 2 NetCDF files: the main file has all attributes, the\nconnectivity file has point positions and cell connectivity\n",
    "information.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkNetCDFCAMReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkNetCDFCAMReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkNetCDFCAMReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

