// python wrapper for vtkPPainterCommunicator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkPPainterCommunicator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPPainterCommunicator(PyObject *); }

static const char **PyvtkPPainterCommunicator_Doc();


static PyObject *
PyvtkPPainterCommunicator_GetRank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRank");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetRank();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetIsNull(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsNull");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->GetIsNull();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetWorldRank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorldRank");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetWorldRank();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetWorldSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWorldSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetWorldSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetMPIInitialized(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMPIInitialized");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->GetMPIInitialized();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetMPIFinalized(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMPIFinalized");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = op->GetMPIFinalized();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_MPIInitialized(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "MPIInitialized");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPPainterCommunicator::MPIInitialized();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_MPIFinalized(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "MPIFinalized");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPPainterCommunicator::MPIFinalized();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPPainterCommunicator_GetCommunicator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCommunicator");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkPPainterCommunicator *op = static_cast<vtkPPainterCommunicator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    void  *tempr = op->GetCommunicator();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPPainterCommunicator_Methods[] = {
  {"GetRank", PyvtkPPainterCommunicator_GetRank, METH_VARARGS,
   "V.GetRank() -> int\nC++: virtual int GetRank()\n\nQuerry MPI for inforrmation about the communicator.\n"},
  {"GetSize", PyvtkPPainterCommunicator_GetSize, METH_VARARGS,
   "V.GetSize() -> int\nC++: virtual int GetSize()\n\nQuerry MPI for inforrmation about the communicator.\n"},
  {"GetIsNull", PyvtkPPainterCommunicator_GetIsNull, METH_VARARGS,
   "V.GetIsNull() -> bool\nC++: virtual bool GetIsNull()\n\nQuerry MPI for inforrmation about the communicator.\n"},
  {"GetWorldRank", PyvtkPPainterCommunicator_GetWorldRank, METH_VARARGS,
   "V.GetWorldRank() -> int\nC++: virtual int GetWorldRank()\n\nQuerry MPI for information a bout the world communicator.\n"},
  {"GetWorldSize", PyvtkPPainterCommunicator_GetWorldSize, METH_VARARGS,
   "V.GetWorldSize() -> int\nC++: virtual int GetWorldSize()\n\nQuerry MPI for information a bout the world communicator.\n"},
  {"GetMPIInitialized", PyvtkPPainterCommunicator_GetMPIInitialized, METH_VARARGS,
   "V.GetMPIInitialized() -> bool\nC++: virtual bool GetMPIInitialized()\n\nQuerry MPI state.\n"},
  {"GetMPIFinalized", PyvtkPPainterCommunicator_GetMPIFinalized, METH_VARARGS,
   "V.GetMPIFinalized() -> bool\nC++: virtual bool GetMPIFinalized()\n\n"},
  {"MPIInitialized", PyvtkPPainterCommunicator_MPIInitialized, METH_VARARGS,
   "V.MPIInitialized() -> bool\nC++: static bool MPIInitialized()\n\n"},
  {"MPIFinalized", PyvtkPPainterCommunicator_MPIFinalized, METH_VARARGS,
   "V.MPIFinalized() -> bool\nC++: static bool MPIFinalized()\n\n"},
  {"GetCommunicator", PyvtkPPainterCommunicator_GetCommunicator, METH_VARARGS,
   "V.GetCommunicator() -> void\nC++: void *GetCommunicator()\n\nSet/Get the communicator. Ownership is not assumed thus caller\nmust keep the commuicator alive while this class is in use and\nfree the communicator when finished.\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkPPainterCommunicator_vtkPPainterCommunicator_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPPainterCommunicator");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkPPainterCommunicator *op = new vtkPPainterCommunicator();

    result = PyVTKSpecialObject_New("vtkPPainterCommunicator", op);
  }

  return result;
}

static PyObject *
PyvtkPPainterCommunicator_vtkPPainterCommunicator_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkPPainterCommunicator");

  vtkPPainterCommunicator *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkPPainterCommunicator"))
  {
    vtkPPainterCommunicator *op = new vtkPPainterCommunicator(*temp0);

    result = PyVTKSpecialObject_New("vtkPPainterCommunicator", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkPPainterCommunicator_vtkPPainterCommunicator_Methods[] = {
  {NULL, PyvtkPPainterCommunicator_vtkPPainterCommunicator_s2, METH_VARARGS,
   "@W vtkPPainterCommunicator"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkPPainterCommunicator_vtkPPainterCommunicator(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkPPainterCommunicator_vtkPPainterCommunicator_s1(self, args);
    case 1:
      return PyvtkPPainterCommunicator_vtkPPainterCommunicator_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkPPainterCommunicator");
  return NULL;
}


static PyObject *
PyvtkPPainterCommunicator_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkPPainterCommunicator_vtkPPainterCommunicator(NULL, args);
}

static void PyvtkPPainterCommunicator_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkPPainterCommunicator *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkPPainterCommunicator_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkPPainterCommunicator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingParallelLICPython.vtkPPainterCommunicator", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkPPainterCommunicator_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkPPainterCommunicator_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkPPainterCommunicator_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkPPainterCommunicator_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkPPainterCommunicator(*static_cast<const vtkPPainterCommunicator*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPPainterCommunicator_TypeNew(); }

PyObject *PyvtkPPainterCommunicator_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkPPainterCommunicator_Type,
    PyvtkPPainterCommunicator_Methods,
    PyvtkPPainterCommunicator_vtkPPainterCommunicator_Methods,
    PyvtkPPainterCommunicator_Doc(), &PyvtkPPainterCommunicator_CCopy);

  PyTypeObject *pytype = &PyvtkPPainterCommunicator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPPainterCommunicator_Doc()
{
  static const char *docstring[] = {
    "vtkPPainterCommunicator - no description provided.\n\n",
    "V.vtkPPainterCommunicator()\nC++: vtkPPainterCommunicator()\nV.vtkPPainterCommunicator(vtkPPainterCommunicator)\nC++: vtkPPainterCommunicator(const vtkPPainterCommunicator &other)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPPainterCommunicator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPPainterCommunicator_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkPPainterCommunicator", o) != 0)
  {
    Py_DECREF(o);
  }

}

