// python wrapper for vtkPVClientServerSynchronizedRenderers
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVClientServerSynchronizedRenderers.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVClientServerSynchronizedRenderers(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVClientServerSynchronizedRenderers_ClassNew(); }

#ifndef DECLARED_PyvtkSynchronizedRenderers_ClassNew
extern "C" { PyObject *PyvtkSynchronizedRenderers_ClassNew(); }
#define DECLARED_PyvtkSynchronizedRenderers_ClassNew
#endif

static const char **PyvtkPVClientServerSynchronizedRenderers_Doc();


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVClientServerSynchronizedRenderers::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClientServerSynchronizedRenderers *op = static_cast<vtkPVClientServerSynchronizedRenderers *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVClientServerSynchronizedRenderers::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVClientServerSynchronizedRenderers *tempr = vtkPVClientServerSynchronizedRenderers::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClientServerSynchronizedRenderers *op = static_cast<vtkPVClientServerSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVClientServerSynchronizedRenderers *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVClientServerSynchronizedRenderers::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_SetLossLessCompression(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLossLessCompression");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClientServerSynchronizedRenderers *op = static_cast<vtkPVClientServerSynchronizedRenderers *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLossLessCompression(temp0);
    }
    else
    {
      op->vtkPVClientServerSynchronizedRenderers::SetLossLessCompression(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_GetLossLessCompression(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLossLessCompression");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClientServerSynchronizedRenderers *op = static_cast<vtkPVClientServerSynchronizedRenderers *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetLossLessCompression() :
      op->vtkPVClientServerSynchronizedRenderers::GetLossLessCompression());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClientServerSynchronizedRenderers_ConfigureCompressor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ConfigureCompressor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClientServerSynchronizedRenderers *op = static_cast<vtkPVClientServerSynchronizedRenderers *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->ConfigureCompressor(temp0);
    }
    else
    {
      op->vtkPVClientServerSynchronizedRenderers::ConfigureCompressor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPVClientServerSynchronizedRenderers_Methods[] = {
  {"IsTypeOf", PyvtkPVClientServerSynchronizedRenderers_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVClientServerSynchronizedRenderers_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVClientServerSynchronizedRenderers_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkPVClientServerSynchronizedRenderers\nC++: static vtkPVClientServerSynchronizedRenderers *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVClientServerSynchronizedRenderers_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVClientServerSynchronizedRenderers\nC++: vtkPVClientServerSynchronizedRenderers *NewInstance()\n\n"},
  {"SetLossLessCompression", PyvtkPVClientServerSynchronizedRenderers_SetLossLessCompression, METH_VARARGS,
   "V.SetLossLessCompression(bool)\nC++: virtual void SetLossLessCompression(bool _arg)\n\n"},
  {"GetLossLessCompression", PyvtkPVClientServerSynchronizedRenderers_GetLossLessCompression, METH_VARARGS,
   "V.GetLossLessCompression() -> bool\nC++: virtual bool GetLossLessCompression()\n\n"},
  {"ConfigureCompressor", PyvtkPVClientServerSynchronizedRenderers_ConfigureCompressor, METH_VARARGS,
   "V.ConfigureCompressor(string)\nC++: virtual void ConfigureCompressor(const char *stream)\n\nSet and configure a compressor from it's own configuration\nstream. This is used by ParaView to configure the compressor from\napplication wide user settings.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVClientServerSynchronizedRenderers_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkPVClientServerSynchronizedRenderers", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVClientServerSynchronizedRenderers_StaticNew()
{
  return vtkPVClientServerSynchronizedRenderers::New();
}

PyObject *PyvtkPVClientServerSynchronizedRenderers_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVClientServerSynchronizedRenderers_Type, PyvtkPVClientServerSynchronizedRenderers_Methods,
    "vtkPVClientServerSynchronizedRenderers",
    PyvtkPVClientServerSynchronizedRenderers_Doc(), &PyvtkPVClientServerSynchronizedRenderers_StaticNew);

  PyTypeObject *pytype = &PyvtkPVClientServerSynchronizedRenderers_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSynchronizedRenderers_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVClientServerSynchronizedRenderers_Doc()
{
  static const char *docstring[] = {
    "vtkPVClientServerSynchronizedRenderers -\nvtkPVClientServerSynchronizedRenderers is similar to\nvtkClientServerSynchronizedRenderers except that it optionally uses\nimage compressors to compress the image before transmitting.\n\n",
    "Superclass: vtkSynchronizedRenderers\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVClientServerSynchronizedRenderers(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVClientServerSynchronizedRenderers_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVClientServerSynchronizedRenderers", o) != 0)
  {
    Py_DECREF(o);
  }

}

