// python wrapper for vtkPVClipDataSet
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInformationVector.h"
#include "vtkPVClipDataSet.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVClipDataSet(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVClipDataSet_ClassNew(); }

#ifndef DECLARED_PyvtkTableBasedClipDataSet_ClassNew
extern "C" { PyObject *PyvtkTableBasedClipDataSet_ClassNew(); }
#define DECLARED_PyvtkTableBasedClipDataSet_ClassNew
#endif

static const char **PyvtkPVClipDataSet_Doc();


static PyObject *
PyvtkPVClipDataSet_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVClipDataSet::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVClipDataSet::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVClipDataSet *tempr = vtkPVClipDataSet::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVClipDataSet *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVClipDataSet::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_SetUseAMRDualClipForAMR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseAMRDualClipForAMR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseAMRDualClipForAMR(temp0);
    }
    else
    {
      op->vtkPVClipDataSet::SetUseAMRDualClipForAMR(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_GetUseAMRDualClipForAMR(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseAMRDualClipForAMR");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseAMRDualClipForAMR() :
      op->vtkPVClipDataSet::GetUseAMRDualClipForAMR());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_UseAMRDualClipForAMROn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseAMRDualClipForAMROn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseAMRDualClipForAMROn();
    }
    else
    {
      op->vtkPVClipDataSet::UseAMRDualClipForAMROn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVClipDataSet_UseAMRDualClipForAMROff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseAMRDualClipForAMROff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVClipDataSet *op = static_cast<vtkPVClipDataSet *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseAMRDualClipForAMROff();
    }
    else
    {
      op->vtkPVClipDataSet::UseAMRDualClipForAMROff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPVClipDataSet_Methods[] = {
  {"IsTypeOf", PyvtkPVClipDataSet_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVClipDataSet_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVClipDataSet_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVClipDataSet\nC++: static vtkPVClipDataSet *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVClipDataSet_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVClipDataSet\nC++: vtkPVClipDataSet *NewInstance()\n\n"},
  {"SetUseAMRDualClipForAMR", PyvtkPVClipDataSet_SetUseAMRDualClipForAMR, METH_VARARGS,
   "V.SetUseAMRDualClipForAMR(bool)\nC++: virtual void SetUseAMRDualClipForAMR(bool _arg)\n\nThis filter uses vtkAMRDualClip for clipping AMR datasets. Do\ndisable that behavior, turn this flag off.\n"},
  {"GetUseAMRDualClipForAMR", PyvtkPVClipDataSet_GetUseAMRDualClipForAMR, METH_VARARGS,
   "V.GetUseAMRDualClipForAMR() -> bool\nC++: virtual bool GetUseAMRDualClipForAMR()\n\nThis filter uses vtkAMRDualClip for clipping AMR datasets. Do\ndisable that behavior, turn this flag off.\n"},
  {"UseAMRDualClipForAMROn", PyvtkPVClipDataSet_UseAMRDualClipForAMROn, METH_VARARGS,
   "V.UseAMRDualClipForAMROn()\nC++: virtual void UseAMRDualClipForAMROn()\n\nThis filter uses vtkAMRDualClip for clipping AMR datasets. Do\ndisable that behavior, turn this flag off.\n"},
  {"UseAMRDualClipForAMROff", PyvtkPVClipDataSet_UseAMRDualClipForAMROff, METH_VARARGS,
   "V.UseAMRDualClipForAMROff()\nC++: virtual void UseAMRDualClipForAMROff()\n\nThis filter uses vtkAMRDualClip for clipping AMR datasets. Do\ndisable that behavior, turn this flag off.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVClipDataSet_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkPVClipDataSet", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVClipDataSet_StaticNew()
{
  return vtkPVClipDataSet::New();
}

PyObject *PyvtkPVClipDataSet_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVClipDataSet_Type, PyvtkPVClipDataSet_Methods,
    "vtkPVClipDataSet",
    PyvtkPVClipDataSet_Doc(), &PyvtkPVClipDataSet_StaticNew);

  PyTypeObject *pytype = &PyvtkPVClipDataSet_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTableBasedClipDataSet_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVClipDataSet_Doc()
{
  static const char *docstring[] = {
    "vtkPVClipDataSet - Clip filter\n\n",
    "Superclass: vtkTableBasedClipDataSet\n\n",
    "This is a subclass of vtkTableBasedClipDataSet that allows selection\nof input scalars.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVClipDataSet(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVClipDataSet_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVClipDataSet", o) != 0)
  {
    Py_DECREF(o);
  }

}

