// python wrapper for vtkPVDisplayInformation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVDisplayInformation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVDisplayInformation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVDisplayInformation_ClassNew(); }

#ifndef DECLARED_PyvtkPVInformation_ClassNew
extern "C" { PyObject *PyvtkPVInformation_ClassNew(); }
#define DECLARED_PyvtkPVInformation_ClassNew
#endif

static const char **PyvtkPVDisplayInformation_Doc();


static PyObject *
PyvtkPVDisplayInformation_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVDisplayInformation::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVDisplayInformation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVDisplayInformation *tempr = vtkPVDisplayInformation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDisplayInformation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVDisplayInformation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_CanOpenDisplayLocally(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "CanOpenDisplayLocally");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPVDisplayInformation::CanOpenDisplayLocally();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_SupportsOpenGLLocally(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SupportsOpenGLLocally");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPVDisplayInformation::SupportsOpenGLLocally();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_CopyFromObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyFromObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    if (ap.IsBound())
    {
      op->CopyFromObject(temp0);
    }
    else
    {
      op->vtkPVDisplayInformation::CopyFromObject(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_AddInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  vtkPVInformation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVInformation"))
  {
    if (ap.IsBound())
    {
      op->AddInformation(temp0);
    }
    else
    {
      op->vtkPVDisplayInformation::AddInformation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_CopyToStream(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyToStream");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  vtkClientServerStream *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkClientServerStream"))
  {
    if (ap.IsBound())
    {
      op->CopyToStream(temp0);
    }
    else
    {
      op->vtkPVDisplayInformation::CopyToStream(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_CopyFromStream(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyFromStream");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  vtkClientServerStream *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkClientServerStream"))
  {
    if (ap.IsBound())
    {
      op->CopyFromStream(temp0);
    }
    else
    {
      op->vtkPVDisplayInformation::CopyFromStream(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_GetCanOpenDisplay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCanOpenDisplay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCanOpenDisplay() :
      op->vtkPVDisplayInformation::GetCanOpenDisplay());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDisplayInformation_GetSupportsOpenGL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSupportsOpenGL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDisplayInformation *op = static_cast<vtkPVDisplayInformation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetSupportsOpenGL() :
      op->vtkPVDisplayInformation::GetSupportsOpenGL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVDisplayInformation_Methods[] = {
  {"IsTypeOf", PyvtkPVDisplayInformation_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVDisplayInformation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVDisplayInformation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVDisplayInformation\nC++: static vtkPVDisplayInformation *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVDisplayInformation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVDisplayInformation\nC++: vtkPVDisplayInformation *NewInstance()\n\n"},
  {"CanOpenDisplayLocally", PyvtkPVDisplayInformation_CanOpenDisplayLocally, METH_VARARGS,
   "V.CanOpenDisplayLocally() -> bool\nC++: static bool CanOpenDisplayLocally()\n\nReturns if the display can be opened up on the current processes.\n"},
  {"SupportsOpenGLLocally", PyvtkPVDisplayInformation_SupportsOpenGLLocally, METH_VARARGS,
   "V.SupportsOpenGLLocally() -> bool\nC++: static bool SupportsOpenGLLocally()\n\nReturns true if OpenGL context supports core features required\nfor rendering.\n"},
  {"CopyFromObject", PyvtkPVDisplayInformation_CopyFromObject, METH_VARARGS,
   "V.CopyFromObject(vtkObject)\nC++: virtual void CopyFromObject(vtkObject *)\n\nTransfer information about a single object into this object.\n"},
  {"AddInformation", PyvtkPVDisplayInformation_AddInformation, METH_VARARGS,
   "V.AddInformation(vtkPVInformation)\nC++: virtual void AddInformation(vtkPVInformation *info)\n\nMerge another information object. Calls AddInformation(info, 0).\n"},
  {"CopyToStream", PyvtkPVDisplayInformation_CopyToStream, METH_VARARGS,
   "V.CopyToStream(vtkClientServerStream)\nC++: virtual void CopyToStream(vtkClientServerStream *)\n\nManage a serialized version of the information.\n"},
  {"CopyFromStream", PyvtkPVDisplayInformation_CopyFromStream, METH_VARARGS,
   "V.CopyFromStream(vtkClientServerStream)\nC++: virtual void CopyFromStream(const vtkClientServerStream *)\n\nManage a serialized version of the information.\n"},
  {"GetCanOpenDisplay", PyvtkPVDisplayInformation_GetCanOpenDisplay, METH_VARARGS,
   "V.GetCanOpenDisplay() -> int\nC++: virtual int GetCanOpenDisplay()\n\nCanOpenDisplay is set to 1 if a window can be opened on the\ndisplay.\n"},
  {"GetSupportsOpenGL", PyvtkPVDisplayInformation_GetSupportsOpenGL, METH_VARARGS,
   "V.GetSupportsOpenGL() -> int\nC++: virtual int GetSupportsOpenGL()\n\nSupportsOpenGL is set to 1 if the OpenGL context available\nsupports core features needed for rendering.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVDisplayInformation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkPVDisplayInformation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVDisplayInformation_StaticNew()
{
  return vtkPVDisplayInformation::New();
}

PyObject *PyvtkPVDisplayInformation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVDisplayInformation_Type, PyvtkPVDisplayInformation_Methods,
    "vtkPVDisplayInformation",
    PyvtkPVDisplayInformation_Doc(), &PyvtkPVDisplayInformation_StaticNew);

  PyTypeObject *pytype = &PyvtkPVDisplayInformation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVInformation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVDisplayInformation_Doc()
{
  static const char *docstring[] = {
    "vtkPVDisplayInformation - provides information about the rendering\ndisplay and OpenGL context.\n\n",
    "Superclass: vtkPVInformation\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVDisplayInformation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVDisplayInformation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVDisplayInformation", o) != 0)
  {
    Py_DECREF(o);
  }

}

