// python wrapper for vtkPVHardwareSelector
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVHardwareSelector.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVHardwareSelector(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVHardwareSelector_ClassNew(); }

#ifndef DECLARED_PyvtkOpenGLHardwareSelector_ClassNew
extern "C" { PyObject *PyvtkOpenGLHardwareSelector_ClassNew(); }
#define DECLARED_PyvtkOpenGLHardwareSelector_ClassNew
#endif

static const char **PyvtkPVHardwareSelector_Doc();


static PyObject *
PyvtkPVHardwareSelector_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVHardwareSelector::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVHardwareSelector::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVHardwareSelector *tempr = vtkPVHardwareSelector::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVHardwareSelector *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVHardwareSelector::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_Select(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Select");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  const int size0 = 4;
  int temp0[4];
  int save0[4];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    ap.SaveArray(temp0, save0, size0);

    vtkSelection *tempr = (ap.IsBound() ?
      op->Select(temp0) :
      op->vtkPVHardwareSelector::Select(temp0));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_PolygonSelect(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PolygonSelect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(2*size0);
  int *temp0 = store0.Data();
  int *save0 = (size0 == 0 ? NULL : temp0 + size0);
  vtkIdType temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1))
  {
    ap.SaveArray(temp0, save0, size0);

    vtkSelection *tempr = (ap.IsBound() ?
      op->PolygonSelect(temp0, temp1) :
      op->vtkPVHardwareSelector::PolygonSelect(temp0, temp1));

    if (ap.ArrayHasChanged(temp0, save0, size0) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(0, temp0, size0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_NeedToRenderForSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NeedToRenderForSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->NeedToRenderForSelection() :
      op->vtkPVHardwareSelector::NeedToRenderForSelection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_InvalidateCachedSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InvalidateCachedSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InvalidateCachedSelection();
    }
    else
    {
      op->vtkPVHardwareSelector::InvalidateCachedSelection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_AssignUniqueId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AssignUniqueId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  vtkProp *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkProp"))
  {
    int tempr = (ap.IsBound() ?
      op->AssignUniqueId(temp0) :
      op->vtkPVHardwareSelector::AssignUniqueId(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_SetSynchronizedWindows(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSynchronizedWindows");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  vtkPVSynchronizedRenderWindows *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVSynchronizedRenderWindows"))
  {
    if (ap.IsBound())
    {
      op->SetSynchronizedWindows(temp0);
    }
    else
    {
      op->vtkPVHardwareSelector::SetSynchronizedWindows(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVHardwareSelector_BeginRenderProp_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginRenderProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  vtkRenderWindow *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindow"))
  {
    if (ap.IsBound())
    {
      op->BeginRenderProp(temp0);
    }
    else
    {
      op->vtkPVHardwareSelector::BeginRenderProp(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPVHardwareSelector_BeginRenderProp_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginRenderProp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVHardwareSelector *op = static_cast<vtkPVHardwareSelector *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->BeginRenderProp();
    }
    else
    {
      op->vtkPVHardwareSelector::BeginRenderProp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkPVHardwareSelector_BeginRenderProp(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkPVHardwareSelector_BeginRenderProp_s1(self, args);
    case 0:
      return PyvtkPVHardwareSelector_BeginRenderProp_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "BeginRenderProp");
  return NULL;
}


static PyMethodDef PyvtkPVHardwareSelector_Methods[] = {
  {"IsTypeOf", PyvtkPVHardwareSelector_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVHardwareSelector_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVHardwareSelector_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVHardwareSelector\nC++: static vtkPVHardwareSelector *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVHardwareSelector_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVHardwareSelector\nC++: vtkPVHardwareSelector *NewInstance()\n\n"},
  {"Select", PyvtkPVHardwareSelector_Select, METH_VARARGS,
   "V.Select([int, int, int, int]) -> vtkSelection\nC++: vtkSelection *Select(int region[4])\n\nOverridden to avoid clearing of captured buffers.\n"},
  {"PolygonSelect", PyvtkPVHardwareSelector_PolygonSelect, METH_VARARGS,
   "V.PolygonSelect([int, ...], int) -> vtkSelection\nC++: vtkSelection *PolygonSelect(int *polygonPoints,\n    vtkIdType count)\n\nSame as Select() above, except this one use a polygon, instead of\na rectangle region, and select elements inside the polygon\n"},
  {"NeedToRenderForSelection", PyvtkPVHardwareSelector_NeedToRenderForSelection, METH_VARARGS,
   "V.NeedToRenderForSelection() -> bool\nC++: virtual bool NeedToRenderForSelection()\n\nReturns true when the next call to Select() will result in\nrenders to capture the selection-buffers.\n"},
  {"InvalidateCachedSelection", PyvtkPVHardwareSelector_InvalidateCachedSelection, METH_VARARGS,
   "V.InvalidateCachedSelection()\nC++: void InvalidateCachedSelection()\n\nCalled to invalidate the cache.\n"},
  {"AssignUniqueId", PyvtkPVHardwareSelector_AssignUniqueId, METH_VARARGS,
   "V.AssignUniqueId(vtkProp) -> int\nC++: int AssignUniqueId(vtkProp *)\n\n"},
  {"SetSynchronizedWindows", PyvtkPVHardwareSelector_SetSynchronizedWindows, METH_VARARGS,
   "V.SetSynchronizedWindows(vtkPVSynchronizedRenderWindows)\nC++: void SetSynchronizedWindows(vtkPVSynchronizedRenderWindows *)\n\nSet the vtkPVSynchronizedRenderWindows instance. This is used to\ncommunicate between all active processes.\n"},
  {"BeginRenderProp", PyvtkPVHardwareSelector_BeginRenderProp, METH_VARARGS,
   "V.BeginRenderProp(vtkRenderWindow)\nC++: void BeginRenderProp(vtkRenderWindow *)\nV.BeginRenderProp()\nC++: void BeginRenderProp()\n\nSet the local ProcessId.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVHardwareSelector_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkPVHardwareSelector", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVHardwareSelector_StaticNew()
{
  return vtkPVHardwareSelector::New();
}

PyObject *PyvtkPVHardwareSelector_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVHardwareSelector_Type, PyvtkPVHardwareSelector_Methods,
    "vtkPVHardwareSelector",
    PyvtkPVHardwareSelector_Doc(), &PyvtkPVHardwareSelector_StaticNew);

  PyTypeObject *pytype = &PyvtkPVHardwareSelector_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkOpenGLHardwareSelector_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVHardwareSelector_Doc()
{
  static const char *docstring[] = {
    "vtkPVHardwareSelector - vtkHardwareSelector subclass with paraview\nsepecific logic to avoid recapturing buffers unless needed.\n\n",
    "Superclass: vtkOpenGLHardwareSelector\n\n",
    "vtkHardwareSelector is subclass of vtkHardwareSelector that adds\nlogic to reuse the captured buffers as much as possible. Thus\navoiding repeated selection-rendering of repeated selections or\npicking. This class does not know, however, when the cached buffers\nare invalid. External logic must explicitly calls\nInvalidateCachedSelection() to ensure that the cache is not reused.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVHardwareSelector(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVHardwareSelector_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVHardwareSelector", o) != 0)
  {
    Py_DECREF(o);
  }

}

