// python wrapper for vtkPVTestUtilities
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVTestUtilities.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVTestUtilities(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVTestUtilities_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPVTestUtilities_Doc();


static PyObject *
PyvtkPVTestUtilities_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVTestUtilities::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTestUtilities_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTestUtilities *op = static_cast<vtkPVTestUtilities *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVTestUtilities::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTestUtilities_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVTestUtilities *tempr = vtkPVTestUtilities::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTestUtilities_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTestUtilities *op = static_cast<vtkPVTestUtilities *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVTestUtilities *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVTestUtilities::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVTestUtilities_GetDataFilePath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataFilePath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTestUtilities *op = static_cast<vtkPVTestUtilities *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetDataFilePath(temp0) :
      op->vtkPVTestUtilities::GetDataFilePath(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTestUtilities_GetTempFilePath(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTempFilePath");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTestUtilities *op = static_cast<vtkPVTestUtilities *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTempFilePath(temp0) :
      op->vtkPVTestUtilities::GetTempFilePath(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVTestUtilities_Methods[] = {
  {"IsTypeOf", PyvtkPVTestUtilities_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVTestUtilities_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVTestUtilities_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVTestUtilities\nC++: static vtkPVTestUtilities *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVTestUtilities_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVTestUtilities\nC++: vtkPVTestUtilities *NewInstance()\n\n"},
  {"GetDataFilePath", PyvtkPVTestUtilities_GetDataFilePath, METH_VARARGS,
   "V.GetDataFilePath(string) -> string\nC++: char *GetDataFilePath(const char *name)\n\nGiven a path relative to the Data root (provided in argv by -D\noption), construct a OS independent path to the file specified by\n\"name\". \"name\" should not start with a path seperator and if path\nseperators are needed use '/'. Be sure to delete [] the return\nwhen you are finished.\n"},
  {"GetTempFilePath", PyvtkPVTestUtilities_GetTempFilePath, METH_VARARGS,
   "V.GetTempFilePath(string) -> string\nC++: char *GetTempFilePath(const char *name)\n\nGiven a path relative to the working directory (provided in argv\nby -T option), construct a OS independent path to the file\nspecified by \"name\". \"name\" should not start with a path\nseperator and if path seperators are needed use '/'. Be sure to\ndelete [] the return when you are finished.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVTestUtilities_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCommonPython.vtkPVTestUtilities", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVTestUtilities_StaticNew()
{
  return vtkPVTestUtilities::New();
}

PyObject *PyvtkPVTestUtilities_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVTestUtilities_Type, PyvtkPVTestUtilities_Methods,
    "vtkPVTestUtilities",
    PyvtkPVTestUtilities_Doc(), &PyvtkPVTestUtilities_StaticNew);

  PyTypeObject *pytype = &PyvtkPVTestUtilities_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVTestUtilities_Doc()
{
  static const char *docstring[] = {
    "vtkPVTestUtilities - A class to facilitate common test operations\n\n",
    "Superclass: vtkObject\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVTestUtilities(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVTestUtilities_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVTestUtilities", o) != 0)
  {
    Py_DECREF(o);
  }

}

