// python wrapper for vtkPVTransposeTable
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVTransposeTable.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVTransposeTable(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVTransposeTable_ClassNew(); }

#ifndef DECLARED_PyvtkTransposeTable_ClassNew
extern "C" { PyObject *PyvtkTransposeTable_ClassNew(); }
#define DECLARED_PyvtkTransposeTable_ClassNew
#endif

static const char **PyvtkPVTransposeTable_Doc();


static PyObject *
PyvtkPVTransposeTable_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVTransposeTable::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVTransposeTable::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVTransposeTable *tempr = vtkPVTransposeTable::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVTransposeTable *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVTransposeTable::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_EnableAttributeArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EnableAttributeArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->EnableAttributeArray(temp0);
    }
    else
    {
      op->vtkPVTransposeTable::EnableAttributeArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_ClearAttributeArrays(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearAttributeArrays");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearAttributeArrays();
    }
    else
    {
      op->vtkPVTransposeTable::ClearAttributeArrays();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_GetDoNotTranspose(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDoNotTranspose");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetDoNotTranspose() :
      op->vtkPVTransposeTable::GetDoNotTranspose());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_SetDoNotTranspose(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDoNotTranspose");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDoNotTranspose(temp0);
    }
    else
    {
      op->vtkPVTransposeTable::SetDoNotTranspose(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_DoNotTransposeOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DoNotTransposeOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->DoNotTransposeOn();
    }
    else
    {
      op->vtkPVTransposeTable::DoNotTransposeOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVTransposeTable_DoNotTransposeOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DoNotTransposeOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVTransposeTable *op = static_cast<vtkPVTransposeTable *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->DoNotTransposeOff();
    }
    else
    {
      op->vtkPVTransposeTable::DoNotTransposeOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPVTransposeTable_Methods[] = {
  {"IsTypeOf", PyvtkPVTransposeTable_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVTransposeTable_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVTransposeTable_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVTransposeTable\nC++: static vtkPVTransposeTable *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVTransposeTable_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVTransposeTable\nC++: vtkPVTransposeTable *NewInstance()\n\n"},
  {"EnableAttributeArray", PyvtkPVTransposeTable_EnableAttributeArray, METH_VARARGS,
   "V.EnableAttributeArray(string)\nC++: void EnableAttributeArray(const char *)\n\nInterface for preparing selection of arrays in ParaView.\n"},
  {"ClearAttributeArrays", PyvtkPVTransposeTable_ClearAttributeArrays, METH_VARARGS,
   "V.ClearAttributeArrays()\nC++: void ClearAttributeArrays()\n\nInterface for preparing selection of arrays in ParaView.\n"},
  {"GetDoNotTranspose", PyvtkPVTransposeTable_GetDoNotTranspose, METH_VARARGS,
   "V.GetDoNotTranspose() -> bool\nC++: virtual bool GetDoNotTranspose()\n\nCan be used to bypass the transposition code. The output is then\nthe table made with the selected columns.\n"},
  {"SetDoNotTranspose", PyvtkPVTransposeTable_SetDoNotTranspose, METH_VARARGS,
   "V.SetDoNotTranspose(bool)\nC++: virtual void SetDoNotTranspose(bool _arg)\n\nCan be used to bypass the transposition code. The output is then\nthe table made with the selected columns.\n"},
  {"DoNotTransposeOn", PyvtkPVTransposeTable_DoNotTransposeOn, METH_VARARGS,
   "V.DoNotTransposeOn()\nC++: virtual void DoNotTransposeOn()\n\nCan be used to bypass the transposition code. The output is then\nthe table made with the selected columns.\n"},
  {"DoNotTransposeOff", PyvtkPVTransposeTable_DoNotTransposeOff, METH_VARARGS,
   "V.DoNotTransposeOff()\nC++: virtual void DoNotTransposeOff()\n\nCan be used to bypass the transposition code. The output is then\nthe table made with the selected columns.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVTransposeTable_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkPVTransposeTable", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVTransposeTable_StaticNew()
{
  return vtkPVTransposeTable::New();
}

PyObject *PyvtkPVTransposeTable_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVTransposeTable_Type, PyvtkPVTransposeTable_Methods,
    "vtkPVTransposeTable",
    PyvtkPVTransposeTable_Doc(), &PyvtkPVTransposeTable_StaticNew);

  PyTypeObject *pytype = &PyvtkPVTransposeTable_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkTransposeTable_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVTransposeTable_Doc()
{
  static const char *docstring[] = {
    "vtkPVTransposeTable - create a subtable made with selected columns of\nthe input vtkTable and transpose it.\n\n",
    "Superclass: vtkTransposeTable\n\n",
    "This ParaView filter allows to select the columns of the input table\nthat must be included in the transposed table. This filter can also\nbe use to extract a non transposed table made by the selected\ncolumns.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVTransposeTable(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVTransposeTable_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVTransposeTable", o) != 0)
  {
    Py_DECREF(o);
  }

}

