// python wrapper for vtkPythonInterpreter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPythonInterpreter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPythonInterpreter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPythonInterpreter_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPythonInterpreter_Doc();


static PyObject *
PyvtkPythonInterpreter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPythonInterpreter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInterpreter *op = static_cast<vtkPythonInterpreter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPythonInterpreter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPythonInterpreter *tempr = vtkPythonInterpreter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPythonInterpreter *op = static_cast<vtkPythonInterpreter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPythonInterpreter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPythonInterpreter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_Initialize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Initialize");

  int temp0 = 1;
  PyObject *result = NULL;

  if (ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    bool tempr = vtkPythonInterpreter::Initialize(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_Finalize(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "Finalize");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkPythonInterpreter::Finalize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_IsInitialized(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsInitialized");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPythonInterpreter::IsInitialized();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_SetProgramName(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SetProgramName");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkPythonInterpreter::SetProgramName(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_RunSimpleString(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "RunSimpleString");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPythonInterpreter::RunSimpleString(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_PrependPythonPath(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "PrependPythonPath");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkPythonInterpreter::PrependPythonPath(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_SetCaptureStdin(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SetCaptureStdin");

  bool temp0 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkPythonInterpreter::SetCaptureStdin(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPythonInterpreter_GetCaptureStdin(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetCaptureStdin");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    bool tempr = vtkPythonInterpreter::GetCaptureStdin();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPythonInterpreter_Methods[] = {
  {"IsTypeOf", PyvtkPythonInterpreter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPythonInterpreter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPythonInterpreter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPythonInterpreter\nC++: static vtkPythonInterpreter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPythonInterpreter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPythonInterpreter\nC++: vtkPythonInterpreter *NewInstance()\n\n"},
  {"Initialize", PyvtkPythonInterpreter_Initialize, METH_VARARGS,
   "V.Initialize(int) -> bool\nC++: static bool Initialize(int initsigs=1)\n\nCall this method to initialize Python. This has no effect if\nPython is already initialized. Returns true if Python was\ninitialized by this call, or false if Python was already\ninitialized. Although, one can call Initialize()/Finalize() pair\nmultiple times, Python documentation warns that \"Some extensions\nmay not work properly if their initialization routine is called\nmore than once; this can happen if an application calls\nPy_InitializeEx() and Py_Finalize() more than once.\"\n"},
  {"Finalize", PyvtkPythonInterpreter_Finalize, METH_VARARGS,
   "V.Finalize()\nC++: static void Finalize()\n\nCall this method to finalize Python. This has no effect if Python\nhasn't been initialized already.\n"},
  {"IsInitialized", PyvtkPythonInterpreter_IsInitialized, METH_VARARGS,
   "V.IsInitialized() -> bool\nC++: static bool IsInitialized()\n\nReturns true is Python is initialized.\n"},
  {"SetProgramName", PyvtkPythonInterpreter_SetProgramName, METH_VARARGS,
   "V.SetProgramName(string)\nC++: static void SetProgramName(const char *programname)\n\nSet the program name. This must be called before the first\nInitialize() call. If called afterwords, this will raise a\nwarning.\n"},
  {"RunSimpleString", PyvtkPythonInterpreter_RunSimpleString, METH_VARARGS,
   "V.RunSimpleString(string) -> int\nC++: static int RunSimpleString(const char *script)\n\nDevelopers are free to call Python C API directly. This\nconvenience method is provided to overcome an issue with the\nPython interpreter with handling of DOS line endings. This will\ninitialize Python if not already initialized. Returns 0 on\nsuccess or -1 if a python exception was raised.\n"},
  {"PrependPythonPath", PyvtkPythonInterpreter_PrependPythonPath, METH_VARARGS,
   "V.PrependPythonPath(string)\nC++: static void PrependPythonPath(const char *)\n\nPrepends the path to the sys.path variable. If Python has been\ninitialized, this call will update the sys.path variable\notherwise the same will be done once Python has been initialized.\nThe paths added are saved so that if Python is initialized again\n(by calls to Initialize()), then these paths will be re-added.\n"},
  {"SetCaptureStdin", PyvtkPythonInterpreter_SetCaptureStdin, METH_VARARGS,
   "V.SetCaptureStdin(bool)\nC++: static void SetCaptureStdin(bool)\n\nTo capture stdin, especially for non-terminal applications, set\nCaptureStdin to true. In that case vtkCommand::UpdateEvent will\nbe fired with the calldata being a reference to a vtkStdString\nthat should be filled in with the text to be passed in as the\ninput.\n"},
  {"GetCaptureStdin", PyvtkPythonInterpreter_GetCaptureStdin, METH_VARARGS,
   "V.GetCaptureStdin() -> bool\nC++: static bool GetCaptureStdin()\n\nTo capture stdin, especially for non-terminal applications, set\nCaptureStdin to true. In that case vtkCommand::UpdateEvent will\nbe fired with the calldata being a reference to a vtkStdString\nthat should be filled in with the text to be passed in as the\ninput.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPythonInterpreter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPythonInterpreterPython.vtkPythonInterpreter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPythonInterpreter_StaticNew()
{
  return vtkPythonInterpreter::New();
}

PyObject *PyvtkPythonInterpreter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPythonInterpreter_Type, PyvtkPythonInterpreter_Methods,
    "vtkPythonInterpreter",
    PyvtkPythonInterpreter_Doc(), &PyvtkPythonInterpreter_StaticNew);

  PyTypeObject *pytype = &PyvtkPythonInterpreter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPythonInterpreter_Doc()
{
  static const char *docstring[] = {
    "vtkPythonInterpreter - wrapper for an embedded Python interpreter.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkPythonInterpreter only offers static methods. However, there may\nbe need to register callbacks to call after the Python interpreter is\ninitialized and before the interpreter is finalized. One can register\nobservers for vtkCommand:EnterEvent and vtkCommand::ExitEvent to a\nlocal instance of vtkPythonInterpreter. vtkPythonInterpreter keeps\ntracks of all instances and invokes those events on all in",
    "stances at\nappropriate times.\n\nSame is true for obtaining outputs/errors generated by Python.\nvtkCommand::ErrorEvent and vtkCommand::SetOutputEvent will be fired\nwith calldata being const char* to the messages. Note that by\ndefault, the texts will be dumped on stdout/stderr in any case.\n\nTo capture stdin, especially for non-terminal applications, set\nCaptureStdin to true. In that case vtkCommand::",
    "UpdateEvent will be\nfired with the calldata being a reference to a vtkStdString that\nshould be filled in with the text to be passed in as the input.\n\nA few of the methods on this class implicitly call\nvtkPythonInterpreter::Initialize() to ensure Python is initialized\nviz. vtkPythonInterpreter::PyMain() and\nvtkPythonInterpreter::RunSimpleString(). These implicit\ninitialization always calls vtkPytho",
    "nInterpreter::Initialize(1). If\nthat's not what is expected, ensure that you call\nvtkPythonInterpreter::Initialize(0) before calling such methods.\nRefer to Py_InitializeEx() documentation for details on the\ndifferences between the two.\n\nNotes on calling Initialize/Finalize multiple times: Although\napplications are free to call Initialize/Finalize pairs multiple\ntimes, there are subtle differences ",
    "between the first Initialize and\nsubsequence Initialize calls after Finalize especially when\nconcerning with imported modules. Refer to Python docs for details.\nIn short, modules like numpy don't continue to work after a\nre-initialize. Hence use it with caution.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPythonInterpreter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPythonInterpreter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPythonInterpreter", o) != 0)
  {
    Py_DECREF(o);
  }

}

