// python wrapper for vtkQuadratureSchemeDictionaryGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkQuadratureSchemeDictionaryGenerator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkQuadratureSchemeDictionaryGenerator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkQuadratureSchemeDictionaryGenerator_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkQuadratureSchemeDictionaryGenerator_Doc();


static PyObject *
PyvtkQuadratureSchemeDictionaryGenerator_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkQuadratureSchemeDictionaryGenerator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuadratureSchemeDictionaryGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuadratureSchemeDictionaryGenerator *op = static_cast<vtkQuadratureSchemeDictionaryGenerator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkQuadratureSchemeDictionaryGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuadratureSchemeDictionaryGenerator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkQuadratureSchemeDictionaryGenerator *tempr = vtkQuadratureSchemeDictionaryGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuadratureSchemeDictionaryGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuadratureSchemeDictionaryGenerator *op = static_cast<vtkQuadratureSchemeDictionaryGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkQuadratureSchemeDictionaryGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkQuadratureSchemeDictionaryGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkQuadratureSchemeDictionaryGenerator_Methods[] = {
  {"IsTypeOf", PyvtkQuadratureSchemeDictionaryGenerator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkQuadratureSchemeDictionaryGenerator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkQuadratureSchemeDictionaryGenerator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkQuadratureSchemeDictionaryGenerator\nC++: static vtkQuadratureSchemeDictionaryGenerator *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkQuadratureSchemeDictionaryGenerator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkQuadratureSchemeDictionaryGenerator\nC++: vtkQuadratureSchemeDictionaryGenerator *NewInstance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkQuadratureSchemeDictionaryGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkQuadratureSchemeDictionaryGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkQuadratureSchemeDictionaryGenerator_StaticNew()
{
  return vtkQuadratureSchemeDictionaryGenerator::New();
}

PyObject *PyvtkQuadratureSchemeDictionaryGenerator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkQuadratureSchemeDictionaryGenerator_Type, PyvtkQuadratureSchemeDictionaryGenerator_Methods,
    "vtkQuadratureSchemeDictionaryGenerator",
    PyvtkQuadratureSchemeDictionaryGenerator_Doc(), &PyvtkQuadratureSchemeDictionaryGenerator_StaticNew);

  PyTypeObject *pytype = &PyvtkQuadratureSchemeDictionaryGenerator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkQuadratureSchemeDictionaryGenerator_Doc()
{
  static const char *docstring[] = {
    "vtkQuadratureSchemeDictionaryGenerator - Given an unstructured grid\non its input this filter generates for each data array in point data\ndictionary (ie an instance of\nvtkInformationQuadratureSchemeDefinitionVectorKey).\n\n",
    "Superclass: vtkDataSetAlgorithm\n\n",
    "This filter has been introduced to facilitate testing of the\nvtkQuadrature* classes as these cannot operate with the dictionary.\nThis class is for testing and should not be used for application\ndevelopment.\n\n@sa\nvtkQuadraturePointInterpolator, vtkQuadraturePointsGenerator,\nvtkQuadratureSchemeDefinition\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkQuadratureSchemeDictionaryGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkQuadratureSchemeDictionaryGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkQuadratureSchemeDictionaryGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

}

