// python wrapper for vtkQuartileChartRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkQuartileChartRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkQuartileChartRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkQuartileChartRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkXYChartRepresentation_ClassNew
extern "C" { PyObject *PyvtkXYChartRepresentation_ClassNew(); }
#define DECLARED_PyvtkXYChartRepresentation_ClassNew
#endif

static const char **PyvtkQuartileChartRepresentation_Doc();


static PyObject *
PyvtkQuartileChartRepresentation_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkQuartileChartRepresentation::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkQuartileChartRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkQuartileChartRepresentation *tempr = vtkQuartileChartRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkQuartileChartRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkQuartileChartRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_GetDefaultSeriesLabel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDefaultSeriesLabel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  vtkStdString temp0;
  vtkStdString temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->GetDefaultSeriesLabel(temp0, temp1) :
      op->vtkQuartileChartRepresentation::GetDefaultSeriesLabel(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_SetQuartileVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetQuartileVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetQuartileVisibility(temp0);
    }
    else
    {
      op->vtkQuartileChartRepresentation::SetQuartileVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_GetQuartileVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetQuartileVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetQuartileVisibility() :
      op->vtkQuartileChartRepresentation::GetQuartileVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_SetRangeVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRangeVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRangeVisibility(temp0);
    }
    else
    {
      op->vtkQuartileChartRepresentation::SetRangeVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_GetRangeVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRangeVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetRangeVisibility() :
      op->vtkQuartileChartRepresentation::GetRangeVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_SetAverageVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAverageVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAverageVisibility(temp0);
    }
    else
    {
      op->vtkQuartileChartRepresentation::SetAverageVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_GetAverageVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAverageVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetAverageVisibility() :
      op->vtkQuartileChartRepresentation::GetAverageVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_SetMedianVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMedianVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMedianVisibility(temp0);
    }
    else
    {
      op->vtkQuartileChartRepresentation::SetMedianVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkQuartileChartRepresentation_GetMedianVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMedianVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkQuartileChartRepresentation *op = static_cast<vtkQuartileChartRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetMedianVisibility() :
      op->vtkQuartileChartRepresentation::GetMedianVisibility());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkQuartileChartRepresentation_Methods[] = {
  {"IsTypeOf", PyvtkQuartileChartRepresentation_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkQuartileChartRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkQuartileChartRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkQuartileChartRepresentation\nC++: static vtkQuartileChartRepresentation *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkQuartileChartRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkQuartileChartRepresentation\nC++: vtkQuartileChartRepresentation *NewInstance()\n\n"},
  {"GetDefaultSeriesLabel", PyvtkQuartileChartRepresentation_GetDefaultSeriesLabel, METH_VARARGS,
   "V.GetDefaultSeriesLabel(string, string) -> string\nC++: virtual vtkStdString GetDefaultSeriesLabel(\n    const vtkStdString &tableName, const vtkStdString &columnName)\n\nOverridden to format the series name to remove the operation\napplied e.g. a columnName of \"min(EQPS)\" and \"max(EQPS)\" both\nwill return \"EQPS\".\n"},
  {"SetQuartileVisibility", PyvtkQuartileChartRepresentation_SetQuartileVisibility, METH_VARARGS,
   "V.SetQuartileVisibility(bool)\nC++: virtual void SetQuartileVisibility(bool _arg)\n\nWhen set to true, q1/q3 region is rendered.\n"},
  {"GetQuartileVisibility", PyvtkQuartileChartRepresentation_GetQuartileVisibility, METH_VARARGS,
   "V.GetQuartileVisibility() -> bool\nC++: virtual bool GetQuartileVisibility()\n\nWhen set to true, q1/q3 region is rendered.\n"},
  {"SetRangeVisibility", PyvtkQuartileChartRepresentation_SetRangeVisibility, METH_VARARGS,
   "V.SetRangeVisibility(bool)\nC++: virtual void SetRangeVisibility(bool _arg)\n\nWhen set to true, min/max region is rendered.\n"},
  {"GetRangeVisibility", PyvtkQuartileChartRepresentation_GetRangeVisibility, METH_VARARGS,
   "V.GetRangeVisibility() -> bool\nC++: virtual bool GetRangeVisibility()\n\nWhen set to true, min/max region is rendered.\n"},
  {"SetAverageVisibility", PyvtkQuartileChartRepresentation_SetAverageVisibility, METH_VARARGS,
   "V.SetAverageVisibility(bool)\nC++: virtual void SetAverageVisibility(bool _arg)\n\nWhen set to true, the avg curve is rendered.\n"},
  {"GetAverageVisibility", PyvtkQuartileChartRepresentation_GetAverageVisibility, METH_VARARGS,
   "V.GetAverageVisibility() -> bool\nC++: virtual bool GetAverageVisibility()\n\nWhen set to true, the avg curve is rendered.\n"},
  {"SetMedianVisibility", PyvtkQuartileChartRepresentation_SetMedianVisibility, METH_VARARGS,
   "V.SetMedianVisibility(bool)\nC++: virtual void SetMedianVisibility(bool _arg)\n\nWhen set to true, the med curve is rendered.\n"},
  {"GetMedianVisibility", PyvtkQuartileChartRepresentation_GetMedianVisibility, METH_VARARGS,
   "V.GetMedianVisibility() -> bool\nC++: virtual bool GetMedianVisibility()\n\nWhen set to true, the med curve is rendered.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkQuartileChartRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkQuartileChartRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkQuartileChartRepresentation_StaticNew()
{
  return vtkQuartileChartRepresentation::New();
}

PyObject *PyvtkQuartileChartRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkQuartileChartRepresentation_Type, PyvtkQuartileChartRepresentation_Methods,
    "vtkQuartileChartRepresentation",
    PyvtkQuartileChartRepresentation_Doc(), &PyvtkQuartileChartRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkQuartileChartRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkXYChartRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkQuartileChartRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkQuartileChartRepresentation - vtkQuartileChartRepresentation\nextends to vtkXYChartRepresentation to add support for combining\nquartile plots.\n\n",
    "Superclass: vtkXYChartRepresentation\n\n",
    "A quartile plot is created by treating multiple input arrays are\nranges for area plots. All properties, like color, label etc. are\nspecified collectively.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkQuartileChartRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkQuartileChartRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkQuartileChartRepresentation", o) != 0)
  {
    Py_DECREF(o);
  }

}

