// python wrapper for vtkSMEnsembleDataReaderProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMEnsembleDataReaderProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMEnsembleDataReaderProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMEnsembleDataReaderProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMSourceProxy_ClassNew
extern "C" { PyObject *PyvtkSMSourceProxy_ClassNew(); }
#define DECLARED_PyvtkSMSourceProxy_ClassNew
#endif

static const char **PyvtkSMEnsembleDataReaderProxy_Doc();


static PyObject *
PyvtkSMEnsembleDataReaderProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMEnsembleDataReaderProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMEnsembleDataReaderProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMEnsembleDataReaderProxy *op = static_cast<vtkSMEnsembleDataReaderProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMEnsembleDataReaderProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMEnsembleDataReaderProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMEnsembleDataReaderProxy *tempr = vtkSMEnsembleDataReaderProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMEnsembleDataReaderProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMEnsembleDataReaderProxy *op = static_cast<vtkSMEnsembleDataReaderProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMEnsembleDataReaderProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMEnsembleDataReaderProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMEnsembleDataReaderProxy_UpdateVTKObjects(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateVTKObjects");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMEnsembleDataReaderProxy *op = static_cast<vtkSMEnsembleDataReaderProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateVTKObjects();
    }
    else
    {
      op->vtkSMEnsembleDataReaderProxy::UpdateVTKObjects();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMEnsembleDataReaderProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMEnsembleDataReaderProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMEnsembleDataReaderProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMEnsembleDataReaderProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMEnsembleDataReaderProxy\nC++: static vtkSMEnsembleDataReaderProxy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMEnsembleDataReaderProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMEnsembleDataReaderProxy\nC++: vtkSMEnsembleDataReaderProxy *NewInstance()\n\n"},
  {"UpdateVTKObjects", PyvtkSMEnsembleDataReaderProxy_UpdateVTKObjects, METH_VARARGS,
   "V.UpdateVTKObjects()\nC++: virtual void UpdateVTKObjects()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMEnsembleDataReaderProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkSMEnsembleDataReaderProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMEnsembleDataReaderProxy_StaticNew()
{
  return vtkSMEnsembleDataReaderProxy::New();
}

PyObject *PyvtkSMEnsembleDataReaderProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMEnsembleDataReaderProxy_Type, PyvtkSMEnsembleDataReaderProxy_Methods,
    "vtkSMEnsembleDataReaderProxy",
    PyvtkSMEnsembleDataReaderProxy_Doc(), &PyvtkSMEnsembleDataReaderProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMEnsembleDataReaderProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMSourceProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMEnsembleDataReaderProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMEnsembleDataReaderProxy - Examines file paths found in ensemble\ndata files (.pve) and creates readers that can read those files.\n\n",
    "Superclass: vtkSMSourceProxy\n\n",
    "Sets the correct reader for each file on the corresponding VTK\nobject.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMEnsembleDataReaderProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMEnsembleDataReaderProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMEnsembleDataReaderProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

