// python wrapper for vtkSMFieldDataDomain
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMFieldDataDomain.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMFieldDataDomain(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMFieldDataDomain_ClassNew(); }

#ifndef DECLARED_PyvtkSMEnumerationDomain_ClassNew
extern "C" { PyObject *PyvtkSMEnumerationDomain_ClassNew(); }
#define DECLARED_PyvtkSMEnumerationDomain_ClassNew
#endif

static const char **PyvtkSMFieldDataDomain_Doc();


static PyObject *
PyvtkSMFieldDataDomain_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMFieldDataDomain::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMFieldDataDomain_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMFieldDataDomain *op = static_cast<vtkSMFieldDataDomain *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMFieldDataDomain::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMFieldDataDomain_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMFieldDataDomain *tempr = vtkSMFieldDataDomain::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMFieldDataDomain_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMFieldDataDomain *op = static_cast<vtkSMFieldDataDomain *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMFieldDataDomain *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMFieldDataDomain::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMFieldDataDomain_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMFieldDataDomain *op = static_cast<vtkSMFieldDataDomain *>(vp);

  vtkSMProperty *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProperty"))
  {
    if (ap.IsBound())
    {
      op->Update(temp0);
    }
    else
    {
      op->vtkSMFieldDataDomain::Update(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMFieldDataDomain_SetDefaultValues(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDefaultValues");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMFieldDataDomain *op = static_cast<vtkSMFieldDataDomain *>(vp);

  vtkSMProperty *temp0 = NULL;
  bool temp1 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkSMProperty") &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->SetDefaultValues(temp0, temp1) :
      op->vtkSMFieldDataDomain::SetDefaultValues(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMFieldDataDomain_Methods[] = {
  {"IsTypeOf", PyvtkSMFieldDataDomain_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMFieldDataDomain_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMFieldDataDomain_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMFieldDataDomain\nC++: static vtkSMFieldDataDomain *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMFieldDataDomain_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMFieldDataDomain\nC++: vtkSMFieldDataDomain *NewInstance()\n\n"},
  {"Update", PyvtkSMFieldDataDomain_Update, METH_VARARGS,
   "V.Update(vtkSMProperty)\nC++: virtual void Update(vtkSMProperty *prop)\n\nCheck the input and appropriate fields (point data or cell data)\nto the enumeration. This uses the Input property with a\nvtkSMInputArrayDomain.\n"},
  {"SetDefaultValues", PyvtkSMFieldDataDomain_SetDefaultValues, METH_VARARGS,
   "V.SetDefaultValues(vtkSMProperty, bool) -> int\nC++: virtual int SetDefaultValues(vtkSMProperty *,\n    bool use_unchecked_values)\n\nOverridden to ensure that the property's default value is valid\nfor the enumeration, if not it will be set to the first\nenumeration value.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMFieldDataDomain_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMFieldDataDomain", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMFieldDataDomain_StaticNew()
{
  return vtkSMFieldDataDomain::New();
}

PyObject *PyvtkSMFieldDataDomain_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMFieldDataDomain_Type, PyvtkSMFieldDataDomain_Methods,
    "vtkSMFieldDataDomain",
    PyvtkSMFieldDataDomain_Doc(), &PyvtkSMFieldDataDomain_StaticNew);

  PyTypeObject *pytype = &PyvtkSMFieldDataDomain_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMEnumerationDomain_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMFieldDataDomain_Doc()
{
  static const char *docstring[] = {
    "vtkSMFieldDataDomain - enumeration with point and cell data entries\n\n",
    "Superclass: vtkSMEnumerationDomain\n\n",
    "vtkSMFieldDataDomain is a sub-class vtkSMEnumerationDomain that looks\nat the input in Update() and populates the entry list based on\nwhether there are valid arrays in point/cell/vertex/edge/row data. At\nmost it consists of two entries: (\"Point Data\",\nvtkDataObject::FIELD_ASSOCIATION_POINTS) and (\"Cell Data\", \nvtkDataObject::FIELD_ASSOCIATION_CELLS) in case of vtkDataSet\nsubclasses OR (\"Vertex Data",
    "\",\nvtkDataObject::FIELD_ASSOCIATION_VERTICES) and (\"Edge Data\",\nvtkDataObject::FIELD_ASSOCIATION_EDGES) in case of vtkGraph and\nsubclasses OR (\"Row Data\", vtkDataObject::FIELD_ASSOCIATION_ROWS) in\ncase of vtkTable and subclasses. It requires Input\n(vtkSMProxyProperty) property. If attribute\n\"disable_update_domain_entries\" is set to true (false by default),\nthen the domain values will not changed b",
    "ased on input field\navailability. Only the default value setting will be affected by\nthat.\n@sa\nvtkSMEnumerationDomain vtkSMProxyProperty\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMFieldDataDomain(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMFieldDataDomain_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMFieldDataDomain", o) != 0)
  {
    Py_DECREF(o);
  }

}

