// python wrapper for vtkSMInteractiveSelectionPipeline
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMInteractiveSelectionPipeline.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMInteractiveSelectionPipeline(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMInteractiveSelectionPipeline_ClassNew(); }

#ifndef DECLARED_PyvtkSMPreselectionPipeline_ClassNew
extern "C" { PyObject *PyvtkSMPreselectionPipeline_ClassNew(); }
#define DECLARED_PyvtkSMPreselectionPipeline_ClassNew
#endif

static const char **PyvtkSMInteractiveSelectionPipeline_Doc();


static PyObject *
PyvtkSMInteractiveSelectionPipeline_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMInteractiveSelectionPipeline::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMInteractiveSelectionPipeline_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMInteractiveSelectionPipeline *op = static_cast<vtkSMInteractiveSelectionPipeline *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMInteractiveSelectionPipeline::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMInteractiveSelectionPipeline_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMInteractiveSelectionPipeline *tempr = vtkSMInteractiveSelectionPipeline::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMInteractiveSelectionPipeline_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMInteractiveSelectionPipeline *op = static_cast<vtkSMInteractiveSelectionPipeline *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMInteractiveSelectionPipeline *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMInteractiveSelectionPipeline::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMInteractiveSelectionPipeline_GetInstance(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "GetInstance");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkSMInteractiveSelectionPipeline *tempr = vtkSMInteractiveSelectionPipeline::GetInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMInteractiveSelectionPipeline_Methods[] = {
  {"IsTypeOf", PyvtkSMInteractiveSelectionPipeline_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMInteractiveSelectionPipeline_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMInteractiveSelectionPipeline_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMInteractiveSelectionPipeline\nC++: static vtkSMInteractiveSelectionPipeline *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMInteractiveSelectionPipeline_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMInteractiveSelectionPipeline\nC++: vtkSMInteractiveSelectionPipeline *NewInstance()\n\n"},
  {"GetInstance", PyvtkSMInteractiveSelectionPipeline_GetInstance, METH_VARARGS,
   "V.GetInstance() -> vtkSMInteractiveSelectionPipeline\nC++: static vtkSMInteractiveSelectionPipeline *GetInstance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMInteractiveSelectionPipeline_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkSMInteractiveSelectionPipeline", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMInteractiveSelectionPipeline_StaticNew()
{
  return vtkSMInteractiveSelectionPipeline::New();
}

PyObject *PyvtkSMInteractiveSelectionPipeline_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMInteractiveSelectionPipeline_Type, PyvtkSMInteractiveSelectionPipeline_Methods,
    "vtkSMInteractiveSelectionPipeline",
    PyvtkSMInteractiveSelectionPipeline_Doc(), &PyvtkSMInteractiveSelectionPipeline_StaticNew);

  PyTypeObject *pytype = &PyvtkSMInteractiveSelectionPipeline_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMPreselectionPipeline_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMInteractiveSelectionPipeline_Doc()
{
  static const char *docstring[] = {
    "vtkSMInteractiveSelectionPipeline - Interactive selection enables the\nuser to inspect cells/points before he decides to select them.\n\n",
    "Superclass: vtkSMPreselectionPipeline\n\n",
    "The user moves the mouse cursor over a cell, can inspect attributes\nof the cell and can select the cell by clicking on it. This is a\nglobal object that holds the pipeline for showing the interactive\nselection.\n\n@sa\nvtkSMPreselectionPipeline vtkSMTooltipSelectionPipeline\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMInteractiveSelectionPipeline(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMInteractiveSelectionPipeline_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMInteractiveSelectionPipeline", o) != 0)
  {
    Py_DECREF(o);
  }

}

