// python wrapper for vtkSMOutputPort
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMOutputPort.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMOutputPort(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMOutputPort_ClassNew(); }

#ifndef DECLARED_PyvtkSMProxy_ClassNew
extern "C" { PyObject *PyvtkSMProxy_ClassNew(); }
#define DECLARED_PyvtkSMProxy_ClassNew
#endif

static const char **PyvtkSMOutputPort_Doc();


static PyObject *
PyvtkSMOutputPort_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMOutputPort::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMOutputPort::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMOutputPort *tempr = vtkSMOutputPort::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMOutputPort *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMOutputPort::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDataInformation *tempr = (ap.IsBound() ?
      op->GetDataInformation() :
      op->vtkSMOutputPort::GetDataInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetTemporalDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTemporalDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVTemporalDataInformation *tempr = (ap.IsBound() ?
      op->GetTemporalDataInformation() :
      op->vtkSMOutputPort::GetTemporalDataInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetDataClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDataClassName() :
      op->vtkSMOutputPort::GetDataClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetClassNameInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassNameInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVClassNameInformation *tempr = (ap.IsBound() ?
      op->GetClassNameInformation() :
      op->vtkSMOutputPort::GetClassNameInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_InvalidateDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InvalidateDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InvalidateDataInformation();
    }
    else
    {
      op->vtkSMOutputPort::InvalidateDataInformation();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetPortIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPortIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPortIndex() :
      op->vtkSMOutputPort::GetPortIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMOutputPort_GetSourceProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSourceProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMOutputPort *op = static_cast<vtkSMOutputPort *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMSourceProxy *tempr = (ap.IsBound() ?
      op->GetSourceProxy() :
      op->vtkSMOutputPort::GetSourceProxy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMOutputPort_Methods[] = {
  {"IsTypeOf", PyvtkSMOutputPort_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMOutputPort_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMOutputPort_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMOutputPort\nC++: static vtkSMOutputPort *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMOutputPort_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMOutputPort\nC++: vtkSMOutputPort *NewInstance()\n\n"},
  {"GetDataInformation", PyvtkSMOutputPort_GetDataInformation, METH_VARARGS,
   "V.GetDataInformation() -> vtkPVDataInformation\nC++: virtual vtkPVDataInformation *GetDataInformation()\n\nReturns data information. If data information is marked invalid,\ncalls GatherDataInformation. If data information is gathered then\nthis fires the vtkCommand::UpdateInformationEvent event.\n"},
  {"GetTemporalDataInformation", PyvtkSMOutputPort_GetTemporalDataInformation, METH_VARARGS,
   "V.GetTemporalDataInformation() -> vtkPVTemporalDataInformation\nC++: virtual vtkPVTemporalDataInformation *GetTemporalDataInformation(\n    )\n\nReturns data information collected over all timesteps provided by\nthe pipeline. If the data information is not valid, this results\niterating over the pipeline and hence can be slow. Use with\ncaution.\n"},
  {"GetDataClassName", PyvtkSMOutputPort_GetDataClassName, METH_VARARGS,
   "V.GetDataClassName() -> string\nC++: virtual const char *GetDataClassName()\n\nReturns the classname of the data object on this output port.\n"},
  {"GetClassNameInformation", PyvtkSMOutputPort_GetClassNameInformation, METH_VARARGS,
   "V.GetClassNameInformation() -> vtkPVClassNameInformation\nC++: virtual vtkPVClassNameInformation *GetClassNameInformation()\n\nReturns classname information.\n"},
  {"InvalidateDataInformation", PyvtkSMOutputPort_InvalidateDataInformation, METH_VARARGS,
   "V.InvalidateDataInformation()\nC++: virtual void InvalidateDataInformation()\n\nMark data information as invalid.\n"},
  {"GetPortIndex", PyvtkSMOutputPort_GetPortIndex, METH_VARARGS,
   "V.GetPortIndex() -> int\nC++: virtual int GetPortIndex()\n\nReturns the index of the port the output is obtained from.\n"},
  {"GetSourceProxy", PyvtkSMOutputPort_GetSourceProxy, METH_VARARGS,
   "V.GetSourceProxy() -> vtkSMSourceProxy\nC++: vtkSMSourceProxy *GetSourceProxy()\n\nProvides access to the source proxy to which the output port\nbelongs.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMOutputPort_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMOutputPort", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMOutputPort_StaticNew()
{
  return vtkSMOutputPort::New();
}

PyObject *PyvtkSMOutputPort_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMOutputPort_Type, PyvtkSMOutputPort_Methods,
    "vtkSMOutputPort",
    PyvtkSMOutputPort_Doc(), &PyvtkSMOutputPort_StaticNew);

  PyTypeObject *pytype = &PyvtkSMOutputPort_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMOutputPort_Doc()
{
  static const char *docstring[] = {
    "vtkSMOutputPort - reference for an output port of a vtkAlgorithm.\n\n",
    "Superclass: vtkSMProxy\n\n",
    "This object manages one output port of an algorithm. It is used\ninternally by vtkSMSourceProxy to manage all of it's\noutputs.@attention Previously, vtkSMOutputPort used to be a\nvtkSMProxy subclass since it was indeed a Proxy for the output port.\nHowever that has now changed. This merely sits as a datastructure to\nmanage ports specific things like data-information. However for\nbackwards compatibili",
    "ty, to keep the impact minimal, we leave this as\na sub-class of a Proxy with GlobalID=0 and Session=NULL.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMOutputPort(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMOutputPort_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMOutputPort", o) != 0)
  {
    Py_DECREF(o);
  }

}

