// python wrapper for vtkSMSaveAnimationProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMSaveAnimationProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMSaveAnimationProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMSaveAnimationProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMSaveScreenshotProxy_ClassNew
extern "C" { PyObject *PyvtkSMSaveScreenshotProxy_ClassNew(); }
#define DECLARED_PyvtkSMSaveScreenshotProxy_ClassNew
#endif

static const char **PyvtkSMSaveAnimationProxy_Doc();


static PyObject *
PyvtkSMSaveAnimationProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMSaveAnimationProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSaveAnimationProxy *op = static_cast<vtkSMSaveAnimationProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMSaveAnimationProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMSaveAnimationProxy *tempr = vtkSMSaveAnimationProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSaveAnimationProxy *op = static_cast<vtkSMSaveAnimationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMSaveAnimationProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMSaveAnimationProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_WriteAnimation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "WriteAnimation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSaveAnimationProxy *op = static_cast<vtkSMSaveAnimationProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->WriteAnimation(temp0) :
      op->vtkSMSaveAnimationProxy::WriteAnimation(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_SupportsDisconnectAndSave(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SupportsDisconnectAndSave");

  vtkSMSession *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMSession"))
  {
    bool tempr = vtkSMSaveAnimationProxy::SupportsDisconnectAndSave(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_SupportsAVI(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SupportsAVI");

  vtkSMSession *temp0 = NULL;
  bool temp1 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkSMSession") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    bool tempr = vtkSMSaveAnimationProxy::SupportsAVI(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSaveAnimationProxy_SupportsOGV(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SupportsOGV");

  vtkSMSession *temp0 = NULL;
  bool temp1 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkSMSession") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    bool tempr = vtkSMSaveAnimationProxy::SupportsOGV(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMSaveAnimationProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMSaveAnimationProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMSaveAnimationProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMSaveAnimationProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMSaveAnimationProxy\nC++: static vtkSMSaveAnimationProxy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMSaveAnimationProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMSaveAnimationProxy\nC++: vtkSMSaveAnimationProxy *NewInstance()\n\n"},
  {"WriteAnimation", PyvtkSMSaveAnimationProxy_WriteAnimation, METH_VARARGS,
   "V.WriteAnimation(string) -> bool\nC++: virtual bool WriteAnimation(const char *filename)\n\nSave animation as images/video. The properties on this proxy\nprovide all the necessary information to save the animation.\n"},
  {"SupportsDisconnectAndSave", PyvtkSMSaveAnimationProxy_SupportsDisconnectAndSave, METH_VARARGS,
   "V.SupportsDisconnectAndSave(vtkSMSession) -> bool\nC++: static bool SupportsDisconnectAndSave(vtkSMSession *session)\n\nReturns true if the session can support disconnecting and saving\nanimations.\n"},
  {"SupportsAVI", PyvtkSMSaveAnimationProxy_SupportsAVI, METH_VARARGS,
   "V.SupportsAVI(vtkSMSession, bool) -> bool\nC++: static bool SupportsAVI(vtkSMSession *session,\n    bool remote=false)\n\nReturns true if the session supports AVI file writing.\n"},
  {"SupportsOGV", PyvtkSMSaveAnimationProxy_SupportsOGV, METH_VARARGS,
   "V.SupportsOGV(vtkSMSession, bool) -> bool\nC++: static bool SupportsOGV(vtkSMSession *session,\n    bool remote=false)\n\nReturns true if the session supports OGV file writing.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMSaveAnimationProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVAnimationPython.vtkSMSaveAnimationProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMSaveAnimationProxy_StaticNew()
{
  return vtkSMSaveAnimationProxy::New();
}

PyObject *PyvtkSMSaveAnimationProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMSaveAnimationProxy_Type, PyvtkSMSaveAnimationProxy_Methods,
    "vtkSMSaveAnimationProxy",
    PyvtkSMSaveAnimationProxy_Doc(), &PyvtkSMSaveAnimationProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMSaveAnimationProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMSaveScreenshotProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMSaveAnimationProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMSaveAnimationProxy - proxy to save animation to images/video.\n\n",
    "Superclass: vtkSMSaveScreenshotProxy\n\n",
    "vtkSMSaveAnimationProxy is a proxy that helps with saving animation\nto images or video. The properties on this proxy provide various\noptions that user can configure when saving animations. Once those\nproperties are setup, one calls\nvtkSMSaveAnimationProxy::WriteAnimation` to save out the animation.\n\nvtkSMSaveAnimationProxy provides static methods such as\n`SupportsDisconnectAndSave`, `SupportsAVI`,",
    " and `SupportsOGV` that\napplications can use to determine support for specific functionality\nin the current session/application.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMSaveAnimationProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMSaveAnimationProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMSaveAnimationProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

