// python wrapper for vtkSMStateVersionController
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMStateVersionController.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMStateVersionController(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMStateVersionController_ClassNew(); }

#ifndef DECLARED_PyvtkSMObject_ClassNew
extern "C" { PyObject *PyvtkSMObject_ClassNew(); }
#define DECLARED_PyvtkSMObject_ClassNew
#endif

static const char **PyvtkSMStateVersionController_Doc();


static PyObject *
PyvtkSMStateVersionController_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMStateVersionController::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMStateVersionController_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMStateVersionController *op = static_cast<vtkSMStateVersionController *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMStateVersionController::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMStateVersionController_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMStateVersionController *tempr = vtkSMStateVersionController::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMStateVersionController_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMStateVersionController *op = static_cast<vtkSMStateVersionController *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMStateVersionController *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMStateVersionController::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMStateVersionController_Process(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Process");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMStateVersionController *op = static_cast<vtkSMStateVersionController *>(vp);

  vtkPVXMLElement *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVXMLElement"))
  {
    bool tempr = (ap.IsBound() ?
      op->Process(temp0) :
      op->vtkSMStateVersionController::Process(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMStateVersionController_Methods[] = {
  {"IsTypeOf", PyvtkSMStateVersionController_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMStateVersionController_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMStateVersionController_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMStateVersionController\nC++: static vtkSMStateVersionController *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMStateVersionController_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMStateVersionController\nC++: vtkSMStateVersionController *NewInstance()\n\n"},
  {"Process", PyvtkSMStateVersionController_Process, METH_VARARGS,
   "V.Process(vtkPVXMLElement) -> bool\nC++: virtual bool Process(vtkPVXMLElement *root)\n\nCalled before a state is loaded. The argument must be the root\nelement for the state being loaded. eg. for server manager state,\nit will point to \\<ServerManagerState/> element. Returns false if\nthe conversion failed, else true.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMStateVersionController_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMStateVersionController", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMStateVersionController_StaticNew()
{
  return vtkSMStateVersionController::New();
}

PyObject *PyvtkSMStateVersionController_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMStateVersionController_Type, PyvtkSMStateVersionController_Methods,
    "vtkSMStateVersionController",
    PyvtkSMStateVersionController_Doc(), &PyvtkSMStateVersionController_StaticNew);

  PyTypeObject *pytype = &PyvtkSMStateVersionController_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMStateVersionController_Doc()
{
  static const char *docstring[] = {
    "vtkSMStateVersionController - vtkSMStateVersionController is used to\nconvert the state XML from any previously supported versions to the\ncurrent version.\n\n",
    "Superclass: vtkSMObject\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMStateVersionController(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMStateVersionController_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMStateVersionController", o) != 0)
  {
    Py_DECREF(o);
  }

}

