// python wrapper for vtkSMUncheckedPropertyHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkSMUncheckedPropertyHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMUncheckedPropertyHelper(PyObject *); }

static const char **PyvtkSMUncheckedPropertyHelper_Doc();

static PyMethodDef PyvtkSMUncheckedPropertyHelper_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkSMUncheckedPropertyHelper");

  vtkSMProxy *temp0 = NULL;
  char *temp1 = NULL;
  bool temp2 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkSMProxy") &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    vtkSMUncheckedPropertyHelper *op = new vtkSMUncheckedPropertyHelper(temp0, temp1, temp2);

    result = PyVTKSpecialObject_New("vtkSMUncheckedPropertyHelper", op);
  }

  return result;
}

static PyObject *
PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkSMUncheckedPropertyHelper");

  vtkSMProperty *temp0 = NULL;
  bool temp1 = false;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkSMProperty") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    vtkSMUncheckedPropertyHelper *op = new vtkSMUncheckedPropertyHelper(temp0, temp1);

    result = PyVTKSpecialObject_New("vtkSMUncheckedPropertyHelper", op);
  }

  return result;
}

static PyMethodDef PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_Methods[] = {
  {NULL, PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s1, METH_VARARGS,
   "@Vz|q *vtkSMProxy"},
  {NULL, PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s2, METH_VARARGS,
   "@V|q *vtkSMProperty"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 3:
      return PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s1(self, args);
    case 1:
      return PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_s2(self, args);
    case 2:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkSMUncheckedPropertyHelper");
  return NULL;
}


static PyObject *
PyvtkSMUncheckedPropertyHelper_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper(NULL, args);
}

static void PyvtkSMUncheckedPropertyHelper_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkSMUncheckedPropertyHelper *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkSMUncheckedPropertyHelper_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkSMUncheckedPropertyHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMUncheckedPropertyHelper", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkSMUncheckedPropertyHelper_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkSMUncheckedPropertyHelper_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkSMUncheckedPropertyHelper_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMUncheckedPropertyHelper_TypeNew(); }

#ifndef DECLARED_PyvtkSMPropertyHelper_TypeNew
extern "C" { PyObject *PyvtkSMPropertyHelper_TypeNew(); }
#define DECLARED_PyvtkSMPropertyHelper_TypeNew
#endif
PyObject *PyvtkSMUncheckedPropertyHelper_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkSMUncheckedPropertyHelper_Type,
    PyvtkSMUncheckedPropertyHelper_Methods,
    PyvtkSMUncheckedPropertyHelper_vtkSMUncheckedPropertyHelper_Methods,
    PyvtkSMUncheckedPropertyHelper_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkSMUncheckedPropertyHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  pytype->tp_base = (PyTypeObject *)PyvtkSMPropertyHelper_TypeNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMUncheckedPropertyHelper_Doc()
{
  static const char *docstring[] = {
    "vtkSMUncheckedPropertyHelper - no description provided.\n\n",
    "Superclass: vtkSMPropertyHelper\n\n",
    "V.vtkSMUncheckedPropertyHelper(vtkSMProxy, string, bool)\nC++: vtkSMUncheckedPropertyHelper(vtkSMProxy *proxy, const char *name,\n     bool quiet=false)\nV.vtkSMUncheckedPropertyHelper(vtkSMProperty, bool)\nC++: vtkSMUncheckedPropertyHelper(vtkSMProperty *property,\n    bool quiet=false)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMUncheckedPropertyHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMUncheckedPropertyHelper_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkSMUncheckedPropertyHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

