// python wrapper for vtkSMWriterFactory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMWriterFactory.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMWriterFactory(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMWriterFactory_ClassNew(); }

#ifndef DECLARED_PyvtkSMObject_ClassNew
extern "C" { PyObject *PyvtkSMObject_ClassNew(); }
#define DECLARED_PyvtkSMObject_ClassNew
#endif

static const char **PyvtkSMWriterFactory_Doc();


static PyObject *
PyvtkSMWriterFactory_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMWriterFactory::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMWriterFactory::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMWriterFactory *tempr = vtkSMWriterFactory::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMWriterFactory *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMWriterFactory::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkSMWriterFactory::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_RegisterPrototype(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterPrototype");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->RegisterPrototype(temp0, temp1);
    }
    else
    {
      op->vtkSMWriterFactory::RegisterPrototype(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_CanWrite(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanWrite");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  vtkSMSourceProxy *temp0 = NULL;
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->CanWrite(temp0, temp1) :
      op->vtkSMWriterFactory::CanWrite(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_CreateWriter_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateWriter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  unsigned int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy") &&
      ap.GetValue(temp2))
  {
    vtkSMProxy *tempr = (ap.IsBound() ?
      op->CreateWriter(temp0, temp1, temp2) :
      op->vtkSMWriterFactory::CreateWriter(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterFactory_CreateWriter_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateWriter");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  vtkSMSourceProxy *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkSMSourceProxy"))
  {
    vtkSMProxy *tempr = (ap.IsBound() ?
      op->CreateWriter(temp0, temp1) :
      op->vtkSMWriterFactory::CreateWriter(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterFactory_CreateWriter(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkSMWriterFactory_CreateWriter_s1(self, args);
    case 2:
      return PyvtkSMWriterFactory_CreateWriter_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "CreateWriter");
  return NULL;
}



static PyObject *
PyvtkSMWriterFactory_GetSupportedFileTypes_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSupportedFileTypes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  vtkSMSourceProxy *temp0 = NULL;
  unsigned int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetSupportedFileTypes(temp0, temp1) :
      op->vtkSMWriterFactory::GetSupportedFileTypes(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterFactory_GetSupportedFileTypes_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSupportedFileTypes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  vtkSMSourceProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy"))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetSupportedFileTypes(temp0) :
      op->vtkSMWriterFactory::GetSupportedFileTypes(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMWriterFactory_GetSupportedFileTypes(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkSMWriterFactory_GetSupportedFileTypes_s1(self, args);
    case 1:
      return PyvtkSMWriterFactory_GetSupportedFileTypes_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "GetSupportedFileTypes");
  return NULL;
}



static PyObject *
PyvtkSMWriterFactory_GetNumberOfRegisteredPrototypes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfRegisteredPrototypes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNumberOfRegisteredPrototypes() :
      op->vtkSMWriterFactory::GetNumberOfRegisteredPrototypes());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_UpdateAvailableWriters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateAvailableWriters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateAvailableWriters();
    }
    else
    {
      op->vtkSMWriterFactory::UpdateAvailableWriters();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_AddGroup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddGroup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->AddGroup(temp0);
    }
    else
    {
      op->vtkSMWriterFactory::AddGroup(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_RemoveGroup(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveGroup");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveGroup(temp0);
    }
    else
    {
      op->vtkSMWriterFactory::RemoveGroup(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_GetGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMWriterFactory *op = static_cast<vtkSMWriterFactory *>(vp);

  vtkStringList *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkStringList"))
  {
    if (ap.IsBound())
    {
      op->GetGroups(temp0);
    }
    else
    {
      op->vtkSMWriterFactory::GetGroups(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMWriterFactory_AddWriterToWhitelist(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "AddWriterToWhitelist");

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkSMWriterFactory::AddWriterToWhitelist(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMWriterFactory_Methods[] = {
  {"IsTypeOf", PyvtkSMWriterFactory_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMWriterFactory_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMWriterFactory_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMWriterFactory\nC++: static vtkSMWriterFactory *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMWriterFactory_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMWriterFactory\nC++: vtkSMWriterFactory *NewInstance()\n\n"},
  {"Initialize", PyvtkSMWriterFactory_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: void Initialize()\n\nCleanup all registered prototypes.\n"},
  {"RegisterPrototype", PyvtkSMWriterFactory_RegisterPrototype, METH_VARARGS,
   "V.RegisterPrototype(string, string)\nC++: void RegisterPrototype(const char *xmlgroup,\n    const char *xmlname)\n\nRegister a prototype.\n"},
  {"CanWrite", PyvtkSMWriterFactory_CanWrite, METH_VARARGS,
   "V.CanWrite(vtkSMSourceProxy, int) -> bool\nC++: bool CanWrite(vtkSMSourceProxy *, unsigned int outputport)\n\nRetruns true if the data from the output port can be written at\nall.\n"},
  {"CreateWriter", PyvtkSMWriterFactory_CreateWriter, METH_VARARGS,
   "V.CreateWriter(string, vtkSMSourceProxy, int) -> vtkSMProxy\nC++: vtkSMProxy *CreateWriter(const char *filename,\n    vtkSMSourceProxy *, unsigned int outputport)\nV.CreateWriter(string, vtkSMSourceProxy) -> vtkSMProxy\nC++: vtkSMProxy *CreateWriter(const char *filename,\n    vtkSMSourceProxy *pxy)\n\nCreate a new writer proxy to write the data from the specified\noutput port to the file specified, if possible. As internally\nUpdatePipeline() will be called on the source proxy, in order to\nprevent a double pipeline execution when you want to write a\ngiven timestep, you should call updatePipeline( time ) before the\nCreateWriter call.\n"},
  {"GetSupportedFileTypes", PyvtkSMWriterFactory_GetSupportedFileTypes, METH_VARARGS,
   "V.GetSupportedFileTypes(vtkSMSourceProxy, int) -> string\nC++: const char *GetSupportedFileTypes(vtkSMSourceProxy *source,\n    unsigned int outputport)\nV.GetSupportedFileTypes(vtkSMSourceProxy) -> string\nC++: const char *GetSupportedFileTypes(vtkSMSourceProxy *source)\n\nReturns a formatted string with all supported file types. An\nexample returned string would look like:\n \"PVD Files (*.pvd);;VTK Files (*.vtk)\"\n \n"},
  {"GetNumberOfRegisteredPrototypes", PyvtkSMWriterFactory_GetNumberOfRegisteredPrototypes, METH_VARARGS,
   "V.GetNumberOfRegisteredPrototypes() -> int\nC++: unsigned int GetNumberOfRegisteredPrototypes()\n\n"},
  {"UpdateAvailableWriters", PyvtkSMWriterFactory_UpdateAvailableWriters, METH_VARARGS,
   "V.UpdateAvailableWriters()\nC++: void UpdateAvailableWriters()\n\nEvery time a new proxy definition is added we check to see if it\nis a writer and then we add it to the list of available writers.\n"},
  {"AddGroup", PyvtkSMWriterFactory_AddGroup, METH_VARARGS,
   "V.AddGroup(string)\nC++: void AddGroup(const char *groupName)\n\nAdd/remove a group name to look for writers in. By default\n\"writers\" is included.\n"},
  {"RemoveGroup", PyvtkSMWriterFactory_RemoveGroup, METH_VARARGS,
   "V.RemoveGroup(string)\nC++: void RemoveGroup(const char *groupName)\n\nAdd/remove a group name to look for writers in. By default\n\"writers\" is included.\n"},
  {"GetGroups", PyvtkSMWriterFactory_GetGroups, METH_VARARGS,
   "V.GetGroups(vtkStringList)\nC++: void GetGroups(vtkStringList *groups)\n\nAdd/remove a group name to look for writers in. By default\n\"writers\" is included.\n"},
  {"AddWriterToWhitelist", PyvtkSMWriterFactory_AddWriterToWhitelist, METH_VARARGS,
   "V.AddWriterToWhitelist(string, string)\nC++: static void AddWriterToWhitelist(const char *writerxmlgroup,\n    const char *writerxmlname)\n\nThis function is for ParaView based applications that only wish\nto expose a subset of the writers.  If this function is never\ncalled, the reader factory will expose all the writers as it has\nin the past.  However, if any writers are specified by passing\ntheir group name and reader name to this function, then only\nthose writers will be available in any reader factories created\nby the application.  This is intended to be called at the\nbegining of the application's execution before any sessions are\ncreated.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMWriterFactory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMWriterFactory", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMWriterFactory_StaticNew()
{
  return vtkSMWriterFactory::New();
}

PyObject *PyvtkSMWriterFactory_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMWriterFactory_Type, PyvtkSMWriterFactory_Methods,
    "vtkSMWriterFactory",
    PyvtkSMWriterFactory_Doc(), &PyvtkSMWriterFactory_StaticNew);

  PyTypeObject *pytype = &PyvtkSMWriterFactory_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMWriterFactory_Doc()
{
  static const char *docstring[] = {
    "vtkSMWriterFactory - is a factory or creating a writer based on the\ndata type information from the output port.\n\n",
    "Superclass: vtkSMObject\n\n",
    "vtkSMWriterFactory is a factory for creating a writer to write the\ndata provided at an output port. This is done whenever a new proxy\ndefinition is added in the writers group.\n\nAlternatively, one can register prototypes using RegisterPrototype\nAPI. The proxy definitions for the writer proxies must provide hints\nthat indicate the file extension and description for the writer.\n\nOnce the factory has ",
    "been configured, the API to create writers, get\navailable writers etc. can be used.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMWriterFactory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMWriterFactory_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMWriterFactory", o) != 0)
  {
    Py_DECREF(o);
  }

}

