// python wrapper for vtkSubdivisionFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSubdivisionFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSubdivisionFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSubdivisionFilter_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkSubdivisionFilter_Doc();


static PyObject *
PyvtkSubdivisionFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSubdivisionFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSubdivisionFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSubdivisionFilter *tempr = vtkSubdivisionFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSubdivisionFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSubdivisionFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_SetNumberOfSubdivisions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfSubdivisions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfSubdivisions(temp0);
    }
    else
    {
      op->vtkSubdivisionFilter::SetNumberOfSubdivisions(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_GetNumberOfSubdivisions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSubdivisions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSubdivisions() :
      op->vtkSubdivisionFilter::GetNumberOfSubdivisions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_SetCheckForTriangles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCheckForTriangles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCheckForTriangles(temp0);
    }
    else
    {
      op->vtkSubdivisionFilter::SetCheckForTriangles(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_GetCheckForTrianglesMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCheckForTrianglesMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCheckForTrianglesMinValue() :
      op->vtkSubdivisionFilter::GetCheckForTrianglesMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_GetCheckForTrianglesMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCheckForTrianglesMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCheckForTrianglesMaxValue() :
      op->vtkSubdivisionFilter::GetCheckForTrianglesMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_GetCheckForTriangles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCheckForTriangles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCheckForTriangles() :
      op->vtkSubdivisionFilter::GetCheckForTriangles());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_CheckForTrianglesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CheckForTrianglesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CheckForTrianglesOn();
    }
    else
    {
      op->vtkSubdivisionFilter::CheckForTrianglesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSubdivisionFilter_CheckForTrianglesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CheckForTrianglesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSubdivisionFilter *op = static_cast<vtkSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CheckForTrianglesOff();
    }
    else
    {
      op->vtkSubdivisionFilter::CheckForTrianglesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSubdivisionFilter_Methods[] = {
  {"IsTypeOf", PyvtkSubdivisionFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSubdivisionFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSubdivisionFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSubdivisionFilter\nC++: static vtkSubdivisionFilter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSubdivisionFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSubdivisionFilter\nC++: vtkSubdivisionFilter *NewInstance()\n\n"},
  {"SetNumberOfSubdivisions", PyvtkSubdivisionFilter_SetNumberOfSubdivisions, METH_VARARGS,
   "V.SetNumberOfSubdivisions(int)\nC++: virtual void SetNumberOfSubdivisions(int _arg)\n\nSet/get the number of subdivisions. Default is 1.\n"},
  {"GetNumberOfSubdivisions", PyvtkSubdivisionFilter_GetNumberOfSubdivisions, METH_VARARGS,
   "V.GetNumberOfSubdivisions() -> int\nC++: virtual int GetNumberOfSubdivisions()\n\nSet/get the number of subdivisions. Default is 1.\n"},
  {"SetCheckForTriangles", PyvtkSubdivisionFilter_SetCheckForTriangles, METH_VARARGS,
   "V.SetCheckForTriangles(int)\nC++: virtual void SetCheckForTriangles(int _arg)\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {"GetCheckForTrianglesMinValue", PyvtkSubdivisionFilter_GetCheckForTrianglesMinValue, METH_VARARGS,
   "V.GetCheckForTrianglesMinValue() -> int\nC++: virtual int GetCheckForTrianglesMinValue()\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {"GetCheckForTrianglesMaxValue", PyvtkSubdivisionFilter_GetCheckForTrianglesMaxValue, METH_VARARGS,
   "V.GetCheckForTrianglesMaxValue() -> int\nC++: virtual int GetCheckForTrianglesMaxValue()\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {"GetCheckForTriangles", PyvtkSubdivisionFilter_GetCheckForTriangles, METH_VARARGS,
   "V.GetCheckForTriangles() -> int\nC++: virtual int GetCheckForTriangles()\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {"CheckForTrianglesOn", PyvtkSubdivisionFilter_CheckForTrianglesOn, METH_VARARGS,
   "V.CheckForTrianglesOn()\nC++: virtual void CheckForTrianglesOn()\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {"CheckForTrianglesOff", PyvtkSubdivisionFilter_CheckForTrianglesOff, METH_VARARGS,
   "V.CheckForTrianglesOff()\nC++: virtual void CheckForTrianglesOff()\n\nSet/get CheckForTriangles Should subdivision check that the\ndataset only contains triangles? Default is On (1).\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSubdivisionFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersGeneralPython.vtkSubdivisionFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkSubdivisionFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSubdivisionFilter_Type, PyvtkSubdivisionFilter_Methods,
    "vtkSubdivisionFilter",
    PyvtkSubdivisionFilter_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkSubdivisionFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSubdivisionFilter_Doc()
{
  static const char *docstring[] = {
    "vtkSubdivisionFilter - base class for subvision filters\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkSubdivisionFilter is an abstract class that defines the protocol\nfor subdivision surface filters.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSubdivisionFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSubdivisionFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSubdivisionFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

