// python wrapper for vtkVisItMM5Reader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVisItMM5Reader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVisItMM5Reader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVisItMM5Reader_ClassNew(); }

#ifndef DECLARED_PyvtkAvtMTSDFileFormatAlgorithm_ClassNew
extern "C" { PyObject *PyvtkAvtMTSDFileFormatAlgorithm_ClassNew(); }
#define DECLARED_PyvtkAvtMTSDFileFormatAlgorithm_ClassNew
#endif

static const char **PyvtkVisItMM5Reader_Doc();


static PyObject *
PyvtkVisItMM5Reader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkVisItMM5Reader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVisItMM5Reader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVisItMM5Reader *op = static_cast<vtkVisItMM5Reader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVisItMM5Reader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVisItMM5Reader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkVisItMM5Reader *tempr = vtkVisItMM5Reader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVisItMM5Reader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVisItMM5Reader *op = static_cast<vtkVisItMM5Reader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVisItMM5Reader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVisItMM5Reader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVisItMM5Reader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVisItMM5Reader *op = static_cast<vtkVisItMM5Reader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkVisItMM5Reader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVisItMM5Reader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVisItMM5Reader *op = static_cast<vtkVisItMM5Reader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkVisItMM5Reader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVisItMM5Reader_Methods[] = {
  {"IsTypeOf", PyvtkVisItMM5Reader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkVisItMM5Reader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkVisItMM5Reader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkVisItMM5Reader\nC++: static vtkVisItMM5Reader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkVisItMM5Reader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVisItMM5Reader\nC++: vtkVisItMM5Reader *NewInstance()\n\n"},
  {"SetFileName", PyvtkVisItMM5Reader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: virtual void SetFileName(const char *_arg)\n\n"},
  {"GetFileName", PyvtkVisItMM5Reader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: virtual char *GetFileName()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVisItMM5Reader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOVisItBridgePython.vtkVisItMM5Reader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVisItMM5Reader_StaticNew()
{
  return vtkVisItMM5Reader::New();
}

PyObject *PyvtkVisItMM5Reader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVisItMM5Reader_Type, PyvtkVisItMM5Reader_Methods,
    "vtkVisItMM5Reader",
    PyvtkVisItMM5Reader_Doc(), &PyvtkVisItMM5Reader_StaticNew);

  PyTypeObject *pytype = &PyvtkVisItMM5Reader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAvtMTSDFileFormatAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVisItMM5Reader_Doc()
{
  static const char *docstring[] = {
    "vtkVisItMM5Reader - no description provided.\n\n",
    "Superclass: vtkAvtMTSDFileFormatAlgorithm\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVisItMM5Reader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVisItMM5Reader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVisItMM5Reader", o) != 0)
  {
    Py_DECREF(o);
  }

}

