// python wrapper for vtkAMRFlashParticlesReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAMRFlashParticlesReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAMRFlashParticlesReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAMRFlashParticlesReader_ClassNew(); }

#ifndef DECLARED_PyvtkAMRBaseParticlesReader_ClassNew
extern "C" { PyObject *PyvtkAMRBaseParticlesReader_ClassNew(); }
#define DECLARED_PyvtkAMRBaseParticlesReader_ClassNew
#endif

static const char **PyvtkAMRFlashParticlesReader_Doc();


static PyObject *
PyvtkAMRFlashParticlesReader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAMRFlashParticlesReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRFlashParticlesReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRFlashParticlesReader *op = static_cast<vtkAMRFlashParticlesReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAMRFlashParticlesReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRFlashParticlesReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAMRFlashParticlesReader *tempr = vtkAMRFlashParticlesReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRFlashParticlesReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRFlashParticlesReader *op = static_cast<vtkAMRFlashParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAMRFlashParticlesReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAMRFlashParticlesReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAMRFlashParticlesReader_GetTotalNumberOfParticles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTotalNumberOfParticles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRFlashParticlesReader *op = static_cast<vtkAMRFlashParticlesReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTotalNumberOfParticles() :
      op->vtkAMRFlashParticlesReader::GetTotalNumberOfParticles());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkAMRFlashParticlesReader_Methods[] = {
  {"IsTypeOf", PyvtkAMRFlashParticlesReader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkAMRFlashParticlesReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkAMRFlashParticlesReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkAMRFlashParticlesReader\nC++: static vtkAMRFlashParticlesReader *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkAMRFlashParticlesReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAMRFlashParticlesReader\nC++: vtkAMRFlashParticlesReader *NewInstance()\n\n"},
  {"GetTotalNumberOfParticles", PyvtkAMRFlashParticlesReader_GetTotalNumberOfParticles, METH_VARARGS,
   "V.GetTotalNumberOfParticles() -> int\nC++: int GetTotalNumberOfParticles()\n\nSee vtkAMRBaseParticlesReader::GetTotalNumberOfParticles.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAMRFlashParticlesReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOAMRPython.vtkAMRFlashParticlesReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAMRFlashParticlesReader_StaticNew()
{
  return vtkAMRFlashParticlesReader::New();
}

PyObject *PyvtkAMRFlashParticlesReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAMRFlashParticlesReader_Type, PyvtkAMRFlashParticlesReader_Methods,
    "vtkAMRFlashParticlesReader",
    PyvtkAMRFlashParticlesReader_Doc(), &PyvtkAMRFlashParticlesReader_StaticNew);

  PyTypeObject *pytype = &PyvtkAMRFlashParticlesReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkAMRBaseParticlesReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAMRFlashParticlesReader_Doc()
{
  static const char *docstring[] = {
    "vtkAMRFlashParticlesReader -  A concrete instance of\nvtkAMRBaseParticlesReader that implements\n functionality for reading flash particle datasets.\n\n",
    "Superclass: vtkAMRBaseParticlesReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAMRFlashParticlesReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAMRFlashParticlesReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAMRFlashParticlesReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

