// python wrapper for vtkAMRStreamingPriorityQueue
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkAMRStreamingPriorityQueue.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkAMRStreamingPriorityQueue(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkAMRStreamingPriorityQueue_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkAMRStreamingPriorityQueue_Doc();


static PyObject *
PyvtkAMRStreamingPriorityQueue_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkAMRStreamingPriorityQueue::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkAMRStreamingPriorityQueue::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkAMRStreamingPriorityQueue *tempr = vtkAMRStreamingPriorityQueue::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAMRStreamingPriorityQueue *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkAMRStreamingPriorityQueue::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkAMRStreamingPriorityQueue::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkAMRStreamingPriorityQueue::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  vtkAMRInformation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAMRInformation"))
  {
    if (ap.IsBound())
    {
      op->Initialize(temp0);
    }
    else
    {
      op->vtkAMRStreamingPriorityQueue::Initialize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_Reinitialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Reinitialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Reinitialize();
    }
    else
    {
      op->vtkAMRStreamingPriorityQueue::Reinitialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_Update_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  const int size0 = 24;
  double temp0[24];
  const int size1 = 6;
  double temp1[6];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetArray(temp0, size0) &&
      ap.GetArray(temp1, size1))
  {
    if (ap.IsBound())
    {
      op->Update(temp0, temp1);
    }
    else
    {
      op->vtkAMRStreamingPriorityQueue::Update(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkAMRStreamingPriorityQueue_Update_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  const int size0 = 24;
  double temp0[24];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->Update(temp0);
    }
    else
    {
      op->vtkAMRStreamingPriorityQueue::Update(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkAMRStreamingPriorityQueue_Update(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkAMRStreamingPriorityQueue_Update_s1(self, args);
    case 1:
      return PyvtkAMRStreamingPriorityQueue_Update_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Update");
  return NULL;
}



static PyObject *
PyvtkAMRStreamingPriorityQueue_IsEmpty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsEmpty");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsEmpty() :
      op->vtkAMRStreamingPriorityQueue::IsEmpty());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkAMRStreamingPriorityQueue_Pop(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pop");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkAMRStreamingPriorityQueue *op = static_cast<vtkAMRStreamingPriorityQueue *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->Pop() :
      op->vtkAMRStreamingPriorityQueue::Pop());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkAMRStreamingPriorityQueue_Methods[] = {
  {"IsTypeOf", PyvtkAMRStreamingPriorityQueue_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkAMRStreamingPriorityQueue_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkAMRStreamingPriorityQueue_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkAMRStreamingPriorityQueue\nC++: static vtkAMRStreamingPriorityQueue *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkAMRStreamingPriorityQueue_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkAMRStreamingPriorityQueue\nC++: vtkAMRStreamingPriorityQueue *NewInstance()\n\n"},
  {"SetController", PyvtkAMRStreamingPriorityQueue_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: void SetController(vtkMultiProcessController *)\n\nIf the controller is specified, the queue can be used in\nparallel. So long as Initialize(), Update() and Pop() methods are\ncalled on all processes (need not be synchronized) and all\nprocess get the same amr tree and view_planes (which is generally\ntrue with ParaView), the blocks are distributed among the\nprocesses. By default, this is set to the\nvtkMultiProcessController::GetGlobalController();\n"},
  {"GetController", PyvtkAMRStreamingPriorityQueue_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\nIf the controller is specified, the queue can be used in\nparallel. So long as Initialize(), Update() and Pop() methods are\ncalled on all processes (need not be synchronized) and all\nprocess get the same amr tree and view_planes (which is generally\ntrue with ParaView), the blocks are distributed among the\nprocesses. By default, this is set to the\nvtkMultiProcessController::GetGlobalController();\n"},
  {"Initialize", PyvtkAMRStreamingPriorityQueue_Initialize, METH_VARARGS,
   "V.Initialize(vtkAMRInformation)\nC++: void Initialize(vtkAMRInformation *amr)\n\nInitializes the queue. All information about items in the is\nlost.\n"},
  {"Reinitialize", PyvtkAMRStreamingPriorityQueue_Reinitialize, METH_VARARGS,
   "V.Reinitialize()\nC++: void Reinitialize()\n\nRe-initializes the priority queue using the amr structure given\nto the most recent call to Initialize().\n"},
  {"Update", PyvtkAMRStreamingPriorityQueue_Update, METH_VARARGS,
   "V.Update((float, float, float, float, float, float, float, float,\n    float, float, float, float, float, float, float, float, float,\n     float, float, float, float, float, float, float), (float,\n    float, float, float, float, float))\nC++: void Update(const double view_planes[24],\n    const double clamp_bounds[6])\nV.Update((float, float, float, float, float, float, float, float,\n    float, float, float, float, float, float, float, float, float,\n     float, float, float, float, float, float, float))\nC++: void Update(const double view_planes[24])\n\nUpdates the priorities of blocks based on the new view frustum\nplanes. Information about blocks \"popped\" from the queue is\npreserved and those blocks are not reinserted in the queue.\n"},
  {"IsEmpty", PyvtkAMRStreamingPriorityQueue_IsEmpty, METH_VARARGS,
   "V.IsEmpty() -> bool\nC++: bool IsEmpty()\n\nReturns if the queue is empty.\n"},
  {"Pop", PyvtkAMRStreamingPriorityQueue_Pop, METH_VARARGS,
   "V.Pop() -> int\nC++: unsigned int Pop()\n\nPops and returns of composite id for the block at the top of the\nqueue. Test if the queue is empty before calling this method.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkAMRStreamingPriorityQueue_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkAMRStreamingPriorityQueue", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkAMRStreamingPriorityQueue_StaticNew()
{
  return vtkAMRStreamingPriorityQueue::New();
}

PyObject *PyvtkAMRStreamingPriorityQueue_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkAMRStreamingPriorityQueue_Type, PyvtkAMRStreamingPriorityQueue_Methods,
    "vtkAMRStreamingPriorityQueue",
    PyvtkAMRStreamingPriorityQueue_Doc(), &PyvtkAMRStreamingPriorityQueue_StaticNew);

  PyTypeObject *pytype = &PyvtkAMRStreamingPriorityQueue_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkAMRStreamingPriorityQueue_Doc()
{
  static const char *docstring[] = {
    "vtkAMRStreamingPriorityQueue - implements a coverage based priority\nqueue for vtkOverlappingAMR dataset.\n\n",
    "Superclass: vtkObject\n\n",
    "vtkAMRStreamingPriorityQueue is used by representations supporting\nstreaming of AMR datasets to determine the priorities for blocks in\nthe dataset. This class relies on the bounds information provided by\nthe AMR meta-data i.e. vtkAMRInformation. This class support\nview-based priority computation. Simply provide the view planes\n(returned by vtkCamera::GetFrustumPlanes()) to the\nvtkAMRStreamingPrior",
    "ityQueue::Update() call to update the prorities\nfor the blocks currently in the queue.\n@sa\nvtkAMROutlineRepresentation, vtkAMRStreamingVolumeRepresentation.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkAMRStreamingPriorityQueue(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkAMRStreamingPriorityQueue_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkAMRStreamingPriorityQueue", o) != 0)
  {
    Py_DECREF(o);
  }

}

