// python wrapper for vtkCPProcessor
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCPProcessor.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCPProcessor(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCPProcessor_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkCPProcessor_Doc();


static PyObject *
PyvtkCPProcessor_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkCPProcessor::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCPProcessor::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkCPProcessor *tempr = vtkCPProcessor::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCPProcessor *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCPProcessor::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_AddPipeline(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddPipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  vtkCPPipeline *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCPPipeline"))
  {
    int tempr = (ap.IsBound() ?
      op->AddPipeline(temp0) :
      op->vtkCPProcessor::AddPipeline(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_GetNumberOfPipelines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPipelines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPipelines() :
      op->vtkCPProcessor::GetNumberOfPipelines());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_GetPipeline(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkCPPipeline *tempr = (ap.IsBound() ?
      op->GetPipeline(temp0) :
      op->vtkCPProcessor::GetPipeline(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_RemovePipeline(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemovePipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  vtkCPPipeline *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCPPipeline"))
  {
    if (ap.IsBound())
    {
      op->RemovePipeline(temp0);
    }
    else
    {
      op->vtkCPProcessor::RemovePipeline(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_RemoveAllPipelines(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveAllPipelines");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RemoveAllPipelines();
    }
    else
    {
      op->vtkCPProcessor::RemoveAllPipelines();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->Initialize() :
      op->vtkCPProcessor::Initialize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_RequestDataDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RequestDataDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  vtkCPDataDescription *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCPDataDescription"))
  {
    int tempr = (ap.IsBound() ?
      op->RequestDataDescription(temp0) :
      op->vtkCPProcessor::RequestDataDescription(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_CoProcess(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CoProcess");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  vtkCPDataDescription *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCPDataDescription"))
  {
    int tempr = (ap.IsBound() ?
      op->CoProcess(temp0) :
      op->vtkCPProcessor::CoProcess(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPProcessor_Finalize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Finalize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPProcessor *op = static_cast<vtkCPProcessor *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->Finalize() :
      op->vtkCPProcessor::Finalize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCPProcessor_Methods[] = {
  {"IsTypeOf", PyvtkCPProcessor_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkCPProcessor_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkCPProcessor_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkCPProcessor\nC++: static vtkCPProcessor *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkCPProcessor_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCPProcessor\nC++: vtkCPProcessor *NewInstance()\n\n"},
  {"AddPipeline", PyvtkCPProcessor_AddPipeline, METH_VARARGS,
   "V.AddPipeline(vtkCPPipeline) -> int\nC++: virtual int AddPipeline(vtkCPPipeline *pipeline)\n\nAdd in a pipeline that is externally configured. Returns 1 if\nsuccessful and 0 otherwise.\n"},
  {"GetNumberOfPipelines", PyvtkCPProcessor_GetNumberOfPipelines, METH_VARARGS,
   "V.GetNumberOfPipelines() -> int\nC++: virtual int GetNumberOfPipelines()\n\nGet the number of pipelines.\n"},
  {"GetPipeline", PyvtkCPProcessor_GetPipeline, METH_VARARGS,
   "V.GetPipeline(int) -> vtkCPPipeline\nC++: virtual vtkCPPipeline *GetPipeline(int which)\n\nReturn a specific pipeline.\n"},
  {"RemovePipeline", PyvtkCPProcessor_RemovePipeline, METH_VARARGS,
   "V.RemovePipeline(vtkCPPipeline)\nC++: virtual void RemovePipeline(vtkCPPipeline *pipeline)\n\nRemove pipelines.\n"},
  {"RemoveAllPipelines", PyvtkCPProcessor_RemoveAllPipelines, METH_VARARGS,
   "V.RemoveAllPipelines()\nC++: virtual void RemoveAllPipelines()\n\n"},
  {"Initialize", PyvtkCPProcessor_Initialize, METH_VARARGS,
   "V.Initialize() -> int\nC++: virtual int Initialize()\n\nInitialize the co-processor. Returns 1 if successful and 0\notherwise. otherwise. If Catalyst is built with MPI then\nInitialize() can also be called with a specific MPI communicator\nif MPI_COMM_WORLD isn't the proper one. Catalyst is initialized\nto use MPI_COMM_WORLD by default.\n"},
  {"RequestDataDescription", PyvtkCPProcessor_RequestDataDescription, METH_VARARGS,
   "V.RequestDataDescription(vtkCPDataDescription) -> int\nC++: virtual int RequestDataDescription(\n    vtkCPDataDescription *dataDescription)\n\nConfiguration Step: The coprocessor first determines if any\ncoprocessing needs to be done at this TimeStep/Time combination\nreturning 1 if it does and 0 otherwise.  If coprocessing does\nneed to be performed this time step it fills in the FieldNames\narray that the coprocessor requires in order to fulfill all the\ncoprocessing requests for this TimeStep/Time combination.\n"},
  {"CoProcess", PyvtkCPProcessor_CoProcess, METH_VARARGS,
   "V.CoProcess(vtkCPDataDescription) -> int\nC++: virtual int CoProcess(vtkCPDataDescription *dataDescription)\n\nProcessing Step: Provides the grid and the field data for the\nco-procesor to process. Return value is 1 for success and 0 for\nfailure.\n"},
  {"Finalize", PyvtkCPProcessor_Finalize, METH_VARARGS,
   "V.Finalize() -> int\nC++: virtual int Finalize()\n\nCalled after all co-processing is complete giving the\nCo-Processor implementation an opportunity to clean up, before it\nis destroyed.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCPProcessor_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVCatalystPython.vtkCPProcessor", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCPProcessor_StaticNew()
{
  return vtkCPProcessor::New();
}

PyObject *PyvtkCPProcessor_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCPProcessor_Type, PyvtkCPProcessor_Methods,
    "vtkCPProcessor",
    PyvtkCPProcessor_Doc(), &PyvtkCPProcessor_StaticNew);

  PyTypeObject *pytype = &PyvtkCPProcessor_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCPProcessor_Doc()
{
  static const char *docstring[] = {
    "vtkCPProcessor - @ingroup CoProcessing\n\n",
    "Superclass: vtkObject\n\n",
    "There are 3 distinct phases for the operation of a co-processor.\n\n1) Initialization -- set up for the run.\n\n2) Processing -- the run.\n\n3) Finalization -- clean up before exit.\n\nThe processing phase occurs repeatedly and is composed of two\ndistinct steps, namely 1) Configuration (see\nvtkCPProcessor::ProcessDataDescription) and\n2) Processing (see vtkCPProcessor::ProcessData).\n\nConfiguration step:\n\nI",
    "n the first step the Co-Processor implemntation is called with a\nvtkDataDescription describing the data that the simulation can\nprovide This gives the Co-Processor implemntation a chance to\nidentify what (if any) of the available data it will process during\nthis pass. By default all of the avaible data is selected, so that if\nthe Co-Processor implementation does nothing it will receive all data\ndu",
    "ring the Processing step. The Co-Processor implementation should\nextract what ever meta-data it will need (or alternatively can save a\nreference to the DataDescription), during the Processing step.\n\nProcessing step:\n\nIn the second step the Co-Processor implementation is called with the\nactual data that it has been asked to provide, if any. If no data was\nselected during the Configuration Step than",
    " the priovided\nvtkDataObject may be NULL.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCPProcessor(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCPProcessor_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCPProcessor", o) != 0)
  {
    Py_DECREF(o);
  }

}

