// python wrapper for vtkCommonInformationKeyManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkCommonInformationKeyManager.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCommonInformationKeyManager(PyObject *); }

static const char **PyvtkCommonInformationKeyManager_Doc();

static PyMethodDef PyvtkCommonInformationKeyManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkCommonInformationKeyManager_vtkCommonInformationKeyManager(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkCommonInformationKeyManager");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkCommonInformationKeyManager *op = new vtkCommonInformationKeyManager();

    result = PyVTKSpecialObject_New("vtkCommonInformationKeyManager", op);
  }

  return result;
}

static PyMethodDef PyvtkCommonInformationKeyManager_vtkCommonInformationKeyManager_Methods[] = {
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkCommonInformationKeyManager_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkCommonInformationKeyManager_vtkCommonInformationKeyManager(NULL, args);
}

static void PyvtkCommonInformationKeyManager_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkCommonInformationKeyManager *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkCommonInformationKeyManager_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkCommonInformationKeyManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkCommonInformationKeyManager", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkCommonInformationKeyManager_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkCommonInformationKeyManager_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkCommonInformationKeyManager_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCommonInformationKeyManager_TypeNew(); }

PyObject *PyvtkCommonInformationKeyManager_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkCommonInformationKeyManager_Type,
    PyvtkCommonInformationKeyManager_Methods,
    PyvtkCommonInformationKeyManager_vtkCommonInformationKeyManager_Methods,
    PyvtkCommonInformationKeyManager_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkCommonInformationKeyManager_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCommonInformationKeyManager_Doc()
{
  static const char *docstring[] = {
    "vtkCommonInformationKeyManager - Manages key types in vtkCommon.\n\n",
    "vtkCommonInformationKeyManager is included in the header of any\nsubclass of vtkInformationKey defined in the vtkCommon library. It\nmakes sure that the table of keys is created before and destroyed\nafter it is used.\n\n",
    "V.vtkCommonInformationKeyManager()\nC++: vtkCommonInformationKeyManager()\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCommonInformationKeyManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCommonInformationKeyManager_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkCommonInformationKeyManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

