// python wrapper for vtkExodusIIReaderParser
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkExodusIIReaderParser.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkExodusIIReaderParser(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkExodusIIReaderParser_ClassNew(); }

#ifndef DECLARED_PyvtkXMLParser_ClassNew
extern "C" { PyObject *PyvtkXMLParser_ClassNew(); }
#define DECLARED_PyvtkXMLParser_ClassNew
#endif

static const char **PyvtkExodusIIReaderParser_Doc();


static PyObject *
PyvtkExodusIIReaderParser_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkExodusIIReaderParser::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkExodusIIReaderParser::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkExodusIIReaderParser *tempr = vtkExodusIIReaderParser::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkExodusIIReaderParser *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkExodusIIReaderParser::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_GetSIL(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSIL");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMutableDirectedGraph *tempr = (ap.IsBound() ?
      op->GetSIL() :
      op->vtkExodusIIReaderParser::GetSIL());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_Go(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Go");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->Go(temp0);
    }
    else
    {
      op->vtkExodusIIReaderParser::Go(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_HasInformationAboutBlock(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasInformationAboutBlock");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasInformationAboutBlock(temp0) :
      op->vtkExodusIIReaderParser::HasInformationAboutBlock(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExodusIIReaderParser_GetBlockName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBlockName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExodusIIReaderParser *op = static_cast<vtkExodusIIReaderParser *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::string tempr = (ap.IsBound() ?
      op->GetBlockName(temp0) :
      op->vtkExodusIIReaderParser::GetBlockName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkExodusIIReaderParser_Methods[] = {
  {"IsTypeOf", PyvtkExodusIIReaderParser_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkExodusIIReaderParser_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkExodusIIReaderParser_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkExodusIIReaderParser\nC++: static vtkExodusIIReaderParser *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkExodusIIReaderParser_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkExodusIIReaderParser\nC++: vtkExodusIIReaderParser *NewInstance()\n\n"},
  {"GetSIL", PyvtkExodusIIReaderParser_GetSIL, METH_VARARGS,
   "V.GetSIL() -> vtkMutableDirectedGraph\nC++: virtual vtkMutableDirectedGraph *GetSIL()\n\nReturns the SIL. This is valid only after Go().\n"},
  {"Go", PyvtkExodusIIReaderParser_Go, METH_VARARGS,
   "V.Go(string)\nC++: void Go(const char *filename)\n\nTrigger parsing of the XML file.\n"},
  {"HasInformationAboutBlock", PyvtkExodusIIReaderParser_HasInformationAboutBlock, METH_VARARGS,
   "V.HasInformationAboutBlock(int) -> bool\nC++: bool HasInformationAboutBlock(int id)\n\n"},
  {"GetBlockName", PyvtkExodusIIReaderParser_GetBlockName, METH_VARARGS,
   "V.GetBlockName(int) -> string\nC++: std::string GetBlockName(int id)\n\nGiven a block \"id\" return the name as determined from the xml.\nThis is valid only after Go().\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkExodusIIReaderParser_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOExodusPython.vtkExodusIIReaderParser", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkExodusIIReaderParser_StaticNew()
{
  return vtkExodusIIReaderParser::New();
}

PyObject *PyvtkExodusIIReaderParser_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkExodusIIReaderParser_Type, PyvtkExodusIIReaderParser_Methods,
    "vtkExodusIIReaderParser",
    PyvtkExodusIIReaderParser_Doc(), &PyvtkExodusIIReaderParser_StaticNew);

  PyTypeObject *pytype = &PyvtkExodusIIReaderParser_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkXMLParser_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkExodusIIReaderParser_Doc()
{
  static const char *docstring[] = {
    "vtkExodusIIReaderParser - internal parser used by vtkExodusIIReader.\n\n",
    "Superclass: vtkXMLParser\n\n",
    "vtkExodusIIReaderParser is an internal XML parser used by\nvtkExodusIIReader. This is not for public use.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkExodusIIReaderParser(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkExodusIIReaderParser_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkExodusIIReaderParser", o) != 0)
  {
    Py_DECREF(o);
  }

}

