// python wrapper for vtkExtractsDeliveryHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkExtractsDeliveryHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkExtractsDeliveryHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkExtractsDeliveryHelper_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkExtractsDeliveryHelper_Doc();


static PyObject *
PyvtkExtractsDeliveryHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkExtractsDeliveryHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkExtractsDeliveryHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkExtractsDeliveryHelper *tempr = vtkExtractsDeliveryHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkExtractsDeliveryHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkExtractsDeliveryHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SetProcessIsProducer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProcessIsProducer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetProcessIsProducer(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::SetProcessIsProducer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_GetProcessIsProducer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProcessIsProducer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetProcessIsProducer() :
      op->vtkExtractsDeliveryHelper::GetProcessIsProducer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SetSimulation2VisualizationController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSimulation2VisualizationController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  vtkSocketController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSocketController"))
  {
    if (ap.IsBound())
    {
      op->SetSimulation2VisualizationController(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::SetSimulation2VisualizationController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SetParallelController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParallelController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetParallelController(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::SetParallelController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_ClearAllExtracts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearAllExtracts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearAllExtracts();
    }
    else
    {
      op->vtkExtractsDeliveryHelper::ClearAllExtracts();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_AddExtractConsumer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddExtractConsumer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  char *temp0 = NULL;
  vtkTrivialProducer *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkTrivialProducer"))
  {
    if (ap.IsBound())
    {
      op->AddExtractConsumer(temp0, temp1);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::AddExtractConsumer(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_RemoveExtractConsumer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RemoveExtractConsumer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RemoveExtractConsumer(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::RemoveExtractConsumer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_AddExtractProducer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddExtractProducer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  char *temp0 = NULL;
  vtkAlgorithmOutput *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkAlgorithmOutput"))
  {
    if (ap.IsBound())
    {
      op->AddExtractProducer(temp0, temp1);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::AddExtractProducer(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->Update() :
      op->vtkExtractsDeliveryHelper::Update());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SetNumberOfVisualizationProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfVisualizationProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfVisualizationProcesses(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::SetNumberOfVisualizationProcesses(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_GetNumberOfVisualizationProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfVisualizationProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfVisualizationProcesses() :
      op->vtkExtractsDeliveryHelper::GetNumberOfVisualizationProcesses());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_SetNumberOfSimulationProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfSimulationProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfSimulationProcesses(temp0);
    }
    else
    {
      op->vtkExtractsDeliveryHelper::SetNumberOfSimulationProcesses(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkExtractsDeliveryHelper_GetNumberOfSimulationProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfSimulationProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkExtractsDeliveryHelper *op = static_cast<vtkExtractsDeliveryHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfSimulationProcesses() :
      op->vtkExtractsDeliveryHelper::GetNumberOfSimulationProcesses());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkExtractsDeliveryHelper_Methods[] = {
  {"IsTypeOf", PyvtkExtractsDeliveryHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkExtractsDeliveryHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkExtractsDeliveryHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkExtractsDeliveryHelper\nC++: static vtkExtractsDeliveryHelper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkExtractsDeliveryHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkExtractsDeliveryHelper\nC++: vtkExtractsDeliveryHelper *NewInstance()\n\n"},
  {"SetProcessIsProducer", PyvtkExtractsDeliveryHelper_SetProcessIsProducer, METH_VARARGS,
   "V.SetProcessIsProducer(bool)\nC++: virtual void SetProcessIsProducer(bool _arg)\n\n"},
  {"GetProcessIsProducer", PyvtkExtractsDeliveryHelper_GetProcessIsProducer, METH_VARARGS,
   "V.GetProcessIsProducer() -> bool\nC++: virtual bool GetProcessIsProducer()\n\n"},
  {"SetSimulation2VisualizationController", PyvtkExtractsDeliveryHelper_SetSimulation2VisualizationController, METH_VARARGS,
   "V.SetSimulation2VisualizationController(vtkSocketController)\nC++: void SetSimulation2VisualizationController(\n    vtkSocketController *)\n\n"},
  {"SetParallelController", PyvtkExtractsDeliveryHelper_SetParallelController, METH_VARARGS,
   "V.SetParallelController(vtkMultiProcessController)\nC++: void SetParallelController(vtkMultiProcessController *)\n\n"},
  {"ClearAllExtracts", PyvtkExtractsDeliveryHelper_ClearAllExtracts, METH_VARARGS,
   "V.ClearAllExtracts()\nC++: void ClearAllExtracts()\n\n"},
  {"AddExtractConsumer", PyvtkExtractsDeliveryHelper_AddExtractConsumer, METH_VARARGS,
   "V.AddExtractConsumer(string, vtkTrivialProducer)\nC++: void AddExtractConsumer(const char *key,\n    vtkTrivialProducer *consumer)\n\n"},
  {"RemoveExtractConsumer", PyvtkExtractsDeliveryHelper_RemoveExtractConsumer, METH_VARARGS,
   "V.RemoveExtractConsumer(string)\nC++: void RemoveExtractConsumer(const char *key)\n\n"},
  {"AddExtractProducer", PyvtkExtractsDeliveryHelper_AddExtractProducer, METH_VARARGS,
   "V.AddExtractProducer(string, vtkAlgorithmOutput)\nC++: void AddExtractProducer(const char *key,\n    vtkAlgorithmOutput *producerPort)\n\n"},
  {"Update", PyvtkExtractsDeliveryHelper_Update, METH_VARARGS,
   "V.Update() -> bool\nC++: bool Update()\n\nReturns true if the data has been made available.\n"},
  {"SetNumberOfVisualizationProcesses", PyvtkExtractsDeliveryHelper_SetNumberOfVisualizationProcesses, METH_VARARGS,
   "V.SetNumberOfVisualizationProcesses(int)\nC++: virtual void SetNumberOfVisualizationProcesses(int _arg)\n\n"},
  {"GetNumberOfVisualizationProcesses", PyvtkExtractsDeliveryHelper_GetNumberOfVisualizationProcesses, METH_VARARGS,
   "V.GetNumberOfVisualizationProcesses() -> int\nC++: virtual int GetNumberOfVisualizationProcesses()\n\n"},
  {"SetNumberOfSimulationProcesses", PyvtkExtractsDeliveryHelper_SetNumberOfSimulationProcesses, METH_VARARGS,
   "V.SetNumberOfSimulationProcesses(int)\nC++: virtual void SetNumberOfSimulationProcesses(int _arg)\n\n"},
  {"GetNumberOfSimulationProcesses", PyvtkExtractsDeliveryHelper_GetNumberOfSimulationProcesses, METH_VARARGS,
   "V.GetNumberOfSimulationProcesses() -> int\nC++: virtual int GetNumberOfSimulationProcesses()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkExtractsDeliveryHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreCorePython.vtkExtractsDeliveryHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkExtractsDeliveryHelper_StaticNew()
{
  return vtkExtractsDeliveryHelper::New();
}

PyObject *PyvtkExtractsDeliveryHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkExtractsDeliveryHelper_Type, PyvtkExtractsDeliveryHelper_Methods,
    "vtkExtractsDeliveryHelper",
    PyvtkExtractsDeliveryHelper_Doc(), &PyvtkExtractsDeliveryHelper_StaticNew);

  PyTypeObject *pytype = &PyvtkExtractsDeliveryHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkExtractsDeliveryHelper_Doc()
{
  static const char *docstring[] = {
    "vtkExtractsDeliveryHelper - \n\n",
    "Superclass: vtkObject\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkExtractsDeliveryHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkExtractsDeliveryHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkExtractsDeliveryHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

