// python wrapper for vtkHierarchicalDataExtractDataSets
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkHierarchicalDataExtractDataSets.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkHierarchicalDataExtractDataSets(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkHierarchicalDataExtractDataSets_ClassNew(); }

#ifndef DECLARED_PyvtkExtractDataSets_ClassNew
extern "C" { PyObject *PyvtkExtractDataSets_ClassNew(); }
#define DECLARED_PyvtkExtractDataSets_ClassNew
#endif

static const char **PyvtkHierarchicalDataExtractDataSets_Doc();


static PyObject *
PyvtkHierarchicalDataExtractDataSets_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkHierarchicalDataExtractDataSets::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalDataExtractDataSets_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalDataExtractDataSets *op = static_cast<vtkHierarchicalDataExtractDataSets *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkHierarchicalDataExtractDataSets::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalDataExtractDataSets_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkHierarchicalDataExtractDataSets *tempr = vtkHierarchicalDataExtractDataSets::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkHierarchicalDataExtractDataSets_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkHierarchicalDataExtractDataSets *op = static_cast<vtkHierarchicalDataExtractDataSets *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkHierarchicalDataExtractDataSets *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkHierarchicalDataExtractDataSets::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkHierarchicalDataExtractDataSets_Methods[] = {
  {"IsTypeOf", PyvtkHierarchicalDataExtractDataSets_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkHierarchicalDataExtractDataSets_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkHierarchicalDataExtractDataSets_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkHierarchicalDataExtractDataSets\nC++: static vtkHierarchicalDataExtractDataSets *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkHierarchicalDataExtractDataSets_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkHierarchicalDataExtractDataSets\nC++: vtkHierarchicalDataExtractDataSets *NewInstance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkHierarchicalDataExtractDataSets_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersExtractionPython.vtkHierarchicalDataExtractDataSets", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkHierarchicalDataExtractDataSets_StaticNew()
{
  return vtkHierarchicalDataExtractDataSets::New();
}

PyObject *PyvtkHierarchicalDataExtractDataSets_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkHierarchicalDataExtractDataSets_Type, PyvtkHierarchicalDataExtractDataSets_Methods,
    "vtkHierarchicalDataExtractDataSets",
    PyvtkHierarchicalDataExtractDataSets_Doc(), &PyvtkHierarchicalDataExtractDataSets_StaticNew);

  PyTypeObject *pytype = &PyvtkHierarchicalDataExtractDataSets_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkExtractDataSets_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkHierarchicalDataExtractDataSets_Doc()
{
  static const char *docstring[] = {
    "vtkHierarchicalDataExtractDataSets - extract a number of datasets\n\n",
    "Superclass: vtkExtractDataSets\n\n",
    "Legacy class. Use vtkExtractDataSets instead.\n\n@sa\nvtkExtractDataSets\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkHierarchicalDataExtractDataSets(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkHierarchicalDataExtractDataSets_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkHierarchicalDataExtractDataSets", o) != 0)
  {
    Py_DECREF(o);
  }

}

