// python wrapper for vtkIOExportOpenGL2ObjectFactory
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkIOExportOpenGL2ObjectFactory.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIOExportOpenGL2ObjectFactory(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkIOExportOpenGL2ObjectFactory_ClassNew(); }

#ifndef DECLARED_PyvtkObjectFactory_ClassNew
extern "C" { PyObject *PyvtkObjectFactory_ClassNew(); }
#define DECLARED_PyvtkObjectFactory_ClassNew
#endif

static const char **PyvtkIOExportOpenGL2ObjectFactory_Doc();


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkIOExportOpenGL2ObjectFactory::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOExportOpenGL2ObjectFactory *op = static_cast<vtkIOExportOpenGL2ObjectFactory *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkIOExportOpenGL2ObjectFactory::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkIOExportOpenGL2ObjectFactory *tempr = vtkIOExportOpenGL2ObjectFactory::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOExportOpenGL2ObjectFactory *op = static_cast<vtkIOExportOpenGL2ObjectFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIOExportOpenGL2ObjectFactory *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkIOExportOpenGL2ObjectFactory::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_GetDescription(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDescription");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOExportOpenGL2ObjectFactory *op = static_cast<vtkIOExportOpenGL2ObjectFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetDescription() :
      op->vtkIOExportOpenGL2ObjectFactory::GetDescription());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOExportOpenGL2ObjectFactory_GetVTKSourceVersion(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVTKSourceVersion");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOExportOpenGL2ObjectFactory *op = static_cast<vtkIOExportOpenGL2ObjectFactory *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetVTKSourceVersion() :
      op->vtkIOExportOpenGL2ObjectFactory::GetVTKSourceVersion());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkIOExportOpenGL2ObjectFactory_Methods[] = {
  {"IsTypeOf", PyvtkIOExportOpenGL2ObjectFactory_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkIOExportOpenGL2ObjectFactory_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkIOExportOpenGL2ObjectFactory_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkIOExportOpenGL2ObjectFactory\nC++: static vtkIOExportOpenGL2ObjectFactory *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkIOExportOpenGL2ObjectFactory_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkIOExportOpenGL2ObjectFactory\nC++: vtkIOExportOpenGL2ObjectFactory *NewInstance()\n\n"},
  {"GetDescription", PyvtkIOExportOpenGL2ObjectFactory_GetDescription, METH_VARARGS,
   "V.GetDescription() -> string\nC++: const char *GetDescription()\n\n"},
  {"GetVTKSourceVersion", PyvtkIOExportOpenGL2ObjectFactory_GetVTKSourceVersion, METH_VARARGS,
   "V.GetVTKSourceVersion() -> string\nC++: const char *GetVTKSourceVersion()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkIOExportOpenGL2ObjectFactory_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOExportOpenGL2Python.vtkIOExportOpenGL2ObjectFactory", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkIOExportOpenGL2ObjectFactory_StaticNew()
{
  return vtkIOExportOpenGL2ObjectFactory::New();
}

PyObject *PyvtkIOExportOpenGL2ObjectFactory_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkIOExportOpenGL2ObjectFactory_Type, PyvtkIOExportOpenGL2ObjectFactory_Methods,
    "vtkIOExportOpenGL2ObjectFactory",
    PyvtkIOExportOpenGL2ObjectFactory_Doc(), &PyvtkIOExportOpenGL2ObjectFactory_StaticNew);

  PyTypeObject *pytype = &PyvtkIOExportOpenGL2ObjectFactory_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObjectFactory_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkIOExportOpenGL2ObjectFactory_Doc()
{
  static const char *docstring[] = {
    "vtkIOExportOpenGL2ObjectFactory - no description provided.\n\n",
    "Superclass: vtkObjectFactory\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkIOExportOpenGL2ObjectFactory(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIOExportOpenGL2ObjectFactory_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkIOExportOpenGL2ObjectFactory", o) != 0)
  {
    Py_DECREF(o);
  }

}

