// python wrapper for vtkImageWrapPad
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkImageWrapPad.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkImageWrapPad(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkImageWrapPad_ClassNew(); }

#ifndef DECLARED_PyvtkImagePadFilter_ClassNew
extern "C" { PyObject *PyvtkImagePadFilter_ClassNew(); }
#define DECLARED_PyvtkImagePadFilter_ClassNew
#endif

static const char **PyvtkImageWrapPad_Doc();


static PyObject *
PyvtkImageWrapPad_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkImageWrapPad::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageWrapPad_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageWrapPad *op = static_cast<vtkImageWrapPad *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkImageWrapPad::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageWrapPad_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkImageWrapPad *tempr = vtkImageWrapPad::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkImageWrapPad_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkImageWrapPad *op = static_cast<vtkImageWrapPad *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkImageWrapPad *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkImageWrapPad::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkImageWrapPad_Methods[] = {
  {"IsTypeOf", PyvtkImageWrapPad_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkImageWrapPad_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkImageWrapPad_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkImageWrapPad\nC++: static vtkImageWrapPad *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkImageWrapPad_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkImageWrapPad\nC++: vtkImageWrapPad *NewInstance()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkImageWrapPad_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkImagingCorePython.vtkImageWrapPad", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkImageWrapPad_StaticNew()
{
  return vtkImageWrapPad::New();
}

PyObject *PyvtkImageWrapPad_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkImageWrapPad_Type, PyvtkImageWrapPad_Methods,
    "vtkImageWrapPad",
    PyvtkImageWrapPad_Doc(), &PyvtkImageWrapPad_StaticNew);

  PyTypeObject *pytype = &PyvtkImageWrapPad_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImagePadFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkImageWrapPad_Doc()
{
  static const char *docstring[] = {
    "vtkImageWrapPad - Makes an image larger by wrapping existing data.\n\n",
    "Superclass: vtkImagePadFilter\n\n",
    "vtkImageWrapPad performs a modulo operation on the output pixel index\nto determine the source input index.  The new image extent of the\noutput has to be specified.  Input has to be the same scalar type as\noutput.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkImageWrapPad(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkImageWrapPad_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkImageWrapPad", o) != 0)
  {
    Py_DECREF(o);
  }

}

