// python wrapper for vtkLoopSubdivisionFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkLoopSubdivisionFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkLoopSubdivisionFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkLoopSubdivisionFilter_ClassNew(); }

#ifndef DECLARED_PyvtkApproximatingSubdivisionFilter_ClassNew
extern "C" { PyObject *PyvtkApproximatingSubdivisionFilter_ClassNew(); }
#define DECLARED_PyvtkApproximatingSubdivisionFilter_ClassNew
#endif

static const char **PyvtkLoopSubdivisionFilter_Doc();


static PyObject *
PyvtkLoopSubdivisionFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkLoopSubdivisionFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLoopSubdivisionFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLoopSubdivisionFilter *op = static_cast<vtkLoopSubdivisionFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkLoopSubdivisionFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLoopSubdivisionFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkLoopSubdivisionFilter *tempr = vtkLoopSubdivisionFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkLoopSubdivisionFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkLoopSubdivisionFilter *op = static_cast<vtkLoopSubdivisionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkLoopSubdivisionFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkLoopSubdivisionFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}

static PyMethodDef PyvtkLoopSubdivisionFilter_Methods[] = {
  {"IsTypeOf", PyvtkLoopSubdivisionFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"IsA", PyvtkLoopSubdivisionFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"SafeDownCast", PyvtkLoopSubdivisionFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkLoopSubdivisionFilter\nC++: static vtkLoopSubdivisionFilter *SafeDownCast(\n    vtkObjectBase *o)\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {"NewInstance", PyvtkLoopSubdivisionFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkLoopSubdivisionFilter\nC++: vtkLoopSubdivisionFilter *NewInstance()\n\nConstruct object with NumberOfSubdivisions set to 1.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkLoopSubdivisionFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersModelingPython.vtkLoopSubdivisionFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkLoopSubdivisionFilter_StaticNew()
{
  return vtkLoopSubdivisionFilter::New();
}

PyObject *PyvtkLoopSubdivisionFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkLoopSubdivisionFilter_Type, PyvtkLoopSubdivisionFilter_Methods,
    "vtkLoopSubdivisionFilter",
    PyvtkLoopSubdivisionFilter_Doc(), &PyvtkLoopSubdivisionFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkLoopSubdivisionFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkApproximatingSubdivisionFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkLoopSubdivisionFilter_Doc()
{
  static const char *docstring[] = {
    "vtkLoopSubdivisionFilter - generate a subdivision surface using the\nLoop Scheme\n\n",
    "Superclass: vtkApproximatingSubdivisionFilter\n\n",
    "vtkLoopSubdivisionFilter is an approximating subdivision scheme that\ncreates four new triangles for each triangle in the mesh. The user\ncan specify the NumberOfSubdivisions. Loop's subdivision scheme is\ndescribed in: Loop, C., \"Smooth Subdivision surfaces based on\ntriangles,\", Masters Thesis, University of Utah, August 1987. For a\nnice summary of the technique see, Hoppe, H., et. al, \"Piecewise\nSm",
    "ooth Surface Reconstruction,:, Proceedings of Siggraph 94 (Orlando,\nFlorida, July 24-29, 1994). In COmputer Graphics Proceedings, Annual\nCOnference Series, 1994, ACM SIGGRAPH, pp. 295-302.\n\nThe filter only operates on triangles. Users should use the\nvtkTriangleFilter to triangulate meshes that contain polygons or\ntriangle strips.\n\nThe filter approximates point data using the same scheme. New\ntrian",
    "gles create at a subdivision step will have the cell data of\ntheir parent cell.\n\n@par Thanks: This work was supported by PHS Research Grant No. 1 P41\nRR13218-01 from the National Center for Research Resources.\n\n@sa\nvtkApproximatingSubdivisionFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkLoopSubdivisionFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkLoopSubdivisionFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkLoopSubdivisionFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

