// python wrapper for vtkMaterialInterfaceCommBuffer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkMaterialInterfaceCommBuffer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMaterialInterfaceCommBuffer(PyObject *); }

static const char **PyvtkMaterialInterfaceCommBuffer_Doc();


static PyObject *
PyvtkMaterialInterfaceCommBuffer_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int temp0;
  int temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    op->Initialize(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_SizeHeader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SizeHeader");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->SizeHeader(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_SizeBuffer_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SizeBuffer");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    op->SizeBuffer(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_SizeBuffer_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SizeBuffer");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->SizeBuffer();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_SizeBuffer(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkMaterialInterfaceCommBuffer_SizeBuffer_s1(self, args);
    case 0:
      return PyvtkMaterialInterfaceCommBuffer_SizeBuffer_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SizeBuffer");
  return NULL;
}



static PyObject *
PyvtkMaterialInterfaceCommBuffer_Clear(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Clear");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->Clear();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetBufferSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBufferSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = op->GetBufferSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetBuffer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetBuffer");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = op->GetBuffer();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetEOD(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEOD");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = op->GetEOD();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetHeaderSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHeaderSize");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = op->GetHeaderSize();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetHeader(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHeader");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType *tempr = op->GetHeader();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_Capacity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Capacity");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = op->Capacity();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_SetNumberOfTuples(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfTuples");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int temp0;
  vtkIdType temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    op->SetNumberOfTuples(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_GetNumberOfTuples(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTuples");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkIdType tempr = op->GetNumberOfTuples(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_Pack_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<double> store0(size0);
  double *temp0 = store0.Data();
  int temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    vtkIdType tempr = op->Pack(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_Pack_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  int size0 = ap.GetArgSize(0);
  vtkPythonArgs::Array<int> store0(size0);
  int *temp0 = store0.Data();
  int temp1;
  vtkIdType temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetArray(temp0, size0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    vtkIdType tempr = op->Pack(temp0, temp1, temp2);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_Pack_s3(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  vtkDoubleArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDoubleArray"))
  {
    vtkIdType tempr = op->Pack(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_Pack_s4(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Pack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  vtkFloatArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkFloatArray"))
  {
    vtkIdType tempr = op->Pack(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMaterialInterfaceCommBuffer_Pack_Methods[] = {
  {NULL, PyvtkMaterialInterfaceCommBuffer_Pack_s1, METH_VARARGS,
   "@Pik *d"},
  {NULL, PyvtkMaterialInterfaceCommBuffer_Pack_s2, METH_VARARGS,
   "@Pik *i"},
  {NULL, PyvtkMaterialInterfaceCommBuffer_Pack_s3, METH_VARARGS,
   "@V *vtkDoubleArray"},
  {NULL, PyvtkMaterialInterfaceCommBuffer_Pack_s4, METH_VARARGS,
   "@V *vtkFloatArray"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMaterialInterfaceCommBuffer_Pack(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkMaterialInterfaceCommBuffer_Pack_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Pack");
  return NULL;
}



static PyObject *
PyvtkMaterialInterfaceCommBuffer_InitUnpack(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitUnpack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    op->InitUnpack();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_UnPack_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UnPack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  vtkDoubleArray *temp0 = NULL;
  int temp1;
  vtkIdType temp2;
  bool temp3 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkDoubleArray") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = op->UnPack(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_UnPack_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UnPack");
  void *vp = ap.GetSelfSpecialPointer(self, args);
  vtkMaterialInterfaceCommBuffer *op = static_cast<vtkMaterialInterfaceCommBuffer *>(vp);

  vtkFloatArray *temp0 = NULL;
  int temp1;
  vtkIdType temp2;
  bool temp3 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4) &&
      ap.GetVTKObject(temp0, "vtkFloatArray") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3))
  {
    int tempr = op->UnPack(temp0, temp1, temp2, temp3);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkMaterialInterfaceCommBuffer_UnPack_Methods[] = {
  {NULL, PyvtkMaterialInterfaceCommBuffer_UnPack_s1, METH_VARARGS,
   "@Vikq *vtkDoubleArray"},
  {NULL, PyvtkMaterialInterfaceCommBuffer_UnPack_s2, METH_VARARGS,
   "@Vikq *vtkFloatArray"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMaterialInterfaceCommBuffer_UnPack(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkMaterialInterfaceCommBuffer_UnPack_Methods;
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 4:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "UnPack");
  return NULL;
}


static PyMethodDef PyvtkMaterialInterfaceCommBuffer_Methods[] = {
  {"Initialize", PyvtkMaterialInterfaceCommBuffer_Initialize, METH_VARARGS,
   "V.Initialize(int, int, int)\nC++: void Initialize(int procId, int nBlocks, vtkIdType nBytes)\n\nInitialize for outgoing comm.\n"},
  {"SizeHeader", PyvtkMaterialInterfaceCommBuffer_SizeHeader, METH_VARARGS,
   "V.SizeHeader(int)\nC++: void SizeHeader(int nBlocks)\n\nSet up for an incoming header.\n"},
  {"SizeBuffer", PyvtkMaterialInterfaceCommBuffer_SizeBuffer, METH_VARARGS,
   "V.SizeBuffer(int)\nC++: void SizeBuffer(vtkIdType nBytes)\nV.SizeBuffer()\nC++: void SizeBuffer()\n\nInitialize the buffer.\n"},
  {"Clear", PyvtkMaterialInterfaceCommBuffer_Clear, METH_VARARGS,
   "V.Clear()\nC++: void Clear()\n\nFree resources set to invalid state.\n"},
  {"GetBufferSize", PyvtkMaterialInterfaceCommBuffer_GetBufferSize, METH_VARARGS,
   "V.GetBufferSize() -> int\nC++: vtkIdType GetBufferSize()\n\nGet size in bytes of the buffer.\n"},
  {"GetBuffer", PyvtkMaterialInterfaceCommBuffer_GetBuffer, METH_VARARGS,
   "V.GetBuffer() -> string\nC++: char *GetBuffer()\n\nGet a pointer to the buffer\n"},
  {"GetEOD", PyvtkMaterialInterfaceCommBuffer_GetEOD, METH_VARARGS,
   "V.GetEOD() -> int\nC++: vtkIdType GetEOD()\n\nGet the byte that the next rerad or write will occur at\n"},
  {"GetHeaderSize", PyvtkMaterialInterfaceCommBuffer_GetHeaderSize, METH_VARARGS,
   "V.GetHeaderSize() -> int\nC++: int GetHeaderSize()\n\nGet size in bytes of the header.\n"},
  {"GetHeader", PyvtkMaterialInterfaceCommBuffer_GetHeader, METH_VARARGS,
   "V.GetHeader() -> (int, ...)\nC++: vtkIdType *GetHeader()\n\nGet a pointer to the header.\n"},
  {"Capacity", PyvtkMaterialInterfaceCommBuffer_Capacity, METH_VARARGS,
   "V.Capacity() -> int\nC++: vtkIdType Capacity()\n\nGet the total memory used.\n"},
  {"SetNumberOfTuples", PyvtkMaterialInterfaceCommBuffer_SetNumberOfTuples, METH_VARARGS,
   "V.SetNumberOfTuples(int, int)\nC++: void SetNumberOfTuples(int blockId, vtkIdType nFragments)\n\nSet the number of tuples for a given block.\n"},
  {"GetNumberOfTuples", PyvtkMaterialInterfaceCommBuffer_GetNumberOfTuples, METH_VARARGS,
   "V.GetNumberOfTuples(int) -> int\nC++: vtkIdType GetNumberOfTuples(int blockId)\n\nGet the number of tuples for a given block\n"},
  {"Pack", PyvtkMaterialInterfaceCommBuffer_Pack, METH_VARARGS,
   "V.Pack((float, ...), int, int) -> int\nC++: vtkIdType Pack(const double *pData, const int nComps,\n    const vtkIdType nTups)\nV.Pack((int, ...), int, int) -> int\nC++: vtkIdType Pack(const int *pData, const int nComps,\n    const vtkIdType nTups)\nV.Pack(vtkDoubleArray) -> int\nC++: vtkIdType Pack(vtkDoubleArray *da)\nV.Pack(vtkFloatArray) -> int\nC++: vtkIdType Pack(vtkFloatArray *da)\n\nAppend the data to the buffer. Return the index where the data\nwas written.\n"},
  {"InitUnpack", PyvtkMaterialInterfaceCommBuffer_InitUnpack, METH_VARARGS,
   "V.InitUnpack()\nC++: void InitUnpack()\n\nPrepare to un pack the buffer.\n"},
  {"UnPack", PyvtkMaterialInterfaceCommBuffer_UnPack, METH_VARARGS,
   "V.UnPack(vtkDoubleArray, int, int, bool) -> int\nC++: int UnPack(vtkDoubleArray *da, const int nComps,\n    const vtkIdType nTups, const bool copyFlag)\nV.UnPack(vtkFloatArray, int, int, bool) -> int\nC++: int UnPack(vtkFloatArray *da, const int nComps,\n    const vtkIdType nTups, const bool copyFlag)\n\nExtract the next array from the buffer\n"},
  {NULL, NULL, 0, NULL}
};


static PyObject *
PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_s1(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMaterialInterfaceCommBuffer");

  PyObject *result = NULL;

  if (ap.CheckArgCount(0))
  {
    vtkMaterialInterfaceCommBuffer *op = new vtkMaterialInterfaceCommBuffer();

    result = PyVTKSpecialObject_New("vtkMaterialInterfaceCommBuffer", op);
  }

  return result;
}

static PyObject *
PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkMaterialInterfaceCommBuffer");

  vtkMaterialInterfaceCommBuffer *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkMaterialInterfaceCommBuffer"))
  {
    vtkMaterialInterfaceCommBuffer *op = new vtkMaterialInterfaceCommBuffer(*temp0);

    result = PyVTKSpecialObject_New("vtkMaterialInterfaceCommBuffer", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_Methods[] = {
  {NULL, PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_s2, METH_VARARGS,
   "@W vtkMaterialInterfaceCommBuffer"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_s1(self, args);
    case 1:
      return PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkMaterialInterfaceCommBuffer");
  return NULL;
}


static PyObject *
PyvtkMaterialInterfaceCommBuffer_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return NULL;
  }

  return PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer(NULL, args);
}

static void PyvtkMaterialInterfaceCommBuffer_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkMaterialInterfaceCommBuffer *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkMaterialInterfaceCommBuffer_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkMaterialInterfaceCommBuffer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsDefaultPython.vtkMaterialInterfaceCommBuffer", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkMaterialInterfaceCommBuffer_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  PyvtkMaterialInterfaceCommBuffer_Hash, // tp_hash
  0, // tp_call
  0, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyvtkMaterialInterfaceCommBuffer_New, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkMaterialInterfaceCommBuffer_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkMaterialInterfaceCommBuffer(*static_cast<const vtkMaterialInterfaceCommBuffer*>(obj));
  }
  return 0;
}

extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMaterialInterfaceCommBuffer_TypeNew(); }

PyObject *PyvtkMaterialInterfaceCommBuffer_TypeNew()
{
  PyVTKSpecialType_Add(
    &PyvtkMaterialInterfaceCommBuffer_Type,
    PyvtkMaterialInterfaceCommBuffer_Methods,
    PyvtkMaterialInterfaceCommBuffer_vtkMaterialInterfaceCommBuffer_Methods,
    PyvtkMaterialInterfaceCommBuffer_Doc(), &PyvtkMaterialInterfaceCommBuffer_CCopy);

  PyTypeObject *pytype = &PyvtkMaterialInterfaceCommBuffer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 3; c++)
  {
    static const struct { const char *name; int value; }
      constants[3] = {
        { "PROC_ID", vtkMaterialInterfaceCommBuffer::PROC_ID },
        { "BUFFER_SIZE", vtkMaterialInterfaceCommBuffer::BUFFER_SIZE },
        { "DESCR_BASE", vtkMaterialInterfaceCommBuffer::DESCR_BASE },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMaterialInterfaceCommBuffer_Doc()
{
  static const char *docstring[] = {
    "vtkMaterialInterfaceCommBuffer - FIFO buffer.\n\n",
    "Can be used to send all attributes and ids in a single send. UnPack\nin the same order that you packed.\n\n",
    "V.vtkMaterialInterfaceCommBuffer()\nC++: vtkMaterialInterfaceCommBuffer()\nV.vtkMaterialInterfaceCommBuffer(vtkMaterialInterfaceCommBuffer)\nC++: vtkMaterialInterfaceCommBuffer(\n    const &vtkMaterialInterfaceCommBuffer)\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMaterialInterfaceCommBuffer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMaterialInterfaceCommBuffer_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkMaterialInterfaceCommBuffer", o) != 0)
  {
    Py_DECREF(o);
  }

}

