// python wrapper for vtkPKMeansStatistics
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPKMeansStatistics.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPKMeansStatistics(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPKMeansStatistics_ClassNew(); }

#ifndef DECLARED_PyvtkKMeansStatistics_ClassNew
extern "C" { PyObject *PyvtkKMeansStatistics_ClassNew(); }
#define DECLARED_PyvtkKMeansStatistics_ClassNew
#endif

static const char **PyvtkPKMeansStatistics_Doc();


static PyObject *
PyvtkPKMeansStatistics_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPKMeansStatistics::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPKMeansStatistics::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPKMeansStatistics *tempr = vtkPKMeansStatistics::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPKMeansStatistics *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPKMeansStatistics::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPKMeansStatistics::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPKMeansStatistics::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_UpdateClusterCenters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateClusterCenters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  vtkTable *temp0 = NULL;
  vtkTable *temp1 = NULL;
  vtkIdTypeArray *temp2 = NULL;
  vtkIdTypeArray *temp3 = NULL;
  vtkDoubleArray *temp4 = NULL;
  vtkIdTypeArray *temp5 = NULL;
  vtkIdTypeArray *temp6 = NULL;
  vtkIntArray *temp7 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(8) &&
      ap.GetVTKObject(temp0, "vtkTable") &&
      ap.GetVTKObject(temp1, "vtkTable") &&
      ap.GetVTKObject(temp2, "vtkIdTypeArray") &&
      ap.GetVTKObject(temp3, "vtkIdTypeArray") &&
      ap.GetVTKObject(temp4, "vtkDoubleArray") &&
      ap.GetVTKObject(temp5, "vtkIdTypeArray") &&
      ap.GetVTKObject(temp6, "vtkIdTypeArray") &&
      ap.GetVTKObject(temp7, "vtkIntArray"))
  {
    if (ap.IsBound())
    {
      op->UpdateClusterCenters(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7);
    }
    else
    {
      op->vtkPKMeansStatistics::UpdateClusterCenters(temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_GetTotalNumberOfObservations(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTotalNumberOfObservations");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetTotalNumberOfObservations(temp0) :
      op->vtkPKMeansStatistics::GetTotalNumberOfObservations(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPKMeansStatistics_CreateInitialClusterCenters(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateInitialClusterCenters");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPKMeansStatistics *op = static_cast<vtkPKMeansStatistics *>(vp);

  vtkIdType temp0;
  vtkIdTypeArray *temp1 = NULL;
  vtkTable *temp2 = NULL;
  vtkTable *temp3 = NULL;
  vtkTable *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkIdTypeArray") &&
      ap.GetVTKObject(temp2, "vtkTable") &&
      ap.GetVTKObject(temp3, "vtkTable") &&
      ap.GetVTKObject(temp4, "vtkTable"))
  {
    if (ap.IsBound())
    {
      op->CreateInitialClusterCenters(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkPKMeansStatistics::CreateInitialClusterCenters(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPKMeansStatistics_Methods[] = {
  {"IsTypeOf", PyvtkPKMeansStatistics_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPKMeansStatistics_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPKMeansStatistics_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPKMeansStatistics\nC++: static vtkPKMeansStatistics *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPKMeansStatistics_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPKMeansStatistics\nC++: vtkPKMeansStatistics *NewInstance()\n\n"},
  {"SetController", PyvtkPKMeansStatistics_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: virtual void SetController(vtkMultiProcessController *)\n\nGet/Set the multiprocess controller. If no controller is set,\nsingle process is assumed.\n"},
  {"GetController", PyvtkPKMeansStatistics_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\nGet/Set the multiprocess controller. If no controller is set,\nsingle process is assumed.\n"},
  {"UpdateClusterCenters", PyvtkPKMeansStatistics_UpdateClusterCenters, METH_VARARGS,
   "V.UpdateClusterCenters(vtkTable, vtkTable, vtkIdTypeArray,\n    vtkIdTypeArray, vtkDoubleArray, vtkIdTypeArray,\n    vtkIdTypeArray, vtkIntArray)\nC++: virtual void UpdateClusterCenters(\n    vtkTable *newClusterElements, vtkTable *curClusterElements,\n    vtkIdTypeArray *numMembershipChanges,\n    vtkIdTypeArray *numElementsInCluster, vtkDoubleArray *error,\n    vtkIdTypeArray *startRunID, vtkIdTypeArray *endRunID,\n    vtkIntArray *computeRun)\n\nSubroutine to update new cluster centers from the old centers.\n"},
  {"GetTotalNumberOfObservations", PyvtkPKMeansStatistics_GetTotalNumberOfObservations, METH_VARARGS,
   "V.GetTotalNumberOfObservations(int) -> int\nC++: virtual vtkIdType GetTotalNumberOfObservations(\n    vtkIdType numObservations)\n\nSubroutine to get the total number of data objects.\n"},
  {"CreateInitialClusterCenters", PyvtkPKMeansStatistics_CreateInitialClusterCenters, METH_VARARGS,
   "V.CreateInitialClusterCenters(int, vtkIdTypeArray, vtkTable,\n    vtkTable, vtkTable)\nC++: virtual void CreateInitialClusterCenters(\n    vtkIdType numToAllocate, vtkIdTypeArray *numberOfClusters,\n    vtkTable *inData, vtkTable *curClusterElements,\n    vtkTable *newClusterElements)\n\nSubroutine to initialize cluster centerss if not provided by the\nuser.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPKMeansStatistics_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelStatisticsPython.vtkPKMeansStatistics", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPKMeansStatistics_StaticNew()
{
  return vtkPKMeansStatistics::New();
}

PyObject *PyvtkPKMeansStatistics_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPKMeansStatistics_Type, PyvtkPKMeansStatistics_Methods,
    "vtkPKMeansStatistics",
    PyvtkPKMeansStatistics_Doc(), &PyvtkPKMeansStatistics_StaticNew);

  PyTypeObject *pytype = &PyvtkPKMeansStatistics_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkKMeansStatistics_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPKMeansStatistics_Doc()
{
  static const char *docstring[] = {
    "vtkPKMeansStatistics - no description provided.\n\n",
    "Superclass: vtkKMeansStatistics\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPKMeansStatistics(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPKMeansStatistics_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPKMeansStatistics", o) != 0)
  {
    Py_DECREF(o);
  }

}

