// python wrapper for vtkPVContextView
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVContextView.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVContextView(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVContextView_ClassNew(); }

#ifndef DECLARED_PyvtkPVView_ClassNew
extern "C" { PyObject *PyvtkPVView_ClassNew(); }
#define DECLARED_PyvtkPVView_ClassNew
#endif

static const char **PyvtkPVContextView_Doc();


static PyObject *
PyvtkPVContextView_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVContextView::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVContextView::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVContextView *tempr = vtkPVContextView::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVContextView *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVContextView::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_StillRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StillRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StillRender();
    }
    else
    {
      op->vtkPVContextView::StillRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_InteractiveRender(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InteractiveRender");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InteractiveRender();
    }
    else
    {
      op->vtkPVContextView::InteractiveRender();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetContextView(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContextView");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkContextView *tempr = (ap.IsBound() ?
      op->GetContextView() :
      op->vtkPVContextView::GetContextView());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetContextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetContextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(0))
  {
    vtkAbstractContextItem *tempr = op->GetContextItem();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetRenderWindow(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRenderWindow");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderWindow *tempr = (ap.IsBound() ?
      op->GetRenderWindow() :
      op->vtkPVContextView::GetRenderWindow());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_SetupInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetupInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  vtkRenderWindowInteractor *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderWindowInteractor"))
  {
    if (ap.IsBound())
    {
      op->SetupInteractor(temp0);
    }
    else
    {
      op->vtkPVContextView::SetupInteractor(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetInteractor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInteractor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderWindowInteractor *tempr = (ap.IsBound() ?
      op->GetInteractor() :
      op->vtkPVContextView::GetInteractor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->Initialize(temp0);
    }
    else
    {
      op->vtkPVContextView::Initialize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkPVContextView::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_SetUseOffscreenRenderingForScreenshots(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOffscreenRenderingForScreenshots");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOffscreenRenderingForScreenshots(temp0);
    }
    else
    {
      op->vtkPVContextView::SetUseOffscreenRenderingForScreenshots(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_UseOffscreenRenderingForScreenshotsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOffscreenRenderingForScreenshotsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOffscreenRenderingForScreenshotsOn();
    }
    else
    {
      op->vtkPVContextView::UseOffscreenRenderingForScreenshotsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_UseOffscreenRenderingForScreenshotsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOffscreenRenderingForScreenshotsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOffscreenRenderingForScreenshotsOff();
    }
    else
    {
      op->vtkPVContextView::UseOffscreenRenderingForScreenshotsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetUseOffscreenRenderingForScreenshots(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseOffscreenRenderingForScreenshots");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseOffscreenRenderingForScreenshots() :
      op->vtkPVContextView::GetUseOffscreenRenderingForScreenshots());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_SetUseOffscreenRendering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseOffscreenRendering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseOffscreenRendering(temp0);
    }
    else
    {
      op->vtkPVContextView::SetUseOffscreenRendering(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_UseOffscreenRenderingOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOffscreenRenderingOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOffscreenRenderingOn();
    }
    else
    {
      op->vtkPVContextView::UseOffscreenRenderingOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_UseOffscreenRenderingOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseOffscreenRenderingOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseOffscreenRenderingOff();
    }
    else
    {
      op->vtkPVContextView::UseOffscreenRenderingOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetUseOffscreenRendering(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseOffscreenRendering");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseOffscreenRendering() :
      op->vtkPVContextView::GetUseOffscreenRendering());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_SetSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  vtkChartRepresentation *temp0 = NULL;
  vtkSelection *temp1 = NULL;
  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkChartRepresentation") &&
      ap.GetVTKObject(temp1, "vtkSelection"))
  {
    op->SetSelection(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_GetSelection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSelection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSelection *tempr = (ap.IsBound() ?
      op->GetSelection() :
      op->vtkPVContextView::GetSelection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVContextView_Export(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Export");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVContextView *op = static_cast<vtkPVContextView *>(vp);

  vtkCSVExporter *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkCSVExporter"))
  {
    bool tempr = (ap.IsBound() ?
      op->Export(temp0) :
      op->vtkPVContextView::Export(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVContextView_Methods[] = {
  {"IsTypeOf", PyvtkPVContextView_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVContextView_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVContextView_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVContextView\nC++: static vtkPVContextView *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVContextView_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVContextView\nC++: vtkPVContextView *NewInstance()\n\n"},
  {"StillRender", PyvtkPVContextView_StillRender, METH_VARARGS,
   "V.StillRender()\nC++: virtual void StillRender()\n\nTriggers a high-resolution render.\n\note CallOnAllProcesses\n"},
  {"InteractiveRender", PyvtkPVContextView_InteractiveRender, METH_VARARGS,
   "V.InteractiveRender()\nC++: virtual void InteractiveRender()\n\nTriggers a interactive render. Based on the settings on the view,\nthis may result in a low-resolution rendering or a simplified\ngeometry rendering.\n\note CallOnAllProcesses\n"},
  {"GetContextView", PyvtkPVContextView_GetContextView, METH_VARARGS,
   "V.GetContextView() -> vtkContextView\nC++: virtual vtkContextView *GetContextView()\n\nGet the context view.\n"},
  {"GetContextItem", PyvtkPVContextView_GetContextItem, METH_VARARGS,
   "V.GetContextItem() -> vtkAbstractContextItem\nC++: virtual vtkAbstractContextItem *GetContextItem()\n\nGet the context item.\n"},
  {"GetRenderWindow", PyvtkPVContextView_GetRenderWindow, METH_VARARGS,
   "V.GetRenderWindow() -> vtkRenderWindow\nC++: virtual vtkRenderWindow *GetRenderWindow()\n\n"},
  {"SetupInteractor", PyvtkPVContextView_SetupInteractor, METH_VARARGS,
   "V.SetupInteractor(vtkRenderWindowInteractor)\nC++: virtual void SetupInteractor(vtkRenderWindowInteractor *)\n\nSet the interactor. Client applications must set the interactor\nto enable interactivity. Note this method will also change the\ninteractor styles set on the interactor.\n"},
  {"GetInteractor", PyvtkPVContextView_GetInteractor, METH_VARARGS,
   "V.GetInteractor() -> vtkRenderWindowInteractor\nC++: vtkRenderWindowInteractor *GetInteractor()\n\nSet the interactor. Client applications must set the interactor\nto enable interactivity. Note this method will also change the\ninteractor styles set on the interactor.\n"},
  {"Initialize", PyvtkPVContextView_Initialize, METH_VARARGS,
   "V.Initialize(int)\nC++: virtual void Initialize(unsigned int id)\n\nInitialize the view with an identifier. Unless noted otherwise,\nthis method must be called before calling any other methods on\nthis class.\n\note CallOnAllProcesses\n"},
  {"Update", PyvtkPVContextView_Update, METH_VARARGS,
   "V.Update()\nC++: virtual void Update()\n\nOverridden to ensure that in multi-client configurations, same\nset of representations are \"dirty\" on all processes to avoid race\nconditions.\n"},
  {"SetUseOffscreenRenderingForScreenshots", PyvtkPVContextView_SetUseOffscreenRenderingForScreenshots, METH_VARARGS,
   "V.SetUseOffscreenRenderingForScreenshots(bool)\nC++: virtual void SetUseOffscreenRenderingForScreenshots(\n    bool _arg)\n\nSet or get whether offscreen rendering should be used during\nCaptureWindow calls. On Apple machines, this flag has no effect.\n"},
  {"UseOffscreenRenderingForScreenshotsOn", PyvtkPVContextView_UseOffscreenRenderingForScreenshotsOn, METH_VARARGS,
   "V.UseOffscreenRenderingForScreenshotsOn()\nC++: virtual void UseOffscreenRenderingForScreenshotsOn()\n\nSet or get whether offscreen rendering should be used during\nCaptureWindow calls. On Apple machines, this flag has no effect.\n"},
  {"UseOffscreenRenderingForScreenshotsOff", PyvtkPVContextView_UseOffscreenRenderingForScreenshotsOff, METH_VARARGS,
   "V.UseOffscreenRenderingForScreenshotsOff()\nC++: virtual void UseOffscreenRenderingForScreenshotsOff()\n\nSet or get whether offscreen rendering should be used during\nCaptureWindow calls. On Apple machines, this flag has no effect.\n"},
  {"GetUseOffscreenRenderingForScreenshots", PyvtkPVContextView_GetUseOffscreenRenderingForScreenshots, METH_VARARGS,
   "V.GetUseOffscreenRenderingForScreenshots() -> bool\nC++: virtual bool GetUseOffscreenRenderingForScreenshots()\n\nSet or get whether offscreen rendering should be used during\nCaptureWindow calls. On Apple machines, this flag has no effect.\n"},
  {"SetUseOffscreenRendering", PyvtkPVContextView_SetUseOffscreenRendering, METH_VARARGS,
   "V.SetUseOffscreenRendering(bool)\nC++: virtual void SetUseOffscreenRendering(bool)\n\nGet/Set whether to use offscreen rendering for all rendering.\nThis is merely a suggestion. If --use-offscreen-rendering command\nline option is specified, then setting this flag to 0 on that\nprocess has no effect. Setting it to true, however, will ensure\nthat even is\n--use-offscreen-rendering is not specified, it will use offscreen\n    rendering.\n"},
  {"UseOffscreenRenderingOn", PyvtkPVContextView_UseOffscreenRenderingOn, METH_VARARGS,
   "V.UseOffscreenRenderingOn()\nC++: virtual void UseOffscreenRenderingOn()\n\nGet/Set whether to use offscreen rendering for all rendering.\nThis is merely a suggestion. If --use-offscreen-rendering command\nline option is specified, then setting this flag to 0 on that\nprocess has no effect. Setting it to true, however, will ensure\nthat even is\n--use-offscreen-rendering is not specified, it will use offscreen\n    rendering.\n"},
  {"UseOffscreenRenderingOff", PyvtkPVContextView_UseOffscreenRenderingOff, METH_VARARGS,
   "V.UseOffscreenRenderingOff()\nC++: virtual void UseOffscreenRenderingOff()\n\nGet/Set whether to use offscreen rendering for all rendering.\nThis is merely a suggestion. If --use-offscreen-rendering command\nline option is specified, then setting this flag to 0 on that\nprocess has no effect. Setting it to true, however, will ensure\nthat even is\n--use-offscreen-rendering is not specified, it will use offscreen\n    rendering.\n"},
  {"GetUseOffscreenRendering", PyvtkPVContextView_GetUseOffscreenRendering, METH_VARARGS,
   "V.GetUseOffscreenRendering() -> bool\nC++: virtual bool GetUseOffscreenRendering()\n\nGet/Set whether to use offscreen rendering for all rendering.\nThis is merely a suggestion. If --use-offscreen-rendering command\nline option is specified, then setting this flag to 0 on that\nprocess has no effect. Setting it to true, however, will ensure\nthat even is\n--use-offscreen-rendering is not specified, it will use offscreen\n    rendering.\n"},
  {"SetSelection", PyvtkPVContextView_SetSelection, METH_VARARGS,
   "V.SetSelection(vtkChartRepresentation, vtkSelection)\nC++: virtual void SetSelection(vtkChartRepresentation *repr,\n    vtkSelection *selection)\n\nRepresentations can use this method to set the selection for a\nparticular representation. Subclasses override this method to\npass on the selection to the chart using annotation link. Note\nthis is meant to pass selection for the local process alone. The\nview does not manage data movement for the selection.\n"},
  {"GetSelection", PyvtkPVContextView_GetSelection, METH_VARARGS,
   "V.GetSelection() -> vtkSelection\nC++: vtkSelection *GetSelection()\n\nGet the current selection created in the view. This will call\nthis->MapSelectionToInput() to transform the selection every time\na new selection is available. Subclasses should override\nMapSelectionToInput() to convert the selection, as appropriate.\n"},
  {"Export", PyvtkPVContextView_Export, METH_VARARGS,
   "V.Export(vtkCSVExporter) -> bool\nC++: virtual bool Export(vtkCSVExporter *exporter)\n\nExport the contents of this view using the exporter. Called\nvtkChartRepresentation::Export() on all visible representations.\nThis is expected to called only on the client side after a\nrender/update. Thus all data is expected to available on the\nlocal process.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVContextView_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkPVContextView", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPVContextView_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVContextView_Type, PyvtkPVContextView_Methods,
    "vtkPVContextView",
    PyvtkPVContextView_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPVContextView_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVView_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVContextView_Doc()
{
  static const char *docstring[] = {
    "vtkPVContextView - vtkPVContextView adopts vtkContextView so that it\ncan be used in ParaView configurations.\n\n",
    "Superclass: vtkPVView\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVContextView(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVContextView_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVContextView", o) != 0)
  {
    Py_DECREF(o);
  }

}

