// python wrapper for vtkPVDataInformationHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVDataInformationHelper.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVDataInformationHelper(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVDataInformationHelper_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPVDataInformationHelper_Doc();


static PyObject *
PyvtkPVDataInformationHelper_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVDataInformationHelper::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDataInformationHelper_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDataInformationHelper *op = static_cast<vtkPVDataInformationHelper *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVDataInformationHelper::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDataInformationHelper_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVDataInformationHelper *tempr = vtkPVDataInformationHelper::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVDataInformationHelper_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDataInformationHelper *op = static_cast<vtkPVDataInformationHelper *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDataInformationHelper *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVDataInformationHelper::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVDataInformationHelper_CopyFromDataObject(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CopyFromDataObject");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDataInformationHelper *op = static_cast<vtkPVDataInformationHelper *>(vp);

  vtkPVDataInformation *temp0 = NULL;
  vtkDataObject *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkPVDataInformation") &&
      ap.GetVTKObject(temp1, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->CopyFromDataObject(temp0, temp1);
    }
    else
    {
      op->vtkPVDataInformationHelper::CopyFromDataObject(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVDataInformationHelper_GetPrettyDataTypeString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPrettyDataTypeString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVDataInformationHelper *op = static_cast<vtkPVDataInformationHelper *>(vp);

  PyObject *result = NULL;

  if (op && !ap.IsPureVirtual() && ap.CheckArgCount(0))
  {
    const char *tempr = op->GetPrettyDataTypeString();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVDataInformationHelper_Methods[] = {
  {"IsTypeOf", PyvtkPVDataInformationHelper_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVDataInformationHelper_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVDataInformationHelper_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVDataInformationHelper\nC++: static vtkPVDataInformationHelper *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVDataInformationHelper_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVDataInformationHelper\nC++: vtkPVDataInformationHelper *NewInstance()\n\n"},
  {"CopyFromDataObject", PyvtkPVDataInformationHelper_CopyFromDataObject, METH_VARARGS,
   "V.CopyFromDataObject(vtkPVDataInformation, vtkDataObject)\nC++: void CopyFromDataObject(vtkPVDataInformation *self,\n    vtkDataObject *data)\n\nThis class is a friend of PVDI, so the work of copying into self\nhappens here.\n"},
  {"GetPrettyDataTypeString", PyvtkPVDataInformationHelper_GetPrettyDataTypeString, METH_VARARGS,
   "V.GetPrettyDataTypeString() -> string\nC++: virtual const char *GetPrettyDataTypeString()\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVDataInformationHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreCorePython.vtkPVDataInformationHelper", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPVDataInformationHelper_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVDataInformationHelper_Type, PyvtkPVDataInformationHelper_Methods,
    "vtkPVDataInformationHelper",
    PyvtkPVDataInformationHelper_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPVDataInformationHelper_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVDataInformationHelper_Doc()
{
  static const char *docstring[] = {
    "vtkPVDataInformationHelper - allows extension of types that\n\n",
    "Superclass: vtkObject\n\n",
    "PVDataInformation can handle\n\nPlugins can subclass this and call\nvtkPVDataInformation::RegisterHelper() in order to allow\nvtkPVDataInformation (and thus ParaView) to handle new data types.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVDataInformationHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVDataInformationHelper_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVDataInformationHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

