// python wrapper for vtkPVMultiServerDataSource
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVMultiServerDataSource.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVMultiServerDataSource(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVMultiServerDataSource_ClassNew(); }

#ifndef DECLARED_PyvtkDataObjectAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataObjectAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataObjectAlgorithm_ClassNew
#endif

static const char **PyvtkPVMultiServerDataSource_Doc();


static PyObject *
PyvtkPVMultiServerDataSource_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVMultiServerDataSource::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVMultiServerDataSource_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVMultiServerDataSource *op = static_cast<vtkPVMultiServerDataSource *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVMultiServerDataSource::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVMultiServerDataSource_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVMultiServerDataSource *tempr = vtkPVMultiServerDataSource::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVMultiServerDataSource_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVMultiServerDataSource *op = static_cast<vtkPVMultiServerDataSource *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVMultiServerDataSource *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVMultiServerDataSource::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVMultiServerDataSource_SetExternalProxy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetExternalProxy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVMultiServerDataSource *op = static_cast<vtkPVMultiServerDataSource *>(vp);

  vtkSMSourceProxy *temp0 = NULL;
  int temp1 = 0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkSMSourceProxy") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetExternalProxy(temp0, temp1);
    }
    else
    {
      op->vtkPVMultiServerDataSource::SetExternalProxy(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVMultiServerDataSource_FetchData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FetchData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVMultiServerDataSource *op = static_cast<vtkPVMultiServerDataSource *>(vp);

  vtkDataObject *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataObject"))
  {
    if (ap.IsBound())
    {
      op->FetchData(temp0);
    }
    else
    {
      op->vtkPVMultiServerDataSource::FetchData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPVMultiServerDataSource_Methods[] = {
  {"IsTypeOf", PyvtkPVMultiServerDataSource_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVMultiServerDataSource_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVMultiServerDataSource_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVMultiServerDataSource\nC++: static vtkPVMultiServerDataSource *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVMultiServerDataSource_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVMultiServerDataSource\nC++: vtkPVMultiServerDataSource *NewInstance()\n\n"},
  {"SetExternalProxy", PyvtkPVMultiServerDataSource_SetExternalProxy, METH_VARARGS,
   "V.SetExternalProxy(vtkSMSourceProxy, int)\nC++: virtual void SetExternalProxy(\n    vtkSMSourceProxy *proxyFromAnotherServer, int portNumber=0)\n\nBind vtk object with a given external proxy\n"},
  {"FetchData", PyvtkPVMultiServerDataSource_FetchData, METH_VARARGS,
   "V.FetchData(vtkDataObject)\nC++: virtual void FetchData(vtkDataObject *dataObjectToFill)\n\nMethod that need to be called when the data has changed and need\nto be updated...\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVMultiServerDataSource_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerDefaultPython.vtkPVMultiServerDataSource", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVMultiServerDataSource_StaticNew()
{
  return vtkPVMultiServerDataSource::New();
}

PyObject *PyvtkPVMultiServerDataSource_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVMultiServerDataSource_Type, PyvtkPVMultiServerDataSource_Methods,
    "vtkPVMultiServerDataSource",
    PyvtkPVMultiServerDataSource_Doc(), &PyvtkPVMultiServerDataSource_StaticNew);

  PyTypeObject *pytype = &PyvtkPVMultiServerDataSource_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataObjectAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVMultiServerDataSource_Doc()
{
  static const char *docstring[] = {
    "vtkPVMultiServerDataSource - VTK class that handle the fetch of\nremote data\n\n",
    "Superclass: vtkDataObjectAlgorithm\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVMultiServerDataSource(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVMultiServerDataSource_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVMultiServerDataSource", o) != 0)
  {
    Py_DECREF(o);
  }

}

