// python wrapper for vtkPVPostFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkPVPostFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVPostFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVPostFilter_ClassNew(); }

#ifndef DECLARED_PyvtkDataObjectAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDataObjectAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDataObjectAlgorithm_ClassNew
#endif

static const char **PyvtkPVPostFilter_Doc();


static PyObject *
PyvtkPVPostFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVPostFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPostFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVPostFilter *op = static_cast<vtkPVPostFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVPostFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPostFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVPostFilter *tempr = vtkPVPostFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPostFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVPostFilter *op = static_cast<vtkPVPostFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVPostFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVPostFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVPostFilter_CreateDefaultExecutive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateDefaultExecutive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVPostFilter *op = static_cast<vtkPVPostFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkExecutive *tempr = (ap.IsBound() ?
      op->CreateDefaultExecutive() :
      op->vtkPVPostFilter::CreateDefaultExecutive());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVPostFilter_DefaultComponentName(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "DefaultComponentName");

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    vtkStdString tempr = vtkPVPostFilter::DefaultComponentName(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVPostFilter_Methods[] = {
  {"IsTypeOf", PyvtkPVPostFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVPostFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVPostFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVPostFilter\nC++: static vtkPVPostFilter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVPostFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVPostFilter\nC++: vtkPVPostFilter *NewInstance()\n\n"},
  {"CreateDefaultExecutive", PyvtkPVPostFilter_CreateDefaultExecutive, METH_VARARGS,
   "V.CreateDefaultExecutive() -> vtkExecutive\nC++: vtkExecutive *CreateDefaultExecutive()\n\nWe need to override this method because the composite data\npipeline is not what we want. Instead we need the\nPVCompositeDataPipeline so that we can figure out what we\nconversion(s) we need to do\n"},
  {"DefaultComponentName", PyvtkPVPostFilter_DefaultComponentName, METH_VARARGS,
   "V.DefaultComponentName(int, int) -> string\nC++: static vtkStdString DefaultComponentName(int componentNumber,\n     int componentCount)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVPostFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVVTKExtensionsCorePython.vtkPVPostFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVPostFilter_StaticNew()
{
  return vtkPVPostFilter::New();
}

PyObject *PyvtkPVPostFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVPostFilter_Type, PyvtkPVPostFilter_Methods,
    "vtkPVPostFilter",
    PyvtkPVPostFilter_Doc(), &PyvtkPVPostFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkPVPostFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataObjectAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVPostFilter_Doc()
{
  static const char *docstring[] = {
    "vtkPVPostFilter - Post Filter for on demand conversion\n\n",
    "Superclass: vtkDataObjectAlgorithm\n\n",
    "vtkPVPostFilter is a filter used for on demand conversion of\nproperties Provide the ability to automatically use a vector\ncomponent as a scalar input property.\n\n\n Interpolate cell centered data to point data, and the inverse if\nneeded by the filter.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVPostFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVPostFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVPostFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

