// python wrapper for vtkPVSessionServer
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVSessionServer.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVSessionServer(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPVSessionServer_ClassNew(); }

#ifndef DECLARED_PyvtkPVSessionBase_ClassNew
extern "C" { PyObject *PyvtkPVSessionBase_ClassNew(); }
#define DECLARED_PyvtkPVSessionBase_ClassNew
#endif

static const char **PyvtkPVSessionServer_Doc();


static PyObject *
PyvtkPVSessionServer_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVSessionServer::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVSessionServer::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVSessionServer *tempr = vtkPVSessionServer::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVSessionServer *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVSessionServer::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_Connect_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Connect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->Connect(temp0) :
      op->vtkPVSessionServer::Connect(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkPVSessionServer_Connect_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Connect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->Connect() :
      op->vtkPVSessionServer::Connect());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkPVSessionServer_Connect(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 1:
      return PyvtkPVSessionServer_Connect_s1(self, args);
    case 0:
      return PyvtkPVSessionServer_Connect_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "Connect");
  return NULL;
}



static PyObject *
PyvtkPVSessionServer_GetIsAlive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsAlive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsAlive() :
      op->vtkPVSessionServer::GetIsAlive());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_MultipleConnectionOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MultipleConnectionOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MultipleConnectionOn();
    }
    else
    {
      op->vtkPVSessionServer::MultipleConnectionOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_MultipleConnectionOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MultipleConnectionOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MultipleConnectionOff();
    }
    else
    {
      op->vtkPVSessionServer::MultipleConnectionOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_SetMultipleConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMultipleConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMultipleConnection(temp0);
    }
    else
    {
      op->vtkPVSessionServer::SetMultipleConnection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_GetMultipleConnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMultipleConnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetMultipleConnection() :
      op->vtkPVSessionServer::GetMultipleConnection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_OnClientServerMessageRMI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnClientServerMessageRMI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  void  *temp0 = NULL;
  Py_buffer pbuf0 = VTK_PYBUFFER_INITIALIZER;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetBuffer(temp0, &pbuf0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->OnClientServerMessageRMI(temp0, temp1);
    }
    else
    {
      op->vtkPVSessionServer::OnClientServerMessageRMI(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf0.obj != 0)
  {
    PyBuffer_Release(&pbuf0);
  }
#endif
  return result;
}


static PyObject *
PyvtkPVSessionServer_OnCloseSessionRMI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnCloseSessionRMI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnCloseSessionRMI();
    }
    else
    {
      op->vtkPVSessionServer::OnCloseSessionRMI();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_NotifyAllClients(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NotifyAllClients");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  vtkSMMessage *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMMessage"))
  {
    if (ap.IsBound())
    {
      op->NotifyAllClients(temp0);
    }
    else
    {
      op->vtkPVSessionServer::NotifyAllClients(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVSessionServer_NotifyOtherClients(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NotifyOtherClients");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVSessionServer *op = static_cast<vtkPVSessionServer *>(vp);

  vtkSMMessage *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMMessage"))
  {
    if (ap.IsBound())
    {
      op->NotifyOtherClients(temp0);
    }
    else
    {
      op->vtkPVSessionServer::NotifyOtherClients(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPVSessionServer_Methods[] = {
  {"IsTypeOf", PyvtkPVSessionServer_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkPVSessionServer_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkPVSessionServer_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkPVSessionServer\nC++: static vtkPVSessionServer *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVSessionServer_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVSessionServer\nC++: vtkPVSessionServer *NewInstance()\n\n"},
  {"Connect", PyvtkPVSessionServer_Connect, METH_VARARGS,
   "V.Connect(string) -> bool\nC++: virtual bool Connect(const char *url)\nV.Connect() -> bool\nC++: bool Connect()\n\nConnects a remote server. URL can be of the following format:\ncs://<pvserver-host>:<pvserver-port>\ncdsrs://<pvdataserver-host>:<pvdataserver-port>/<pvrenderserver-ho\nst>:<pvrenderserver-port> In both cases the port is optional.\nWhen not provided default pvserver/pvdataserver port // is 11111,\nwhile default pvrenderserver port is 22221. For reverse connect\ni.e. the client waits for the server to connect back, simply add\n\"rc\" to the protocol e.g. csrc://<pvserver-host>:<pvserver-port>\ncdsrsrc://<pvdataserver-host>:<pvdataserver-port>/<pvrenderserver-\nhost>:<pvrenderserver-port> In this case, the hostname is\nirrelevant and is ignored.\n"},
  {"GetIsAlive", PyvtkPVSessionServer_GetIsAlive, METH_VARARGS,
   "V.GetIsAlive() -> bool\nC++: virtual bool GetIsAlive()\n\nReturns true is this session is active/alive/valid.\n"},
  {"MultipleConnectionOn", PyvtkPVSessionServer_MultipleConnectionOn, METH_VARARGS,
   "V.MultipleConnectionOn()\nC++: virtual void MultipleConnectionOn()\n\nEnable or Disable multi-connection support. The\nMultipleConnection is only used inside the DATA_SERVER to support\nseveral clients to connect to it. By default we allow\ncollaboration (this->MultipleConnection = true)\n"},
  {"MultipleConnectionOff", PyvtkPVSessionServer_MultipleConnectionOff, METH_VARARGS,
   "V.MultipleConnectionOff()\nC++: virtual void MultipleConnectionOff()\n\nEnable or Disable multi-connection support. The\nMultipleConnection is only used inside the DATA_SERVER to support\nseveral clients to connect to it. By default we allow\ncollaboration (this->MultipleConnection = true)\n"},
  {"SetMultipleConnection", PyvtkPVSessionServer_SetMultipleConnection, METH_VARARGS,
   "V.SetMultipleConnection(bool)\nC++: virtual void SetMultipleConnection(bool _arg)\n\nEnable or Disable multi-connection support. The\nMultipleConnection is only used inside the DATA_SERVER to support\nseveral clients to connect to it. By default we allow\ncollaboration (this->MultipleConnection = true)\n"},
  {"GetMultipleConnection", PyvtkPVSessionServer_GetMultipleConnection, METH_VARARGS,
   "V.GetMultipleConnection() -> bool\nC++: virtual bool GetMultipleConnection()\n\nEnable or Disable multi-connection support. The\nMultipleConnection is only used inside the DATA_SERVER to support\nseveral clients to connect to it. By default we allow\ncollaboration (this->MultipleConnection = true)\n"},
  {"OnClientServerMessageRMI", PyvtkPVSessionServer_OnClientServerMessageRMI, METH_VARARGS,
   "V.OnClientServerMessageRMI(void, int)\nC++: void OnClientServerMessageRMI(void *message,\n    int message_length)\n\n"},
  {"OnCloseSessionRMI", PyvtkPVSessionServer_OnCloseSessionRMI, METH_VARARGS,
   "V.OnCloseSessionRMI()\nC++: void OnCloseSessionRMI()\n\n"},
  {"NotifyAllClients", PyvtkPVSessionServer_NotifyAllClients, METH_VARARGS,
   "V.NotifyAllClients(vtkSMMessage)\nC++: virtual void NotifyAllClients(const vtkSMMessage *)\n\nSends the message to all clients.\n"},
  {"NotifyOtherClients", PyvtkPVSessionServer_NotifyOtherClients, METH_VARARGS,
   "V.NotifyOtherClients(vtkSMMessage)\nC++: virtual void NotifyOtherClients(const vtkSMMessage *)\n\nSends the message to all but the active client-session.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPVSessionServer_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerImplementationCorePython.vtkPVSessionServer", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVSessionServer_StaticNew()
{
  return vtkPVSessionServer::New();
}

PyObject *PyvtkPVSessionServer_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPVSessionServer_Type, PyvtkPVSessionServer_Methods,
    "vtkPVSessionServer",
    PyvtkPVSessionServer_Doc(), &PyvtkPVSessionServer_StaticNew);

  PyTypeObject *pytype = &PyvtkPVSessionServer_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVSessionBase_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  for (int c = 0; c < 14; c++)
  {
    static const struct { const char *name; int value; }
      constants[14] = {
        { "PUSH", vtkPVSessionServer::PUSH },
        { "PULL", vtkPVSessionServer::PULL },
        { "EXECUTE_STREAM", vtkPVSessionServer::EXECUTE_STREAM },
        { "GATHER_INFORMATION", vtkPVSessionServer::GATHER_INFORMATION },
        { "REGISTER_SI", vtkPVSessionServer::REGISTER_SI },
        { "UNREGISTER_SI", vtkPVSessionServer::UNREGISTER_SI },
        { "LAST_RESULT", vtkPVSessionServer::LAST_RESULT },
        { "SERVER_NOTIFICATION_MESSAGE_RMI", vtkPVSessionServer::SERVER_NOTIFICATION_MESSAGE_RMI },
        { "CLIENT_SERVER_MESSAGE_RMI", vtkPVSessionServer::CLIENT_SERVER_MESSAGE_RMI },
        { "CLOSE_SESSION", vtkPVSessionServer::CLOSE_SESSION },
        { "REPLY_GATHER_INFORMATION_TAG", vtkPVSessionServer::REPLY_GATHER_INFORMATION_TAG },
        { "REPLY_PULL", vtkPVSessionServer::REPLY_PULL },
        { "REPLY_LAST_RESULT", vtkPVSessionServer::REPLY_LAST_RESULT },
        { "EXECUTE_STREAM_TAG", vtkPVSessionServer::EXECUTE_STREAM_TAG },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPVSessionServer_Doc()
{
  static const char *docstring[] = {
    "vtkPVSessionServer - vtkSMSessionServer is a session used on data\nand/or render servers.\n\n",
    "Superclass: vtkPVSessionBase\n\n",
    "It's designed for a process that works with a separate client process\nthat acts as the visualization driver.\n@sa\nvtkSMSessionClient\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPVSessionServer(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVSessionServer_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVSessionServer", o) != 0)
  {
    Py_DECREF(o);
  }

}

