// python wrapper for vtkProgressBarSourceRepresentation
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkProgressBarSourceRepresentation.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkProgressBarSourceRepresentation(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkProgressBarSourceRepresentation_ClassNew(); }

#ifndef DECLARED_PyvtkPVDataRepresentation_ClassNew
extern "C" { PyObject *PyvtkPVDataRepresentation_ClassNew(); }
#define DECLARED_PyvtkPVDataRepresentation_ClassNew
#endif

static const char **PyvtkProgressBarSourceRepresentation_Doc();


static PyObject *
PyvtkProgressBarSourceRepresentation_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkProgressBarSourceRepresentation::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkProgressBarSourceRepresentation::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkProgressBarSourceRepresentation *tempr = vtkProgressBarSourceRepresentation::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkProgressBarSourceRepresentation *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkProgressBarSourceRepresentation::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_SetProgressBarWidgetRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetProgressBarWidgetRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  vtk3DWidgetRepresentation *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtk3DWidgetRepresentation"))
  {
    if (ap.IsBound())
    {
      op->SetProgressBarWidgetRepresentation(temp0);
    }
    else
    {
      op->vtkProgressBarSourceRepresentation::SetProgressBarWidgetRepresentation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_GetProgressBarWidgetRepresentation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProgressBarWidgetRepresentation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtk3DWidgetRepresentation *tempr = (ap.IsBound() ?
      op->GetProgressBarWidgetRepresentation() :
      op->vtkProgressBarSourceRepresentation::GetProgressBarWidgetRepresentation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_MarkModified(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkModified");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->MarkModified();
    }
    else
    {
      op->vtkProgressBarSourceRepresentation::MarkModified();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_SetVisibility(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVisibility");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetVisibility(temp0);
    }
    else
    {
      op->vtkProgressBarSourceRepresentation::SetVisibility(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_SetInteractivity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInteractivity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInteractivity(temp0);
    }
    else
    {
      op->vtkProgressBarSourceRepresentation::SetInteractivity(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkProgressBarSourceRepresentation_ProcessViewRequest(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ProcessViewRequest");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkProgressBarSourceRepresentation *op = static_cast<vtkProgressBarSourceRepresentation *>(vp);

  vtkInformationRequestKey *temp0 = NULL;
  vtkInformation *temp1 = NULL;
  vtkInformation *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetVTKObject(temp0, "vtkInformationRequestKey") &&
      ap.GetVTKObject(temp1, "vtkInformation") &&
      ap.GetVTKObject(temp2, "vtkInformation"))
  {
    int tempr = (ap.IsBound() ?
      op->ProcessViewRequest(temp0, temp1, temp2) :
      op->vtkProgressBarSourceRepresentation::ProcessViewRequest(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkProgressBarSourceRepresentation_Methods[] = {
  {"IsTypeOf", PyvtkProgressBarSourceRepresentation_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkProgressBarSourceRepresentation_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkProgressBarSourceRepresentation_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkProgressBarSourceRepresentation\nC++: static vtkProgressBarSourceRepresentation *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkProgressBarSourceRepresentation_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkProgressBarSourceRepresentation\nC++: vtkProgressBarSourceRepresentation *NewInstance()\n\n"},
  {"SetProgressBarWidgetRepresentation", PyvtkProgressBarSourceRepresentation_SetProgressBarWidgetRepresentation, METH_VARARGS,
   "V.SetProgressBarWidgetRepresentation(vtk3DWidgetRepresentation)\nC++: void SetProgressBarWidgetRepresentation(\n    vtk3DWidgetRepresentation *widget)\n\nSet the ProgressBar widget.\n"},
  {"GetProgressBarWidgetRepresentation", PyvtkProgressBarSourceRepresentation_GetProgressBarWidgetRepresentation, METH_VARARGS,
   "V.GetProgressBarWidgetRepresentation()\n    -> vtk3DWidgetRepresentation\nC++: virtual vtk3DWidgetRepresentation *GetProgressBarWidgetRepresentation(\n    )\n\nSet the ProgressBar widget.\n"},
  {"MarkModified", PyvtkProgressBarSourceRepresentation_MarkModified, METH_VARARGS,
   "V.MarkModified()\nC++: virtual void MarkModified()\n\n"},
  {"SetVisibility", PyvtkProgressBarSourceRepresentation_SetVisibility, METH_VARARGS,
   "V.SetVisibility(bool)\nC++: virtual void SetVisibility(bool)\n\nSet the visibility.\n"},
  {"SetInteractivity", PyvtkProgressBarSourceRepresentation_SetInteractivity, METH_VARARGS,
   "V.SetInteractivity(bool)\nC++: void SetInteractivity(bool)\n\nSet the interactivity.\n"},
  {"ProcessViewRequest", PyvtkProgressBarSourceRepresentation_ProcessViewRequest, METH_VARARGS,
   "V.ProcessViewRequest(vtkInformationRequestKey, vtkInformation,\n    vtkInformation) -> int\nC++: int ProcessViewRequest(\n    vtkInformationRequestKey *request_type,\n    vtkInformation *inInfo, vtkInformation *outInfo)\n\nvtkAlgorithm::ProcessRequest() equivalent for rendering passes.\nThis is typically called by the vtkView to request meta-data from\nthe representations or ask them to perform certain tasks e.g.\nPrepareForRendering.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkProgressBarSourceRepresentation_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVClientServerCoreRenderingPython.vtkProgressBarSourceRepresentation", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkProgressBarSourceRepresentation_StaticNew()
{
  return vtkProgressBarSourceRepresentation::New();
}

PyObject *PyvtkProgressBarSourceRepresentation_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkProgressBarSourceRepresentation_Type, PyvtkProgressBarSourceRepresentation_Methods,
    "vtkProgressBarSourceRepresentation",
    PyvtkProgressBarSourceRepresentation_Doc(), &PyvtkProgressBarSourceRepresentation_StaticNew);

  PyTypeObject *pytype = &PyvtkProgressBarSourceRepresentation_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVDataRepresentation_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkProgressBarSourceRepresentation_Doc()
{
  static const char *docstring[] = {
    "vtkProgressBarSourceRepresentation -\nvtkProgressBarSourceRepresentation is a representation to show\nProgressBar.\n\n",
    "Superclass: vtkPVDataRepresentation\n\n",
    "The input is expected to a vtkTable with a single row and column\n(atleast on the data server nodes). The content of this entry in the\ntable is shown as ProgressBar on the rendering nodes.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkProgressBarSourceRepresentation(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkProgressBarSourceRepresentation_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkProgressBarSourceRepresentation", o) != 0)
  {
    Py_DECREF(o);
  }

}

