// python wrapper for vtkSMCompoundProxyDefinitionLoader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMCompoundProxyDefinitionLoader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMCompoundProxyDefinitionLoader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMCompoundProxyDefinitionLoader_ClassNew(); }

#ifndef DECLARED_PyvtkSMDeserializerXML_ClassNew
extern "C" { PyObject *PyvtkSMDeserializerXML_ClassNew(); }
#define DECLARED_PyvtkSMDeserializerXML_ClassNew
#endif

static const char **PyvtkSMCompoundProxyDefinitionLoader_Doc();


static PyObject *
PyvtkSMCompoundProxyDefinitionLoader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMCompoundProxyDefinitionLoader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCompoundProxyDefinitionLoader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCompoundProxyDefinitionLoader *op = static_cast<vtkSMCompoundProxyDefinitionLoader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMCompoundProxyDefinitionLoader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCompoundProxyDefinitionLoader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMCompoundProxyDefinitionLoader *tempr = vtkSMCompoundProxyDefinitionLoader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMCompoundProxyDefinitionLoader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCompoundProxyDefinitionLoader *op = static_cast<vtkSMCompoundProxyDefinitionLoader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMCompoundProxyDefinitionLoader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMCompoundProxyDefinitionLoader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMCompoundProxyDefinitionLoader_SetRootElement(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRootElement");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMCompoundProxyDefinitionLoader *op = static_cast<vtkSMCompoundProxyDefinitionLoader *>(vp);

  vtkPVXMLElement *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVXMLElement"))
  {
    if (ap.IsBound())
    {
      op->SetRootElement(temp0);
    }
    else
    {
      op->vtkSMCompoundProxyDefinitionLoader::SetRootElement(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMCompoundProxyDefinitionLoader_Methods[] = {
  {"IsTypeOf", PyvtkSMCompoundProxyDefinitionLoader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMCompoundProxyDefinitionLoader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMCompoundProxyDefinitionLoader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkSMCompoundProxyDefinitionLoader\nC++: static vtkSMCompoundProxyDefinitionLoader *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMCompoundProxyDefinitionLoader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMCompoundProxyDefinitionLoader\nC++: vtkSMCompoundProxyDefinitionLoader *NewInstance()\n\n"},
  {"SetRootElement", PyvtkSMCompoundProxyDefinitionLoader_SetRootElement, METH_VARARGS,
   "V.SetRootElement(vtkPVXMLElement)\nC++: virtual void SetRootElement(vtkPVXMLElement *)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMCompoundProxyDefinitionLoader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMCompoundProxyDefinitionLoader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMCompoundProxyDefinitionLoader_StaticNew()
{
  return vtkSMCompoundProxyDefinitionLoader::New();
}

PyObject *PyvtkSMCompoundProxyDefinitionLoader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMCompoundProxyDefinitionLoader_Type, PyvtkSMCompoundProxyDefinitionLoader_Methods,
    "vtkSMCompoundProxyDefinitionLoader",
    PyvtkSMCompoundProxyDefinitionLoader_Doc(), &PyvtkSMCompoundProxyDefinitionLoader_StaticNew);

  PyTypeObject *pytype = &PyvtkSMCompoundProxyDefinitionLoader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMDeserializerXML_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMCompoundProxyDefinitionLoader_Doc()
{
  static const char *docstring[] = {
    "vtkSMCompoundProxyDefinitionLoader - Creates a compound proxy from an\n\n",
    "Superclass: vtkSMDeserializerXML\n\n",
    "XML definition.\n\nvtkSMCompoundProxyDefinitionLoader can load a compound proxy\ndefinition from a given vtkPVXMLElement. This element can be\npopulated by a vtkPVXMLElement or obtained from the proxy manager.\n@sa\nvtkPVXMLElement vtkPVXMLParser vtkSMProxyManager\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMCompoundProxyDefinitionLoader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMCompoundProxyDefinitionLoader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMCompoundProxyDefinitionLoader", o) != 0)
  {
    Py_DECREF(o);
  }

}

