// python wrapper for vtkSMDeserializerXMLCache
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMDeserializerXMLCache.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMDeserializerXMLCache(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMDeserializerXMLCache_ClassNew(); }

#ifndef DECLARED_PyvtkSMDeserializerXML_ClassNew
extern "C" { PyObject *PyvtkSMDeserializerXML_ClassNew(); }
#define DECLARED_PyvtkSMDeserializerXML_ClassNew
#endif

static const char **PyvtkSMDeserializerXMLCache_Doc();


static PyObject *
PyvtkSMDeserializerXMLCache_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMDeserializerXMLCache::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMDeserializerXMLCache_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMDeserializerXMLCache *op = static_cast<vtkSMDeserializerXMLCache *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMDeserializerXMLCache::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMDeserializerXMLCache_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMDeserializerXMLCache *tempr = vtkSMDeserializerXMLCache::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMDeserializerXMLCache_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMDeserializerXMLCache *op = static_cast<vtkSMDeserializerXMLCache *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMDeserializerXMLCache *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMDeserializerXMLCache::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMDeserializerXMLCache_CacheXMLProxyState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CacheXMLProxyState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMDeserializerXMLCache *op = static_cast<vtkSMDeserializerXMLCache *>(vp);

  unsigned int temp0;
  vtkPVXMLElement *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkPVXMLElement"))
  {
    if (ap.IsBound())
    {
      op->CacheXMLProxyState(temp0, temp1);
    }
    else
    {
      op->vtkSMDeserializerXMLCache::CacheXMLProxyState(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkSMDeserializerXMLCache_Methods[] = {
  {"IsTypeOf", PyvtkSMDeserializerXMLCache_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMDeserializerXMLCache_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMDeserializerXMLCache_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMDeserializerXMLCache\nC++: static vtkSMDeserializerXMLCache *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMDeserializerXMLCache_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMDeserializerXMLCache\nC++: vtkSMDeserializerXMLCache *NewInstance()\n\n"},
  {"CacheXMLProxyState", PyvtkSMDeserializerXMLCache_CacheXMLProxyState, METH_VARARGS,
   "V.CacheXMLProxyState(int, vtkPVXMLElement)\nC++: virtual void CacheXMLProxyState(vtkTypeUInt32 id,\n    vtkPVXMLElement *xml)\n\nAllow to register a given XML state for a given proxy GlobalId\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMDeserializerXMLCache_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMDeserializerXMLCache", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMDeserializerXMLCache_StaticNew()
{
  return vtkSMDeserializerXMLCache::New();
}

PyObject *PyvtkSMDeserializerXMLCache_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMDeserializerXMLCache_Type, PyvtkSMDeserializerXMLCache_Methods,
    "vtkSMDeserializerXMLCache",
    PyvtkSMDeserializerXMLCache_Doc(), &PyvtkSMDeserializerXMLCache_StaticNew);

  PyTypeObject *pytype = &PyvtkSMDeserializerXMLCache_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMDeserializerXML_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMDeserializerXMLCache_Doc()
{
  static const char *docstring[] = {
    "vtkSMDeserializerXMLCache - deserializes proxies from their XML\nstates.\n\n",
    "Superclass: vtkSMDeserializerXML\n\n",
    "vtkSMDeserializerXMLCache is used to deserialize proxies from\npreviously stored XML states.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMDeserializerXMLCache(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMDeserializerXMLCache_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMDeserializerXMLCache", o) != 0)
  {
    Py_DECREF(o);
  }

}

