// python wrapper for vtkSMRepresentationProxy
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkSMRepresentationProxy.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMRepresentationProxy(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMRepresentationProxy_ClassNew(); }

#ifndef DECLARED_PyvtkSMSourceProxy_ClassNew
extern "C" { PyObject *PyvtkSMSourceProxy_ClassNew(); }
#define DECLARED_PyvtkSMSourceProxy_ClassNew
#endif

static const char **PyvtkSMRepresentationProxy_Doc();


static PyObject *
PyvtkSMRepresentationProxy_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMRepresentationProxy::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMRepresentationProxy::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMRepresentationProxy *tempr = vtkSMRepresentationProxy::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMRepresentationProxy *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMRepresentationProxy::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_MarkDirty(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkDirty");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->MarkDirty(temp0);
    }
    else
    {
      op->vtkSMRepresentationProxy::MarkDirty(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_GetRepresentedDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRepresentedDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDataInformation *tempr = (ap.IsBound() ?
      op->GetRepresentedDataInformation() :
      op->vtkSMRepresentationProxy::GetRepresentedDataInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_GetProminentValuesInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProminentValuesInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  vtkStdString temp0;
  int temp1;
  int temp2;
  double temp3 = 1e-6;
  double temp4 = 1e-3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    vtkPVProminentValuesInformation *tempr = (ap.IsBound() ?
      op->GetProminentValuesInformation(temp0, temp1, temp2, temp3, temp4) :
      op->vtkSMRepresentationProxy::GetProminentValuesInformation(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_UpdatePipeline_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdatePipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdatePipeline();
    }
    else
    {
      op->vtkSMRepresentationProxy::UpdatePipeline();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSMRepresentationProxy_UpdatePipeline_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdatePipeline");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->UpdatePipeline(temp0);
    }
    else
    {
      op->vtkSMRepresentationProxy::UpdatePipeline(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkSMRepresentationProxy_UpdatePipeline(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 0:
      return PyvtkSMRepresentationProxy_UpdatePipeline_s1(self, args);
    case 1:
      return PyvtkSMRepresentationProxy_UpdatePipeline_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "UpdatePipeline");
  return NULL;
}



static PyObject *
PyvtkSMRepresentationProxy_PostUpdateData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PostUpdateData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PostUpdateData();
    }
    else
    {
      op->vtkSMRepresentationProxy::PostUpdateData();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_ViewUpdated(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ViewUpdated");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  vtkSMProxy *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMProxy"))
  {
    if (ap.IsBound())
    {
      op->ViewUpdated(temp0);
    }
    else
    {
      op->vtkSMRepresentationProxy::ViewUpdated(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_GetGlobalID(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlobalID");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetGlobalID() :
      op->vtkSMRepresentationProxy::GetGlobalID());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMRepresentationProxy_SetRepresentationType_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRepresentationType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMRepresentationProxy *op = static_cast<vtkSMRepresentationProxy *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->SetRepresentationType(temp0) :
      op->vtkSMRepresentationProxy::SetRepresentationType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMRepresentationProxy_SetRepresentationType_s2(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SetRepresentationType");

  vtkSMProxy *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkSMProxy") &&
      ap.GetValue(temp1))
  {
    bool tempr = vtkSMRepresentationProxy::SetRepresentationType(temp0, temp1);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSMRepresentationProxy_SetRepresentationType(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 1:
      return PyvtkSMRepresentationProxy_SetRepresentationType_s1(self, args);
    case 2:
      return PyvtkSMRepresentationProxy_SetRepresentationType_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetRepresentationType");
  return NULL;
}


static PyMethodDef PyvtkSMRepresentationProxy_Methods[] = {
  {"IsTypeOf", PyvtkSMRepresentationProxy_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMRepresentationProxy_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMRepresentationProxy_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMRepresentationProxy\nC++: static vtkSMRepresentationProxy *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMRepresentationProxy_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMRepresentationProxy\nC++: vtkSMRepresentationProxy *NewInstance()\n\n"},
  {"MarkDirty", PyvtkSMRepresentationProxy_MarkDirty, METH_VARARGS,
   "V.MarkDirty(vtkSMProxy)\nC++: virtual void MarkDirty(vtkSMProxy *modifiedProxy)\n\nCalls MarkDirty() and invokes ModifiedEvent.\n"},
  {"GetRepresentedDataInformation", PyvtkSMRepresentationProxy_GetRepresentedDataInformation, METH_VARARGS,
   "V.GetRepresentedDataInformation() -> vtkPVDataInformation\nC++: virtual vtkPVDataInformation *GetRepresentedDataInformation()\n\nReturns information about the data that is finally rendered by\nthis representation.\n"},
  {"GetProminentValuesInformation", PyvtkSMRepresentationProxy_GetProminentValuesInformation, METH_VARARGS,
   "V.GetProminentValuesInformation(string, int, int, float, float)\n    -> vtkPVProminentValuesInformation\nC++: virtual vtkPVProminentValuesInformation *GetProminentValuesInformation(\n    vtkStdString name, int fieldAssoc, int numComponents,\n    double uncertaintyAllowed=1e-6, double fraction=1e-3)\n\nReturns information about a specific array component's prominent\nvalues (or NULL).\n\n* The name, fieldAssoc, and numComponents arguments specify\n* which arrays on the input dataset to examine. Because\n  multiblock\n* datasets may have multiple arrays of the same name on different\nblocks,\n* and these arrays may not have the same storage type or number\n  of\n* components, this method requires you to specify the number of\n* components per tuple the array(s) of interest must have.\n* You may call GetRepresentedDataInformation() to obtain the\n  number of\n* components for any array.\n\n* See vtkAbstractArray::GetProminentComponentValues for more\n  information\n* about the uncertaintyAllowed and fraction arguments.\n"},
  {"UpdatePipeline", PyvtkSMRepresentationProxy_UpdatePipeline, METH_VARARGS,
   "V.UpdatePipeline()\nC++: virtual void UpdatePipeline()\nV.UpdatePipeline(float)\nC++: virtual void UpdatePipeline(double time)\n\nCalls Update() on all sources. It also creates output ports if\nthey are not already created.\n"},
  {"PostUpdateData", PyvtkSMRepresentationProxy_PostUpdateData, METH_VARARGS,
   "V.PostUpdateData()\nC++: virtual void PostUpdateData()\n\nOverridden to reset this->MarkedModified flag.\n"},
  {"ViewUpdated", PyvtkSMRepresentationProxy_ViewUpdated, METH_VARARGS,
   "V.ViewUpdated(vtkSMProxy)\nC++: virtual void ViewUpdated(vtkSMProxy *view)\n\nCalled after the view updates.\n"},
  {"GetGlobalID", PyvtkSMRepresentationProxy_GetGlobalID, METH_VARARGS,
   "V.GetGlobalID() -> int\nC++: virtual vtkTypeUInt32 GetGlobalID()\n\nOverridden to reserve additional IDs for use by internal\ncomposite representation\n"},
  {"SetRepresentationType", PyvtkSMRepresentationProxy_SetRepresentationType, METH_VARARGS,
   "V.SetRepresentationType(string) -> bool\nC++: virtual bool SetRepresentationType(const char *type)\nV.SetRepresentationType(vtkSMProxy, string) -> bool\nC++: static bool SetRepresentationType(vtkSMProxy *repr,\n    const char *type)\n\nSet the representation type. Default implementation simply\nupdates the \"Representation\" property, if present with the value\nprovided. Subclasses can override this method to add custom logic\nto manage the representation state to support the change e.g.\npick a scalar color array when switching to Volume or Slice\nrepresentation, for example. Returns true, if the change was\nsuccessful, otherwise returns false.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMRepresentationProxy_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerRenderingPython.vtkSMRepresentationProxy", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMRepresentationProxy_StaticNew()
{
  return vtkSMRepresentationProxy::New();
}

PyObject *PyvtkSMRepresentationProxy_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMRepresentationProxy_Type, PyvtkSMRepresentationProxy_Methods,
    "vtkSMRepresentationProxy",
    PyvtkSMRepresentationProxy_Doc(), &PyvtkSMRepresentationProxy_StaticNew);

  PyTypeObject *pytype = &PyvtkSMRepresentationProxy_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMSourceProxy_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMRepresentationProxy_Doc()
{
  static const char *docstring[] = {
    "vtkSMRepresentationProxy - \n\n",
    "Superclass: vtkSMSourceProxy\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMRepresentationProxy(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMRepresentationProxy_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMRepresentationProxy", o) != 0)
  {
    Py_DECREF(o);
  }

}

