// python wrapper for vtkSMSessionClient
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMSessionClient.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMSessionClient(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMSessionClient_ClassNew(); }

#ifndef DECLARED_PyvtkSMSession_ClassNew
extern "C" { PyObject *PyvtkSMSession_ClassNew(); }
#define DECLARED_PyvtkSMSession_ClassNew
#endif

static const char **PyvtkSMSessionClient_Doc();


static PyObject *
PyvtkSMSessionClient_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkSMSessionClient::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMSessionClient::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkSMSessionClient *tempr = vtkSMSessionClient::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMSessionClient *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMSessionClient::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetURI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetURI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetURI() :
      op->vtkSMSessionClient::GetURI());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_Connect(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Connect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->Connect(temp0) :
      op->vtkSMSessionClient::Connect(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetIsAlive(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIsAlive");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetIsAlive() :
      op->vtkSMSessionClient::GetIsAlive());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetServerInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetServerInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVServerInformation *tempr = (ap.IsBound() ?
      op->GetServerInformation() :
      op->vtkSMSessionClient::GetServerInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkSMSessionClient::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_PushState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PushState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  vtkSMMessage *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMMessage"))
  {
    if (ap.IsBound())
    {
      op->PushState(temp0);
    }
    else
    {
      op->vtkSMSessionClient::PushState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_PullState(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PullState");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  vtkSMMessage *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkSMMessage"))
  {
    if (ap.IsBound())
    {
      op->PullState(temp0);
    }
    else
    {
      op->vtkSMSessionClient::PullState(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_SetAbortConnect(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAbortConnect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAbortConnect(temp0);
    }
    else
    {
      op->vtkSMSessionClient::SetAbortConnect(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_CloseSession(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CloseSession");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->CloseSession();
    }
    else
    {
      op->vtkSMSessionClient::CloseSession();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GatherInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GatherInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  unsigned int temp0;
  vtkPVInformation *temp1 = NULL;
  unsigned int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetVTKObject(temp1, "vtkPVInformation") &&
      ap.GetValue(temp2))
  {
    bool tempr = (ap.IsBound() ?
      op->GatherInformation(temp0, temp1, temp2) :
      op->vtkSMSessionClient::GatherInformation(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetNumberOfProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfProcesses(temp0) :
      op->vtkSMSessionClient::GetNumberOfProcesses(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_IsMPIInitialized(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsMPIInitialized");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsMPIInitialized(temp0) :
      op->vtkSMSessionClient::IsMPIInitialized(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_PreDisconnection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PreDisconnection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PreDisconnection();
    }
    else
    {
      op->vtkSMSessionClient::PreDisconnection();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_IsNotBusy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsNotBusy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsNotBusy() :
      op->vtkSMSessionClient::IsNotBusy());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_StartBusyWork(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartBusyWork");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StartBusyWork();
    }
    else
    {
      op->vtkSMSessionClient::StartBusyWork();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_EndBusyWork(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EndBusyWork");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->EndBusyWork();
    }
    else
    {
      op->vtkSMSessionClient::EndBusyWork();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetCollaborationManager(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCollaborationManager");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMCollaborationManager *tempr = (ap.IsBound() ?
      op->GetCollaborationManager() :
      op->vtkSMSessionClient::GetCollaborationManager());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetNextGlobalUniqueIdentifier(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextGlobalUniqueIdentifier");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNextGlobalUniqueIdentifier() :
      op->vtkSMSessionClient::GetNextGlobalUniqueIdentifier());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_GetNextChunkGlobalUniqueIdentifier(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNextChunkGlobalUniqueIdentifier");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetNextChunkGlobalUniqueIdentifier(temp0) :
      op->vtkSMSessionClient::GetNextChunkGlobalUniqueIdentifier(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMSessionClient_OnServerNotificationMessageRMI(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnServerNotificationMessageRMI");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMSessionClient *op = static_cast<vtkSMSessionClient *>(vp);

  void  *temp0 = NULL;
  Py_buffer pbuf0 = VTK_PYBUFFER_INITIALIZER;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetBuffer(temp0, &pbuf0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->OnServerNotificationMessageRMI(temp0, temp1);
    }
    else
    {
      op->vtkSMSessionClient::OnServerNotificationMessageRMI(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

#if PY_VERSION_HEX >= 0x02060000
  if (pbuf0.obj != 0)
  {
    PyBuffer_Release(&pbuf0);
  }
#endif
  return result;
}

static PyMethodDef PyvtkSMSessionClient_Methods[] = {
  {"IsTypeOf", PyvtkSMSessionClient_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkSMSessionClient_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkSMSessionClient_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkSMSessionClient\nC++: static vtkSMSessionClient *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkSMSessionClient_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMSessionClient\nC++: vtkSMSessionClient *NewInstance()\n\n"},
  {"GetURI", PyvtkSMSessionClient_GetURI, METH_VARARGS,
   "V.GetURI() -> string\nC++: virtual const char *GetURI()\n\nReturn the url used to connect the current session to a server\n"},
  {"Connect", PyvtkSMSessionClient_Connect, METH_VARARGS,
   "V.Connect(string) -> bool\nC++: virtual bool Connect(const char *url)\n\nConnects a remote server. URL can be of the following format:\ncs://<pvserver-host>:<pvserver-port>\ncdsrs://<pvdataserver-host>:<pvdataserver-port>/<pvrenderserver-ho\nst>:<pvrenderserver-port> In both cases the port is optional.\nWhen not provided default pvserver/pvdataserver port // is 11111,\nwhile default pvrenderserver port is 22221. For reverse connect\ni.e. the client waits for the server to connect back, simply add\n\"rc\" to the protocol e.g. csrc://<pvserver-host>:<pvserver-port>\ncdsrsrc://<pvdataserver-host>:<pvdataserver-port>/<pvrenderserver-\nhost>:<pvrenderserver-port> In this case, the hostname is\nirrelevant and is ignored.\n"},
  {"GetIsAlive", PyvtkSMSessionClient_GetIsAlive, METH_VARARGS,
   "V.GetIsAlive() -> bool\nC++: virtual bool GetIsAlive()\n\nReturns true is this session is active/alive/valid.\n"},
  {"GetServerInformation", PyvtkSMSessionClient_GetServerInformation, METH_VARARGS,
   "V.GetServerInformation() -> vtkPVServerInformation\nC++: virtual vtkPVServerInformation *GetServerInformation()\n\nvtkPVServerInformation is an information-object that provides\ninformation about the server processes. These include server-side\ncapabilities as well as server-side command line arguments e.g.\ntile-display parameters. Use this method to obtain the\nserver-side information. Overridden to provide return the\ninformation gathered from data-server and render-server.\n"},
  {"Initialize", PyvtkSMSessionClient_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: virtual void Initialize()\n\nCalled to do any initializations after a successful session has\nbeen established. Initialize the data-server-render-server\nconnection, if applicable.\n"},
  {"PushState", PyvtkSMSessionClient_PushState, METH_VARARGS,
   "V.PushState(vtkSMMessage)\nC++: virtual void PushState(vtkSMMessage *msg)\n\nPush the state.\n"},
  {"PullState", PyvtkSMSessionClient_PullState, METH_VARARGS,
   "V.PullState(vtkSMMessage)\nC++: virtual void PullState(vtkSMMessage *message)\n\nPush the state.\n"},
  {"SetAbortConnect", PyvtkSMSessionClient_SetAbortConnect, METH_VARARGS,
   "V.SetAbortConnect(bool)\nC++: virtual void SetAbortConnect(bool _arg)\n\nWhen Connect() is waiting for a server to connect back to the\nclient (in reverse connect mode), then it periodically fires\nProgressEvent. Application can add observer to this signal and\nset this flag to true, if it wants to abort the wait for the\nserver.\n"},
  {"CloseSession", PyvtkSMSessionClient_CloseSession, METH_VARARGS,
   "V.CloseSession()\nC++: void CloseSession()\n\nGracefully exits the session.\n"},
  {"GatherInformation", PyvtkSMSessionClient_GatherInformation, METH_VARARGS,
   "V.GatherInformation(int, vtkPVInformation, int) -> bool\nC++: virtual bool GatherInformation(vtkTypeUInt32 location,\n    vtkPVInformation *information, vtkTypeUInt32 globalid)\n\nGather information about an object referred by the\nglobalid.location identifies the processes to gather the\ninformation from. Overridden to fetch the information from server\nif needed, otherwise it's handled locally.\n"},
  {"GetNumberOfProcesses", PyvtkSMSessionClient_GetNumberOfProcesses, METH_VARARGS,
   "V.GetNumberOfProcesses(int) -> int\nC++: virtual int GetNumberOfProcesses(vtkTypeUInt32 servers)\n\nReturns the number of processes on the given server/s. If more\nthan 1 server is identified, than it returns the maximum number\nof processes e.g. is servers = DATA_SERVER | RENDER_SERVER and\nthere are 3 data-server nodes and 2 render-server nodes, then\nthis method will return 3.\n"},
  {"IsMPIInitialized", PyvtkSMSessionClient_IsMPIInitialized, METH_VARARGS,
   "V.IsMPIInitialized(int) -> bool\nC++: virtual bool IsMPIInitialized(vtkTypeUInt32 servers)\n\nReturns whether or not MPI is initialized on the specified\nserver/s. If more than 1 server is identified it will return true\nonly if all of the servers have MPI initialized.\n"},
  {"PreDisconnection", PyvtkSMSessionClient_PreDisconnection, METH_VARARGS,
   "V.PreDisconnection()\nC++: virtual void PreDisconnection()\n\n"},
  {"IsNotBusy", PyvtkSMSessionClient_IsNotBusy, METH_VARARGS,
   "V.IsNotBusy() -> bool\nC++: virtual bool IsNotBusy()\n\nFlag used to know if it is a good time to handle server\nnotification.\n"},
  {"StartBusyWork", PyvtkSMSessionClient_StartBusyWork, METH_VARARGS,
   "V.StartBusyWork()\nC++: virtual void StartBusyWork()\n\nBusyWork should be declared inside method that will request\nseveral network call that we don't want to interupt such as\nGatherInformation and Pull.\n"},
  {"EndBusyWork", PyvtkSMSessionClient_EndBusyWork, METH_VARARGS,
   "V.EndBusyWork()\nC++: virtual void EndBusyWork()\n\nBusyWork should be declared inside method that will request\nseveral network call that we don't want to interupt such as\nGatherInformation and Pull.\n"},
  {"GetCollaborationManager", PyvtkSMSessionClient_GetCollaborationManager, METH_VARARGS,
   "V.GetCollaborationManager() -> vtkSMCollaborationManager\nC++: virtual vtkSMCollaborationManager *GetCollaborationManager()\n\nReturn the instance of vtkSMCollaborationManager that will be\nlazy created at the first call.\n"},
  {"GetNextGlobalUniqueIdentifier", PyvtkSMSessionClient_GetNextGlobalUniqueIdentifier, METH_VARARGS,
   "V.GetNextGlobalUniqueIdentifier() -> int\nC++: virtual vtkTypeUInt32 GetNextGlobalUniqueIdentifier()\n\nProvides the next available identifier. This implementation works\nlocally. without any code distribution. To support the\ndistributed architecture the vtkSMSessionClient overide those\nmethod to call them on the DATA_SERVER vtkPVSessionBase instance.\n"},
  {"GetNextChunkGlobalUniqueIdentifier", PyvtkSMSessionClient_GetNextChunkGlobalUniqueIdentifier, METH_VARARGS,
   "V.GetNextChunkGlobalUniqueIdentifier(int) -> int\nC++: virtual vtkTypeUInt32 GetNextChunkGlobalUniqueIdentifier(\n    vtkTypeUInt32 chunkSize)\n\nReturn the first Id of the requested chunk. 1 =\nReverveNextIdChunk(10); | Reserved ids [1,2,3,4,5,6,7,8,9,10] 11\n= ReverveNextIdChunk(10);| Reserved ids\n[11,12,13,14,15,16,17,18,19,20] b = a + 10;\n"},
  {"OnServerNotificationMessageRMI", PyvtkSMSessionClient_OnServerNotificationMessageRMI, METH_VARARGS,
   "V.OnServerNotificationMessageRMI(void, int)\nC++: void OnServerNotificationMessageRMI(void *message,\n    int message_length)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMSessionClient_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkPVServerManagerCorePython.vtkSMSessionClient", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMSessionClient_StaticNew()
{
  return vtkSMSessionClient::New();
}

PyObject *PyvtkSMSessionClient_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMSessionClient_Type, PyvtkSMSessionClient_Methods,
    "vtkSMSessionClient",
    PyvtkSMSessionClient_Doc(), &PyvtkSMSessionClient_StaticNew);

  PyTypeObject *pytype = &PyvtkSMSessionClient_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSMSession_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMSessionClient_Doc()
{
  static const char *docstring[] = {
    "vtkSMSessionClient - vtkSMSessionClient is a remote-session that\nconnects to a remote server.\n\n",
    "Superclass: vtkSMSession\n\n",
    "vtkSMSessionClient supports both connecting a pvserver as well as\nconnecting a pvdataserver/pvrenderserver.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMSessionClient(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMSessionClient_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMSessionClient", o) != 0)
  {
    Py_DECREF(o);
  }

}

