// python wrapper for vtkXdmfDataArray
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkXdmfDataArray.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXdmfDataArray(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkXdmfDataArray_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkXdmfDataArray_Doc();


static PyObject *
PyvtkXdmfDataArray_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkXdmfDataArray::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkXdmfDataArray::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkXdmfDataArray *tempr = vtkXdmfDataArray::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkXdmfDataArray *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkXdmfDataArray::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_FromArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FromArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->FromArray() :
      op->vtkXdmfDataArray::FromArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_ToArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->ToArray() :
      op->vtkXdmfDataArray::ToArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_FromXdmfArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "FromXdmfArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  char *temp0 = NULL;
  int temp1 = 1;
  int temp2 = 1;
  int temp3 = 1;
  int temp4 = 1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0, 5) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->FromXdmfArray(temp0, temp1, temp2, temp3, temp4) :
      op->vtkXdmfDataArray::FromXdmfArray(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_ToXdmfArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ToXdmfArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  vtkDataArray *temp0 = NULL;
  int temp1 = 1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0, 2) &&
      (ap.NoArgsLeft() || ap.GetVTKObject(temp0, "vtkDataArray")) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    char *tempr = (ap.IsBound() ?
      op->ToXdmfArray(temp0, temp1) :
      op->vtkXdmfDataArray::ToXdmfArray(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_SetArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetArray(temp0);
    }
    else
    {
      op->vtkXdmfDataArray::SetArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_GetArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetArray() :
      op->vtkXdmfDataArray::GetArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_SetVtkArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetVtkArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  vtkDataArray *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkDataArray"))
  {
    if (ap.IsBound())
    {
      op->SetVtkArray(temp0);
    }
    else
    {
      op->vtkXdmfDataArray::SetVtkArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkXdmfDataArray_GetVtkArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetVtkArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXdmfDataArray *op = static_cast<vtkXdmfDataArray *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkDataArray *tempr = (ap.IsBound() ?
      op->GetVtkArray() :
      op->vtkXdmfDataArray::GetVtkArray());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkXdmfDataArray_Methods[] = {
  {"IsTypeOf", PyvtkXdmfDataArray_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\n"},
  {"IsA", PyvtkXdmfDataArray_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type)\n\n"},
  {"SafeDownCast", PyvtkXdmfDataArray_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkXdmfDataArray\nC++: static vtkXdmfDataArray *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkXdmfDataArray_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkXdmfDataArray\nC++: vtkXdmfDataArray *NewInstance()\n\n"},
  {"FromArray", PyvtkXdmfDataArray_FromArray, METH_VARARGS,
   "V.FromArray() -> vtkDataArray\nC++: vtkDataArray *FromArray(void)\n\n"},
  {"ToArray", PyvtkXdmfDataArray_ToArray, METH_VARARGS,
   "V.ToArray() -> string\nC++: char *ToArray(void)\n\n"},
  {"FromXdmfArray", PyvtkXdmfDataArray_FromXdmfArray, METH_VARARGS,
   "V.FromXdmfArray(string, int, int, int, int) -> vtkDataArray\nC++: vtkDataArray *FromXdmfArray(char *ArrayName=NULL,\n    int CopyShape=1, int rank=1, int Components=1, int MakeCopy=1)\n\n"},
  {"ToXdmfArray", PyvtkXdmfDataArray_ToXdmfArray, METH_VARARGS,
   "V.ToXdmfArray(vtkDataArray, int) -> string\nC++: char *ToXdmfArray(vtkDataArray *DataArray=NULL,\n    int CopyShape=1)\n\n"},
  {"SetArray", PyvtkXdmfDataArray_SetArray, METH_VARARGS,
   "V.SetArray(string)\nC++: void SetArray(char *TagName)\n\n"},
  {"GetArray", PyvtkXdmfDataArray_GetArray, METH_VARARGS,
   "V.GetArray() -> string\nC++: char *GetArray(void)\n\n"},
  {"SetVtkArray", PyvtkXdmfDataArray_SetVtkArray, METH_VARARGS,
   "V.SetVtkArray(vtkDataArray)\nC++: void SetVtkArray(vtkDataArray *array)\n\n"},
  {"GetVtkArray", PyvtkXdmfDataArray_GetVtkArray, METH_VARARGS,
   "V.GetVtkArray() -> vtkDataArray\nC++: vtkDataArray *GetVtkArray(void)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkXdmfDataArray_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOXdmf2Python.vtkXdmfDataArray", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkXdmfDataArray_StaticNew()
{
  return vtkXdmfDataArray::New();
}

PyObject *PyvtkXdmfDataArray_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkXdmfDataArray_Type, PyvtkXdmfDataArray_Methods,
    "vtkXdmfDataArray",
    PyvtkXdmfDataArray_Doc(), &PyvtkXdmfDataArray_StaticNew);

  PyTypeObject *pytype = &PyvtkXdmfDataArray_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkXdmfDataArray_Doc()
{
  static const char *docstring[] = {
    "vtkXdmfDataArray - no description provided.\n\n",
    "Superclass: vtkObject\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkXdmfDataArray(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXdmfDataArray_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkXdmfDataArray", o) != 0)
  {
    Py_DECREF(o);
  }

}

