/* #undef PARAVIEW_USE_UNIFIED_BINDINGS */
/* #undef NO_PYTHON_BINDINGS_AVAILABLE */
#ifdef NO_PYTHON_BINDINGS_AVAILABLE
#undef PARAVIEW_USE_UNIFIED_BINDINGS
#endif
#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
#include "vtkPython.h"
#include "vtkPythonInterpreter.h"
#endif

#include "vtkClientServerInterpreter.h"

#ifndef PARAVIEW_BUILD_SHARED_LIBS
#define PARAVIEW_BUILD_SHARED_LIBS
#endif
#if defined(PARAVIEW_BUILD_SHARED_LIBS) && defined(_WIN32)
# define VTK_WRAP_CS_EXPORT __declspec(dllexport)
#else
# define VTK_WRAP_CS_EXPORT
#endif

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
extern "C" void real_initvtkFiltersVerdictPython(const char *modulename);

void initvtkFiltersVerdictPython()
{
  static const char modulename[] = "vtkFiltersVerdictPython";
  real_initvtkFiltersVerdictPython(modulename);
}
#endif

extern void vtkCellQuality_Init(vtkClientServerInterpreter* csi);
extern void vtkCellSizeFilter_Init(vtkClientServerInterpreter* csi);
extern void vtkMatrixMathFilter_Init(vtkClientServerInterpreter* csi);
extern void vtkMeshQuality_Init(vtkClientServerInterpreter* csi);


extern "C" void VTK_WRAP_CS_EXPORT vtkFiltersVerdictCS_Initialize(
  vtkClientServerInterpreter *csi)
{
  // silence unreferenced var warning.
  (void) csi;

#ifdef PARAVIEW_USE_UNIFIED_BINDINGS
  if (!vtkPythonInterpreter::IsInitialized())
    {
    vtkPythonInterpreter::Initialize();
    }

  static bool initialized = false;

  if (!initialized)
    {
    initialized = true;
    PyImport_AppendInittab("vtkFiltersVerdictPython", initvtkFiltersVerdictPython);
    }

  csi->Load("vtkFiltersVerdict");
#endif

  vtkCellQuality_Init(csi);
  vtkCellSizeFilter_Init(csi);
  vtkMatrixMathFilter_Init(csi);
  vtkMeshQuality_Init(csi);

}
